<?php
/**
 * class-affiliates-enterprise-database.php
 * 
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 * 
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 1.0.0
 */

/**
 * Platform-independent Enterprise database extension.
 */
abstract class Affiliates_Enterprise_Database implements I_Affiliates_Enterprise_Database {

	private $implementation;
	private $host;
	private $database;
	private $user;
	private $password;

	protected $affiliates_db_impl;

	public function __construct( $implementation, $host = null, $database = null, $user = null, $password = null ) { $this->implementation = $implementation; $this->host = $host; $this->database = $database; $this->user = $user; $this->password = $password; }

	public function create_tables( $charset = null, $collate = null ) { $this->affiliates_db_impl->create_tables( $charset, $collate ); $IX94005 = ''; if ( ! empty( $charset ) ) { $IX94005 = "DEFAULT CHARACTER SET $charset"; } if ( ! empty( $collate ) ) { $IX94005 .= " COLLATE $collate"; } $IX90842 = $this->get_tablename( 'affiliates_relations' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX90842 . "'" ) != $IX90842 ) { $IX24301 = "CREATE TABLE " . $IX90842 . " (
				from_affiliate_id bigint(20) unsigned NOT NULL,
				to_affiliate_id   bigint(20) unsigned NOT NULL,
				type              varchar(10) NOT NULL DEFAULT '" . AFFILIATES_RELATIONS_TYPE_REFERRAL . "',
				from_date         date NOT NULL,
				thru_date         date default NULL,
				status            varchar(10) NOT NULL DEFAULT '" . AFFILIATES_RELATIONS_STATUS_ACTIVE . "',
				PRIMARY KEY       (from_affiliate_id, to_affiliate_id, type, from_date),
				INDEX             aff_rel_ttsf (to_affiliate_id, type, status, from_date),
				INDEX             aff_rel_tf (to_affiliate_id, from_affiliate_id, type, status, from_date)
			) $IX94005;"; $this->query( $IX24301 ); } $IX60744 = $this->get_tablename( 'campaigns' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX60744 . "'" ) != $IX60744 ) { $IX24301 = "CREATE TABLE " . $IX60744 . " (
				campaign_id  BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
				affiliate_id BIGINT(20) UNSIGNED NOT NULL,
				name         VARCHAR(100) DEFAULT NULL,
				description  LONGTEXT DEFAULT NULL,
				from_date    DATE DEFAULT NULL,
				thru_date    DATE DEFAULT NULL,
				type         VARCHAR(10) DEFAULT NULL,
				status       VARCHAR(10) DEFAULT NULL,
				PRIMARY KEY  (campaign_id),
				INDEX        aff_cmp_aid (affiliate_id)
				) $IX94005;"; $this->query( $IX24301 ); } }

	public function update_tables( $previous_version = null, $charset = null, $collate = null ) { $IX47435 = $this->affiliates_db_impl->update_tables( $previous_version, $charset, $collate ); $IX36450 = ''; if ( ! empty( $charset ) ) { $IX36450 = "DEFAULT CHARACTER SET $charset"; } if ( ! empty( $collate ) ) { $IX36450 .= " COLLATE $collate"; } $IX67648 = $this->get_tablename( 'campaigns' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX67648 . "'" ) != $IX67648 ) { $IX91585 = "CREATE TABLE " . $IX67648 . " (
			campaign_id  BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
			affiliate_id BIGINT(20) UNSIGNED NOT NULL,
			name         VARCHAR(100) DEFAULT NULL,
			description  LONGTEXT DEFAULT NULL,
			from_date    DATE DEFAULT NULL,
			thru_date    DATE DEFAULT NULL,
			type         VARCHAR(10) DEFAULT NULL,
			status       VARCHAR(10) DEFAULT NULL,
			PRIMARY KEY  (campaign_id),
			INDEX        aff_cmp_acn (affiliate_id,campaign_id,name),
			INDEX        aff_cmp_nam (name(20))
			) $IX36450;"; if ( !$this->query( $IX91585 ) ) { $IX47435 = false; } } return $IX47435; }

	public function drop_tables() { $IX86943 = $this->get_tablename( 'affiliates_relations' ); $IX80131 = "DROP TABLE IF EXISTS " . $IX86943 . ";"; $this->query( $IX80131 ); $IX66585 = $this->get_tablename( 'campaigns' ); $IX80131 = "DROP TABLE IF EXISTS " . $IX66585 . ";"; $this->query( $IX80131 ); $this->affiliates_db_impl->drop_tables(); }
}
