<?php
/**
 * class-affiliates-dashboard-banners-enterprise.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Banners
 */
class Affiliates_Dashboard_Banners_Enterprise extends Affiliates_Dashboard_Banners {

	protected $campaign_id = null;

	public static function init() { }

	/**
	 * Returns the current campaign ID or null.
	 *
	 * @return int
	 */
	public function get_campaign_id() { return $this->campaign_id; }

	/**
	 * Returns campaigns related to the section's affiliate, key-value pairs: campaign_id => campaign name.
	 *
	 * @return string[int]
	 */
	public function get_campaigns() { $IX74478 = array(); $IX48460 = Affiliates_Campaign::get_campaigns( $this->get_affiliate_id() ); foreach ( $IX48460 as $IX59780 ) { $IX74478[$IX59780->campaign_id] = $IX59780->name; } return $IX74478; }

	public function __construct( $params = array() ) { parent::__construct( $params ); $this->template = 'dashboard/banners-enterprise.php'; $this->url_parameters[] = 'campaign_id'; }

	public function get_url( $params = array() ) { $IX39208 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX39208 = remove_query_arg( 'clear_filters', $IX39208 ); $IX39208 = remove_query_arg( 'apply_filters', $IX39208 ); foreach ( $this->url_parameters as $IX54311 ) { $IX39208 = remove_query_arg( $IX54311, $IX39208 ); $IX84024 = null; switch ( $IX54311 ) { case 'per_page' : $IX84024 = $this->get_per_page(); break; case 'from_date' : $IX84024 = $this->get_from_date(); break; case 'thru_date' : $IX84024 = $this->get_thru_date(); break; case 'orderby' : $IX84024 = $this->get_orderby(); break; case 'order' : $IX84024 = $this->get_sort_order(); break; case 'search' : $IX84024 = $this->get_search(); break; case 'banner_url' : $IX84024 = $this->get_banner_url(); break; case 'campaign_id' : $IX84024 = $this->get_campaign_id(); break; } if ( $IX84024 !== null ) { $IX39208 = add_query_arg( $IX54311, $IX84024, $IX39208 ); } } foreach ( $params as $IX20201 => $IX84024 ) { $IX39208 = remove_query_arg( $IX20201, $IX39208 ); if ( $IX84024 !== null ) { $IX39208 = add_query_arg( $IX20201, $IX84024, $IX39208 ); } } return $IX39208; }

	public function render() { if ( $this->get_affiliate_id() === null ) { return; } if ( isset( $_REQUEST['clear_filters'] ) ) { unset( $_REQUEST['campaign_id'] ); $this->campaign_id = null; } else { if ( !empty( $_REQUEST['campaign_id'] ) ) { $this->campaign_id = intval( $_REQUEST['campaign_id'] ); } else { $this->campaign_id = null; } } parent::render(); }

	protected function get_affiliate_url( $url ) { if ( $this->campaign_id !== null ) { $IX54737 = Affiliates_Campaign::get_affiliate_campaign( $this->get_affiliate_id(), $this->campaign_id ); $url = $IX54737->get_url( array( 'url' => $url ) ); } else { $url = parent::get_affiliate_url( $url ); } return $url; }
}
Affiliates_Dashboard_Banners_Enterprise::init();
