<?php
/**
 * class-affiliates-dashboard-campaigns-block.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Campaigns
 */
class Affiliates_Dashboard_Campaigns_Block extends Affiliates_Dashboard_Campaigns {

	public static function init() { add_action( 'init', array( __CLASS__, 'wp_init' ) ); add_action( 'enqueue_block_editor_assets', array( __CLASS__, 'enqueue_block_editor_assets' ) ); add_action( 'enqueue_block_assets', array( __CLASS__, 'enqueue_block_assets' ) ); }

	public static function enqueue_block_editor_assets() { wp_register_script( 'affiliates-dashboard-campaigns-block', plugins_url( 'js/dashboard-campaigns-block.js', AFFILIATES_FILE ), array( 'wp-blocks', 'wp-element' ) ); wp_localize_script( 'affiliates-dashboard-campaigns-block', 'affiliates_dashboard_campaigns_block', array( 'title' => _x( 'Affiliates Dashboard Campaigns', 'block title', 'affiliates' ), 'description' => _x( 'Displays the Campaigns section from the Affiliates Dashboard', 'block description', 'affiliates' ), 'keyword_affiliates' => __( 'Affiliates', 'affiliates' ), 'keyword_dashboard' => __( 'Dashboard', 'affiliates' ), 'keyword_campaigns' => __( 'Campaigns', 'affiliates' ), 'dashboard_campaigns_notice' => _x( 'Affiliates Dashboard Campaigns', 'Notice shown when editing the Affiliates Dashboard Campaigns block as a non-affiliate.', 'affiliates' ) ) ); }

	public static function enqueue_block_assets() { }

	public static function wp_init() { if ( function_exists( 'register_block_type' ) ) { register_block_type( 'affiliates/dashboard-campaigns', array( 'editor_script' => 'affiliates-dashboard-campaigns-block', 'render_callback' => array( __CLASS__, 'block' ) ) ); } }

	public static function block( $atts, $content = '' ) { $IX68193 = ''; if ( affiliates_user_is_affiliate( get_current_user_id() ) ) { $IX19244 = new Affiliates_Dashboard_Campaigns(); ob_start(); $IX19244->render(); $IX68193 = ob_get_clean(); } if ( ( strlen( $IX68193 ) === 0 ) && defined( 'REST_REQUEST' ) && REST_REQUEST && isset( $_REQUEST['context'] ) && $_REQUEST['context'] === 'edit' ) { $IX68193 .= '<div style="display:none"></div>'; } return $IX68193; }
}
Affiliates_Dashboard_Campaigns_Block::init();
