<?php
/**
 * class-affiliates-dashboard-enterprise.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard extensions.
 */
class Affiliates_Dashboard_Enterprise extends Affiliates_Dashboard_Pro {

	public static function init() { Affiliates_Dashboard_Factory::set_dashboard_class( __CLASS__ ); Affiliates_Dashboard_Section_Factory::set_section_classes( array( Affiliates_Dashboard_Overview_Enterprise::get_key() => Affiliates_Dashboard_Overview_Enterprise::class, Affiliates_Dashboard_Banners_Enterprise::get_key() => Affiliates_Dashboard_Banners_Enterprise::class, Affiliates_Dashboard_Traffic_Enterprise::get_key() => Affiliates_Dashboard_Traffic_Enterprise::class, Affiliates_Dashboard_Referrals_Enterprise::get_key() => Affiliates_Dashboard_Referrals_Enterprise::class, Affiliates_Dashboard_Campaigns::get_key() => Affiliates_Dashboard_Campaigns::class, ) ); }

	public function __construct( $params = array() ) { parent::__construct( $params ); }

	public function setup_sections( $sections ) { $sections = parent::setup_sections( $sections ); $IX44073 = $this->get_user_id(); if ( $IX44073 !== null && affiliates_user_is_affiliate( $IX44073 ) ) { $sections[Affiliates_Dashboard_Overview_Enterprise::get_key()] = array( 'class' => 'Affiliates_Dashboard_Overview_Enterprise', 'parameters' => array( 'user_id' => $IX44073 ) ); $sections[Affiliates_Dashboard_Referrals_Enterprise::get_key()] = array( 'class' => 'Affiliates_Dashboard_Referrals_Enterprise', 'parameters' => array( 'user_id' => $IX44073 ) ); $sections[Affiliates_Dashboard_Traffic_Enterprise::get_key()] = array( 'class' => 'Affiliates_Dashboard_Traffic_Enterprise', 'parameters' => array( 'user_id' => $IX44073 ) ); $sections[Affiliates_Dashboard_Banners_Enterprise::get_key()] = array( 'class' => 'Affiliates_Dashboard_Banners_Enterprise', 'parameters' => array( 'user_id' => $IX44073 ) ); $sections[Affiliates_Dashboard_Campaigns::get_key()] = array( 'class' => 'Affiliates_Dashboard_Campaigns', 'parameters' => array( 'user_id' => $IX44073 ) ); } return $sections; }
}
Affiliates_Dashboard_Enterprise::init();
