<?php
/**
 * class-affiliates-dashboard-overview-enterprise.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Overview
 */
class Affiliates_Dashboard_Overview_Enterprise extends Affiliates_Dashboard_Overview_Pro {

	protected $campaign_id = null;

	public static function init() { }

	public function __construct( $params = array() ) { parent::__construct( $params ); $this->template = 'dashboard/overview-enterprise.php'; }

	/**
	 * Returns the current campaign ID or null.
	 *
	 * @return int
	 */
	public function get_campaign_id() { return $this->campaign_id; }

	/**
	 * Returns campaigns related to the section's affiliate, key-value pairs: campaign_id => campaign name.
	 *
	 * @return string[int]
	 */
	public function get_campaigns() { $IX36983 = array(); $IX89972 = Affiliates_Campaign::get_campaigns( $this->get_affiliate_id() ); foreach ( $IX89972 as $IX53952 ) { $IX36983[$IX53952->campaign_id] = $IX53952->name; } return $IX36983; }

	public function render() { global $affiliates_version; if ( !affiliates_user_is_affiliate( $this->user_id ) ) { return; } wp_dequeue_script( 'overview-controls' ); wp_enqueue_script( 'overview-controls', AFFILIATES_PLUGIN_URL . 'js/dashboard-overview-controls-enterprise.js', array( 'jquery' ), $affiliates_version ); if ( !empty( $_REQUEST['campaign_id'] ) ) { $this->campaign_id = intval( $_REQUEST['campaign_id'] ); if ( $this->campaign_id <= 0 ) { $this->campaign_id = null; } } else { $this->campaign_id = null; } parent::render(); wp_localize_script( 'overview-controls', 'affiliates_overview_controls', array( 'pname' => get_option( 'aff_pname', AFFILIATES_PNAME ), 'cname' => Affiliates_Campaign::get_name(), 'site_url' => home_url(), 'affiliate_id' => affiliates_encode_affiliate_id( $this->get_affiliate_id() ) ) ); }

	protected function get_hits_query() { global $affiliates_db; $IX67218 = $affiliates_db->get_tablename( 'hits' ); $IX20425 = ''; if ( $this->campaign_id !== null ) { $IX20425 = sprintf( ' AND campaign_id = %d ', esc_sql( $this->campaign_id ) ); } return "SELECT COUNT(*) as hits, date FROM $IX67218 WHERE date >= %s AND date <= %s AND affiliate_id = %d " . $IX20425 . " GROUP BY date ORDER BY date "; }

	protected function get_visits_query() { global $affiliates_db; $IX37412 = $affiliates_db->get_tablename( 'hits' ); $IX16484 = ''; if ( $this->campaign_id !== null ) { $IX16484 = sprintf( ' AND campaign_id = %d ', esc_sql( $this->campaign_id ) ); } return "SELECT count(DISTINCT IP) visits, date FROM $IX37412 WHERE date >= %s AND date <= %s AND affiliate_id = %d " . $IX16484 . " GROUP BY date ORDER BY date"; }

	protected function get_referrals_query() { global $affiliates_db; $IX35448 = $affiliates_db->get_tablename( 'referrals' ); $IX75034 = ''; if ( $this->campaign_id !== null ) { $IX75034 = sprintf( ' AND campaign_id = %d ', esc_sql( $this->campaign_id ) ); } return "SELECT count(referral_id) referrals, date(datetime) date FROM $IX35448 WHERE status IN (%s,%s) AND date(datetime) >= %s AND date(datetime) <= %s AND affiliate_id = %d " . $IX75034 . " GROUP BY date ORDER BY date"; }

	protected function get_amounts_query() { global $affiliates_db; $IX64111 = $affiliates_db->get_tablename( 'referrals' ); $IX39024 = ''; if ( $this->campaign_id !== null ) { $IX39024 = sprintf( ' AND campaign_id = %d ', esc_sql( $this->campaign_id ) ); } return "SELECT sum(amount) amount, currency_id, date(datetime) date FROM $IX64111 WHERE status IN (%s,%s) AND date(datetime) >= %s AND date(datetime) <= %s AND affiliate_id = %d " . $IX39024 . " GROUP BY date, currency_id ORDER BY date"; }
}
Affiliates_Dashboard_Overview_Enterprise::init();
