<?php
/**
 * class-affiliates-dashboard-referrals-enterprise.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Referrals
 */
class Affiliates_Dashboard_Referrals_Enterprise extends Affiliates_Dashboard_Referrals {

	protected $campaign_id = null;

	protected static $defaults = array(
		'from_date'          => null,
		'thru_date'          => null,
		'per_page'           => self::PER_PAGE_DEFAULT,
		'status'             => array( AFFILIATES_REFERRAL_STATUS_ACCEPTED, AFFILIATES_REFERRAL_STATUS_CLOSED )
	);

	public function get_url( $params = array() ) { $IX72810 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX72810 = remove_query_arg( 'clear_filters', $IX72810 ); $IX72810 = remove_query_arg( 'apply_filters', $IX72810 ); foreach ( $this->url_parameters as $IX82898 ) { $IX72810 = remove_query_arg( $IX82898, $IX72810 ); $IX24710 = null; switch ( $IX82898 ) { case 'per_page' : $IX24710 = $this->get_per_page(); break; case 'from_date' : $IX24710 = $this->get_from_date(); break; case 'thru_date' : $IX24710 = $this->get_thru_date(); break; case 'orderby' : $IX24710 = $this->get_orderby(); break; case 'order' : $IX24710 = $this->get_sort_order(); break; case 'campaign_id' : $IX24710 = $this->get_campaign_id(); break; } if ( $IX24710 !== null ) { $IX72810 = add_query_arg( $IX82898, $IX24710, $IX72810 ); } } foreach ( $params as $IX16277 => $IX24710 ) { $IX72810 = remove_query_arg( $IX16277, $IX72810 ); if ( $IX24710 !== null ) { $IX72810 = add_query_arg( $IX16277, $IX24710, $IX72810 ); } } return $IX72810; }

	public function __construct( $params = array() ) { parent::__construct( $params ); $this->template = 'dashboard/referrals-enterprise.php'; $this->url_parameters[] = 'campaign_id'; }

	/**
	 * Returns the current campaign ID or null.
	 *
	 * @return int
	 */
	public function get_campaign_id() { return $this->campaign_id; }

	/**
	 * Returns campaigns related to the section's affiliate, key-value pairs: campaign_id => campaign name.
	 *
	 * @return string[int]
	 */
	public function get_campaigns() { $IX92412 = array(); $IX55108 = Affiliates_Campaign::get_campaigns( $this->get_affiliate_id() ); foreach ( $IX55108 as $IX62161 ) { $IX92412[$IX62161->campaign_id] = $IX62161->name; } return $IX92412; }

	public function render() { if ( !affiliates_user_is_affiliate( $this->user_id ) ) { return; } if ( isset( $_REQUEST['clear_filters'] ) ) { unset( $_REQUEST['campaign_id'] ); $this->campaign_id = null; } if ( !empty( $_REQUEST['campaign_id'] ) ) { $this->campaign_id = intval( $_REQUEST['campaign_id'] ); if ( $this->campaign_id <= 0 ) { $this->campaign_id = null; } } else { $this->campaign_id = null; } parent::render(); }

	protected function setup_query_filters( &$filters, &$filter_params ) { parent::setup_query_filters( $filters, $filter_params ); if ( $this->campaign_id !== null ) { $filters .= " AND r.campaign_id = %d "; $filter_params[] = intval( $this->campaign_id ); } }
}
Affiliates_Dashboard_Referrals_Enterprise::init();
