<?php
/**
 * class-affiliates-dashboard-traffic-enterprise.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Referrals
 */
class Affiliates_Dashboard_Traffic_Enterprise extends Affiliates_Dashboard_Traffic {

	protected $campaign_id = null;

	protected static $defaults = array(
		'from_date'          => null,
		'thru_date'          => null,
		'src_uri'            => null,
		'dest_uri'           => null,
		'min_referrals'      => null,
		'show_dates'         => true,
		'show_visits'        => true,
		'show_hits'          => true,
		'show_referrals'     => true,
		'show_src_uris'      => true,
		'show_dest_uris'     => true,
		'show_campaigns'     => true,
		'show_filters'       => true,
		'show_pagination'    => true,
		'src_uri_maxlength'  => self::MAXLENGTH_DEFAULT,
		'dest_uri_maxlength' => self::MAXLENGTH_DEFAULT,
		'per_page'           => self::PER_PAGE_DEFAULT,
		'status'             => array( AFFILIATES_REFERRAL_STATUS_ACCEPTED, AFFILIATES_REFERRAL_STATUS_CLOSED )
	);

	public function get_url( $params = array() ) { $IX90179 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX90179 = remove_query_arg( 'clear_filters', $IX90179 ); $IX90179 = remove_query_arg( 'apply_filters', $IX90179 ); foreach ( $this->url_parameters as $IX27432 ) { $IX90179 = remove_query_arg( $IX27432, $IX90179 ); $IX98623 = null; switch ( $IX27432 ) { case 'per_page' : $IX98623 = $this->get_per_page(); break; case 'from_date' : $IX98623 = $this->get_from_date(); break; case 'thru_date' : $IX98623 = $this->get_thru_date(); break; case 'src_uri' : $IX98623 = $this->get_src_uri(); break; case 'dest_uri' : $IX98623 = $this->get_dest_uri(); break; case 'min_referrals' : $IX98623 = $this->get_min_referrals(); break; case 'orderby' : $IX98623 = $this->get_orderby(); break; case 'order' : $IX98623 = $this->get_sort_order(); break; case 'campaign_id' : $IX98623 = $this->get_campaign_id(); break; } if ( $IX98623 !== null ) { $IX90179 = add_query_arg( $IX27432, $IX98623, $IX90179 ); } } foreach ( $params as $IX27410 => $IX98623 ) { $IX90179 = remove_query_arg( $IX27410, $IX90179 ); if ( $IX98623 !== null ) { $IX90179 = add_query_arg( $IX27410, $IX98623, $IX90179 ); } } return $IX90179; }

	public function __construct( $params = array() ) { parent::__construct( $params ); $this->template = 'dashboard/traffic-enterprise.php'; $this->url_parameters[] = 'campaign_id'; }

	/**
	 * Returns the current campaign ID or null.
	 *
	 * @return int
	 */
	public function get_campaign_id() { return $this->campaign_id; }

	/**
	 * Returns campaigns related to the section's affiliate, key-value pairs: campaign_id => campaign name.
	 *
	 * @return string[int]
	 */
	public function get_campaigns() { $IX32480 = array(); $IX21988 = Affiliates_Campaign::get_campaigns( $this->get_affiliate_id() ); foreach ( $IX21988 as $IX44244 ) { $IX32480[$IX44244->campaign_id] = $IX44244->name; } return $IX32480; }

	public function render() { if ( !affiliates_user_is_affiliate( $this->user_id ) ) { return; } if ( isset( $_REQUEST['clear_filters'] ) ) { unset( $_REQUEST['campaign_id'] ); $this->campaign_id = null; } if ( !empty( $_REQUEST['campaign_id'] ) ) { $this->campaign_id = intval( $_REQUEST['campaign_id'] ); if ( $this->campaign_id <= 0 ) { $this->campaign_id = null; } } else { $this->campaign_id = null; } parent::render(); }

	protected function setup_query_filters( &$filters, &$filter_params ) { parent::setup_query_filters( $filters, $filter_params ); if ( $this->campaign_id !== null ) { $filters .= " AND r.campaign_id = %d "; $filter_params[] = intval( $this->campaign_id ); } }
}
Affiliates_Dashboard_Traffic_Enterprise::init();
