<?php
/**
 * class-affiliates-campaign.php
 * 
 * Copyright 2015 "kento" Karim Rahimpur - www.itthinx.com
 * 
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 2.8.0
 */

/**
 * Campaign handling.
 */
class Affiliates_Campaign {

	protected static $pname = null;
	protected static $cname = null;
	protected static $url_renderer = null;
	protected static $affiliate_id_encoder = null;
	protected static $base_url = null;

	protected $campaign_id = null;
	protected $affiliate_id = null;
	protected $name = null;
	protected $description = null;
	protected $from_date = null;
	protected $thru_date = null;
	protected $type = null;
	protected $status = null;
	protected $hits = null;
	protected $visits = null;
	protected $referrals = null;
	protected $url = null;

	public function __construct( $o = null ) { self::initialize( $this, $o ); }

	private static function initialize( &$campaign, $o ) { if ( isset( $o->campaign_id ) ) { $campaign->campaign_id = $o->campaign_id; } if ( isset( $o->affiliate_id ) ) { $campaign->affiliate_id = $o->affiliate_id; } if ( isset( $o->name ) ) { $campaign->name = $o->name; } if ( isset( $o->description ) ) { $campaign->description = $o->description; } if ( isset( $o->from_date ) ) { $campaign->from_date = $o->from_date; } if ( isset( $o->thru_date ) ) { $campaign->thru_date = $o->thru_date; } if ( isset( $o->type ) ) { $campaign->type = $o->type; } if ( isset( $o->status ) ) { $campaign->status = $o->status; } }

	public function create() { global $affiliates_db; $IX46472 = null; if ( $this->campaign_id === null ) { if ( $this->affiliate_id !== null ) { $IX24172 = $affiliates_db->get_tablename( 'campaigns' ); if ( $affiliates_db->query( "INSERT INTO $IX24172 " . "SET affiliate_id = %d, name = %s, description = %s, from_date = %s, thru_date = %s, type = %s, status = %s", intval( $this->affiliate_id ), $this->name, $this->description, $this->from_date, $this->thru_date, $this->type, $this->status ) ) { $this->campaign_id = $affiliates_db->get_value( "SELECT LAST_INSERT_ID()" ); $IX46472 = $this->campaign_id; } } } return $IX46472; }

	public function read( $campaign_id ) { global $affiliates_db; $IX25023 = null; $IX93321 = $affiliates_db->get_tablename( 'campaigns' ); if ( $IX60289 = $affiliates_db->get_objects( "SELECT * FROM $IX93321 WHERE campaign_id = %d", intval( $campaign_id ) ) ) { if ( $IX62078 = array_shift( $IX60289 ) ) { self::initialize( $this, $IX62078 ); $IX25023 = $this; } } return $IX25023; }

	public function update() { global $affiliates_db; $IX68067 = false; if ( $this->campaign_id !== null ) { $IX60563 = $affiliates_db->get_tablename( 'campaigns' ); if ( $affiliates_db->query( "UPDATE $IX60563 " . "SET affiliate_id = %d, name = %s, description = %s, from_date = %s, thru_date = %s, type = %s, status = %s " . "WHERE campaign_id = %d", intval( $this->affiliate_id ), $this->name, $this->description, $this->from_date, $this->thru_date, $this->type, $this->status, intval( $this->campaign_id ) ) ) { $IX68067 = true; } } return $IX68067; }

	public function delete() { global $affiliates_db; $IX21965 = false; if ( $this->campaign_id !== null ) { $IX94607 = $affiliates_db->get_tablename( 'campaigns' ); if ( $affiliates_db->query( "DELETE FROM $IX94607 " . "WHERE campaign_id = %d", intval( $this->campaign_id ) ) ) { $IX21965 = true; } } return $IX21965; }

	public function get_hits( $from_date = null , $thru_date = null, $precise = false ) { global $affiliates_db; $IX24482 = $affiliates_db->get_tablename( 'hits' ); $IX40102 = 0; $IX23279 = " WHERE affiliate_id = %d AND campaign_id = %d "; $IX73751 = array( $this->affiliate_id, $this->campaign_id ); if ( $from_date ) { if ( $precise ) { $IX60141 = date( 'Y-m-d H:i:s', strtotime( $from_date ) ); } else { $from_date = date( 'Y-m-d', strtotime( $from_date ) ); } } if ( $thru_date ) { if ( $precise ) { $IX54850 = date( 'Y-m-d H:i:s', strtotime( $thru_date ) ); } else { $thru_date = date( 'Y-m-d', strtotime( $thru_date ) + 24*3600 ); } } if ( $from_date && $thru_date ) { if ( $precise ) { $IX23279 .= " AND datetime >= %s AND datetime < %s "; $IX73751[] = $IX60141; $IX73751[] = $IX54850; } else { $IX23279 .= " AND date >= %s AND date < %s "; $IX73751[] = $from_date; $IX73751[] = $thru_date; } } else if ( $from_date ) { if ( $precise ) { $IX23279 .= " AND datetime >= %s "; $IX73751[] = $IX60141; } else { $IX23279 .= " AND date >= %s "; $IX73751[] = $from_date; } } else if ( $thru_date ) { if ( $precise ) { $IX23279 .= " AND datetime < %s "; $IX73751[] = $IX54850; } else { $IX23279 .= " AND date < %s "; $IX73751[] = $thru_date; } } $IX40102 = intval( $affiliates_db->get_value( "SELECT COUNT(*) FROM $IX24482 $IX23279", $IX73751 ) ); return $IX40102; }

	public function get_visits( $from_date = null , $thru_date = null, $precise = false ) { global $affiliates_db; $IX77854 = $affiliates_db->get_tablename( 'hits' ); $IX80628 = 0; $IX70638 = " WHERE affiliate_id = %d AND campaign_id = %d "; $IX65002 = array( $this->affiliate_id, $this->campaign_id ); if ( $from_date ) { if ( $precise ) { $IX38868 = date( 'Y-m-d H:i:s', strtotime( $from_date ) ); } else { $from_date = date( 'Y-m-d', strtotime( $from_date ) ); } } if ( $thru_date ) { if ( $precise ) { $IX69336 = date( 'Y-m-d H:i:s', strtotime( $thru_date ) ); } else { $thru_date = date( 'Y-m-d', strtotime( $thru_date ) + 24*3600 ); } } if ( $from_date && $thru_date ) { if ( $precise ) { $IX70638 .= " AND datetime >= %s AND datetime < %s "; $IX65002[] = $IX38868; $IX65002[] = $IX69336; } else { $IX70638 .= " AND date >= %s AND date < %s "; $IX65002[] = $from_date; $IX65002[] = $thru_date; } } else if ( $from_date ) { if ( $precise ) { $IX70638 .= " AND datetime >= %s "; $IX65002[] = $IX38868; } else { $IX70638 .= " AND date >= %s "; $IX65002[] = $from_date; } } else if ( $thru_date ) { if ( $precise ) { $IX70638 .= " AND datetime < %s "; $IX65002[] = $IX69336; } else { $IX70638 .= " AND date < %s "; $IX65002[] = $thru_date; } } $IX80628 = intval( $affiliates_db->get_value( "SELECT SUM(visits) FROM " . "(SELECT count(DISTINCT IP) visits FROM $IX77854 $IX70638 GROUP BY DATE) tmp", $IX65002 ) ); return $IX80628; }

	function get_referrals( $from_date = null , $thru_date = null, $status = null, $precise = false ) { global $affiliates_db; $IX47224 = $affiliates_db->get_tablename( 'referrals' ); $IX15585 = 0; $IX72023 = " WHERE affiliate_id = %d AND campaign_id = %d "; $IX25599 = array( $this->affiliate_id, $this->campaign_id ); if ( $from_date ) { if ( $precise ) { $from_date = date( 'Y-m-d H:i:s', strtotime( $from_date ) ); } else { $from_date = date( 'Y-m-d', strtotime( $from_date ) ); } } if ( $thru_date ) { if ( $precise ) { $thru_date = date( 'Y-m-d H:i:s', strtotime( $thru_date ) ); } else { $thru_date = date( 'Y-m-d', strtotime( $thru_date ) + 24*3600 ); } } if ( $from_date && $thru_date ) { $IX72023 .= " AND datetime >= %s AND datetime < %s "; $IX25599[] = $from_date; $IX25599[] = $thru_date; } else if ( $from_date ) { $IX72023 .= " AND datetime >= %s "; $IX25599[] = $from_date; } else if ( $thru_date ) { $IX72023 .= " AND datetime < %s "; $IX25599[] = $thru_date; } if ( !empty( $status ) ) { $IX72023 .= " AND status = %s "; $IX25599[] = $status; } else { $IX72023 .= " AND status IN ( %s, %s ) "; $IX25599[] = AFFILIATES_REFERRAL_STATUS_ACCEPTED; $IX25599[] = AFFILIATES_REFERRAL_STATUS_CLOSED; } $IX15585 = intval( $affiliates_db->get_value( "SELECT count(*) FROM $IX47224 $IX72023", $IX25599 ) ); return $IX15585; }

	public function get_totals( $from_date = null , $thru_date = null, $status = null, $currency_id = null ) { global $affiliates_db; $IX30245 = $affiliates_db->get_tablename( 'referrals' ); $IX59198 = " WHERE affiliate_id = %d AND campaign_id = %d "; $IX34876 = array( $this->affiliate_id, $this->campaign_id ); if ( !empty( $currency_id ) ) { $IX59198 .= " AND currency_id = %s "; $IX34876[] = $currency_id; } if ( $from_date ) { $from_date = date( 'Y-m-d', strtotime( $from_date ) ); } if ( $thru_date ) { $thru_date = date( 'Y-m-d', strtotime( $thru_date ) + 24*3600 ); } if ( $from_date && $thru_date ) { $IX59198 .= " AND datetime >= %s AND datetime < %s "; $IX34876[] = $from_date; $IX34876[] = $thru_date; } else if ( $from_date ) { $IX59198 .= " AND datetime >= %s "; $IX34876[] = $from_date; } else if ( $thru_date ) { $IX59198 .= " AND datetime < %s "; $IX34876[] = $thru_date; } if ( !empty( $status ) ) { $IX59198 .= " AND status = %s "; $IX34876[] = $status; } else { $IX59198 .= " AND status IN ( %s, %s ) "; $IX34876[] = AFFILIATES_REFERRAL_STATUS_ACCEPTED; $IX34876[] = AFFILIATES_REFERRAL_STATUS_CLOSED; } $IX28447 = $affiliates_db->get_objects( "SELECT SUM(amount) total, currency_id FROM $IX30245
			$IX59198
			GROUP BY currency_id
			", $IX34876 ); if ( $IX28447 ) { $IX12305 = array(); foreach( $IX28447 as $IX86003 ) { if ( ( $IX86003->currency_id !== null ) && ( $IX86003->total !== null ) ) { $IX12305[$IX86003->currency_id] = $IX86003->total; } } return $IX12305; } else { return false; } }

	public function get_url( $options = array() ) { $IX58242 = self::$base_url; if ( !empty( $options['url'] ) ) { $IX58242 = $options['url'] ; } return Affiliates_Url_Renderer::get_affiliate_url( $IX58242, $this->affiliate_id, $this->campaign_id ); }

	public function __get( $name ) { $IX83146 = null; switch( $name ) { case 'campaign_id' : case 'affiliate_id' : case 'name' : case 'description' : case 'from_date' : case 'thru_date' : case 'type' : case 'status' : $IX83146 = $this->$name; break; case 'hits' : $IX83146 = $this->get_hits(); break; case 'visits' : $IX83146 = $this->get_visits(); break; case 'referrals' : $IX83146 = $this->get_referrals(); break; case 'totals' : $IX83146 = $this->get_totals(); break; case 'url' : $IX83146 = $this->get_url(); break; } return $IX83146; }

	public function __set( $name, $value ) { switch( $name ) { case 'campaign_id' : case 'affiliate_id' : case 'name' : case 'description' : case 'from_date' : case 'thru_date' : case 'type' : case 'status' : $this->$name = $value; break; } return $value; }

	public function to_array() { $IX11941 = array( 'campaign_id' => $this->campaign_id, 'affiliate_id' => $this->affiliate_id, 'name' => $this->name, 'description' => $this->description, 'from_date' => $this->from_date, 'thru_date' => $this->thru_date, 'type' => $this->type, 'status' => $this->status, 'hits' => $this->get_hits(), 'visits' => $this->get_visits(), 'referrals' => $this->get_referrals(), 'totals' => $this->get_totals() ); return $IX11941; }

	/**
	 * Class setup.
	 */
	public static function init() { }

	public static function is_affiliate_campaign( $affiliate_id, $campaign_id ) { return self::get_affiliate_campaign($affiliate_id, $campaign_id) !== null; }

	public static function get_affiliate_campaign( $affiliate_id, $campaign_id ) { global $affiliates_db; $IX74156 = null; $IX24639 = $affiliates_db->get_tablename( 'campaigns' ); if ( $IX51633 = $affiliates_db->get_objects( "SELECT * FROM $IX24639 WHERE campaign_id = %d AND affiliate_id = %d", intval( $campaign_id ), intval( $affiliate_id ) ) ) { if ( $IX51633 = array_shift( $IX51633 ) ) { $IX74156 = new Affiliates_Campaign( $IX51633 ); } } return $IX74156; }

	public static function get_campaigns( $affiliate_id = null, $params = array() ) { global $affiliates_db; $IX83112 = null; if ( isset( $params['limit'] ) ) { $IX83112 = intval( $params['limit'] ); if ( $IX83112 < 0 ) { $IX83112 = null; } } $IX60316 = null; if ( isset( $params['offset'] ) ) { $IX60316 = intval( $params['offset'] ); if ( $IX60316 < 0 ) { $IX60316 = null; } } $IX46578 = ''; if ( $IX83112 !== null ) { $IX46578 .= ' LIMIT ' . $IX83112; } if ( $IX60316 !== null ) { $IX46578 .= ' OFFSET ' . $IX60316; } $IX22082 = $affiliates_db->get_tablename( 'campaigns' ); $IX25930 = array(); if ( empty( $affiliate_id ) ) { $IX34816 = $affiliates_db->get_objects( "SELECT * FROM $IX22082 " . $IX46578 ); } else if ( is_array( $affiliate_id ) ) { if ( count( $affiliate_id ) > 0 ) { $IX75646 = array_map( 'intval', implode(',', $affiliate_id ) ); $IX34816 = $affiliates_db->get_objects( "SELECT * FROM $IX22082 WHERE affiliate_id IN (" . $IX75646 . ")" . $IX46578 ); } } else { $IX34816 = $affiliates_db->get_objects( "SELECT * FROM $IX22082 WHERE affiliate_id = %d" . $IX46578, intval( $affiliate_id ) ); } foreach( $IX34816 as $IX19219 ) { $IX25930[] = new Affiliates_Campaign( $IX19219 ); } return $IX25930; }

	public static function evaluate( $cmid, $affiliate_id, &$request = null ) { $cmid = trim( $cmid ); $cmid = strtolower( $cmid ); if ( !self::is_affiliate_campaign( $affiliate_id, $cmid ) ) { $cmid = null; } return $cmid; }

	/**
	 * Sets the pname of the campaign.
	 *
	 * @param string $pname
	 */
	public static function set_pname( $pname ) { self::$pname = $pname; }

	/**
	 * Returns the pname of the campaign.
	 *
	 * @param string $pname
	 */
	public static function get_pname() { return self::$pname; }

	/**
	 * Sets the cname of the campaign.
	 *
	 * @param string $cname
	 */
	public static function set_cname( $cname ) { self::$cname = $cname; }

	/**
	 * Returns the cname of the campaign.
	 *
	 * @param string $pname
	 */
	public static function get_cname() { return self::$cname; }

	/**
	 * Returns the name of the campaign.
	 *
	 * @param string $pname
	 */
	public static function get_name() { return self::$cname; }

	/**
	 * Sets the URL renderer.
	 *
	 * @param object $o
	 */
	public static function set_url_renderer( $o ) { self::$url_renderer = $o; }

	/**
	 * Returns the URL renderer.
	 *
	 * @return object
	 */
	public static function get_url_renderer() { return self::$url_renderer; }

	/**
	 * Sets the ID encoder.
	 *
	 * @param object $encoder
	 */
	public static function set_affiliate_id_encoder( $encoder ) { self::$affiliate_id_encoder = $encoder; }

	/**
	 * Returns the ID encoder.
	 *
	 * @return object
	 */
	public static function get_affiliate_id_encoder() { return self::$affiliate_id_encoder; }

	/**
	 * Sets the base URL.
	 *
	 * @param string $url
	 */
	public static function set_base_url( $url ) { self::$base_url = $url; }

	/**
	 * Returns the base URL.
	 *
	 * @return string
	 */
	public static function get_base_url() { return self::$base_url; }
}
Affiliates_Campaign::init();
