<?php
/**
 * class-affiliates-enterprise-shortcodes.php
 * 
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 2.4.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Enterprise-specific shortcodes.
 */
class Affiliates_Enterprise_Shortcodes {

	/**
	 * Add shortcodes.
	 */
	public static function init() { add_shortcode( 'affiliates_tiers', array( __CLASS__, 'affiliates_tiers' ) ); add_shortcode( 'affiliates_campaigns', array( __CLASS__, 'affiliates_campaigns' ) ); add_shortcode( 'affiliates_manage_campaigns', array( __CLASS__, 'affiliates_manage_campaigns' ) ); add_shortcode( 'affiliates_pixel', array( __CLASS__, 'affiliates_pixel' ) ); }

	/**
	 * Renders tiers.
	 * @param array $atts
	 * @param string $content not used
	 */
	public static function affiliates_tiers( $atts, $content = null ) { $IX29620 = shortcode_atts( array( 'link_to_user_url' => 'no', 'show_depth_title' => 'no', 'depth_title' => __( 'Depth %d', 'affiliates' ), 'show_avatar' => 'yes', 'avatar_size' => 32, 'style' => '<style type="text/css">.branch {padding-left:1em;margin-right:1em;} .branch img.avatar {vertical-align:middle;padding:4px;}</style>', 'max_depth' => null, 'show_from_date' => 'no', 'show_thru_date' => 'no', 'since' => __( 'since %s', 'affiliates' ), 'until' => __( 'until %s', 'affiliates' ), 'show_email' => 'no', 'before_referrals' => '', 'after_referrals' => '', 'closed' => 'yes', 'accepted' => 'yes', 'pending' => 'no', 'rejected' => 'no' ), $atts ); $IX66769 = $IX29620['max_depth']; if ( $IX66769 !== null ) { $IX66769 = intval( $IX66769 ); if ( $IX66769 <= 0 ) { $IX66769 = null; } } $IX29620['max_depth'] = $IX66769; $IX29620['link_to_user_url'] = $IX29620['link_to_user_url'] === 'yes'; $IX29620['show_depth_title'] = $IX29620['show_depth_title'] === 'yes'; $IX29620['show_avatar'] = $IX29620['show_avatar'] === 'yes'; $IX29620['show_from_date'] = $IX29620['show_from_date'] === 'yes'; $IX29620['show_thru_date'] = $IX29620['show_thru_date'] === 'yes'; $IX29620['show_email'] = $IX29620['show_email'] === 'yes'; $IX29620['accepted'] = $IX29620['accepted'] === 'yes'; $IX29620['closed'] = $IX29620['closed'] === 'yes'; $IX29620['pending'] = $IX29620['pending'] === 'yes'; $IX29620['rejected'] = $IX29620['rejected'] === 'yes'; $IX11148 = ''; if ( $IX21065 = get_current_user_id() ) { if ( $IX71440 = affiliates_get_user_affiliate( $IX21065 ) ) { if ( count( $IX71440 ) > 0 ) { Affiliates_Multi_Tier::get_tree( $IX71440, $IX18718 ); self::render_tree( $IX71440, $IX18718, $IX11148, $IX66769, 0, $IX29620 ); } } } $IX11148 = apply_filters( 'affiliates_tiers_output', $IX11148 ); return $IX11148; }

	public static function render_tree( $base_affiliate_ids, &$tree, &$output, $max_depth = null, $depth = 0, $options = array() ) { global $affiliates_db; $IX58690 = $affiliates_db->get_tablename( 'referrals' ); $options = shortcode_atts( array( 'link_to_user_url' => false, 'show_depth_title' => false, 'depth_title' => __( 'Depth %d', 'affiliates' ), 'show_avatar' => true, 'avatar_size' => 32, 'style' => '.branch {padding-left:1em;margin-right:1em;} .branch img.avatar {vertical-align:middle;padding:4px;}', 'show_from_date' => false, 'show_thru_date' => false, 'since' => __( 'since %s', 'affiliates' ), 'until' => __( 'until %s', 'affiliates' ), 'show_email' => false, 'before_referrals' => '', 'after_referrals' => '', 'accepted' => true, 'closed' => true, 'pending' => false, 'rejected' => false ), $options ); $IX54744 = array(); if ( $options['accepted'] ) { $IX54744[] = "'" . AFFILIATES_REFERRAL_STATUS_ACCEPTED . "'"; } if ( $options['closed'] ) { $IX54744[] = "'" . AFFILIATES_REFERRAL_STATUS_CLOSED . "'"; } if ( $options['pending'] ) { $IX54744[] = "'" . AFFILIATES_REFERRAL_STATUS_PENDING . "'"; } if ( $options['rejected'] ) { $IX54744[] = "'" . AFFILIATES_REFERRAL_STATUS_REJECTED . "'"; } if ( count( $IX54744 ) > 0 ) { $IX54744 = implode( ',', $IX54744 ); } else { return; } if ( !empty( $options['style'] ) ) { $output .= '<style type="text/css">'; $output .= $options['style']; $output .= '</style>'; } $output .= sprintf( '<div class="depth depth-%d %s">', $depth, $depth % 2 ? 'odd' : 'even' ); if ( $options['show_depth_title'] && $depth > 0 ) { $output .= '<span class="title">'; $output .= sprintf( $options['depth_title'], $depth ); $output .= '</span>'; } $output .= '<ul class="branch">'; foreach( $tree as $IX53464 => $IX62527 ) { $output .= '<li>'; $IX25947 = affiliates_get_affiliate( $IX53464 ); if ( $IX25947 ) { $IX14226 = affiliates_get_affiliate_user( $IX53464 ); $output .= '<div class="affiliate">'; if ( $options['show_avatar'] ) { $IX31002 = ''; $IX41042 = intval( $options['avatar_size'] ); if ( $IX14226 ) { $IX31002 = get_avatar( $IX14226, $IX41042 ); } else if ( !empty( $IX25947['email'] ) ) { $IX31002 = get_avatar( $IX25947['email'], $IX41042 ); } $output .= $IX31002; } if ( $options['link_to_user_url'] && ( $IX40480 = get_user_by( 'id', $IX14226 ) ) && !empty( $IX40480->user_url ) ) { $output .= sprintf( '<a href="%s" title="%s">%s</a>', esc_attr( $IX40480->user_url ), sprintf( __( 'Visit %s\'s website', 'affiliates' ), wp_filter_nohtml_kses( $IX25947['name'] ) ), wp_filter_nohtml_kses( $IX25947['name'] ) ); } else { $output .= wp_filter_nohtml_kses( $IX25947['name'] ); } $output .= '</div>'; if ( $options['show_email'] && !empty( $IX25947['email'] ) ) { $output .= '<div class="email">'; $output .= sprintf( '<a href="mailto:%s">', esc_attr( $IX25947['email'] ) ); $output .= wp_strip_all_tags( $IX25947['email'] ); $output .= '</a>'; $output .= '</div>'; } if ( $options['show_from_date'] ) { $output .= '<div class="from_date">'; $output .= sprintf( $options['since'], date_i18n( get_option( 'date_format' ), strtotime( $IX25947['from_date'] ) ) ); $output .= '</div>'; } if ( $options['show_thru_date'] ) { if ( $IX25947['thru_date'] ) { $output .= '<div class="thru_date">'; $output .= sprintf( $options['until'], date_i18n( get_option( 'date_format' ), strtotime( $IX25947['thru_date'] ) ) ); $output .= '</div>'; } } if ( count( $base_affiliate_ids ) === 1 ) { $IX52458 = "SELECT sum(amount) total, currency_id FROM $IX58690 " . "WHERE affiliate_id = %d " . "AND status IN ($IX54744) " . "AND IFNULL(reference,post_id) IN " . "(SELECT IFNULL(reference,post_id) FROM $IX58690 WHERE affiliate_id = %d) " . "AND data LIKE '%%tier_level%%\"value\";i:%d%%' " . "GROUP BY currency_id"; $IX16963 = $affiliates_db->get_objects( $IX52458, intval( $base_affiliate_ids[0] ), intval( $IX53464 ), intval( $depth ) ); if ( count( $IX16963 ) > 0 ) { $output .= '<div class="referrals">'; $output .= stripslashes( wp_filter_kses( $options['before_referrals'] ) ); $output .= '<ul>'; foreach( $IX16963 as $IX10289 ) { $output .= '<li>' . sprintf( __( '%s %s', 'affiliates' ), $IX10289->total, $IX10289->currency_id ) . '</li>'; } $output .= '</ul>'; $output .= stripslashes( wp_filter_kses( $options['after_referrals'] ) ); $output .= '</div>'; } } } if ( !empty( $IX62527 ) ) { if ( $max_depth === null || $max_depth > 0 ) { if ( $depth === 0 ) { $IX69915 = array( $IX53464 ); } else { $IX69915 = $base_affiliate_ids; } self::render_tree( $IX69915, $IX62527, $output, $max_depth === null ? null : $max_depth - 1, $depth + 1, $options ); } } $output .= '</li>'; } $output .= '</ul>'; $output .= '</div>'; }

	/**
	 * Renders the campaign report and management form for an affiliate.
	 * @param array $atts
	 * @param string $content not used
	 */
	public static function affiliates_campaigns( $atts, $content = null ) { $IX77882 = shortcode_atts( array( 'style' => '<style type="text/css">.branch {padding-left:1em;margin-right:1em;}</style>', 'show_from_date' => 'no', 'show_thru_date' => 'no', 'since' => __( 'since %s', 'affiliates' ), 'until' => __( 'until %s', 'affiliates' ), 'show_email' => 'no', 'closed' => 'yes', 'accepted' => 'yes', 'pending' => 'no', 'rejected' => 'no' ), $atts ); $IX77882['show_from_date'] = $IX77882['show_from_date'] === 'yes'; $IX77882['show_thru_date'] = $IX77882['show_thru_date'] === 'yes'; $IX77882['accepted'] = $IX77882['accepted'] === 'yes'; $IX77882['closed'] = $IX77882['closed'] === 'yes'; $IX77882['pending'] = $IX77882['pending'] === 'yes'; $IX77882['rejected'] = $IX77882['rejected'] === 'yes'; $IX80817 = ''; if ( $IX63559 = get_current_user_id() ) { if ( $IX40793 = affiliates_get_user_affiliate( $IX63559 ) ) { if ( $IX81275 = array_shift( $IX40793 ) ) { $IX91779 = Affiliates_Campaign::get_campaigns( $IX81275 ); if ( count( $IX91779 ) > 0 ) { $IX80817 .= '<div class="affiliates-campaigns">'; $IX80817 .= '<table>'; $IX80817 .= '<thead>'; $IX80817 .= '<tr>'; $IX80817 .= '<th>' . __( 'ID', 'affiliates' ) . '</th>'; $IX80817 .= '<th>' . __( 'Name', 'affiliates' ) . '</th>'; $IX80817 .= '<th>' . __( 'Hits', 'affiliates' ) . '</th>'; $IX80817 .= '<th>' . __( 'Visits', 'affiliates' ) . '</th>'; $IX80817 .= '<th>' . __( 'Referrals', 'affiliates' ) . '</th>'; $IX80817 .= '<th>' . __( 'Total', 'affiliates' ) . '</th>'; $IX80817 .= '</tr>'; $IX80817 .= '</thead>'; $IX80817 .= '<tbody>'; foreach( $IX91779 as $IX64024 ) { $IX80817 .= '<tr>'; $IX97674 = ''; $IX80686 = $IX64024->totals; if ( !empty( $IX80686) ) { $IX58144 = count( $IX80686 ) > 1; $IX97674 .= $IX58144 ? '<ul>' : ''; foreach( $IX80686 as $IX66258 => $IX87513 ) { $IX97674 .= $IX58144 ? '<li>' : ''; $IX97674 .= sprintf( __( '%1$s %2$s', 'affiliates' ), $IX66258, $IX87513 ); $IX97674 .= $IX58144 ? '</li>' : ''; } $IX97674 .= $IX58144 ? '</ul>' : ''; } $IX80817 .= sprintf( '<td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td>', $IX64024->campaign_id, stripslashes( $IX64024->name ), $IX64024->hits, $IX64024->visits, $IX64024->referrals, $IX97674 ); $IX80817 .= '</tr>'; } $IX80817 .= '</tbody>'; $IX80817 .= '</table>'; $IX80817 .= '</div>'; } else { $IX80817 .= '<div class="affiliates-campaigns no-campaigns">'; $IX80817 .= __( 'There are no campaigns.', 'affiliates' ); $IX80817 .= '</div>'; } } } } $IX80817 = apply_filters( 'affiliates_campaigns_output', $IX80817 ); return $IX80817; }

	/**
	 * Renders the campaign management form for an affiliate.
	 * @param array $atts allows to specify 'columns'
	 * @param string $content not used
	 */
	public static function affiliates_manage_campaigns( $atts, $content = null ) { $IX19637 = ''; if ( $IX93575 = get_current_user_id() ) { if ( $IX88134 = affiliates_get_user_affiliate( $IX93575 ) ) { if ( $IX40394 = array_shift( $IX88134 ) ) { ob_start(); $IX45883 = array( 'affiliate_id' => $IX40394 ); if ( isset( $atts['columns'] ) ) { $IX45883['columns'] = $atts['columns']; } Affiliates_Campaign_Table::render( $IX45883 ); return ob_get_clean(); } } } $IX19637 = apply_filters( 'affiliates_manage_campaigns_output', $IX19637 ); return $IX19637; }

	/**
	 * Affiliates tracking pixel shortcode handler.
	 * 
	 * @param array $atts
	 * @param string $content
	 */
	public static function affiliates_pixel( $atts, $content = null ) { $atts = shortcode_atts( array( 'type' => 'image' ), $atts ); $IX67502 = ''; if ( $IX82403 = get_current_user_id() ) { if ( $IX59129 = affiliates_get_user_affiliate( $IX82403 ) ) { if ( $IX30272 = array_shift( $IX59129 ) ) { $IX89270 = get_option( 'aff_pname', AFFILIATES_PNAME ); $IX76303 = new Affiliates_Pixel( home_url(), $IX89270 ); $IX30048 = true; $IX47967 = get_headers( $IX76303->get_pixel_url() ); foreach( $IX47967 as $IX37215 ) { if ( stripos( $IX37215, '200 OK' ) !== false ) { $IX30048 = false; break; } } $IX76303->parametric = $IX30048; $IX85954 = Affiliates_Url_Renderer::get_affiliate_url( $IX76303->get_pixel_url(), $IX30272 ); switch( $atts['type'] ) { case 'img' : case 'image' : $IX67502 .= sprintf( '&lt;img src="%s" alt="" width="1" height="1" /&gt;', esc_url( $IX85954 ) ); break; default : $IX67502 .= sprintf( '&lt;iframe src="%s" scrolling="no" frameborder="0" width="1" height="1"&gt;&lt;/iframe&gt;', esc_url( $IX85954 ) ); } } } } $IX67502 = apply_filters( 'affiliates_pixel', $IX67502, $atts ); return $IX67502; }
}
Affiliates_Enterprise_Shortcodes::init();
