<?php
/**
 * class-affiliates-pixel.php
 *
 * Copyright 2015 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 2.11.0
 */

/**
 * Pixel tracking.
 */
class Affiliates_Pixel {

	private $home = null;
	private $pname = null;
	private $parametric = false;
	const FLAG = 1;

	public function __construct( $home, $pname ) { $home = rtrim( $home, '/\\' ) . '/'; $this->home = $home; $this->pname = $pname; }

	public function __set( $name, $value ) { switch( $name ) { case 'home' : case 'pname' : $this->$name = $value; break; case 'parametric' : $this->parametric = (bool) $value; break; } }

	public function __get( $name ) { switch( $name ) { case 'home' : case 'pname' : case 'parametric' : return $this->$name; break; default : return null; } }

	public function get_pixel_url() { if ( !$this->parametric ) { $IX25342 = $this->home . $this->get_pixel_name(); } else { $IX25342 = add_query_arg( array( str_replace( '.', '_', $this->get_pixel_name() ) => self::FLAG ), $this->home ); } return $IX25342; }

	public function get_pixel_name() { return $this->pname . '.png'; }

	public function is_pixel_request( $url ) { $IX99921 = str_replace( '.', '_', $this->get_pixel_name() ); if ( isset( $_REQUEST[$IX99921] ) && ( $_REQUEST[$IX99921] == self::FLAG ) ) { $IX70876 = true; } else { $IX12729 = parse_url( $url ); $IX96145 = parse_url( $this->home ); $IX77555 = str_replace( $IX96145['path'], '', $IX12729['path'] ); $IX70876 = $IX77555 == $this->get_pixel_name(); } return $IX70876; }

	public function pixel() { header( 'Content-Type: image/png' ); header( 'Pragma: no-cache'); header( 'Cache-Control: no-cache, no-store' ); header( 'Expires: 0'); if ( $IX87747 = @file_get_contents( AFFILIATES_PLUGIN_URL . '/images/pixel.png' ) ) { die( $IX87747 ); } }

	/**
	 * Initializer.
	 */
	public static function init() { }
}
Affiliates_Pixel::init();
