<?php
/**
 * class-affiliates-campaigns-wordpress.php
 *
 * Copyright (c) 2015 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 2.8.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

if ( !class_exists( 'WP_Screen' ) ) {
	include_once(ABSPATH . 'wp-admin/includes/class-wp-screen.php');
	require_once ABSPATH . 'wp-admin/includes/screen.php';
}
if ( !function_exists( 'convert_to_screen' ) ) {
	require_once ABSPATH . 'wp-admin/includes/template.php';
}
if( !class_exists( 'WP_List_Table' ) ){
	require_once ABSPATH . 'wp-admin/includes/class-wp-list-table.php';
}

/**
 * Extends WP_List_Table for campaigns.
 */
class Affiliates_Campaign_Table extends WP_List_Table {

	const ACTION = 'manage';
	const NONCE  = 'campaign-table-nonce';

	private $affiliate_id = null;

	private $show_campaign_columns = array();

	const MAX_DESCRIPTION = 5000;

	/**
	 * Constructor.
	 */
	function __construct( $args = array() ){ global $status, $page; if ( isset( $args['affiliate_id'] ) ) { $this->affiliate_id = $args['affiliate_id']; } if ( isset( $args['columns'] ) ) { $IX72389 = $args['columns']; if ( is_string( $IX72389 ) ) { $IX72389 = str_replace( ' ', ',', $IX72389 ); $IX72389 = explode( ',', $IX72389 ); } if ( is_array( $IX72389 ) ) { foreach ( $IX72389 as $IX93269 ) { $IX93269 = trim( strtolower( $IX93269 ) ); if ( strlen( $IX93269 ) > 0 ) { switch( $IX93269 ) { case 'cb' : case 'affiliate_id' : case 'campaign_id' : case 'name' : case 'description' : case 'from_date' : case 'thru_date' : case 'type' : case 'status' : case 'hits' : case 'visits' : case 'referrals' : case 'totals' : case 'url' : case 'actions' : $this->show_campaign_columns[] = $IX93269; break; } } } } } parent::__construct( array( 'singular' => 'campaign', 'plural' => 'campaigns', 'ajax' => false, 'screen' => 'manage-campaigns' ) ); if ( !is_admin() ) { wp_enqueue_script( 'affiliates-campaigns' ); } wp_enqueue_style( 'affiliates-campaigns' ); }

	function column_default( $item, $column_name ){ $IX72917 = ''; switch( $column_name ) { case 'affiliate_id' : if ( $IX58625 = affiliates_get_affiliate( $item[$column_name] ) ) { $IX72917 = stripslashes( wp_filter_nohtml_kses( $IX58625['name'] ) ); } break; case 'campaign_id' : case 'name' : case 'description' : case 'from_date' : case 'thru_date' : case 'type' : case 'status' : case 'hits' : case 'visits' : case 'referrals' : $IX72917 = stripslashes( $item[$column_name] ); break; case 'totals' : $IX59876 = ''; $IX72852 = $item['totals']; if ( !empty( $IX72852) ) { $IX99998 = count( $IX72852 ) > 1; $IX59876 .= $IX99998 ? '<ul>' : ''; foreach( $IX72852 as $IX74537 => $IX39510 ) { $IX59876 .= $IX99998 ? '<li>' : ''; $IX59876 .= sprintf( __( '%1$s %2$s', 'affiliates' ), $IX74537, $IX39510 ); $IX59876 .= $IX99998 ? '</li>' : ''; } $IX59876 .= $IX99998 ? '</ul>' : ''; } $IX72917 = $IX59876; break; case 'url' : $IX46083 = $item['campaign']->get_url(); $IX72917 = htmlentities( $IX46083 ); break; case 'actions' : $IX47278 = self::current_url_clean(); printf( "<a class='button action' title='%s' href='%s'>%s</a>", esc_attr( __( 'Edit this campaign', 'affiliates' ) ), esc_url( wp_nonce_url( add_query_arg( array( 'campaign_id' => $item['campaign_id'], 'action' => 'edit-campaign' ), $IX47278 ), self::ACTION, self::NONCE ) ), __( 'Edit', 'affiliates' ) ); break; default : if ( is_string( $item[$column_name] ) ) { $IX72917 = wp_strip_all_tags( $item[$column_name] ); } } return $IX72917; }

	function column_cb( $item ){ $IX70551 = ''; $IX62131 = new Affiliates_Campaign(); if ( $IX62131->read( $item['campaign_id'] ) ) { if ( $IX62131->hits || $IX62131->referrals ) { $IX70551 = ' disabled="disabled" '; } } return sprintf( '<input class="campaign-cb" type="checkbox" name="_campaign_id[]" value="%d" %s />', intval( $item['campaign_id'] ), $IX70551 ); }

	function get_columns(){ $IX14347 = array( 'cb' => '<input type="checkbox" />', 'campaign_id' => __( 'ID', 'affiliates' ), 'affiliate_id' => __( 'Affiliate', 'affiliates' ), 'name' => __( 'Name', 'affiliates' ), 'description' => __( 'Description', 'affiliates' ), 'hits' => __( 'Hits', 'affiliates' ), 'visits' => __( 'Visits', 'affiliates' ), 'referrals' => __( 'Referrals', 'affiliates' ), 'totals' => __( 'Totals', 'affiliates' ), 'url' => __( 'URL', 'affiliates' ), 'actions' => '' ); if ( isset( $this->affiliate_id ) ) { unset( $IX14347['affiliate_id'] ); } if ( count( $this->show_campaign_columns ) > 0 ) { $IX41637 = array(); foreach ( $IX14347 as $IX15248 => $IX59667 ) { if ( in_array( $IX15248, $this->show_campaign_columns ) ) { $IX41637[$IX15248] = $IX59667; } } $IX14347 = $IX41637; } return $IX14347; }

	function get_sortable_columns() { $IX36770 = array( 'campaign_id' => array( 'campaign_id', false ), 'affiliate_id' => array( 'affiliate_id', false ), 'name' => array( 'name', false ), 'description' => array( 'description', false ) ); if ( isset( $this->affiliate_id ) ) { unset( $IX36770['affiliate_id'] ); } return $IX36770; }

	function get_bulk_actions() { $IX44757 = array( 'delete' => __( 'Delete', 'affiliates' ) ); return $IX44757; }

	function process_bulk_action() { if ( isset( $_REQUEST['_wpnonce'] ) && wp_verify_nonce( $_REQUEST['_wpnonce'], 'bulk-campaigns' ) ) { $IX75399 = $this->current_action(); switch( $IX75399 ) { case 'delete' : if ( !empty( $_REQUEST['_campaign_id'] ) ) { $IX81157 = $_REQUEST['_campaign_id']; $IX15052 = Affiliates_Affiliate_WordPress::get_user_affiliate_id(); if ( is_array( $IX81157 ) ) { foreach( $IX81157 as $IX37145 ) { if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) || Affiliates_Campaign::is_affiliate_campaign( $IX15052, $IX37145 ) ) { $IX39719 = new Affiliates_Campaign(); if ( $IX39719->read( $IX37145 ) ) { if ( $IX39719->hits || $IX39719->referrals ) { } else { $IX39719->delete(); } } } } } } break; } } }

	public function extra_tablenav( $which ) { if ( $which === 'top' ) { if ( isset( $_REQUEST['affiliates-dashboard-section'] ) ) { printf( '<input type="hidden" name="affiliates-dashboard-section" value="%s"/>', esc_attr( $_REQUEST['affiliates-dashboard-section'] ) ); } if ( isset( $_REQUEST['management'] ) ) { printf( '<input type="hidden" name="management" value="%s"/>', esc_attr( $_REQUEST['management'] ) ); } } }

	function prepare_items() { global $wpdb; $IX64458 = 10; $IX33700 = $this->get_columns(); $IX95895 = array(); $IX77835 = $this->get_sortable_columns(); $this->_column_headers = array ($IX33700, $IX95895, $IX77835 ); $this->process_bulk_action(); $IX44789 = Affiliates_Campaign::get_campaigns( $this->affiliate_id ); $IX61902 = array(); $IX61800 = 0; foreach( $IX44789 as $IX28842 ) { $IX61902[] = $IX28842->to_array(); $IX61902[$IX61800]['campaign'] = $IX28842; $IX61800++; } if ( !empty( $IX61902 ) ) { usort( $IX61902, array( __CLASS__, 'sort' ) ); } $IX84812 = $this->get_pagenum(); $IX37530 = count( $IX61902 ); $IX61902 = array_slice( $IX61902, ( ( $IX84812 - 1 ) * $IX64458 ), $IX64458 ); $this->items = $IX61902; $this->set_pagination_args( array( 'total_items' => $IX37530, 'per_page' => $IX64458, 'total_pages' => ceil( $IX37530 / $IX64458 ) ) ); }

	public static function sort( $item1, $item2 ) { $IX34531 = !empty( $_REQUEST['orderby'] ) ? $_REQUEST['orderby'] : 'campaign_id'; $IX47094 = strtolower( !empty($_REQUEST['order'] ) ? $_REQUEST['order'] : 'asc' ); $IX94732 = 0; if ( $IX34531 == 'campaign_id' ) { $IX94732 = $item1[$IX34531] - $item2[$IX34531]; } else if ( $IX34531 == 'affiliate_id' ) { $IX24936 = affiliates_get_affiliate($item1[$IX34531]); $IX25237 = affiliates_get_affiliate($item2[$IX34531]); $IX94732 = strcmp( $IX24936['name'], $IX25237['name'] ); } else { $IX94732 = strcmp( isset( $item1[$IX34531] ) ? $item1[$IX34531] : '', isset( $item2[$IX34531] ) ? $item2[$IX34531] : '' ); } return ( $IX47094 === 'asc') ? $IX94732 : -$IX94732; }

	public static function render( $options = array() ) { global $wpdb; $IX77632 = false; if ( isset( $_REQUEST['campaign-action'] ) || isset( $_REQUEST['campaign-action'] ) ) { if ( wp_verify_nonce( $_REQUEST[self::NONCE], self::ACTION ) ) { if ( isset( $_REQUEST['action'] ) ) { switch( $_REQUEST['action'] ) { case 'create-campaign' : $IX47805 = !empty( $_REQUEST['affiliate_id'] ) ? intval( $_REQUEST['affiliate_id'] ) : null; if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) || ( ( $IX47805 !== null ) && ( $IX47805 == Affiliates_Affiliate_WordPress::get_user_affiliate_id() ) ) ) { $IX81467 = !empty( $_REQUEST['campaign_name'] ) ? wp_strip_all_tags( trim( $_REQUEST['campaign_name'] ) ) : ''; $IX19486 = !empty( $_REQUEST['campaign_description'] ) ? substr( wp_strip_all_tags( trim( $_REQUEST['campaign_description'] ) ), 0, self::MAX_DESCRIPTION ) : ''; $IX97344 = new Affiliates_Campaign( (object) array( 'affiliate_id' => $IX47805, 'name' => $IX81467, 'description' => $IX19486 ) ); if ( $IX97344->create() ) { $IX77632 = true; echo '<div class="updated">'; echo __( 'Campaign created.', 'affiliates' ); echo '</div>'; } else { echo '<div class="error">'; echo __( 'Campaign could not be created.', 'affiliates' ); echo '</div>'; } } else { wp_die( __( 'Access denied.', 'affiliates' ) ); } break; case 'edit-campaign' : $IX47805 = !empty( $_REQUEST['affiliate_id'] ) ? intval( $_REQUEST['affiliate_id'] ) : null; $IX53861 = !empty( $_REQUEST['campaign_id'] ) ? intval( $_REQUEST['campaign_id'] ) : null; if ( !empty( $IX53861 ) ) { $IX97344 = new Affiliates_Campaign(); if ( $IX97344->read( $IX53861 ) ) { if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) || ( ( $IX47805 !== null ) && ( $IX47805 == Affiliates_Affiliate_WordPress::get_user_affiliate_id() ) && Affiliates_Campaign::is_affiliate_campaign( $IX47805, $IX53861 ) ) ) { $IX81467 = !empty( $_REQUEST['campaign_name'] ) ? wp_strip_all_tags( trim( $_REQUEST['campaign_name'] ) ) : ''; $IX19486 = !empty( $_REQUEST['campaign_description'] ) ? substr( wp_strip_all_tags( trim( $_REQUEST['campaign_description'] ) ), 0, self::MAX_DESCRIPTION ) : ''; $IX97344->name = $IX81467; $IX97344->description = $IX19486; if ( $IX97344->update() ) { $IX77632 = true; echo '<div class="updated">'; echo __( 'Campaign updated.', 'affiliates' ); echo '</div>'; } else { if ( ( $wpdb->rows_affected === 0 ) && ( $wpdb->last_error === "" ) ) { $IX77632 = true; } else { echo '<div class="error">'; echo __( 'Campaign could not be updated.', 'affiliates' ); echo '</div>'; } } } else { wp_die( __( 'Access denied.', 'affiliates' ) ); } } } break; } } } } $IX47805 = isset( $options['affiliate_id'] ) ? intval( $options['affiliate_id'] ) : null; $IX60632 = false; $IX48720 = false; if ( !$IX77632 ) { if ( isset( $_REQUEST['action'] ) && isset( $_REQUEST[self::NONCE] ) && wp_verify_nonce( $_REQUEST[self::NONCE], self::ACTION ) ) { $IX53861 = isset( $_REQUEST['campaign_id'] ) ? intval( $_REQUEST['campaign_id'] ) : null; switch( $_REQUEST['action'] ) { case 'create-campaign' : $IX60632 = true; self::create_campaign_form( $IX47805 ); break; case 'edit-campaign' : $IX48720 = true; self::edit_campaign_form( $IX47805, $IX53861 ); break; } } } if ( !$IX60632 && !$IX48720 ) { $IX73622 = new Affiliates_Campaign_Table( $options ); $IX73622->prepare_items(); echo '<div class="campaigns">'; echo '<form class="campaigns-table" method="get">'; echo '<div>'; echo '<div class="buttons">'; $IX18282 = self::current_url_clean(); printf( "<a class='button action' title='%s' href='%s'>%s</a>", esc_attr( __( 'Create a new campaign', 'affiliates' ) ), esc_url( wp_nonce_url( add_query_arg( array( 'affiliate_id' => $IX47805, 'action' => 'create-campaign' ), $IX18282 ), self::ACTION, self::NONCE ) ), __( 'Create a Campaign', 'affiliates' ) ); echo '</div>'; echo '<br/>'; if ( isset( $_REQUEST['page'] ) ) { echo sprintf( '<input type="hidden" name="page" value="%s" />', esc_attr( $_REQUEST['page'] ) ); } $IX73622->display(); echo '</div>'; echo '</form>'; echo '</div>'; } }

	/**
	 * Render the form to create a campaign.
	 * 
	 * @param int $campaign_id
	 */
	public static function create_campaign_form( $affiliate_id = null ) { wp_enqueue_style( 'affiliates-campaigns' ); if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) || ( $affiliate_id !== null ) && ( $affiliate_id == Affiliates_Affiliate_WordPress::get_user_affiliate_id() ) ) { $IX83465 = isset( $_REQUEST['campaign_name'] ) ? stripslashes( wp_strip_all_tags( trim( $_REQUEST['campaign_name'] ) ) ) : ''; $IX44778 = isset( $_REQUEST['campaign_description'] ) ? stripslashes( substr( wp_strip_all_tags( trim( $_REQUEST['campaign_description'] ) ), 0, self::MAX_DESCRIPTION ) ) : ''; echo '<div class="campaign-create">'; echo '<h2>'; echo __( 'Create Campaign', 'affiliates' ); echo '</h2>'; printf( '<form action="%s" method="post">', esc_attr( self::current_url_clean() ) ); echo '<div>'; if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { if ( isset( $_REQUEST['affiliate_id'] ) ) { $affiliate_id = intval( $_REQUEST['affiliate_id'] ); } echo '<div class="field affiliate_id">'; echo Affiliates_UI_Elements::affiliates_select( array( 'affiliate_id' => $affiliate_id ) ); echo '</div>'; } else { printf( '<input type="hidden" name="affiliate_id" value="%d" />', intval( $affiliate_id ) ); } echo '<div class="field name">'; echo '<label>'; echo __( 'Name', 'affiliates' ); echo '<br/>'; printf( '<input type="text" name="campaign_name" value="%s" />', esc_attr( $IX83465 ) ); echo '</label>'; echo '</div>'; echo '<div class="field description">'; echo '<label>'; echo __( 'Description', 'affiliates' ); echo '<br/>'; echo '<textarea name="campaign_description">'; echo htmlentities( $IX44778 ); echo '</textarea>'; echo '</label>'; echo '</div>'; echo '<div class="buttons">'; printf( '<input type="submit" name="campaign-action" class="button button-primary action" value="%s" />', __( 'Create', 'affiliates' ) ); echo '<input type="hidden" name="action" value="create-campaign" />'; echo ' '; self::cancel_link(); wp_nonce_field( self::ACTION, self::NONCE ); wp_referer_field(); echo '</div>'; echo '</div>'; echo '</form>'; echo '</div>'; } else { wp_die( __( 'Access denied.', 'affiliates' ) ); } }

	public static function edit_campaign_form( $affiliate_id, $campaign_id ) { wp_enqueue_style( 'affiliates-campaigns' ); if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) || ( $affiliate_id !== null ) && ( $affiliate_id == Affiliates_Affiliate_WordPress::get_user_affiliate_id() ) && Affiliates_Campaign::is_affiliate_campaign( $affiliate_id, $campaign_id ) ) { $IX75105 = new Affiliates_Campaign(); if ( $IX75105->read( $campaign_id ) ) { echo '<div class="campaign-edit">'; echo '<h2>'; echo __( 'Edit Campaign', 'affiliates' ); echo '</h2>'; printf( '<form action="%s" method="post">', esc_attr( self::current_url_clean() ) ); echo '<div>'; if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { if ( $IX36518 = Affiliates_Affiliate::get_affiliate( $affiliate_id ) ) { echo '<div class="field name">'; echo '<label>'; echo __( 'Affiliate', 'affiliates' ); echo ' '; printf( '<input type="text" name="affiliate-name" value="%s" readonly="readonly" />', esc_attr( $IX36518->name ) ); echo '</label>'; echo '</div>'; } } echo '<div class="field name">'; echo '<label>'; echo __( 'Name', 'affiliates' ); echo '<br/>'; printf( '<input type="text" name="campaign_name" value="%s" />', esc_attr( stripslashes( $IX75105->name ) ) ); echo '</label>'; echo '</div>'; echo '<div class="field description">'; echo '<label>'; echo __( 'Description', 'affiliates' ); echo '<br/>'; echo '<textarea name="campaign_description">'; echo htmlentities( stripslashes( $IX75105->description ) ); echo '</textarea>'; echo '</label>'; echo '</div>'; echo '<div class="buttons">'; printf( '<input type="hidden" name="affiliate_id" value="%d" />', intval( $affiliate_id ) ); printf( '<input type="hidden" name="campaign_id" value="%d" />', intval( $campaign_id ) ); printf( '<input type="submit" name="campaign-action" class="button button-primary action" value="%s" />', __( 'Save', 'affiliates' ) ); echo '<input type="hidden" name="action" value="edit-campaign" />'; echo ' '; self::cancel_link(); wp_nonce_field( self::ACTION, self::NONCE ); echo '</div>'; echo '</div>'; echo '</form>'; echo '</div>'; } } }

	private static function cancel_link() { $IX47340 = self::current_url_clean(); printf( '<a class="button action" title="%s" href="%s">%s</a>', esc_attr( __( 'Cancel this action', 'affiliates' ) ), esc_url( $IX47340 ), __( 'Cancel', 'affiliates' ) ); }

	private static function current_url_clean() { $IX99187 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX99187 = remove_query_arg( 'affiliate_id', $IX99187 ); $IX99187 = remove_query_arg( 'campaign_id', $IX99187 ); $IX99187 = remove_query_arg( '_campaign_id', $IX99187 ); $IX99187 = remove_query_arg( 'action', $IX99187 ); $IX99187 = remove_query_arg( 'action2', $IX99187 ); $IX99187 = remove_query_arg( '_wpnonce', $IX99187 ); $IX99187 = remove_query_arg( '_wp_http_referer', $IX99187 ); $IX99187 = remove_query_arg( self::NONCE, $IX99187 ); return $IX99187; }

	public static function admin_enqueue_scripts() { wp_register_style( 'affiliates-campaigns', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'css/affiliates-campaigns.css', array(), AFFILIATES_EEXT_VERSION ); }

	public static function wp_enqueue_scripts() { wp_register_script( 'affiliates-campaigns', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'js/affiliates-campaigns.js', array( 'jquery' ), AFFILIATES_EEXT_VERSION, true ); wp_register_style( 'affiliates-campaigns', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'css/affiliates-campaigns.css', array(), AFFILIATES_EEXT_VERSION ); }

	public static function init() { add_action( 'wp_enqueue_scripts', array( __CLASS__, 'wp_enqueue_scripts' ) ); add_action( 'admin_enqueue_scripts', array( __CLASS__, 'admin_enqueue_scripts' ) ); }
}
Affiliates_Campaign_Table::init();
