<?php
/**
 * class-affiliates-campaigns-wordpress.php
 * 
 * Copyright (c) 2015 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 2.8.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Campaigns admin section.
 */
class Affiliates_Campaigns_WordPress {

	const NONCE     = 'nonce-campaigns';
	const CAMPAIGNS = 'campaigns';

	public static function init() { add_action( 'affiliates_admin_menu', array( __CLASS__, 'affiliates_admin_menu' ) ); }

	public static function affiliates_admin_menu() { $IX95406 = add_submenu_page( 'affiliates-admin', __( 'Campaigns', 'affiliates' ), __( 'Campaigns', 'affiliates' ), AFFILIATES_ADMINISTER_OPTIONS, 'affiliates-admin-campaigns', array( __CLASS__, 'affiliates_admin_campaigns' ) ); $IX62926[] = $IX95406; add_action( 'admin_print_styles-' . $IX95406, 'affiliates_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX95406, 'affiliates_admin_print_scripts' ); add_action( 'admin_print_styles-' . $IX95406, 'affiliates_pro_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX95406, 'affiliates_pro_admin_print_scripts' ); }

	public static function admin_print_styles() { global $affiliates_enterprise_version; if ( !wp_style_is( 'chosen' ) ) { wp_enqueue_style( 'chosen', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'css/chosen/chosen.min.css', array(), $affiliates_enterprise_version ); } }

	public static function admin_print_scripts() { global $affiliates_enterprise_version; if ( !wp_script_is( 'chosen' ) ) { wp_enqueue_script( 'chosen', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'js/chosen/chosen.jquery.min.js', array( 'jquery' ), $affiliates_enterprise_version ); } }

	public static function affiliates_admin_campaigns() { if ( !current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } Affiliates_Campaign_Table::render(); affiliates_footer(); }

}
add_action( 'init', array( 'Affiliates_Campaigns_WordPress', 'init' ) );
