<?php
/**
 * wp-init.php
 * 
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

global $affiliates_options, $affiliates_version, $affiliates_pro_version, $affiliates_enterprise_version, $affiliates_enterprise_admin_messages;

if ( !isset( $affiliates_enterprise_admin_messages ) ) {
	$affiliates_enterprise_admin_messages = array();
}

if ( !isset( $affiliates_enterprise_version ) ) {
	$affiliates_enterprise_version = AFFILIATES_EEXT_VERSION;
}

add_action( 'init', 'affiliates_enterprise_version_check' );
function affiliates_enterprise_version_check() { global $affiliates_enterprise_version, $affiliates_enterprise_admin_messages; $IX93944 = get_option( 'affiliates_enterprise_plugin_version', null ); $affiliates_enterprise_version = AFFILIATES_EEXT_VERSION; if ( version_compare( $IX93944, $affiliates_enterprise_version ) < 0 ) { $IX51814 = affiliates_enterprise_update( $IX93944 ); if ( $IX51814 === true ) { update_option( 'affiliates_enterprise_plugin_version', $affiliates_enterprise_version ); } else { if ( $IX51814 === false ) { affiliates_log_error( 'There were errors during update (eext) – this might only be a temporary issue, unless this message comes up permanently.' ); } } } }

function affiliates_enterprise_admin_notices() { global $affiliates_enterprise_admin_messages; if ( !empty( $affiliates_enterprise_admin_messages ) ) { foreach ( $affiliates_enterprise_admin_messages as $IX66340 ) { echo $IX66340; } } }

add_action( 'admin_notices', 'affiliates_enterprise_admin_notices' );

function affiliates_enterprise_activate( $network_wide = false ) { if ( is_multisite() && $network_wide ) { $IX82446 = affiliates_get_blogs(); foreach ( $IX82446 as $IX84546 ) { switch_to_blog( $IX84546 ); wp_cache_reset(); affiliates_enterprise_setup(); restore_current_blog(); } } else { affiliates_pro_setup(); } }

function affiliates_enterprise_setup() { global $affiliates_db, $wpdb; if ( affiliates_enterprise_check_dependencies() ) { $IX42260 = null; $IX88476 = null; if ( ! empty( $wpdb->charset ) ) { $IX42260 = $wpdb->charset; } if ( ! empty( $wpdb->collate ) ) { $IX88476 = $wpdb->collate; } $affiliates_db->create_tables( $IX42260, $IX88476 ); affiliates_enterprise_update(); } }

function affiliates_enterprise_wpmu_new_blog( $blog_id, $user_id ) { if ( is_multisite() ) { if ( affiliates_is_sitewide_plugin() ) { switch_to_blog( $blog_id ); wp_cache_reset(); affiliates_enterprise_setup(); restore_current_blog(); } } }

function affiliates_enterprise_delete_blog( $blog_id, $drop = false ) { if ( is_multisite() ) { if ( affiliates_is_sitewide_plugin() ) { switch_to_blog( $blog_id ); wp_cache_reset(); affiliates_enterprise_cleanup( $drop ); restore_current_blog(); } } }

register_activation_hook( AFFILIATES_ENTERPRISE_PLUGIN_FILE, 'affiliates_enterprise_activate' );
add_action( 'wpmu_new_blog', 'affiliates_enterprise_wpmu_new_blog', 12, 2 );
add_action( 'delete_blog', 'affiliates_enterprise_delete_blog', 10, 2 );

function affiliates_enterprise_update( $previous_version = null ) { global $affiliates_db, $wpdb; $IX84837 = true; if ( defined( 'DOING_AJAX' ) && DOING_AJAX || defined( 'DOING_CRON' ) && DOING_CRON ) { return null; } $IX57705 = null; $IX89652 = null; if ( ! empty( $wpdb->charset ) ) { $IX57705 = $wpdb->charset; } if ( ! empty( $wpdb->collate ) ) { $IX89652 = $wpdb->collate; } if ( !$affiliates_db->update_tables( $previous_version, $IX57705, $IX89652 ) ) { $IX84837 = false; } return $IX84837; }

remove_action( 'deactivate_' . plugin_basename( AFFILIATES_PRO_FILE ), 'affiliates_pro_deactivate' );
register_deactivation_hook( AFFILIATES_ENTERPRISE_PLUGIN_FILE, 'affiliates_enterprise_deactivate' );

function affiliates_enterprise_deactivate( $network_wide = false ) { if ( is_multisite() && $network_wide ) { if ( get_option( 'aff_delete_network_data', false ) ) { $IX24335 = affiliates_get_blogs(); foreach ( $IX24335 as $IX47155 ) { switch_to_blog( $IX47155 ); wp_cache_reset(); affiliates_enterprise_cleanup( true ); restore_current_blog(); } } } else { affiliates_enterprise_cleanup(); } }

function affiliates_enterprise_cleanup( $delete = false ) { global $affiliates_db; $IX16458 = get_option( 'aff_delete_data', false ) || $delete; if ( $IX16458 ) { $IX82540 = $affiliates_db->get_tablename( 'affiliates' ); if ( $IX59550 = $affiliates_db->get_objects( "SELECT affiliate_id FROM $IX82540" ) ) { foreach( $IX59550 as $IX56154 ) { delete_option( Affiliates_Multi_Tier::TIER_RATES . '_' . intval( $IX56154->affiliate_id ) ); } } $affiliates_db->drop_tables(); delete_option( 'affiliates_pro_plugin_version' ); delete_option( 'affiliates_enterprise_plugin_version' ); delete_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY ); delete_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE ); delete_option( 'affiliates_notifications' ); delete_option( Affiliates_Multi_Tier::ENABLE_TIERS ); delete_option( Affiliates_Multi_Tier::TIER_RATES ); delete_option( Affiliates_Multi_Tier::ALLOW_TIER_REFERRALS_ON_ADMIN ); delete_option( Affiliates_Multi_Tier::INCLUDE_DIRECT ); delete_option( Affiliates_Multi_Tier::N_TIERS ); delete_option( Affiliates_Multi_Tier::RELATIVE_TIER_RATES ); } affiliates_deactivate(); }

add_action( 'init', 'affiliates_enterprise_init' );

function affiliates_enterprise_init() { global $affiliates_enterprise_admin_messages; load_plugin_textdomain( 'affiliates', null, AFFILIATES_PLUGIN_NAME . '/lib/eext/languages' ); affiliates_enterprise_check_dependencies(); }

function affiliates_enterprise_check_dependencies() { global $affiliates_enterprise_admin_messages; $IX52154 = true; $IX27578 = get_option( 'active_plugins', array() ); if ( is_multisite() ) { $IX11160 = get_site_option( 'active_sitewide_plugins', array() ); $IX11160 = array_keys( $IX11160 ); $IX27578 = array_merge( $IX27578, $IX11160 ); } $IX67425 = in_array( 'affiliates-pro/affiliates-pro.php', $IX27578 ); if ( $IX67425 ) { $affiliates_enterprise_admin_messages[] = "<div class='error'>" . __( 'The <a href="http://www.itthinx.com/plugins/affiliates-pro" target="_blank">Affiliates Pro</a> plugin must be deactivated or removed.', 'affiliates' ) . "</div>"; } if ( $IX67425 ) { include_once ABSPATH . 'wp-admin/includes/plugin.php'; deactivate_plugins( AFFILIATES_PLUGIN_BASENAME ); $IX52154 = false; } return $IX52154; }

require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/interfaces.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/abstract/abstract.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/includes/includes.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/wordpress/wordpress.php';

require_once AFFILIATES_CORE_LIB . '/class-affiliates-utility.php';
require_once AFFILIATES_CORE_LIB . '/class-affiliates-pagination.php';

require_once AFFILIATES_CORE_LIB . '/class-affiliates-date-helper.php';

add_action( 'widgets_init', 'affiliates_enterprise_widgets_init' );

require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-overview-enterprise.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-referrals-enterprise.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-traffic-enterprise.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-campaigns.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-campaigns-block.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-campaigns-shortcode.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-banners-enterprise.php';
require_once dirname( AFFILIATES_ENTERPRISE_PLUGIN_FILE ) . '/lib/eext/dashboard/class-affiliates-dashboard-enterprise.php';

function affiliates_enterprise_widgets_init() { }

add_action( 'admin_init', 'affiliates_enterprise_admin_init' );

function affiliates_enterprise_admin_init() { global $affiliates_enterprise_version; wp_register_style( 'smoothness', AFFILIATES_CORE_URL . '/css/smoothness/jquery-ui-1.8.16.custom.css', array(), $affiliates_enterprise_version ); wp_register_style( 'affiliates_enterprise_admin', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'css/affiliates_enterprise_admin.css', array(), $affiliates_enterprise_version ); }

add_action( 'affiliates_admin_menu', 'affiliates_enterprise_affiliates_admin_menu' );
function affiliates_enterprise_affiliates_admin_menu( $pages ) { foreach ( $pages as $IX82265 ) { add_action( 'admin_print_styles-' . $IX82265, 'affiliates_enterprise_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX82265, 'affiliates_enterprise_admin_print_scripts' ); } }

function affiliates_enterprise_admin_print_styles() { wp_enqueue_style( 'smoothness' ); wp_enqueue_style( 'affiliates_enterprise_admin' ); }

function affiliates_enterprise_admin_print_scripts() { global $affiliates_enterprise_version; }
