<?php
/**
 * class-affiliates-database.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

/**
 * Implementation-independent database abstraction.
 */
abstract class Affiliates_Database implements I_Affiliates_Database {

	private $implementation;
	private $host;
	private $database;
	private $user;
	private $password;

	public function __construct( $implementation, $host = null, $database = null, $user = null, $password = null ) { $this->implementation = $implementation; $this->host = $host; $this->database = $database; $this->user = $user; $this->password = $password; }

	public function create_tables( $charset = null, $collate = null ) { $IX39291 = ''; if ( ! empty( $charset ) ) { $IX39291 = "DEFAULT CHARACTER SET $charset"; } if ( ! empty( $collate ) ) { $IX39291 .= " COLLATE $collate"; } $IX69007 = $this->get_tablename( 'affiliates_attributes' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX69007 . "'" ) != $IX69007 ) { $IX22543 = "CREATE TABLE " . $IX69007 . " (
				affiliate_id BIGINT(20) UNSIGNED NOT NULL,
				attr_key     VARCHAR(100) NOT NULL,
				attr_value   LONGTEXT DEFAULT NULL,
				PRIMARY KEY  (affiliate_id, attr_key),
				INDEX        aff_attr_akv (affiliate_id, attr_key, attr_value(100)),
				INDEX        aff_attr_ka (attr_key, affiliate_id),
				INDEX        aff_attr_kva (attr_key, attr_value(100), affiliate_id)
			) $IX39291;"; $this->query( $IX22543 ); } $IX57143 = $this->get_tablename( 'rates' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX57143 . "'" ) != $IX57143 ) { $IX22543 = "CREATE TABLE " . $IX57143 . "(
			rate_id      BIGINT(20) UNSIGNED NOT NULL auto_increment,
			type         VARCHAR(10) DEFAULT NULL,
			value        decimal(24,6) DEFAULT NULL,
			currency_id  CHAR(3) DEFAULT NULL,
			affiliate_id BIGINT(20) UNSIGNED DEFAULT NULL,
			group_id     BIGINT(20) UNSIGNED DEFAULT NULL,
			object_id    BIGINT(20) UNSIGNED DEFAULT NULL,
			term_id      BIGINT(20) UNSIGNED DEFAULT NULL,
			level        INT UNSIGNED DEFAULT NULL,
			integration  VARCHAR(255) DEFAULT NULL,
			description  varchar(255) DEFAULT NULL,
			PRIMARY KEY  (rate_id),
			INDEX        type (type),
			INDEX        affiliate (affiliate_id),
			INDEX        object (object_id),
			INDEX        term (term_id),
			INDEX        level (level),
			INDEX        integration (integration(20))
			) $IX39291;"; $this->query( $IX22543 ); } $IX81738 = $this->get_tablename( 'rates_metas' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX81738 . "'" ) != $IX81738 ) { $IX22543 = "CREATE TABLE " . $IX81738 . "(
			rate_meta_id      BIGINT(20) UNSIGNED NOT NULL auto_increment,
			rate_id           BIGINT(20) UNSIGNED NOT NULL,
			meta_key          VARCHAR(255) DEFAULT NULL,
			meta_value        LONGTEXT DEFAULT NULL,
			PRIMARY KEY       (rate_meta_id),
			INDEX             rate_id (rate_id),
			INDEX             meta_key (meta_key(20))
			) $IX39291;"; $this->query( $IX22543 ); } }

	public function update_tables( $previous_version = null, $charset = null, $collate = null ) { $IX85129 = true; $IX51396 = ''; if ( ! empty( $charset ) ) { $IX51396 = "DEFAULT CHARACTER SET $charset"; } if ( ! empty( $collate ) ) { $IX51396 .= " COLLATE $collate"; } if ( !empty( $previous_version ) && version_compare( $previous_version, '3.0.0' ) < 0 ) { $IX68625 = $this->get_tablename( 'rates' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX68625 . "'" ) != $IX68625 ) { $IX16552 = "CREATE TABLE " . $IX68625 . "(
				rate_id      BIGINT(20) UNSIGNED NOT NULL auto_increment,
				type         VARCHAR(10) DEFAULT NULL,
				value        decimal(24,6) DEFAULT NULL,
				currency_id  CHAR(3) DEFAULT NULL,
				affiliate_id BIGINT(20) UNSIGNED DEFAULT NULL,
				group_id     BIGINT(20) UNSIGNED DEFAULT NULL,
				object_id    BIGINT(20) UNSIGNED DEFAULT NULL,
				term_id      BIGINT(20) UNSIGNED DEFAULT NULL,
				level        INT UNSIGNED DEFAULT NULL,
				integration  VARCHAR(255) DEFAULT NULL,
				description  VARCHAR(255) DEFAULT NULL,
				PRIMARY KEY  (rate_id),
				INDEX        type (type),
				INDEX        affiliate (affiliate_id),
				INDEX        object (object_id),
				INDEX        term (term_id),
				INDEX        level (level),
				INDEX        integration (integration(20))
				) $IX51396;"; if ( !$this->query( $IX16552 ) ) { $IX85129 = false; } } $IX96191 = $this->get_tablename( 'rates_metas' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX96191 . "'" ) != $IX96191 ) { $IX16552 = "CREATE TABLE " . $IX96191 . "(
				rate_meta_id      BIGINT(20) UNSIGNED NOT NULL auto_increment,
				rate_id           BIGINT(20) UNSIGNED NOT NULL,
				meta_key          VARCHAR(255) DEFAULT NULL,
				meta_value        LONGTEXT DEFAULT NULL,
				PRIMARY KEY       (rate_meta_id),
				INDEX             rate_id (rate_id),
				INDEX             meta_key (meta_key(20))
				) $IX51396;"; if ( !$this->query( $IX16552 ) ) { $IX85129 = false; } } } $IX68625 = $this->get_tablename( 'rates' ); if ( $this->get_value( "SHOW TABLES LIKE '" . $IX68625 . "'" ) == $IX68625 ) { $IX57360 = $this->get_objects( "SHOW COLUMNS FROM $IX68625 LIKE 'currency_id'" ); if ( empty( $IX57360 ) ) { if ( !$this->query( "ALTER TABLE " . $IX68625 . " ADD COLUMN currency_id  CHAR(3) DEFAULT NULL;" ) ) { $IX85129 = false; } } } return $IX85129; }

	public function drop_tables() { $IX58309 = $this->get_tablename( 'affiliates_attributes' ); $IX37683 = "DROP TABLE IF EXISTS " . $IX58309 . ";"; $this->query( $IX37683 ); $IX36443 = $this->get_tablename( 'rates' ); $IX37683 = "DROP TABLE IF EXISTS " . $IX36443 . ";"; $this->query( $IX37683 ); $IX38824 = $this->get_tablename( 'rates_metas' ); $IX37683 = "DROP TABLE IF EXISTS " . $IX38824 . ";"; $this->query( $IX37683 ); }
}
