<?php
/**
 * class-affiliates-graph-renderer.php
 *
 * Copyright 2012 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 2.2.1
 */

/**
 * Graph renderer base.
 */
abstract class Affiliates_Graph_Renderer implements I_Affiliates_Graph_Renderer {

	protected static $graph_options = array(
		'from_date' => null,
		'thru_date' => null,
		'days_back' => null,
		'interval'  => null,
		'legend'    => true,
		'render'    => 'graph'
	);

	protected static $today;
	protected static $day_interval  = 7;
	protected static $min_days_back = 7;
	protected static $max_days_back = 1100;

	public static function init() { self::$today = date( 'Y-m-d', time() ); }

	static function render_graph( $options = array() ) { global $affiliates_db, $affiliate_graph_count; $affiliate_graph_count++; self::init(); $IX29370 = ''; $IX59105 = Affiliates_Affiliate_WordPress::get_user_affiliate_id(); if ( $IX59105 === false ) { return $IX29370; } $IX98715 = isset( $options['interval'] ) && ( $options['interval'] !== null ) ? $options['interval'] : null; $IX30689 = isset( $options['render'] ) ? $options['render'] : self::$graph_options['render']; switch( $IX30689 ) { case 'graph' : case 'hits' : case 'visits' : case 'referrals' : case 'accepted' : case 'closed' : case 'pending' : case 'rejected' : break; default : $IX30689 = self::$graph_options['render']; } $IX14861 = isset( $options['legend'] ) && ( ( $options['legend'] === true ) || ( $options['legend'] === 'true' ) ); if ( $IX14861 ) { $IX18659 = 'true'; } else { $IX18659 = 'false'; } $IX77386 = isset( $options['days_back'] ) && ( $options['days_back'] !== null ) ? $options['days_back'] : self::$min_days_back; if ( $IX77386 < self::$min_days_back ) { $IX77386 = self::$min_days_back; } if ( $IX77386 > self::$max_days_back ) { $IX77386 = self::$max_days_back; } $IX54213 = isset( $options['from_date'] ) && ( $options['from_date'] !== null ) ? $options['from_date'] : null; $IX95503 = isset( $options['thru_date'] ) && ( $options['thru_date'] !== null ) ? $options['thru_date'] : null; switch( $IX98715 ) { case 'month' : $IX54213 = date( 'Y-m-d', strtotime( 'first day of' ) ); $IX95503 = date( 'Y-m-d', strtotime( 'last day of' ) ); $IX77386 = 1 + ( strtotime( $IX95503 ) - strtotime( $IX54213 ) ) / ( 3600 * 24 ); break; case 'year' : $IX54213 = date( 'Y-m-d', strtotime( 'first day of January' ) ); $IX95503 = date( 'Y-m-d', strtotime( 'last day of December' ) ); $IX77386 = 1 + ( strtotime( $IX95503 ) - strtotime( $IX54213 ) ) / ( 3600 * 24 ); break; } if ( empty( $IX95503 ) ) { $IX95503 = self::$today; } if ( empty( $IX54213 ) ) { $IX54213 = date( 'Y-m-d', strtotime( $IX95503 ) - $IX77386 * 3600 * 24 ); } $IX41151 = $affiliates_db->get_tablename( 'affiliates' ); $IX76926 = $affiliates_db->get_tablename( 'hits' ); $IX74929 = $affiliates_db->get_tablename( 'referrals' ); $IX19937 = "SELECT date, COUNT(*) as hits FROM $IX76926 WHERE date >= %s AND date <= %s AND affiliate_id = %d GROUP BY date"; $IX44179 = $affiliates_db->get_objects( $IX19937, $IX54213, $IX95503, intval( $IX59105 ) ); $IX82701 = array(); foreach( $IX44179 as $IX90556 ) { $IX82701[$IX90556->date] = $IX90556->hits; } $IX19937 = "SELECT count(DISTINCT IP) visits, date FROM $IX76926 WHERE date >= %s AND date <= %s AND affiliate_id = %d GROUP BY date"; $IX19458 = $affiliates_db->get_objects( $IX19937, $IX54213, $IX95503, intval( $IX59105 ) ); $IX89278 = array(); foreach( $IX19458 as $IX12840 ) { $IX89278[$IX12840->date] = $IX12840->visits; } $IX19937 = "SELECT count(referral_id) referrals, date(datetime) date FROM $IX74929 WHERE status = %s AND date(datetime) >= %s AND date(datetime) <= %s AND affiliate_id = %d GROUP BY date"; $IX91024 = $affiliates_db->get_objects( $IX19937, AFFILIATES_REFERRAL_STATUS_ACCEPTED, $IX54213, $IX95503, intval( $IX59105 ) ); $IX43763 = array(); foreach( $IX91024 as $IX44037 ) { $IX43763[$IX44037->date] = $IX44037->referrals; } $IX91024 = $affiliates_db->get_objects( $IX19937, AFFILIATES_REFERRAL_STATUS_CLOSED, $IX54213, $IX95503, intval( $IX59105 ) ); $IX74414 = array(); foreach( $IX91024 as $IX44037 ) { $IX74414[$IX44037->date] = $IX44037->referrals; } $IX91024 = $affiliates_db->get_objects( $IX19937, AFFILIATES_REFERRAL_STATUS_PENDING, $IX54213, $IX95503, intval( $IX59105 ) ); $IX97563 = array(); foreach( $IX91024 as $IX44037 ) { $IX97563[$IX44037->date] = $IX44037->referrals; } $IX91024 = $affiliates_db->get_objects( $IX19937, AFFILIATES_REFERRAL_STATUS_REJECTED, $IX54213, $IX95503, intval( $IX59105 ) ); $IX39972 = array(); foreach( $IX91024 as $IX44037 ) { $IX39972[$IX44037->date] = $IX44037->referrals; } $IX45806 = array(); $IX56815 = array(); $IX33589 = array(); $IX80548 = array(); $IX88754 = array(); $IX44077 = array(); $IX12539 = array(); $IX15761 = array(); for ( $IX92607 = -$IX77386; $IX92607 <= 0; $IX92607++ ) { $IX61889 = date( 'Y-m-d', strtotime( $IX95503 ) + $IX92607 * 3600 * 24 ); $IX15761[$IX92607] = $IX61889; if ( isset( $IX43763[$IX61889] ) ) { $IX45806[] = array( $IX92607, intval( $IX43763[$IX61889] ) ); } if ( isset( $IX97563[$IX61889] ) ) { $IX56815[] = array( $IX92607, intval( $IX97563[$IX61889] ) ); } if ( isset( $IX39972[$IX61889] ) ) { $IX33589[] = array( $IX92607, intval( $IX39972[$IX61889] ) ); } if ( isset( $IX74414[$IX61889] ) ) { $IX80548[] = array( $IX92607, intval( $IX74414[$IX61889] ) ); } if ( isset( $IX82701[$IX61889] ) ) { $IX88754[] = array( $IX92607, intval( $IX82701[$IX61889] ) ); } if ( isset( $IX89278[$IX61889] ) ) { $IX44077[] = array( $IX92607, intval( $IX89278[$IX61889] ) ); } if ( $IX77386 <= ( self::$day_interval + self::$min_days_back ) ) { $IX44326 = date( 'm-d', strtotime( $IX61889 ) ); $IX12539[] = array( $IX92607, $IX44326 ); } else if ( $IX77386 <= 91 ) { $IX72327 = date( 'd', strtotime( $IX61889 ) ); if ( $IX72327 == '1' || $IX72327 == '15' ) { $IX44326 = date( 'm-d', strtotime( $IX61889 ) ); $IX12539[] = array( $IX92607, $IX44326 ); } } else { if ( date( 'd', strtotime( $IX61889 ) ) == '1' ) { if ( date( 'm', strtotime( $IX61889 ) ) == '1' ) { $IX44326 = '<strong>' . date( 'Y', strtotime( $IX61889 ) ) . '</strong>'; } else { $IX44326 = date( 'm-d', strtotime( $IX61889 ) ); } $IX12539[] = array( $IX92607, $IX44326 ); } } } $IX27750 = json_encode( $IX45806 ); $IX67950 = json_encode( $IX56815 ); $IX19465 = json_encode( $IX33589 ); $IX11902 = json_encode( $IX80548 ); $IX65834 = json_encode( $IX88754 ); $IX61895 = json_encode( $IX44077 ); $IX58280 = json_encode( array( array( intval( -$IX77386 ), 0 ), array( 0, 0 ) ) ); $IX97243 = json_encode( $IX12539 ); $IX74013 = json_encode( $IX15761 ); $IX10225 = isset( $options['class'] ) ? $options['class'] : 'affiliate-graph'; $IX10414 = isset( $options['id'] ) ? $options['id'] : 'affiliate-graph-' . $affiliate_graph_count; $IX90810 = isset( $options['style'] ) ? $options['style'] : ''; ob_start(); $IX72480 = $IX77386 <= 61 ? 'true' : 'false'; ?>
		<div id="<?php echo $IX10414; ?>" class="<?php echo $IX10225; ?>" style="<?php echo $IX90810; ?>"></div>
		<script type="text/javascript">
		document.addEventListener( "DOMContentLoaded", function() {
		if ( typeof jQuery !== "undefined" ) {
			(function($){
					var data = [
						<?php if ( $IX30689 == 'graph' || $IX30689 == 'hits' ) : ?>
						{
							label : "<?php _e( 'Hits', AFFILIATES_PLUGIN_DOMAIN ); ?>",
							data : <?php echo $IX65834; ?>,
							lines : { show : true },
							points : { show : <?php echo $IX72480; ?> },
							yaxis : 2,
							color : '#ccddff'
						},
						<?php endif; ?>
						<?php if ( $IX30689 == 'graph' || $IX30689 == 'visits' ) : ?>
						{
							label : "<?php _e( 'Visits', AFFILIATES_PLUGIN_DOMAIN ); ?>",
							data : <?php echo $IX61895; ?>,
							lines : { show : true },
							points : { show : <?php echo $IX72480; ?> },
							yaxis : 2,
							color : '#ffddcc'
						},
						<?php endif; ?>
						<?php if ( $IX30689 == 'graph' || $IX30689 == 'accepted' || $IX30689 == 'referrals' ) : ?>
						{
							label : "<?php _e( 'Accepted', AFFILIATES_PLUGIN_DOMAIN ); ?>",
							data : <?php echo $IX27750; ?>,
							color : '#009900',
							bars : { align : "center", show : true, barWidth : 1 },
							hoverable : true,
							yaxis : 1
						},
						<?php endif; ?>
						<?php if ( $IX30689 == 'graph' || $IX30689 == 'pending' || $IX30689 == 'referrals' ) : ?>
						{
							label : "<?php _e( 'Pending', AFFILIATES_PLUGIN_DOMAIN ); ?>",
							data : <?php echo $IX67950; ?>,
							color : '#0000ff',
							bars : { align : "center", show : true, barWidth : 0.6 },
							yaxis : 1
						},
						<?php endif; ?>
						<?php if ( $IX30689 == 'graph' || $IX30689 == 'rejected' || $IX30689 == 'referrals' ) : ?>
						{
							label : "<?php _e( 'Rejected', AFFILIATES_PLUGIN_DOMAIN ); ?>",
							data : <?php echo $IX19465; ?>,
							color : '#ff0000',
							bars : { align : "center", show : true, barWidth : .3 },
							yaxis : 1
						},
						<?php endif; ?>
						<?php if ( $IX30689 == 'graph' || $IX30689 == 'closed' || $IX30689 == 'referrals' ) : ?>
						{
							label : "<?php _e( 'Closed', AFFILIATES_PLUGIN_DOMAIN ); ?>",
							data : <?php echo $IX11902; ?>,
							color : '#333333',
							points : { show : true },
							yaxis : 1
						},
						<?php endif; ?>
						{
							data : <?php echo $IX58280; ?>,
							lines : { show : false },
							yaxis : 1
						}
					];

					var options = {
						xaxis : {
							ticks : <?php echo $IX97243; ?>
						},
						yaxis : {
							min : 0,
							tickDecimals : 0
						},
						yaxes : [
							{},
							{ position : 'right' }
						],
						grid : {
							hoverable : true
						},
						legend : {
							show : <?php echo $IX18659; ?>,
							position : 'nw'
						}
					};

					$.plot($("#<?php echo $IX10414; ?>"),data,options);

					function statsTooltip(x, y, contents) {
						var tooltip = $('<div id="<?php echo $IX10414; ?>-tooltip">' + contents + '</div>').css( {
							position: 'absolute',
							display: 'none',
							top: y + 5,
							left: x + 5,
							border: '1px solid #333',
							'border-radius' : '4px',
							padding: '6px',
							'background-color': '#ccc',
							opacity: 0.90
						}).appendTo("body").fadeIn(200);
						if ( tooltip.position().left >= tooltip.parent().width() / 2 ) {
							tooltip.css({left:x-tooltip.outerWidth()});
						}
					}

					var tooltipItem = null;
					var statsDates = <?php echo $IX74013; ?>;
					$("#<?php echo $IX10414; ?>").bind("plothover", function (event, pos, item) {
						if (item) {
							if (tooltipItem === null || item.dataIndex != tooltipItem.dataIndex || item.seriesIndex != tooltipItem.seriesIndex) {
								tooltipItem = item;
								$("#<?php echo $IX10414; ?>-tooltip").remove();
								var x = item.datapoint[0];
									y = item.datapoint[1];
								statsTooltip(
									item.pageX,
									item.pageY,
									item.series.label + " : " + y +  '<br/>' + statsDates[x] 
								);
							}
						} else {
							$("#<?php echo $IX10414;?>-tooltip").remove();
							tooltipItem = null;
						}
					});
			})(jQuery);
		}
		} );
		</script>
		<?php
 $IX29370 .= ob_get_contents(); ob_end_clean(); return $IX29370; }

	static function render_hits( $options = array() ) { self::init(); $options['render'] = 'hits'; return self::render_graph( $options ); }

	static function render_visits( $options = array() ) { self::init(); $options['render'] = 'visits'; return self::render_graph( $options ); }

	static function render_referrals( $options = array() ) { self::init(); $options['render'] = 'referrals'; return self::render_graph( $options ); }

	static function render_totals( $options = array() ) { self::init(); }
}
