<?php
/**
 * class-affiliates-link-renderer.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

/**
 * Link renderer base.
 */
abstract class Affiliates_Link_Renderer implements I_Affiliates_Link_Renderer {
	protected static $link_defaults = array(
		'render'        => self::RENDER_HTML,
		'content'       => null,
		'type'          => self::TYPE_AUTO,
		'url'           => null,
		'a_class'       => null,
		'a_id'          => null,
		'a_style'       => null,
		'a_title'       => null,
		'a_name'        => null,
		'a_rel'         => null,
		'a_rev'         => null,
		'a_target'      => null,
		'a_type'        => null,
		'img_alt'       => null,
		'img_class'     => null,
		'img_height'    => null,
		'img_id'        => null,
		'img_name'      => null,
		'img_src'       => null,
		'img_title'     => null,
		'img_width'     => null,
		'attachment_id' => null,
		'size'          => 'full'
	);

	protected static $implementation = null;

	public static function set_implementation( $implementation ) { self::$implementation = $implementation; }

	public static function render_affiliate_link( $options = array(), $IX17568 = null ) { if ( self::$implementation === null ) { return ''; } $IX75188 = ''; $IX96190 = call_user_func( array( self::$implementation['Affiliates_Url_Renderer'], 'render_affiliate_url'), $options ); if ( empty( $IX17568 ) ) { if ( !empty( $options['content'] ) ) { $IX17568 = $options['content']; } else { $IX17568 = $IX96190; } } $IX20369 = array(); $IX86089 = array(); foreach ( $options as $IX43926 => $IX44058 ) { if ( strpos($IX43926, "a_") === 0 ) { if ( $IX44058 !== null ) { $IX20369[substr( $IX43926, 2 )] = $IX44058; } } else if ( strpos($IX43926, "img_") === 0 ) { if ( $IX44058 !== null ) { switch ( $IX43926 ) { case 'img_height' : if ( preg_match( "/(\d+)(px|\%)?/", $IX44058, $IX99830 ) ) { $IX92156 = intval( $IX99830[1] ); if ( isset( $IX99830[2] ) ) { $IX54454 = $IX99830[2] == "px" ? "px" : "%"; } else { $IX54454 = ""; } $IX86089['height'] = $IX92156 . $IX54454; } break; case 'img_width' : if ( preg_match( "/(\d+)(px|\%)?/", $IX44058, $IX99830 ) ) { $IX56337 = intval( $IX99830[1] ); if ( isset( $IX99830[2] ) ) { $IX32367 = $IX99830[2] == "px" ? "px" : "%"; } else { $IX32367 = ""; } $IX86089['width'] = $IX56337 . $IX32367; } break; default : $IX86089[substr( $IX43926, 4 )] = $IX44058; } } } } if ( !empty( $IX92156 ) && !empty( $IX56337 ) ) { $IX88737 = array( $IX56337, $IX92156 ); } else if ( isset( $options['size'] ) ) { if ( in_array( $options['size'], self::$implementation['image_sizes'] ) ) { $IX88737 = $options['size']; } else { $IX88737 = self::$link_defaults['size']; } } $IX75188 = '<a href="' . $IX96190 . '"'; foreach( $IX20369 as $IX43926 => $IX44058 ) { $IX75188 .= ' ' . $IX43926 . '="' . call_user_func( self::$implementation['esc_attr'], $IX44058 ) . '"'; } $IX75188 .= '>'; if ( isset( $options['attachment_id'] ) ) { $IX75188 .= call_user_func( self::$implementation['image_retriever'], $options['attachment_id'], $IX88737, false, $IX86089 ); } else if ( isset( $options['img_src'] ) ) { $IX75188 .= "<img "; foreach ( $IX86089 as $IX43926 => $IX44058 ) { $IX75188 .= " $IX43926=" . '"' . call_user_func( self::$implementation['esc_attr'], $IX44058 ) . '"'; } $IX75188 .= ' />'; } else if ( isset( $options['content'] ) ) { $IX75188 .= $options['content']; } else { $IX75188 .= $IX17568; } $IX75188 .= '</a>'; if ( isset( $options['render'] ) && ( $options['render'] == self::RENDER_CODE ) ) { $IX75188 = htmlentities( $IX75188, ENT_COMPAT, get_bloginfo( 'charset' ) ); } return $IX75188; }
}
