<?php
/**
 * class-affiliates-url-renderer.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

/**
 * URL-renderer - implementation-independent abstraction to be used as the base for implementation-specific renderers.
 */
abstract class Affiliates_Url_Renderer implements I_Affiliates_Url_Renderer {
	protected static $pname   = 'affiliates';
	protected static $cname   = 'cmid';
	protected static $encoder = null;
	protected static $url_defaults = array(
		'type'   => self::TYPE_AUTO,
		'url'    => null
	);

	protected static $implementation = null;

	public static function set_implementation( $implementation ) { self::$implementation = $implementation; }

	static function render_affiliate_url( $options = array() ) { if ( self::$implementation === null ) { return ''; } $IX92355 = ''; if ( $IX19874 = call_user_func( array( self::$implementation['Affiliates_Affiliate'], 'get_user_affiliate_id' ) ) ) { $IX76128 = call_user_func( self::$encoder, $IX19874 ); } else { $IX76128 = 'affiliate-id'; } if ( !isset( $options['type'] ) ) { $options['type'] = self::TYPE_AUTO; } if ( isset( $options['url'] ) ) { $IX29897 = $options['url']; } else { $IX29897 = ''; } switch ( $options['type'] ) { case self::TYPE_APPEND : $IX92355 = self::get_affiliate_url( $IX29897, $IX19874 ); break; case self::TYPE_PARAMETER : $IX92355 = self::get_affiliate_url( $IX29897, $IX19874 ); break; case self::TYPE_PRETTY : $IX92355 = $IX29897 . '/' . self::$pname . '/' . $IX76128; break; case self::TYPE_AUTO : default : if ( isset( $options['use_parameter'] ) && $options['use_parameter'] ) { $IX92355 = $IX29897 . '/' . self::$pname . '/' . $IX76128; } else { $IX92355 = self::get_affiliate_url( $IX29897, $IX19874 ); } break; } return $IX92355; }

	public static function compose_url( $components ) { $IX89982 = isset( $components['scheme'] ) ? $components['scheme'] . '://' : ''; $IX30611 = isset( $components['host'] ) ? $components['host'] : ''; $IX31808 = isset( $components['port'] ) ? ':' . $components['port'] : ''; $IX64527 = isset( $components['user'] ) ? $components['user'] : ''; $IX41149 = isset( $components['pass'] ) ? ':' . $components['pass'] : ''; $IX41149 = ( !empty( $IX64527 ) || !empty( $IX41149 ) ) ? "$IX41149@" : ''; $IX50229 = isset( $components['path'] ) ? $components['path'] : ''; $IX77009 = isset( $components['query'] ) ? '?' . $components['query'] : ''; $IX69684 = isset( $components['fragment'] ) ? '#' . $components['fragment'] : ''; return "$IX89982$IX64527$IX41149$IX30611$IX31808$IX50229$IX77009$IX69684"; }

	public static function get_affiliate_url( $url, $affiliate_id, $campaign_id = null, $params = array() ) { $IX39527 = self::$pname; $IX38134 = self::$cname; $IX68936 = self::$encoder; $IX58907 = parse_url( $url, PHP_URL_SCHEME ); if ( empty( $IX58907 ) ) { $IX24517 = ''; if ( strpos( $url, 'http://' ) !== 0 && strpos( $url, 'https://' ) !== 0 ) { $IX24517 = !empty( $_SERVER['HTTPS'] ) && strtolower( $_SERVER['HTTPS'] ) != 'off' ? 'https:' : 'http:'; if ( strpos( $url, '//' ) !== 0 ) { $IX24517 .= '//'; } } $url = $IX24517 . $url; } $IX92533 = parse_url( $url ); if ( strpos( isset( $IX92533['query'] ) ? $IX92533['query'] : '', "$IX39527=" ) === false ) { $IX15558 = ''; if ( !empty( $IX92533['query'] ) ) { $IX15558 = $IX92533['query'] . '&'; } $IX77576 = $affiliate_id; if ( !empty( $IX68936 ) ) { $IX77576 = call_user_func( $IX68936, $affiliate_id ); } $IX15558 .= sprintf( '%s=%s', $IX39527, $IX77576 ); if ( empty( $IX92533['path'] ) ) { $IX92533['path'] = '/'; } if ( !empty( $campaign_id ) ) { $IX15558 .= '&'; $IX15558 .= sprintf( '%s=%s', $IX38134, $campaign_id ); } $IX92533['query'] = $IX15558; } return self::compose_url( $IX92533 ); }

}
