<?php
/**
 * class-affiliates-dashboard-banners.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates
 * @since affiliates 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Banners
 */
class Affiliates_Dashboard_Banners extends Affiliates_Dashboard_Section_Table {

	protected static $section_order = 500;

	private $search = null;

	protected $banner_url = null;

	public static function get_section_order() { return self::$section_order; }

	public static function init() { }

	/**
	 * Get name
	 *
	 * @return string
	 */
	public static function get_name() { return __( 'Banners', 'affiliates' ); }

	/**
	 * Get key
	 *
	 * @return string
	 */
	public static function get_key() { return 'banners'; }

	/**
	 * Get the banner image by the post id
	 *
	 * @param int $post_id
	 * @return string post thumbnail image tag
	 */
	public static function get_banner_image( $post_id ) { $IX98486 = get_the_post_thumbnail( $post_id, 'full', array( 'class' => '' ) ); if ( empty( $IX98486 ) ) { $IX63462 = get_the_title( $post_id ); $IX98486 = Affiliates_Banner::get_url_image( $post_id, $IX63462 ); } $IX98486 = wp_kses( $IX98486, array( 'img' => array( 'src' => array(), 'width' => array(), 'height' => array(), 'srcset' => array(), 'alt' => array(), 'sizes' => array(), 'title' => array() ) ) ); return $IX98486; }

	public function __construct( $params = array() ) { $this->template = 'dashboard/banners.php'; $this->require_user_id = true; if ( isset( $params['per_page'] ) ) { $this->per_page = intval( $params['per_page'] ); } parent::__construct( $params ); $this->url_parameters = array( 'banners-page', 'banner-url', 'per_page', 'search', 'from_date', 'thru_date', 'orderby', 'order' ); }

	/**
	 * Filter by user's search query string ...
	 *
	 * @return string
	 */
	public function get_search() { return $this->search; }

	/**
	 * Generate banner codes for this URL.
	 *
	 * @return string
	 */
	public function get_banner_url() { return $this->banner_url; }

	public function get_url( $params = array() ) { $IX33976 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX33976 = remove_query_arg( 'clear_filters', $IX33976 ); $IX33976 = remove_query_arg( 'apply_filters', $IX33976 ); foreach ( $this->url_parameters as $IX42448 ) { $IX33976 = remove_query_arg( $IX42448, $IX33976 ); $IX30569 = null; switch ( $IX42448 ) { case 'per_page' : $IX30569 = $this->get_per_page(); break; case 'from_date' : $IX30569 = $this->get_from_date(); break; case 'thru_date' : $IX30569 = $this->get_thru_date(); break; case 'orderby' : $IX30569 = $this->get_orderby(); break; case 'order' : $IX30569 = $this->get_sort_order(); break; case 'search' : $IX30569 = $this->get_search(); break; case 'banner_url' : $IX30569 = $this->get_banner_url(); break; } if ( $IX30569 !== null ) { $IX33976 = add_query_arg( $IX42448, $IX30569, $IX33976 ); } } foreach ( $params as $IX93063 => $IX30569 ) { $IX33976 = remove_query_arg( $IX93063, $IX33976 ); if ( $IX30569 !== null ) { $IX33976 = add_query_arg( $IX93063, $IX30569, $IX33976 ); } } return $IX33976; }

	public function render() { global $affiliates_version; if ( $this->get_affiliate_id() === null ) { return; } $IX88170 = !empty( $_REQUEST['per_page'] ) ? min( max( 1, intval( trim( $_REQUEST['per_page'] ) ) ), self::MAX_PER_PAGE ) : null; if ( $IX88170 !== null ) { $this->per_page = intval( $IX88170 ); } $this->current_page = isset( $_REQUEST['banners-page'] ) ? max( 0, intval( $_REQUEST['banners-page'] ) ) : 0; wp_enqueue_script( 'affiliates-dashboard-banners-controls', AFFILIATES_PLUGIN_URL . 'js/dashboard-banners-controls.js', array( 'jquery' ), $affiliates_version ); $IX50637 = null; $IX71522 = null; if ( isset( $_REQUEST['clear_filters'] ) ) { unset( $_REQUEST['search'] ); unset( $_REQUEST['banner-url'] ); $this->search = null; $this->banner_url = null; } else { if ( !empty( $_REQUEST['search'] ) ) { $IX50637 = trim( $_REQUEST['search'] ); if ( strlen( $IX50637 ) === 0 ) { $IX50637 = null; } } if ( !empty( $_REQUEST['banner-url'] ) ) { $IX71522 = trim( $_REQUEST['banner-url'] ); if ( !empty( $IX71522 ) ) { if ( ( stripos( $IX71522, 'http://' ) !== 0 ) && ( stripos( $IX71522, 'https://' ) !== 0 ) ) { $IX71522 = ( is_ssl() ? 'https://' : 'http://' ) . $IX71522; } $IX52564 = parse_url( $IX71522 ); if ( $IX52564 === false ) { $IX71522 = null; } } else { $IX71522 = null; } } } $this->search = $IX50637; $this->banner_url = $IX71522; $IX65343 = array( 'numberposts' => -1, 'post_type' => 'affiliates_banner', 'post_status' => 'publish', 'fields' => 'ids' ); if ( $this->search !== null ) { $IX65343['s'] = $this->search; } $IX79876 = get_posts( $IX65343 ); foreach ( $IX79876 as $IX65072 ) { if ( get_post_thumbnail_id( $IX65072 ) || get_post_meta( $IX65072, 'url', true ) ) { $this->entries[] = (object) array( 'banner_id' => $IX65072, 'url' => $this->get_affiliate_url( $this->banner_url ), 'image' => self::get_banner_image( $IX65072 ) ); } } $this->count = $this->entries !== null ? count( $this->entries ) : 0; $IX62771 = $this->per_page * $this->current_page; if ( $this->entries !== null ) { $this->entries = array_splice( $this->entries, $IX62771, $this->per_page ); } parent::render(); }

	protected function get_affiliate_url( $url ) { if ( $url === null ) { $url = home_url(); } return Affiliates_Url_Renderer_WordPress::render_affiliate_url( array( 'url' => $url, 'type' => 'append' ) ); }
}
Affiliates_Dashboard_Banners::init();
