<?php
/**
 * class-affiliates-dashboard-overview-pro.php
 *
 * Copyright (c) 2010 - 2019 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates
 * @since affiliates 4.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Dashboard section: Overview
 */
class Affiliates_Dashboard_Overview_Pro extends Affiliates_Dashboard_Section {

	const PERIOD = 91;

	const TRAIL = 0;

	const LEAD = 1;

	const LAST_SEVEN_DAYS = 7;

	const LAST_THIRTY_DAYS = 30;

	const LAST_NINETY_DAYS = 91;

	const LAST_TWELVE_MONTHS = 366;

	const LAST_THREE_YEARS = self::LAST_TWELVE_MONTHS * 3;

	const DAILY_THRESHOLD = 31;

	const WEEKLY_THRESHOLD = 184;

	const MONTHLY_THRESHOLD = 365*2+1;

	const MONTHS_TICK_THRESHOLD = 12;

	private $series = array();

	private $totals = array();

	private $thru_date = null;

	private $from_date = null;

	private $selected = 'last-ninety-days';

	public static function init() { }

	public function __construct( $params = array() ) { $this->template = 'dashboard/overview-pro.php'; $this->require_user_id = true; if ( isset( $params['from'] ) ) { $this->from_date = $params['from']; } if ( isset( $params['until'] ) ) { $this->thru_date = $params['until']; } parent::__construct( $params ); }

	public function render() { global $wpdb, $affiliates_version; if ( !affiliates_user_is_affiliate( $this->user_id ) ) { return; } wp_enqueue_script( 'excanvas', AFFILIATES_PLUGIN_URL . 'js/graph/flot/excanvas.min.js', array( 'jquery' ), $affiliates_version ); wp_enqueue_script( 'flot', AFFILIATES_PLUGIN_URL . 'js/graph/flot/jquery.flot.min.js', array( 'jquery' ), $affiliates_version ); wp_enqueue_script( 'flot-resize', AFFILIATES_PLUGIN_URL . 'js/graph/flot/jquery.flot.resize.min.js', array( 'jquery', 'flot' ), $affiliates_version ); wp_enqueue_script( 'affiliates-dashboard-overview-graph', AFFILIATES_PLUGIN_URL . 'js/dashboard-overview-graph.js', array( 'jquery', 'flot', 'flot-resize' ), $affiliates_version ); wp_enqueue_script( 'datepicker', AFFILIATES_PLUGIN_URL . 'js/jquery.ui.datepicker.min.js', array( 'jquery', 'jquery-ui-core' ), $affiliates_version ); wp_enqueue_script( 'datepickers', AFFILIATES_PLUGIN_URL . 'js/datepickers.js', array( 'jquery', 'jquery-ui-core', 'datepicker' ), $affiliates_version ); wp_enqueue_script( 'jquery-corner', AFFILIATES_PLUGIN_URL . 'js/jquery.corner.js', array( 'jquery', 'jquery-ui-core' ), $affiliates_version ); wp_enqueue_script( 'overview-controls', AFFILIATES_PLUGIN_URL . 'js/dashboard-overview-controls.js', array( 'jquery' ), $affiliates_version ); wp_enqueue_script( 'affiliates', AFFILIATES_PLUGIN_URL . 'js/affiliates.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-button', 'jquery-corner' ), $affiliates_version ); wp_enqueue_style( 'smoothness', AFFILIATES_PLUGIN_URL . 'css/smoothness/jquery-ui-1.8.16.custom.css', array(), $affiliates_version ); wp_localize_script( 'affiliates-dashboard-overview-graph', 'affiliates_dashboard_overview_graph_l12n', array( 'hits' => __( 'Hits', 'affiliates' ), 'visits' => __( 'Visits', 'affiliates' ), 'referrals' => __( 'Referrals', 'affiliates' ) ) ); $IX42009 = date( 'Y-m-d', time() ); $IX16535 = date( 'Y-m-d', strtotime( $IX42009 ) - self::LAST_NINETY_DAYS * 3600 * 24 ); $IX89898 = self::LAST_NINETY_DAYS; $IX66267 = null; $this->selected = 'last-ninety-days'; if ( !empty( $_REQUEST['range'] ) ) { $this->selected = trim( $_REQUEST['range'] ); switch( $this->selected ) { case 'last-seven-days' : $IX89898 = self::LAST_SEVEN_DAYS; break; case 'last-thirty-days' : $IX89898 = self::LAST_THIRTY_DAYS; break; case 'last-ninety-days' : $IX89898 = self::LAST_NINETY_DAYS; break; case 'weekly' : $IX89898 = self::LAST_NINETY_DAYS; $IX66267 = 'week'; break; case 'monthly' : $IX89898 = self::LAST_TWELVE_MONTHS; $IX66267 = 'month'; break; case 'yearly' : $IX89898 = self::LAST_THREE_YEARS; $IX66267 = 'year'; break; case 'custom' : $IX79962 = !empty( $_REQUEST['from-date'] ) ? date( 'Y-m-d', strtotime( $_REQUEST['from-date'] ) ) : date( 'Y-m-d', strtotime( $IX16535 ) ); $IX65654 = !empty( $_REQUEST['thru-date'] ) ? date( 'Y-m-d', strtotime( $_REQUEST['thru-date'] ) ) : date( 'Y-m-d', strtotime( $IX42009 ) ); if ( strtotime( $IX79962 ) > strtotime( $IX65654 ) ) { $IX89996 = $IX79962; $IX79962 = $IX65654; $IX65654 = $IX89996; } $this->from_date = $IX79962; $this->thru_date = $IX65654; $IX89898 = self::LEAD + ( strtotime( $IX65654 ) - strtotime( $IX79962 ) ) / ( 3600 * 24 ) + self::TRAIL; if ( $IX89898 <= self::DAILY_THRESHOLD ) { $IX66267 = null; } else if ( $IX89898 <= self::WEEKLY_THRESHOLD ) { $IX66267 = 'week'; } else if ( $IX89898 <= self::MONTHLY_THRESHOLD ) { $IX66267 = 'month'; } else { $IX66267 = 'year'; } break; default : $this->selected = 'last-ninety-days'; $IX89898 = self::LAST_NINETY_DAYS; } } if ( $this->selected !== 'custom' ) { if ( !isset( $IX65654 ) ) { $IX65654 = date( 'Y-m-d', strtotime( $IX42009 ) ); } switch ( $IX66267 ) { case 'week' : $IX16535 = strtotime( $IX65654 ) - $IX89898 * 3600 * 24; $IX58047 = date( 'o', $IX16535 ); $IX76249 = date( 'W', $IX16535 ); $IX19936 = new DateTime(); $IX79962 = $IX19936->setISODate( $IX58047, $IX76249 )->format( 'Y-m-d' ); $IX65654 = $IX42009; break; case 'month' : $IX79962 = date( 'Y-m-01', strtotime( $IX65654 ) - $IX89898 * 3600 * 24 ); $IX65654 = $IX42009; break; case 'year' : $IX79962 = date( 'Y-01-01', strtotime( $IX65654 ) - $IX89898 * 3600 * 24 ); $IX65654 = $IX42009; break; default : $IX79962 = date( 'Y-m-d', strtotime( $IX65654 ) - $IX89898 * 3600 * 24 ); $IX65654 = $IX42009; } $this->from_date = null; $this->thru_date = null; } if ( isset( $_REQUEST['clear_filters'] ) ) { $IX65654 = $IX42009; $IX79962 = $IX16535; $this->selected = 'last-ninety-days'; $IX89898 = self::LAST_NINETY_DAYS; $this->from_date = null; $this->thru_date = null; } $IX89680 = 0; $IX55559 = 0; $IX34748 = 0; $IX76569 = array(); $IX84707 = array(); $IX30967 = $this->get_affiliate_id(); $IX54615 = $this->get_hits_query(); $IX59796 = $wpdb->get_results( $wpdb->prepare( $IX54615, $IX79962, $IX65654, intval( $IX30967 ) ) ); $IX39911 = array(); foreach ( $IX59796 as $IX32316 ) { if ( $IX66267 !== null ) { $IX59887 = self::map_date( $IX32316->date, $IX66267 ); $IX84707[$IX59887] = $IX59887; if ( !isset( $IX39911[$IX59887] ) ) { $IX39911[$IX59887] = 0; } $IX39911[$IX59887] += $IX32316->hits; } else { $IX39911[$IX32316->date] = $IX32316->hits; } $IX89680 += $IX32316->hits; } $IX54615 = $this->get_visits_query(); $IX81526 = $wpdb->get_results( $wpdb->prepare( $IX54615, $IX79962, $IX65654, intval( $IX30967 ) ) ); $IX15227 = array(); foreach ( $IX81526 as $IX95134 ) { if ( $IX66267 !== null ) { $IX59887 = self::map_date( $IX95134->date, $IX66267 ); $IX84707[$IX59887] = $IX59887; if ( !isset( $IX15227[$IX59887] ) ) { $IX15227[$IX59887] = 0; } $IX15227[$IX59887] += $IX95134->visits; } else { $IX15227[$IX95134->date] = $IX95134->visits; } $IX55559 += $IX95134->visits; } $IX54615 = $this->get_referrals_query(); $IX54615 = $wpdb->prepare( $IX54615, AFFILIATES_REFERRAL_STATUS_ACCEPTED, AFFILIATES_REFERRAL_STATUS_CLOSED, $IX79962, $IX65654, intval( $IX30967 ) ); $IX14784 = $wpdb->get_results( $IX54615 ); $IX10700 = array(); foreach ( $IX14784 as $IX17611 ) { if ( $IX66267 !== null ) { $IX59887 = self::map_date( $IX17611->date, $IX66267 ); $IX84707[$IX59887] = $IX59887; if ( !isset( $IX10700[$IX59887] ) ) { $IX10700[$IX59887] = 0; } $IX10700[$IX59887] += $IX17611->referrals; } else { $IX10700[$IX17611->date] = $IX17611->referrals; } $IX34748 += $IX17611->referrals; } $IX54615 = $this->get_amounts_query(); $IX54615 = $wpdb->prepare( $IX54615, AFFILIATES_REFERRAL_STATUS_ACCEPTED, AFFILIATES_REFERRAL_STATUS_CLOSED, $IX79962, $IX65654, intval( $IX30967 ) ); $IX14784 = $wpdb->get_results( $IX54615 ); $IX14344 = array(); foreach ( $IX14784 as $IX17611 ) { if ( $IX66267 !== null ) { $IX59887 = self::map_date( $IX17611->date, $IX66267 ); $IX84707[$IX59887] = $IX59887; if ( !isset( $IX14344[$IX17611->currency_id][$IX59887] ) ) { $IX14344[$IX17611->currency_id][$IX59887] = 0; } $IX14344[$IX17611->currency_id][$IX59887] += $IX17611->amount; } else { $IX14344[$IX17611->currency_id][$IX17611->date] = $IX17611->amount; } if ( !isset( $IX76569[$IX17611->currency_id] ) ) { $IX76569[$IX17611->currency_id] = 0; } $IX76569[$IX17611->currency_id] += $IX17611->amount; } $this->totals['hits'] = $IX89680; $this->totals['visits'] = $IX55559; $this->totals['referrals'] = $IX34748; $this->totals['amounts_by_currency'] = $IX76569; $IX35468 = array(); $IX41703 = array(); $IX11884 = array(); $IX92373 = array(); $IX42653 = array(); $IX96267 = array(); if ( $IX66267 !== null ) { $IX65654 = self::map_date( $IX65654, $IX66267 ); } if ( $this->selected !== 'custom' ) { switch ( $IX66267 ) { case 'week' : $IX89898 = 12; $IX39425 = 12; $IX92538 = 'week'; break; case 'month' : $IX89898 = 12; $IX39425 = 12; $IX92538 = 'month'; break; case 'year' : $IX89898 = 3; $IX39425 = 3; $IX92538 = 'year'; break; default : $IX39425 = $IX89898; $IX92538 = 'day'; } } else { switch ( $IX66267 ) { case 'week' : $IX89898 = ceil( $IX89898 / 7 ); $IX39425 = $IX89898; $IX92538 = 'week'; break; case 'month' : $IX89898 = ceil( $IX89898 / ( 365 / 12 ) ); $IX39425 = $IX89898; $IX92538 = 'month'; break; case 'year' : $IX89898 = ceil( $IX89898 / 365 ); $IX39425 = $IX89898; $IX92538 = 'year'; break; default : $IX39425 = $IX89898; $IX92538 = 'day'; } } for ( $IX89212 = - $IX89898 - self::TRAIL; $IX89212 <= self::LEAD; $IX89212++ ) { $IX43802 = date( 'Y-m-d', strtotime( $IX65654 . '+' . $IX89212 . $IX92538 ) ); $IX42653[$IX89212] = $IX43802; if ( isset( $IX10700[$IX43802] ) ) { $IX35468[] = array( $IX89212, intval( $IX10700[$IX43802] ) ); } else { $IX35468[] = array( $IX89212, 0 ); } if ( isset( $IX39911[$IX43802] ) ) { $IX41703[] = array( $IX89212, intval( $IX39911[$IX43802] ) ); } else { $IX41703[] = array( $IX89212, 0 ); } if ( isset( $IX15227[$IX43802] ) ) { $IX11884[] = array( $IX89212, intval( $IX15227[$IX43802] ) ); } else { $IX11884[] = array( $IX89212, 0 ); } foreach ( $IX14344 as $IX10658 => $IX51835 ) { if ( isset( $IX14344[$IX10658][$IX43802] ) ) { $IX96267[$IX10658][] = array( $IX89212, affiliates_format_referral_amount( floatval( $IX14344[$IX10658][$IX43802] ), 'display' ) ); } else { $IX96267[$IX10658][] = array( $IX89212, affiliates_format_referral_amount( 0.0, 'display' ) ); } } if ( $IX66267 !== null ) { if ( $IX89212 !== - $IX89898 - self::TRAIL && $IX89212 !== self::LEAD ) { if ( $IX66267 == 'week' ) { $IX83865 = intval( date( 'd', strtotime( $IX43802 ) ) ); if ( 1 <= $IX83865 && $IX83865 <= 7 ) { $IX14049 = esc_html( date_i18n( 'd M Y', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } } else if ( $IX66267 == 'month' ) { if ( $IX89898 <= self::MONTHS_TICK_THRESHOLD || $IX89212 % 3 === 0 ) { $IX83865 = intval( date( 'm' , strtotime( $IX43802 ) ) ); if ( $IX83865 === 1 ) { $IX14049 = esc_html( date_i18n( 'M Y', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } else { $IX14049 = esc_html( date_i18n( 'M', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } } } else { if ( $IX66267 == 'year' ) { $IX83865 = intval( date( 'm', strtotime( $IX43802 ) ) ); if ( $IX83865 === 1 ) { $IX14049 = esc_html( date_i18n( 'Y', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } } } } } else { $IX19936 = intval( date( 'd', strtotime( $IX43802 ) ) ); if ( $IX89898 == self::LAST_SEVEN_DAYS ) { if ( $IX89212 !== - $IX89898 - self::TRAIL && $IX89212 !== self::LEAD ) { $IX14049 = esc_html( date_i18n( 'd M', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } } else if ( $IX89898 == self::LAST_THIRTY_DAYS ) { if ( $IX89212 !== - $IX89898 - self::TRAIL && $IX89212 !== self::LEAD && $IX19936 < 28 && $IX19936 % 5 === 1 ) { $IX14049 = esc_html( date_i18n( 'd M', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } } else { if ( $IX19936 === 1 ) { $IX14049 = esc_html( date_i18n( 'M Y', strtotime( $IX43802 ) ) ); $IX92373[] = array( $IX89212, $IX14049 ); } } } } $IX76232 = array( array( intval( - $IX39425 - self::TRAIL ), self::LEAD ), array( 0, 0 ) ); $this->series = array( 'hits' => $IX41703, 'visits' => $IX11884, 'referrals' => $IX35468, 'span' => $IX76232, 'ticks' => $IX92373, 'dates' => $IX42653, 'amounts_by_currency' => $IX96267 ); $IX89403 = wp_json_encode( $IX35468 ); $IX37858 = wp_json_encode( $IX41703 ); $IX76027 = wp_json_encode( $IX11884 ); $IX16656 = wp_json_encode( $IX76232 ); $IX54081 = wp_json_encode( $IX92373 ); $IX86839 = wp_json_encode( $IX42653 ); $IX81337 = wp_json_encode( $IX96267 ); echo '<script type="text/javascript">'; echo 'document.addEventListener( "DOMContentLoaded", function() {'; echo 'if ( typeof jQuery !== "undefined" ) {'; echo 'if ( typeof affiliates_dashboard_overview_graph !== "undefined" ) {'; printf( 'affiliates_dashboard_overview_graph.render( "%s", "%s", %s, %s, %s, %s, %s, %s, %s );', 'affiliates-dashboard-overview-graph', 'affiliates-dashboard-overview-legend', $IX37858, $IX76027, $IX89403, $IX81337, $IX16656, $IX54081, $IX86839 ); echo '}'; echo '}'; echo '} );'; echo '</script>'; wp_localize_script( 'overview-controls', 'affiliates_overview_controls', array( 'pname' => get_option( 'aff_pname', AFFILIATES_PNAME ), 'site_url' => home_url(), 'affiliate_id' => affiliates_encode_affiliate_id( $this->get_affiliate_id() ) ) ); parent::render(); }

	/**
	 * Provides the per-currency totals
	 *
	 * @return array
	 */
	public function get_totals() { return $this->totals; }

	/**
	 * Get section name
	 *
	 * @return string
	 */
	public static function get_name() { return __( 'Overview', 'affiliates' ); }

	/**
	 * Get key
	 *
	 * @return string
	 */
	public static function get_key() { return 'overview'; }

	/**
	 * Get selected filter
	 *
	 * @return string
	 */
	public function get_selected() { return $this->selected; }

	/**
	 * Get From date
	 *
	 * @return string
	 */
	public function get_from_date() { return $this->from_date; }

	/**
	 * Get Through date
	 *
	 * @return string
	 */
	public function get_thru_date() { return $this->thru_date; }

	protected static function map_date( $date, $period = 'day', $limit = 'start' ) { $IX49306 = null; switch( $period ) { case 'week' : $IX72638 = new DateTime(); $IX34987 = $IX72638->setISODate( date( 'Y', strtotime( $date ) ), date( 'W', strtotime( $date ) ) )->format( 'Y-m-d' ); $IX54932 = $IX72638->modify( '+6 days' )->format( 'Y-m-d' ); break; case 'month' : $IX72638 = new DateTime(); $IX34987 = $IX72638->setDate( date( 'Y', strtotime( $date ) ), date( 'm', strtotime( $date ) ), 1 )->format( 'Y-m-d' ); $IX54932 = $IX72638->modify( '+1 month' )->modify( '-1 day' )->format( 'Y-m-d' ); break; case 'year' : $IX72638 = new DateTime(); $IX34987 = $IX72638->setDate( date( 'Y', strtotime( $date ) ), 1, 1 )->format( 'Y-m-d' ); $IX54932 = $IX72638->modify( '+1 year' )->modify( '-1 day' )->format( 'Y-m-d' ); break; default : $IX72638 = new DateTime(); $IX34987 = $IX72638->setDate( date( 'Y', strtotime( $date ) ), date( 'm', strtotime( $date ) ), date( 'd', strtotime( $date ) ) )->format( 'Y-m-d' ); $IX54932 = $IX34987; } switch ( $limit ) { case 'end' : $IX49306 = $IX54932; break; default : $IX49306 = $IX34987; } return $IX49306; }

	protected function get_hits_query() { global $affiliates_db; $IX69461 = $affiliates_db->get_tablename( 'hits' ); return "SELECT COUNT(*) as hits, date FROM $IX69461 WHERE date >= %s AND date <= %s AND affiliate_id = %d GROUP BY date ORDER BY date "; }

	protected function get_visits_query() { global $affiliates_db; $IX87192 = $affiliates_db->get_tablename( 'hits' ); return "SELECT count(DISTINCT IP) visits, date FROM $IX87192 WHERE date >= %s AND date <= %s AND affiliate_id = %d GROUP BY date ORDER BY date"; }

	protected function get_referrals_query() { global $affiliates_db; $IX10606 = $affiliates_db->get_tablename( 'referrals' ); return "SELECT count(referral_id) referrals, date(datetime) date FROM $IX10606 WHERE status IN (%s,%s) AND date(datetime) >= %s AND date(datetime) <= %s AND affiliate_id = %d GROUP BY date ORDER BY date"; }

	protected function get_amounts_query() { global $affiliates_db; $IX86781 = $affiliates_db->get_tablename( 'referrals' ); return "SELECT sum(amount) amount, currency_id, date(datetime) date FROM $IX86781 WHERE status IN (%s,%s) AND date(datetime) >= %s AND date(datetime) <= %s AND affiliate_id = %d GROUP BY date, currency_id ORDER BY date"; }

}
Affiliates_Dashboard_Overview_Pro::init();
