<?php
/**
 * class-affiliates-export.php
 *
 * Copyright 2015 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 2.11.0
 */

/**
 * Handles exporting affiliate data.
 */
class Affiliates_Export {

	private $charset = 'UTF-8';

	public function __construct() { $this->charset = get_option( 'blog_charset' ); }

	public function __set( $name, $value ) { switch( $name ) { case 'charset' : $this->charset = $value; break; } }

	public function __get( $name ) { $IX39317 = null; switch( $name ) { case 'charset' : $IX39317 = $this->charset; break; } return $IX39317; }

	public function request() { $IX44076 = date( 'Y-m-d-H-i-s', time() ); header( 'Content-Description: File Transfer' ); if ( !empty( $this->charset ) ) { header( 'Content-Type: text/tab-separated-values; charset=' . $this->charset ); } else { header( 'Content-Type: text/tab-separated-values' ); } header( "Content-Disposition: attachment; filename=\"affiliates-export-$IX44076.tsv\"" ); $this->entries(); echo "\n"; }

	private function entries() { global $wpdb, $affiliates_db, $affiliates_options; $IX72014 = $affiliates_db->get_tablename( 'affiliates' ); $IX70919 = $affiliates_db->get_tablename( 'affiliates_users' ); $IX78332 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX80003 = date( 'Y-m-d', time() ); $IX38429 = array( 'affiliate_id' => __( 'Id', 'affiliates' ), 'name' => __( 'Affiliate', 'affiliates' ), 'email' => __( 'Email', 'affiliates' ), 'user_login' => __( 'Username', 'affiliates' ), 'from_date' => __( 'From', 'affiliates' ), 'thru_date' => __( 'Until', 'affiliates' ), 'links' => __( 'Links', 'affiliates' ), ); foreach ( Affiliates_Attributes::get_keys() as $IX52127 => $IX78364 ) { $IX52127 = '_attr_' . preg_replace( '/(\.|\-)/', '_', $IX52127 ); $IX38429[$IX52127] = $IX78364; } $IX64124 = array(); foreach( array_keys( $IX38429 ) as $IX21099 ) { $IX21099 = preg_replace( '/(\.|\-)/', '_', $IX21099 ); switch( $IX21099 ) { case 'name' : case 'email' : case 'user_login' : $IX64124[$IX21099] = true; break; default : $IX64124[$IX21099] = false; } } $IX55793 = $IX64124; foreach( $affiliates_options->get_option( 'affiliates_overview_columns', array() ) as $IX21099 => $IX48318 ) { $IX55793[$IX21099] = $IX48318; } $IX35563 = array(); foreach( $IX38429 as $IX21099 => $IX29030 ) { $IX78190 = preg_replace( '/(\.|\-)/', '_', $IX21099 ); if ( isset( $IX55793[$IX78190] ) && $IX55793[$IX78190] ) { $IX35563[] = $IX29030; } } require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings.php'; require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings-registration.php'; $IX36401 = Affiliates_Settings_Registration::get_fields(); foreach( Affiliates_Registration::get_skip_meta_fields() as $IX21099 ) { unset( $IX36401[$IX21099] ); } if ( !empty( $IX36401 ) ) { foreach( $IX36401 as $IX13765 => $IX91158 ) { if ( isset( $IX55793[$IX13765] ) && $IX55793[$IX13765] && $IX91158['enabled'] ) { $IX35563[] = stripslashes( $IX91158['label'] ); } } } $IX88746 = count( $IX35563 ); for ( $IX50377 = 0; $IX50377 < $IX88746; $IX50377++ ) { echo $IX35563[$IX50377]; if ( $IX50377 < $IX88746 - 1 ) { echo "\t"; } } echo "\n"; $IX64521 = $affiliates_options->get_option( 'affiliates_from_date', null ); $IX59157 = null; $IX34551 = $affiliates_options->get_option( 'affiliates_thru_date', null ); $IX89717 = null; $IX58006 = $affiliates_options->get_option( 'affiliates_affiliate_id', null ); $IX26206 = $affiliates_options->get_option( 'affiliates_affiliate_name', null ); $IX11522 = $affiliates_options->get_option( 'affiliates_affiliate_email', null ); $IX32835 = $affiliates_options->get_option( 'affiliates_affiliate_user_login', null ); $IX49391 = $affiliates_options->get_option( 'affiliates_show_deleted', false ); $IX92789 = $affiliates_options->get_option( 'affiliates_show_inoperative', false ); $IX53049 = $affiliates_options->get_option( 'affiliates_show_totals', true ); $IX56898 = array( " 1=%d " ); $IX92493 = array( 1 ); if ( $IX58006 ) { $IX56898[] = " $IX72014.affiliate_id = %d "; $IX92493[] = $IX58006; } if ( $IX26206 ) { $IX56898[] = " $IX72014.name LIKE '%%%s%%' "; $IX92493[] = $IX26206; } if ( $IX11522 ) { $IX56898[] = " $IX72014.email LIKE '%%%s%%' "; $IX92493[] = $IX11522; } if ( $IX32835 ) { $IX56898[] = " $wpdb->users.user_login LIKE '%%%s%%' "; $IX92493[] = $IX32835; } if ( !$IX49391 ) { $IX56898[] = " $IX72014.status = %s "; $IX92493[] = 'active'; } if ( !$IX92789 ) { $IX56898[] = " $IX72014.from_date <= %s AND ( $IX72014.thru_date IS NULL OR $IX72014.thru_date >= %s ) "; $IX92493[] = $IX80003; $IX92493[] = $IX80003; } if ( $IX59157 && $IX89717 ) { $IX56898[] = " $IX72014.from_date >= %s AND ( $IX72014.thru_date IS NULL OR $IX72014.thru_date < %s ) "; $IX92493[] = $IX59157; $IX92493[] = $IX89717; } else if ( $IX59157 ) { $IX56898[] = " $IX72014.from_date >= %s "; $IX92493[] = $IX59157; } else if ( $IX89717 ) { $IX56898[] = " $IX72014.thru_date < %s "; $IX92493[] = $IX89717; } if ( !empty( $IX56898 ) ) { $IX56898 = " WHERE " . implode( " AND ", $IX56898 ); } else { $IX56898 = ''; } $IX54838 = $wpdb->prepare( "SELECT $IX72014.*, $wpdb->users.* " . "FROM $IX72014 " . "LEFT JOIN $IX70919 ON $IX72014.affiliate_id = $IX70919.affiliate_id " . "LEFT JOIN $wpdb->users on $IX70919.user_id = $wpdb->users.ID " . "$IX56898 ", $IX92493 ); $IX19478 = $wpdb->get_results( $IX54838, OBJECT ); foreach( $IX19478 as $IX62961 ) { $IX78825 = array(); if ( isset( $IX55793['affiliate_id'] ) && $IX55793['affiliate_id'] ) { $IX78825[] = $IX62961->affiliate_id; } if ( isset( $IX55793['name'] ) && $IX55793['name'] ) { $IX78825[] = stripslashes( wp_filter_nohtml_kses( $IX62961->name ) ); } if ( isset( $IX55793['email'] ) && $IX55793['email'] ) { $IX78825[] = $IX62961->email; } if ( isset( $IX55793['user_login'] ) && $IX55793['user_login'] ) { $IX78825[] = $IX62961->user_login; } if ( isset( $IX55793['from_date'] ) && $IX55793['from_date'] ) { $IX78825[] = $IX62961->from_date; } if ( isset( $IX55793['thru_date'] ) && $IX55793['thru_date'] ) { $IX78825[] = $IX62961->thru_date; } if ( isset( $IX55793['links'] ) && $IX55793['links'] ) { $IX78825[] = Affiliates_Url_Renderer::get_affiliate_url( home_url(), $IX62961->affiliate_id ); } foreach( Affiliates_Attributes::get_keys() as $IX52127 => $IX78364 ) { $IX46010 = $IX52127; $IX52127 = '_attr_' . preg_replace( '/(\.|\-)/', '_', $IX52127 ); if ( isset( $IX55793[$IX52127] ) && $IX55793[$IX52127] ) { $IX99183 = $affiliates_db->get_value( "SELECT attr_value FROM $IX78332 WHERE affiliate_id = %d AND attr_key = %s", $IX62961->affiliate_id, $IX46010 ); $IX78825[] = wp_filter_nohtml_kses( $IX99183 ); } } if ( !empty( $IX36401 ) ) { foreach( $IX36401 as $IX13765 => $IX91158 ) { if ( isset( $IX55793[$IX13765] ) && $IX55793[$IX13765] && $IX91158['enabled'] ) { $IX94573 = isset( $IX91158['type'] ) ? $IX91158['type'] : 'text'; $IX48318 = ''; switch( $IX13765 ) { case 'user_login' : $IX48318 = $IX71249->user_login; break; case 'user_email' : $IX48318 = $IX71249->user_email; break; case 'user_url' : $IX48318 = $IX71249->user_url; break; case 'password' : $IX48318 = ''; break; default : $IX48318 = get_user_meta( $IX62961->ID, $IX13765 , true ); } $IX78825[] = stripslashes( $IX48318 ); } } } $IX88746 = count( $IX78825 ); for ( $IX50377 = 0; $IX50377 < $IX88746; $IX50377++ ) { echo $IX78825[$IX50377]; echo "\t"; } echo "\n"; } }

	public static function init() { add_action( 'init', array(__CLASS__,'wp_init' ) ); }

	public static function wp_init() { if ( isset( $_REQUEST['action'] ) && $_REQUEST['action'] == 'export' && wp_verify_nonce( $_REQUEST['export-nonce'], 'export-affiliates' ) ) { if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX90348 = new Affiliates_Export(); $IX90348->request(); die; } }

}
Affiliates_Export::init();
