<?php
/**
 * class-affiliates-rate.php
 * 
 * Copyright 2017 "kento" Karim Rahimpur - www.itthinx.com
 * 
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author itthinx
 * @package affiliates-pro
 * @since affiliates-pro 3.0.0
 */

/**
 * Rate object.
 */
class Affiliates_Rate {

	protected $rate_id      = null;
	protected $type         = null;
	protected $value        = null;
	protected $currency_id  = null;
	protected $affiliate_id = null;
	protected $group_id     = null;
	protected $object_id    = null;
	protected $term_id      = null;
	protected $level        = null;
	protected $integration  = null;
	protected $description  = null;
	protected $metas        = null;

	public function __construct( $o = null ) { self::initialize( $this, $o ); }

	private static function initialize( &$rate, $o ) { if ( isset( $o->rate_id ) ) { $rate->rate_id = $o->rate_id !== null ? intval( $o->rate_id ) : null; } if ( isset( $o->type ) ) { $rate->type = $o->type; } if ( isset( $o->value ) ) { $rate->value = $o->value; } if ( isset( $o->currency_id ) ) { $rate->currency_id = $o->currency_id; } if ( isset( $o->affiliate_id ) ) { $rate->affiliate_id = $o->affiliate_id !== null ? intval( $o->affiliate_id ) : null; } if ( isset( $o->group_id ) ) { $rate->group_id = $o->group_id !== null ? intval( $o->group_id ) : null; } if ( isset( $o->object_id ) ) { $rate->object_id = $o->object_id !== null ? intval( $o->object_id ) : null; } if ( isset( $o->term_id ) ) { $rate->term_id = $o->term_id !== null ? intval( $o->term_id ) : null; } if ( isset( $o->level ) ) { $rate->level = $o->level !== null ? intval( $o->level ) : null; } if ( isset( $o->integration ) ) { $rate->integration = $o->integration; } if ( isset( $o->description ) ) { $rate->description = $o->description; } if ( isset( $o->metas ) ) { $rate->metas = $o->metas; } }

	public function create() { global $affiliates_db; $IX20160 = null; if ( $this->rate_id === null ) { $IX90413 = $affiliates_db->get_tablename( 'rates' ); $IX16022 = array(); $IX65799 = array(); if ( $this->type !== null ) { $IX16022[] = 'type = %s'; $IX65799[] = $this->type; } if ( $this->value !== null ) { $IX16022[] = 'value = %s'; $IX65799[] = $this->value; } if ( $this->currency_id !== null ) { $IX16022[] = 'currency_id = %s'; $IX65799[] = $this->currency_id; } if ( $this->affiliate_id !== null ) { $IX16022[] = 'affiliate_id = %d'; $IX65799[] = intval( $this->affiliate_id ); } if ( $this->group_id !== null ) { $IX16022[] = 'group_id = %d'; $IX65799[] = intval( $this->group_id ); } if ( $this->object_id !== null ) { $IX16022[] = 'object_id = %d'; $IX65799[] = intval( $this->object_id ); } if ( $this->term_id !== null ) { $IX16022[] = 'term_id = %d'; $IX65799[] = intval( $this->term_id ); } if ( $this->level !== null ) { $IX16022[] = 'level = %d'; $IX65799[] = intval( $this->level ); } if ( $this->integration !== null ) { $IX16022[] = 'integration = %s'; $IX65799[] = $this->integration; } if ( $this->description !== null ) { $IX16022[] = 'description = %s'; $IX65799[] = $this->description; } if ( count( $IX16022 ) > 0 ) { $IX73926 = "INSERT INTO $IX90413 SET " . implode( ',', $IX16022 ); if ( $affiliates_db->query( $IX73926, $IX65799 ) ) { if ( $this->rate_id = $affiliates_db->get_value( 'SELECT LAST_INSERT_ID()' ) ) { $IX20160 = $this->rate_id; if ( !empty( $this->metas ) ) { $IX50228 = $affiliates_db->get_tablename( 'rates_metas' ); foreach( $this->metas as $IX70342 => $IX62399 ) { $IX73926 = "INSERT INTO $IX50228 SET rate_id = %d, meta_key = %s, meta_value = %s"; $IX62399 = serialize( $IX62399 ); $affiliates_db->query( $IX73926, intval( $this->rate_id ), $IX70342, $IX62399 ); } } } } } } return $IX20160; }

	public function read( $rate_id ) { global $affiliates_db; $IX83040 = null; $IX36788 = $affiliates_db->get_tablename( 'rates' ); if ( $IX73025 = $affiliates_db->get_objects( "SELECT * FROM $IX36788 WHERE rate_id = %d", intval( $rate_id ) ) ) { if ( $IX56761 = array_shift( $IX73025 ) ) { self::initialize( $this, $IX56761 ); $IX83040 = $this; $IX73047 = $affiliates_db->get_tablename( 'rates_metas' ); if ( $IX77717 = $affiliates_db->get_objects( "SELECT * FROM $IX73047 WHERE rate_id = %d", intval( $rate_id ) ) ) { $this->metas = array(); foreach( $IX77717 as $IX55497 ) { $this->metas[$IX55497->meta_key] = unserialize( $IX55497->meta_value ); } } } } return $IX83040; }

	public function update() { global $affiliates_db; $IX61952 = false; $IX83569 = $affiliates_db->get_tablename( 'rates' ); if ( $this->rate_id !== null ) { $IX34855 = array(); $IX20363 = array(); if ( $this->type !== null ) { $IX34855[] = 'type = %s'; $IX20363[] = $this->type; } else { $IX34855[] = 'type = NULL'; } if ( $this->value !== null ) { $IX34855[] = 'value = %s'; $IX20363[] = $this->value; } else { $IX34855[] = 'value = NULL'; } if ( $this->currency_id !== null ) { $IX34855[] = 'currency_id = %s'; $IX20363[] = $this->currency_id; } else { $IX34855[] = 'currency_id = NULL'; } if ( $this->affiliate_id !== null ) { $IX34855[] = 'affiliate_id = %d'; $IX20363[] = intval( $this->affiliate_id ); } else { $IX34855[] = 'affiliate_id = NULL'; } if ( $this->group_id !== null ) { $IX34855[] = 'group_id = %d'; $IX20363[] = intval( $this->group_id ); } else { $IX34855[] = 'group_id = NULL'; } if ( $this->object_id !== null ) { $IX34855[] = 'object_id = %d'; $IX20363[] = intval( $this->object_id ); } else { $IX34855[] = 'object_id = NULL'; } if ( $this->term_id !== null ) { $IX34855[] = 'term_id = %d'; $IX20363[] = intval( $this->term_id ); } else { $IX34855[] = 'term_id = NULL'; } if ( $this->level !== null ) { $IX34855[] = 'level = %d'; $IX20363[] = intval( $this->level ); } else { $IX34855[] = 'level = NULL'; } if ( $this->integration !== null ) { $IX34855[] = 'integration = %s'; $IX20363[] = $this->integration; } else { $IX34855[] = 'integration = NULL'; } if ( $this->description !== null ) { $IX34855[] = 'description = %s'; $IX20363[] = $this->description; } else { $IX34855[] = 'description = NULL'; } $IX20363[] = intval( $this->rate_id ); if ( count( $IX34855 ) > 0 ) { $IX98923 = "UPDATE $IX83569 SET " . implode( ',', $IX34855 ) . " WHERE rate_id = %d"; if ( $affiliates_db->query( $IX98923, $IX20363 ) ) { $IX61952 = true; } } $IX64298 = false; $IX54557 = Affiliates_Rate::get_rate_by_id( $this->rate_id ); if ( !empty( $this->metas ) ) { foreach( $this->metas as $IX23187 => $IX82234 ) { if ( !$IX54557->has_meta( $IX23187 ) || ( $IX54557->get_meta( $IX23187 ) != $IX82234 ) ) { $IX64298 = true; } } } if ( !empty( $IX54557->metas ) ) { foreach( $IX54557->metas as $IX23187 => $IX82234 ) { if ( !$this->has_meta( $IX23187 ) || ( $this->get_meta( $IX23187 ) != $IX82234 ) ) { $IX64298 = true; } } } if ( $IX64298 ) { $IX61952 = true; $IX69485 = $affiliates_db->get_tablename( 'rates_metas' ); $affiliates_db->query( "DELETE FROM $IX69485 WHERE rate_id = %d", intval( $this->rate_id ) ); if ( !empty( $this->metas ) ) { foreach( $this->metas as $IX23187 => $IX82234 ) { $IX98923 = "INSERT INTO $IX69485 SET rate_id = %d, meta_key = %s, meta_value = %s"; $IX82234 = serialize( $IX82234 ); $affiliates_db->query( $IX98923, intval( $this->rate_id ), $IX23187, $IX82234 ); } } } } return $IX61952; }

	public function delete() { global $affiliates_db; $IX36949 = false; if ( $this->rate_id !== null ) { $IX10021 = $affiliates_db->get_tablename( 'rates' ); if ( $affiliates_db->query( "DELETE FROM $IX10021 WHERE rate_id = %d", intval( $this->rate_id ) ) ) { $IX36949 = true; $IX28691 = $affiliates_db->get_tablename( 'rates_metas' ); $affiliates_db->query( "DELETE FROM $IX28691 WHERE rate_id = %d", intval( $this->rate_id ) ); } } return $IX36949; }

	public function __get( $name ) { $IX49846 = null; switch( $name ) { case 'rate_id' : case 'affiliate_id' : case 'group_id' : case 'object_id' : case 'term_id' : case 'level' : if ( $this->$name !== null ) { $IX49846 = intval( $this->$name ); } else { $IX49846 = null; } break; case 'type' : case 'value' : case 'currency_id' : case 'metas' : case 'integration' : case 'description' : $IX49846 = $this->$name; break; } return $IX49846; }

	public function __set( $name, $value ) { switch( $name ) { case 'rate_id' : case 'affiliate_id' : case 'group_id' : case 'object_id' : case 'term_id' : case 'level' : if ( $value !== null ) { $this->$name = intval( $value ); } else { $this->$name = null; } break; case 'type' : case 'value' : case 'currency_id' : case 'metas' : case 'integration' : case 'description' : $this->$name = $value; break; } }

	public function to_array() { $IX95121 = array( 'rate_id' => $this->rate_id, 'type' => $this->type, 'value' => $this->value, 'currency_id' => $this->currency_id, 'affiliate_id' => $this->affiliate_id, 'group_id' => $this->group_id, 'object_id' => $this->object_id, 'term_id' => $this->term_id, 'level' => $this->level, 'metas' => $this->metas, 'integration' => $this->integration, 'description' => $this->description ); return $IX95121; }

	/**
	 * Returns rates.
	 * $params will obtain all rates by default and accepts type, value, currency_id, affiliate_id, group_id, object_id, term_id, level, integration and description to obtain a matching subset of rates
	 * $params allows to indicate the order (asc,desc), orderby (rate_id, type, ...), limit and offset.
	 *
	 * @param array $params accepts key-value pairs to determine the subset of rates and the order
	 *
	 * @return array of Affiliates_Rate
	 */
	public static function get_rates( $params = array() ) { global $affiliates_db, $wpdb; $IX58026 = array( 'type' => null, 'value' => null, 'currency_id' => null, 'affiliate_id' => null, 'group_id' => null, 'object_id' => null, 'term_id' => null, 'level' => null, 'integration' => null, 'description' => null, 'order' => 'asc', 'orderby' => 'rate_id', 'limit' => null, 'offset' => null ); $params = array_merge( $IX58026, $params ); $IX44627 = ''; $IX40803 = array(); $IX10893 = array(); foreach ( $params as $IX48329 => $IX96993 ) { if ( $IX96993 !== null ) { switch( $IX48329 ) { case 'type' : switch ( $IX96993 ) { case AFFILIATES_PRO_RATES_TYPE_AMOUNT : case AFFILIATES_PRO_RATES_TYPE_RATE : case AFFILIATES_PRO_RATES_TYPE_FORMULA : $IX40803[] = 'type = %s'; $IX10893[] = $IX96993; break; } break; case 'value' : case 'currency_id' : case 'integration' : $IX40803[] = $IX48329 . ' = %s'; $IX10893[] = $IX96993; break; case 'description' : $IX40803[] = 'description LIKE "%s"'; $IX10893[] = '%' . $wpdb->esc_like( $IX96993 ) .'%'; break; case 'affiliate_id' : case 'group_id' : case 'object_id' : case 'term_id' : case 'level' : $IX40803[] = $IX48329 . ' = %d'; $IX10893[] = intval( $IX96993 ); break; } } } if ( count( $IX40803 ) > 0 ) { $IX44627 = ' WHERE ' . implode( ' AND ', $IX40803 ) . ' '; } $IX49867 = !empty( $params['order'] ) ? $params['order'] : 'asc'; $IX49557 = !empty( $params['orderby'] ) ? $params['orderby'] : 'rate_id'; $IX93593 = !empty( $params['limit'] ) ? intval( $params['limit'] ) : null; $IX76556 = !empty( $params['offset'] ) ? intval( $params['offset'] ) : null; switch( $IX49867 ) { case 'asc' : case 'desc' : break; default : $IX49867 = 'asc'; } switch( $IX49557 ) { case 'rate_id' : case 'type' : case 'value' : case 'currency_id' : case 'affiliate_id' : case 'group_id' : case 'object_id' : case 'term_id' : case 'level' : case 'integration' : case 'description' : break; default : $IX49557 = 'rate_id'; } $IX23820 = $affiliates_db->get_tablename( 'rates' ); $IX32426 = "SELECT * FROM $IX23820 $IX44627 ORDER BY $IX49557 $IX49867"; if ( $IX93593 !== null ) { $IX32426 .= " LIMIT $IX93593 "; } if ( $IX76556 !== null ) { $IX32426 .= " OFFSET $IX76556 "; } if ( count( $IX10893 ) > 0 ) { $IX66912 = $affiliates_db->get_objects( $IX32426, $IX10893 ); } else { $IX66912 = $affiliates_db->get_objects( $IX32426 ); } $IX86556 = array(); if ( !empty( $IX66912 ) && is_array( $IX66912 ) ) { foreach( $IX66912 as $IX38011 ) { $IX86556[] = new Affiliates_Rate( $IX38011 ); } } return $IX86556; }

	/**
	 * Check if there is an entry with the rate conditions of this object.
	 * 
	 * @return boolean true|false
	 */
	public function exists() { return self::get_rate( $this->to_array() ) !== null; }

	/**
	 * Check if there is another entry with the rate conditions of this object.
	 * This object must have its rate_id set, otherwise the result from $this->exists()
	 * is returned.
	 * 
	 * @return boolean
	 */
	public function exists_other() { $IX18482 = false; if ( $this->rate_id !== null ) { $IX96982 = $this->to_array(); $IX96982['limit'] = 2; $IX90101 = self::get_rate( $IX96982 ); if ( count( $IX90101 ) > 0 ) { unset( $IX90101[$this->rate_id] ); $IX18482 = count( $IX90101 ) > 0; } } else { $IX18482 = $this->exists(); } return $IX18482; }

	/**
	 * Returns the rate object for the given rate_id if it exists or null otherwise.
	 *
	 * @param int $rate_id ID of the desired rate
	 * @return Affiliates_Rate or null
	 */
	public static function get_rate_by_id( $rate_id ) { $IX83737 = new Affiliates_Rate(); return $IX83737->read( intval( $rate_id ) ); }

	/**
	 * Retrieve the first matching rate based on the parameters provided.
	 *
	 * This method does NOT support retrieval by rate_id.
	 * To retrieve a rate by if use Affiliates_Rate::get_rate_by_id( $rate_id ) instead.
	 *
	 * @param array $params acceptepted parameters include: type, affiliate_id, group_id, object_id, term_id, level, integration and limit
	 * @return null|Affiliates_Rate|array of Affiliates_Rate when limit is given and other than 1
	 */
	public static function get_rate( $params = null ) { global $affiliates_db; $IX77489 = null; $IX33093 = 1; $IX84036 = array( 'currency_id' => null, 'type' => null, 'affiliate_id' => null, 'group_id' => null, 'object_id' => null, 'term_id' => null, 'level' => null, 'integration' => null, 'limit' => $IX33093 ); $params = array_merge( $IX84036, $params !== null && is_array( $params ) ? $params : array() ); unset( $params['rate_id'] ); if ( ( $params !== null ) && is_array( $params ) ) { $IX31769 = array( '1=1' ); $IX29334 = array(); foreach( $params as $IX24456 => $IX68835 ) { switch( $IX24456 ) { case 'type' : switch( $IX68835 ) { case AFFILIATES_PRO_RATES_TYPE_RATE: case AFFILIATES_PRO_RATES_TYPE_AMOUNT: break; default : $IX68835 = null; } if ( $IX68835 !== null ) { $IX31769[] = 'type = %s'; $IX29334[] = $IX68835; } break; case 'affiliate_id' : case 'group_id' : case 'object_id' : case 'term_id' : case 'level' : if ( ( $IX68835 !== null ) && is_numeric( $IX68835 ) ) { $IX68835 = intval( $IX68835 ); } else { $IX68835 = null; } if ( $IX68835 === null ) { $IX31769[] = "$IX24456 IS NULL"; } else { $IX31769[] = "$IX24456 = %d"; $IX29334[] = $IX68835; } break; case 'integration' : if ( !empty( $IX68835 ) && is_string( $IX68835 ) ) { $IX68835 = trim( $IX68835 ); } else { $IX68835 = null; } if ( $IX68835 === null ) { $IX31769[] = "integration IS NULL"; } else { $IX31769[] = "integration = %s"; $IX29334[] = $IX68835; } break; case 'limit' : $IX33093 = intval( $IX68835 ); if ( $IX33093 < 0 ) { $IX33093 = 1; } break; case 'currency_id' : if ( !empty( $IX68835 ) && is_string( $IX68835 ) ) { $IX68835 = trim( $IX68835 ); if ( strlen( $IX68835 ) > 0 ) { $IX31769[] = 'currency_id = %s'; $IX29334[] = $IX68835; } } break; } } $IX31769 = implode( ' AND ', $IX31769 ); $IX91516 = $affiliates_db->get_tablename( 'rates' ); $IX40602 = "SELECT rate_id FROM $IX91516 WHERE $IX31769 ORDER BY rate_id ASC"; if ( $IX33093 > 0 ) { $IX40602 .= " LIMIT $IX33093"; } if ( count( $IX29334 ) > 0 ) { $IX83852 = $affiliates_db->get_objects( $IX40602, $IX29334 ); } else { $IX83852 = $affiliates_db->get_objects( $IX40602 ); } if ( count( $IX83852 ) > 0 ) { $IX98011 = array(); foreach( $IX83852 as $IX44764 ) { $IX77489 = new Affiliates_Rate(); $IX77489 = $IX77489->read( $IX44764->rate_id ); $IX98011[$IX77489->rate_id] = $IX77489; } if ( $IX33093 == 1 ) { $IX77489 = array_shift( $IX98011 ); } else { $IX77489 = $IX98011; } } } return $IX77489; }

	public function set_meta( $key, $value ) { if ( $this->metas === null ) { $this->metas = array(); } $this->metas[$key] = $value; }

	public function get_meta( $key ) { $IX15948 = null; if ( $this->has_meta( $key ) ) { $IX15948 = $this->metas[$key]; } return $IX15948; }

	public function has_meta( $key ) { $IX94807 = false; if ( $this->metas !== null ) { if ( isset( $this->metas[$key] ) ) { $IX94807 = true; } } return $IX94807; }

	public function delete_meta( $key ) { $IX85250 = false; if ( $this->has_meta( $key ) ) { unset( $this->metas[$key] ); $IX85250 = true; } return $IX85250; }

	/**
	 * Renders rate details.
	 *
	 * @return string
	 */
	public function view( $params = array() ) { $IX36193 = array( 'titles' => false, 'values' => true, 'style' => 'flat', 'separator' => null, 'exclude' => array(), 'prefix_class' => '' ); $params = array_merge( $IX36193, $params ); $IX58504 = new Affiliates_Rates_Table(); $IX18067 = $IX58504->get_columns(); unset( $IX18067['cb'] ); unset( $IX18067['actions'] ); if ( !is_array( $params['exclude'] ) ) { if ( is_string( $params['exclude'] ) ) { $params['exclude'] = array( $params['exclude'] ); } else { $params['exclude'] = array(); } } foreach ( $params['exclude'] as $IX65856 ) { unset( $IX18067[$IX65856] ); } $IX78455 = $this->to_array(); $IX33144 = ''; $IX11018 = ''; $IX27199 = ''; $IX40608 = ''; switch ( $params['style'] ) { case 'table' : $IX98042 = 'td'; $IX27199 = '<tr>'; $IX11018 = sprintf( '<tr class="%s">', esc_attr( $params['prefix_class'] ) ); $IX40608 = '</tr>'; break; case 'list' : $IX98042 = 'li'; break; case 'flat' : default : $IX98042 = 'span'; $IX33144 = ' '; break; } if ( $params['separator'] !== null ) { $IX33144 = $params['separator']; } $IX74003 = ''; if ( $params['titles'] && $params['style'] === 'table' ) { $IX74003 .= $IX27199; foreach( $IX18067 as $IX15955 => $IX52562 ) { $IX74003 .= sprintf( '<th class="%s">%s</th>', esc_attr( $IX15955 ), esc_html( $IX52562 ) ); } $IX74003 .= $IX40608; } if ( $params['values'] ) { $IX74003 .= $IX11018; foreach( $IX18067 as $IX15955 => $IX52562 ) { $IX74003 .= sprintf( '<%s class="%s">', esc_html( strip_tags( $IX98042 ) ), esc_attr( $IX15955 ) ); if ( $IX15955 === 'rate_id' && current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { $IX53190 = wp_nonce_url( add_query_arg( array( 'rate_id' => $this->rate_id, 'action' => 'edit-rate' ), admin_url( 'admin.php?page=affiliates-admin-rates' ) ) ); $IX74003 .= sprintf( '<a href="%s">', esc_url( $IX53190 ) ); $IX74003 .= $IX58504->column_default( $IX78455, $IX15955 ); $IX74003 .= '</a>'; } else { $IX74003 .= $IX58504->column_default( $IX78455, $IX15955 ); } $IX74003 .= sprintf( '</%s>', esc_html( strip_tags( $IX98042 ) ) ); } $IX74003 .= $IX40608; $IX74003 .= esc_html( $IX33144 ); } return $IX74003; }
}
