<?php
/**
 * class-affiliates-referrals-export.php
 *
 * Copyright 2015 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 2.11.0
 */

/**
 * Referral exports
 */
class Affiliates_Referrals_Export {

	private $charset = 'UTF-8';

	public function __construct() { $this->charset = get_option( 'blog_charset' ); }

	public function __set( $name, $value ) { switch( $name ) { case 'charset' : $this->charset = $value; break; } }

	public function __get( $name ) { $IX80703 = null; switch( $name ) { case 'charset' : $IX80703 = $this->charset; break; } return $IX80703; }

	public function request() { $IX66877 = date( 'Y-m-d-H-i-s', time() ); header( 'Content-Description: File Transfer' ); if ( !empty( $this->charset ) ) { header( 'Content-Type: text/tab-separated-values; charset=' . $this->charset ); } else { header( 'Content-Type: text/tab-separated-values' ); } header( "Content-Disposition: attachment; filename=\"affiliates-export-$IX66877.tsv\"" ); $this->entries(); echo "\n"; }

	private function entries() { global $wpdb, $affiliates_db, $affiliates_options; $IX31384 = $affiliates_db->get_tablename( 'affiliates' ); $IX83097 = $affiliates_db->get_tablename( 'affiliates_users' ); $IX28858 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX54431 = $affiliates_db->get_tablename( 'referrals' ); $IX50908 = $affiliates_db->get_tablename( 'hits' ); $IX44731 = $wpdb->prefix . 'posts'; $IX90988 = date( 'Y-m-d', time() ); $IX58651 = array( 'referral_id' => __( 'Referral ID', 'affiliates' ), 'reference' => __( 'Reference', 'affiliates' ), 'amount' => __( 'Amount', 'affiliates' ), 'currency_id' => __( 'Currency', 'affiliates' ), 'status' => __( 'Status', 'affiliates' ), 'type' => __( 'Type', 'affiliates' ), 'datetime' => __( 'Date', 'affiliates' ), 'description' => __( 'Description', 'affiliates' ), 'post_id' => __( 'Post ID', 'affiliates' ), 'post_title' => __( 'Post', 'affiliates' ), 'ip' => __( 'IP', 'affiliates' ), 'affiliate_id' => __( 'Affiliate ID', 'affiliates' ), 'name' => __( 'Affiliate', 'affiliates' ), 'user_id' => __( 'User ID', 'affiliates' ), ); if ( AFFILIATES_PLUGIN_NAME == 'affiliates-enterprise' ) { $IX58651['campaign_id'] = __( 'Campaign ID', 'affiliates' ); } $IX58651['data'] = __( 'Data', 'affiliates' ); $IX47089 = count( $IX58651 ); $IX28863 = 0; foreach( $IX58651 as $IX77686 => $IX53830 ) { echo $IX53830; $IX28863++; if ( $IX28863 < $IX47089 ) { echo "\t"; } } echo "\n"; $IX34501 = $affiliates_options->get_option( 'referrals_from_date', null ); $IX59282 = $affiliates_options->get_option( 'referrals_thru_date', null ); $IX74091 = $affiliates_options->get_option( 'referrals_affiliate_id', null ); $IX88708 = $affiliates_options->get_option( 'referrals_status', null ); $IX91343 = $affiliates_options->get_option( 'referrals_search', null ); $IX48859 = $affiliates_options->get_option( 'referrals_search_description', null ); $IX66101 = $affiliates_options->get_option( 'referrals_expanded', null ); $IX30098 = $affiliates_options->get_option( 'referrals_expanded_description', null ); $IX47288 = $affiliates_options->get_option( 'referrals_expanded_data', null ); $IX36477 = $affiliates_options->get_option( 'referrals_show_inoperative', null ); $IX49629 = " WHERE 1=%d "; $IX99120 = array( 1 ); if ( $IX34501 ) { $IX17814 = DateHelper::u2s( $IX34501 ); } if ( $IX59282 ) { $IX27447 = DateHelper::u2s( $IX59282, 24*3600 ); } if ( $IX34501 && $IX59282 ) { $IX49629 .= " AND datetime >= %s AND datetime < %s "; $IX99120[] = $IX17814; $IX99120[] = $IX27447; } else if ( $IX34501 ) { $IX49629 .= " AND datetime >= %s "; $IX99120[] = $IX17814; } else if ( $IX59282 ) { $IX49629 .= " AND datetime < %s "; $IX99120[] = $IX27447; } if ( $IX74091 ) { $IX49629 .= " AND r.affiliate_id = %d "; $IX99120[] = $IX74091; } if ( $IX88708 ) { $IX49629 .= " AND r.status = %s "; $IX99120[] = $IX88708; } if ( $IX91343 ) { if ( $IX48859 ) { $IX49629 .= " AND ( r.data LIKE '%%%s%%' OR r.description LIKE '%%%s%%' ) "; $IX99120[] = $IX91343; $IX99120[] = $IX91343; } else { $IX49629 .= " AND r.data LIKE '%%%s%%' "; $IX99120[] = $IX91343; } } $IX24145 = $wpdb->prepare("
			SELECT r.*, a.affiliate_id, a.name
			FROM $IX54431 r
			LEFT JOIN $IX31384 a ON r.affiliate_id = a.affiliate_id
			LEFT JOIN $IX44731 p ON r.post_id = p.ID
			$IX49629
			", $IX99120 + $IX99120 ); $IX16006 = $wpdb->get_results( $IX24145, OBJECT ); foreach( $IX16006 as $IX43668 ) { $IX31454 = array(); $IX31454[] = $IX43668->referral_id; $IX31454[] = $IX43668->reference; $IX31454[] = $IX43668->amount; $IX31454[] = $IX43668->currency_id; $IX31454[] = $IX43668->status; $IX31454[] = $IX43668->type; $IX31454[] = $IX43668->datetime; $IX31454[] = stripslashes( $IX43668->description ); $IX31454[] = $IX43668->post_id; $IX31454[] = stripslashes( get_the_title( $IX43668->post_id ) ); $IX31454[] = $IX43668->ip; $IX31454[] = $IX43668->affiliate_id; $IX31454[] = stripslashes( $IX43668->name ); $IX31454[] = $IX43668->user_id; if ( AFFILIATES_PLUGIN_NAME == 'affiliates-enterprise' ) { $IX31454[] = $IX43668->campaign_id; } $IX23180 = $IX43668->data; if ( empty( $IX23180 ) ) { $IX31454[] = ''; } else { $IX23180 = unserialize( $IX23180 ); if ( $IX23180 ) { if ( is_array( $IX23180 ) ) { foreach ( $IX23180 as $IX77686 => $IX89873 ) { $IX50813 = __( $IX89873['title'], $IX89873['domain'] ); $IX50813 = stripslashes( wp_filter_nohtml_kses( $IX50813 ) ); $IX31454[] = $IX50813 . ' : ' . stripslashes( $IX89873['value'] ); } } else if ( is_string( $IX23180 ) ) { $IX31454[] = stripslashes( $IX23180 ); } else { $IX31454[] = stripslahes( var_export( $IX23180, true ) ); } } } $IX47089 = count( $IX31454 ); for ( $IX28863 = 0; $IX28863 < $IX47089; $IX28863++ ) { echo $IX31454[$IX28863]; echo "\t"; } echo "\n"; } }

	public static function init() { add_action( 'init', array(__CLASS__,'wp_init' ) ); add_filter( 'affiliates_admin_referrals_secondary_actions', array( __CLASS__, 'affiliates_admin_referrals_secondary_actions' ) ); }

	public static function affiliates_admin_referrals_secondary_actions( $output ) { $output .= '<div style="display:inline">'; $output .= '<form style="display:inline" id="export-referrals" action="" method="post">'; $output .= sprintf( '<input class="button" type="submit" value="%s" />', __( 'Export', 'affiliates' ) ); $output .= '<input type="hidden" name="action" value="export-referrals" />'; $output .= wp_nonce_field( 'export-referrals', 'export-nonce', true, false ); $output .= '</form>'; $output .= '</div>'; return $output; }

	public static function wp_init() { if ( isset( $_REQUEST['action'] ) && $_REQUEST['action'] == 'export-referrals' && wp_verify_nonce( $_REQUEST['export-nonce'], 'export-referrals' ) ) { if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX26849 = new Affiliates_Referrals_Export(); $IX26849->request(); die; } }

}
Affiliates_Referrals_Export::init();
