<?php
/**
 * fake_bcmath.php
 * 
 * Every time you use any of the fake bcmath functions, a puppy dies.
 * So please don't do it and get yourself bcmath enabled.
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.1.0
 */

global $fake_bcmath_scale;
$fake_bcmath_scale = null;

function fake_bcadd( $left_operand, $right_operand, $scale = null ) { return fake_bcmath_scale( ( string ) ( doubleval( $left_operand ) + doubleval( $right_operand ) ), $scale ); }

function fake_bccomp( $left_operand, $right_operand, $scale = null ) { $IX50668 = doubleval( fake_bcmath_scale( $left_operand, $scale ) ); $IX16134 = doubleval( fake_bcmath_scale( $right_operand, $scale ) ); $IX74089 = 0; if ( $IX50668 < $IX16134 ) { $IX74089 = -1; } else if ( $IX50668 > $IX16134 ) { $IX74089 = 1; } return $IX74089; }

function fake_bcdiv( $left_operand, $right_operand, $scale = null ) { return fake_bcmath_scale( ( string ) ( doubleval( $left_operand ) / doubleval( $right_operand ) ), $scale ); }

function fake_bcmod( $left_operand, $modulus ) { return ( string ) ( intval( $left_operand ) % intval( $modulus ) ); }

function fake_bcmul( $left_operand, $right_operand, $scale = null ) { return fake_bcmath_scale( ( string ) ( doubleval( $left_operand ) * doubleval( $right_operand ) ), $scale ); }

function fake_bcpow( $left_operand, $right_operand, $scale = null ) { return fake_bcmath_scale( ( string ) ( pow( doubleval( $left_operand ), doubleval( $right_operand ) ) ), $scale ); }

function fake_bcpowmod( $left_operand , $right_operand , $modulus, $scale = null ) { if ( $modulus == 0 ) { $IX95559 = null; } else { $IX95559 = fake_bcmath_scale( ( string ) ( pow( doubleval( $left_operand ), doubleval( $right_operand ) ) % intval( $modulus ) ), $scale ); } return $IX95559; } 

function fake_bcscale( $scale ) { global $fake_bcmath_scale; $IX44200 = intval( $scale ); if ( $IX44200 >= 0 ) { $fake_bcmath_scale = $IX44200; return true; } else { return false; } }

function fake_bcsqrt( $operand, $scale = null ) { return fake_bcmath_scale( ( string ) sqrt( doubleval( $operand ) ), $scale ); }

function fake_bcsub( $left_operand, $right_operand, $scale = null ) { return fake_bcmath_scale( ( string ) ( doubleval( $left_operand ) - doubleval( $right_operand ) ), $scale ); }

function fake_bcmath_scale( $value, $scale = null ) { global $fake_bcmath_scale; $IX56915 = null; if ( $scale !== null ) { $IX56915 = intval( $scale ); } else if ( $fake_bcmath_scale !== null ) { $IX56915 = intval( $fake_bcmath_scale ); } if ( $IX56915 !== null ) { return ( string ) round( doubleval( $value ), $IX56915 ); } else { return $value; } }

if ( !function_exists( 'bcadd' ) ) {

	function bcadd( $left_operand, $right_operand, $scale = null ) { return fake_bcadd( $left_operand, $right_operand, $scale ); }

	function bccomp( $left_operand, $right_operand, $scale = null ) { return fake_bccomp( $left_operand, $right_operand, $scale ); }

	function bcdiv( $left_operand, $right_operand, $scale = null ) { return fake_bcdiv($left_operand, $right_operand, $scale ); }

	function bcmod( $left_operand, $modulus ) { return fake_bcmod( $left_operand, $modulus ); }

	function bcmul( $left_operand, $right_operand, $scale = null ) { return fake_bcmul( $left_operand, $right_operand, $scale ); }

	function bcpow( $left_operand, $right_operand, $scale = null ) { return fake_bcpow($left_operand, $right_operand, $scale ); }

	function bcpowmod( $left_operand , $right_operand , $modulus, $scale = null ) { return fake_bcpowmod($left_operand, $right_operand, $modulus, $scale ); }

	function bcscale( $scale ) { return fake_bcscale( $scale ); }

	function bcsqrt( $operand, $scale = null ) { return fake_bcsqrt( $operand, $scale ); }

	function bcsub( $left_operand, $right_operand, $scale = null ) { return fake_bcsub( $left_operand, $right_operand, $scale ); }
}
