<?php
/**
 * class-affiliates-admin-menu-wordpress.php
 *
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.2
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Admin Menu.
 */
class Affiliates_Admin_Menu_WordPress {

	const NONCE = 'aff-admin-menu';
	const SETTINGS = 'aff-settings';

	public static function init() { add_action( 'affiliates_admin_menu', array( __CLASS__, 'affiliates_admin_menu' ) ); add_action( 'affiliates_admin_menu', array( __CLASS__, 'affiliates_admin_menu_sort' ), 999 ); add_filter( 'affiliates_settings_sections', array( __CLASS__, 'affiliates_settings_sections' ) ); add_action( 'affiliates_settings_section', array( __CLASS__, 'affiliates_settings_section' ) ); add_filter( 'affiliates_help_tab_footer', array( __CLASS__, 'affiliates_help_tab_footer' ) ); add_filter( 'affiliates_help_tab_title', array( __CLASS__, 'affiliates_help_tab_title' ) ); }

	public static function affiliates_settings_sections( $sections ) { $sections['commissions'] = __( 'Commissions', 'affiliates' ); return $sections; }

	public static function affiliates_settings_section( $section ) { if ( $section == 'commissions' ) { self::affiliates_admin_settings(); } }

	public static function affiliates_admin_menu() { global $submenu; $IX93598 = get_post_type_object( 'affiliates_banner' ); $IX15330 = add_submenu_page( 'affiliates-admin', $IX93598->labels->name, $IX93598->labels->all_items, $IX93598->cap->edit_posts, "edit.php?post_type=affiliates_banner" ); $IX20177[] = $IX15330; $IX15330 = add_submenu_page( 'affiliates-admin', __( 'Totals', 'affiliates' ), __( 'Totals', 'affiliates' ), AFFILIATES_ACCESS_AFFILIATES, 'affiliates-admin-totals', array( 'Affiliates_Totals_WordPress', 'view' ) ); $IX20177[] = $IX15330; add_action( 'admin_print_styles-' . $IX15330, 'affiliates_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX15330, 'affiliates_admin_print_scripts' ); add_action( 'admin_print_styles-' . $IX15330, 'affiliates_pro_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX15330, 'affiliates_pro_admin_print_scripts' ); }

	public static function affiliates_admin_menu_sort() { global $submenu; if ( isset( $submenu['affiliates-admin'] )) { usort( $submenu['affiliates-admin'], array( __CLASS__, 'menu_sort' ) ); } }

	public static function menu_sort( $o1, $o2 ) { global $submenu; $IX80160 = 0; $IX98393 = array( 'affiliates-admin' => 0, 'affiliates-admin-affiliates' => 1, 'affiliates-admin-hits' => 2, 'affiliates-admin-hits-affiliate' => 3, 'affiliates-admin-hits-uri' => 4, 'affiliates-admin-referrals' => 5, 'affiliates-admin-totals' => 6, 'edit.php?post_type=affiliates_banner' => 7, 'affiliates-admin-options' => 8, 'affiliates-admin-settings' => 9, 'affiliates-admin-rates' => 10, 'affiliates-admin-notifications' => 11, 'affiliates-admin-user-registration' => 12, 'affiliates-admin-tiers' => 13, 'affiliates-admin-campaigns' => 14, 'affiliates-admin-add-ons' => 999 ); $IX16757 = isset( $o1[2] ) && isset( $IX98393[$o1[2]] ) ? $IX98393[$o1[2]] : 100; $IX17286 = isset( $o2[2] ) && isset( $IX98393[$o2[2]] ) ? $IX98393[$o2[2]] : 100; $IX80160 = $IX16757 - $IX17286; return $IX80160; }

	public static function affiliates_admin_settings() { if ( !current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX88713 = Affiliates_Referral::get_referral_amount_methods(); $IX97963 = array(); foreach ( $IX88713 as $IX52556 ) { if ( is_array( $IX52556 ) ) { $IX61672 = implode( "::", $IX52556 ); } else { $IX61672 = $IX52556; } $IX97963[$IX61672] = $IX61672; } $IX97963 = array_merge( array( '' => __( 'None', 'affiliates' ) ), $IX97963 ); if ( isset( $_POST['submit'] ) ) { if ( wp_verify_nonce( $_POST[self::NONCE], self::SETTINGS ) ) { if ( !empty( $_POST[Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY] ) ) { $IX64136 = trim( $_POST[Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY] ); if ( $IX64136 = Affiliates_Attributes::validate_key( $IX64136 ) ) { update_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, $IX64136 ); } else { $IX64136 = ''; delete_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY ); } } else { $IX64136 = ''; delete_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY ); } if ( !empty( $_POST[Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE] ) ) { $IX49343 = trim( $_POST[Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE] ); if ( $IX49343 = Affiliates_Attributes::validate_value( $IX64136, $IX49343 ) ) { update_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE, $IX49343 ); } else { $IX49343 = ''; delete_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE ); } } else { $IX49343 = ''; delete_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE ); } Affiliates_Settings::settings_saved_notice(); } } $IX64136 = get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, '' ); $IX49343 = get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE, '' ); $IX94930 = array_merge( array( '' => __( 'Rates', 'affiliates' ) ), Affiliates_Attributes::get_keys() ); unset( $IX94930[Affiliates_Attributes::PAYPAL_EMAIL] ); unset( $IX94930[Affiliates_Attributes::COUPONS] ); unset( $IX94930[Affiliates_Attributes::COOKIE_TIMEOUT_DAYS] ); $IX85314 = '<select id ="' . Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY . '" name="' . Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY . '">'; foreach ( $IX94930 as $IX40998 => $IX78536 ) { $IX21559 = ( $IX40998 == $IX64136 ) ? ' selected="selected" ' : ''; $IX85314 .= '<option value="' . $IX40998 . '" ' . $IX21559 . '>' . $IX78536 . '</option>'; } $IX85314 .= '</select>'; $IX99732 = ''; $IX90625 = '<input name="' . Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE . '" type="text" value="' . esc_attr( !is_array( $IX49343 ) ? $IX49343 : '' ) . '" />'; $IX49633 = '<select name="' . Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE . '">'; foreach ( $IX97963 as $IX40998 => $IX61672 ) { $IX21559 = ( Affiliates_Referral::get_referral_amount_method( $IX40998 ) == Affiliates_Referral::get_referral_amount_method( $IX49343 ) ) ? ' selected="selected" ' : ''; $IX49633 .= '<option value="' . $IX40998 . '" ' . $IX21559 . '>' . $IX61672 . '</option>'; } $IX49633 .= '</select>'; switch ( $IX64136 ) { case '' : $IX65093 = $IX99732; break; case Affiliates_Attributes::REFERRAL_AMOUNT_METHOD : $IX65093 = $IX49633; break; default: $IX65093 = $IX90625; } echo '<form action="" name="options" method="post">' . '<div>' . '<p class="description">' . __( 'These settings are used to calculate commissions for affiliates in general.', 'affiliates' ) . '</p>' . '<p>' . sprintf( '<label title="%s" for="' . Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY . '">', __( 'Default referral calculation', 'affiliates' ) ) . __( 'Method', 'affiliates' ) . ' ' . $IX85314 . '</label>' . '</p>' . '<p>' . sprintf( '<label title="%s" for="' . Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE . '">', __( 'Default referral calculation value', 'affiliates' ) ) . __( 'Value', 'affiliates' ) . ' <span id="method-value-input-container">'. $IX65093 . '</span>' . '</label>' . '</p>' . '<p>' . wp_nonce_field( self::SETTINGS, self::NONCE, true, false ) . '<input class="button button-primary" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>' . '</div>' . '</form>'; echo '<script type="text/javascript">'; echo 'document.addEventListener( "DOMContentLoaded", function() {'; echo 'if (typeof jQuery !== "undefined" ) {'; echo 'jQuery("#'.Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY.'").change(function(e){'; echo sprintf( 'if ( jQuery(this).val() == "%s" ) {', Affiliates_Attributes::REFERRAL_AMOUNT_METHOD ); echo sprintf( 'jQuery("#method-value-input-container").html(\'%s\');', $IX49633 ); echo '} else if ( jQuery(this).val() == "" ) {'; echo sprintf( 'jQuery("#method-value-input-container").html(\'%s\');', $IX99732 ); echo '} else {'; echo sprintf( 'jQuery("#method-value-input-container").html(\'%s\');', $IX90625 ); echo '}'; echo '});'; echo '}'; echo '} );'; echo '</script>'; echo '<div style="margin: 1em 1em 1em inherit; padding:0.31em 0.62em; background-color:#fff;">'; echo '<p>'; echo '<strong>'; echo __( 'Which method to choose &hellip;', 'affiliates' ); echo '</strong>'; echo '</p>'; echo '<p>'; printf( __( 'The recommended method is <em>Rates</em>, which calculates commissions based on the definitions in the <a href="%s">Rates</a> section.', 'affiliates' ), esc_url( admin_url( 'admin.php?page=affiliates-admin-rates' ) ) ); echo ' '; echo __( 'All other choices represent legacy options.', 'affiliates' ); echo '</p>'; echo '<ul>'; echo '<li>'; echo '<em>' . __( 'Rates', 'affiliates' ) . '</em>'; echo ' &mdash; '; printf( __( 'Calculates commissions based on the definitions in the <a href="%s">Rates</a> section.', 'affiliates' ), esc_url( admin_url( 'admin.php?page=affiliates-admin-rates' ) ) ); echo '</li>'; echo '<li>'; echo '<em>' . __( 'Referral Rate', 'affiliates' ) . '</em>'; echo ' &mdash; '; echo __( '(legacy)', 'affiliates' ); echo ' '; echo __( 'The commission amount is proportional to the amount of the originating transaction.', 'affiliates' ); echo ' '; echo __( 'This is recommended if commissions are a percentage of sales amounts.', 'affiliates' ); echo ' '; echo __( 'Note that the value indicated is a rate, for example, to grant 10% commissions on sales, indicate <code>0.10</code> as the value.', 'affiliates' ); echo ' '; echo __( 'Also note that if the value is equal to or greater than <code>1</code>, this would grant a commission amount higher than the actual (net) purchase amount &ndash; a case which is normally not desired.', 'affiliates' ); echo ' '; echo __( 'Using <code>0</code> results in zero commission amounts.', 'affiliates' ); echo '</li>'; echo '<li>'; echo '<em>' . __( 'Referral Amount', 'affiliates' ) . '</em>'; echo ' &mdash; '; echo __( '(legacy)', 'affiliates' ); echo ' '; echo __( 'A fixed commission amount is attributed with each referral.', 'affiliates' ); echo '</li>'; echo '<li>'; echo '<em>' . __( 'Referral Amount Method', 'affiliates' ) . '</em>'; echo ' &mdash; '; echo __( '(legacy)', 'affiliates' ); echo ' '; echo __( 'The commission amount is calculated by a specific algorithm.', 'affiliates' ); echo '</li>'; echo '</ul>'; echo '</div>'; echo '<h3>'; echo __( 'Migrate Rates 2.x => 3.x', 'affiliates' ); echo '</h3>'; echo '<p>'; echo __( 'Before switching from legacy options to <em>Rates</em>, use these buttons to generate rate entries from existing data.', 'affiliates' ); echo '</p>'; require_once dirname( AFFILIATES_PRO_FILE ) . '/lib/ext/includes/class-affiliates-upgrade-3.php'; Affiliates_Upgrade_3::form(); echo '<p class="description">'; echo __( 'Use these buttons to migrate referral rates from version 2.x to version 3.x.', 'affiliates' ); echo '</p>'; echo '<p>'; echo __( 'Once the rate entries have been created, you can switch the <em>Method</em> setting above to <em>Rates</em>.', 'affiliates' ); echo ' '; echo __( 'Please note that this only supports methods of type <em>Referral Amount</em> and <em>Referral Rate</em>, no rate entries will be created for <em>Referral Amount Method</em>.', 'affiliates' ); echo ' '; echo __( 'If <em>Referral Amount Method</em> is used in general or for some affiliates, switching to <em>Rates</em> is currently not recommended.', 'affiliates' ); echo '</p>'; affiliates_footer(); }

	public static function affiliates_admin_totals() { }

	public static function get_help_tab_footer() { $IX12190 = '<div class="affiliates-documentation">'; if ( AFFILIATES_PLUGIN_NAME == 'affiliates-enterprise' ) { $IX12190 .= sprintf( '<a href="%s">%s</a>', esc_attr( 'http://docs.itthinx.com/document/affiliates-enterprise/' ), esc_html( __( 'Online documentation', 'affiliates' ) ) ); } else { $IX12190 .= sprintf( '<a href="%s">%s</a>', esc_attr( 'http://docs.itthinx.com/document/affiliates-pro/' ), esc_html( __( 'Online documentation', 'affiliates' ) ) ); } $IX12190 .= '</div>'; return $IX12190; }

	public static function affiliates_help_tab_footer( $footer ) { return self::get_help_tab_footer(); }

	public static function affiliates_help_tab_title( $title ) { $title = '<h3>'; if ( AFFILIATES_PLUGIN_NAME == 'affiliates-enterprise' ) { $title .= __( 'Affiliates Enterprise', 'affiliates' ); } else { $title .= __( 'Affiliates Pro', 'affiliates' ); } $title .= '</h3>'; return $title; }
}
Affiliates_Admin_Menu_WordPress::init();
