<?php
/**
 * class-affiliates-affiliate-profile-wordpress.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Profile renderer implementation.
 */
class Affiliates_Affiliate_Profile_WordPress extends Affiliates_Affiliate_Profile {

	const NONCE               = 'affiliate-profile-nonce';
	const EDIT_PROFILE_ACTION = 'edit-profile';

	/**
	 * Class initialization.
	 */
	static function init() { add_shortcode( 'affiliates_affiliate_profile', array( __CLASS__, 'profile_shortcode' ) ); }

	static function profile_shortcode( $atts, $content = null ) { $IX20605 = shortcode_atts( self::$option_defaults, $atts ); return self::render_profile( $IX20605 ); }

	static function render_profile( $options = array() ) { global $affiliates_db; wp_enqueue_style( 'affiliates' ); $IX92366 = ''; $IX87069 = Affiliates_Affiliate_WordPress::get_user_affiliate_id(); if ( $IX87069 === false ) { return $IX92366; } $IX41779 = Affiliates_Affiliate_WordPress::get_affiliate( $IX87069 ); $IX69015 = isset( $options['show_name'] ) ? $options['show_name'] : self::$option_defaults['show_name']; $IX71749 = $IX69015 && isset( $options['edit_name'] ) ? $options['edit_name'] : self::$option_defaults['edit_name']; $IX16865 = isset( $options['show_email'] ) ? $options['show_email'] : self::$option_defaults['show_email']; $IX19942 = $IX16865 && isset( $options['edit_email'] ) ? $options['edit_email'] : self::$option_defaults['edit_email']; $IX50674 = isset( $options['show_attributes'] ) ? $options['show_attributes'] : self::$option_defaults['show_attributes']; if ( $IX50674 ) { $IX50674 = explode( ",", $IX50674 ); $IX49331 = array(); foreach ( $IX50674 as $IX13467 ) { $IX13467 = trim( $IX13467 ); if ( Affiliates_Attributes::validate_key( $IX13467 ) ) { $IX49331[] = $IX13467; } } $IX50674 = $IX49331; } else { $IX50674 = array(); } $IX32504 = isset( $options['edit_attributes'] ) ? $options['edit_attributes'] : self::$option_defaults['edit_attributes']; if ( $IX32504 ) { $IX49331 = explode( ",", $IX32504 ); $IX32504 = array(); foreach ( $IX49331 as $IX13467 ) { if ( in_array( $IX13467, $IX50674 ) ) { $IX32504[] = $IX13467; } } } else { $IX32504 = array(); } if ( isset( $_POST[self::NONCE] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE], self::EDIT_PROFILE_ACTION ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( $IX71749 && isset( $_POST['first_name'] ) && ( $_POST['last_name'] ) ) { $IX83294 = $_POST['first_name'] . " " . $_POST['last_name']; if ( $IX41779->name != $IX83294 ) { if ( $IX20142 = Affiliates_Affiliate_WordPress::get_affiliate_user_id( $IX87069 ) ) { if ( $IX56781 = Affiliates_Utility::filter( $_POST['first_name'] ) ) { update_user_meta( $IX20142, 'first_name', $IX56781 ); } if ( $IX45167 = Affiliates_Utility::filter( $_POST['last_name'] ) ) { update_user_meta( $IX20142, 'last_name', $IX45167 ); } } Affiliates_Affiliate_WordPress::update_name( $IX87069, $IX83294 ); } } if ( $IX19942 && isset( $_POST['affiliate_email'] ) && ( $_POST['affiliate_email'] != $IX41779->email ) ) { if ( ( $IX20709 = Affiliates_Validator::validate_email( $_POST['affiliate_email'] ) ) && !email_exists( $IX20709 ) ) { if ( $IX20709 = Affiliates_Affiliate_WordPress::update_email( $IX87069, $IX20709 ) ) { if ( $IX20142 = Affiliates_Affiliate_WordPress::get_affiliate_user_id( $IX87069 ) ) { $IX31000 = array( 'ID' => $IX20142, 'user_email' => $IX20709 ); wp_update_user( $IX31000 ); } } } } foreach ( $IX32504 as $IX13467 ) { $IX52929 = "aff_attr_" . $IX13467; if ( isset( $_POST[$IX52929] ) ) { Affiliates_Affiliate_WordPress::update_attribute( $IX87069, $IX13467, $_POST[$IX52929] ); } } } $IX41779 = Affiliates_Affiliate_WordPress::get_affiliate( $IX87069 ); $IX92366 .= '<div class="affiliate-profile">' . '<form id="affiliate-profile" action="" method="post">'; if ( $IX69015 ) { $IX43973 = !$IX71749 ? ' readonly="readonly" ' : ''; if ( $IX20142 = Affiliates_Affiliate_WordPress::get_affiliate_user_id( $IX87069 ) ) { $IX56781 = get_user_meta( $IX20142, 'first_name', true ); $IX45167 = get_user_meta( $IX20142, 'last_name', true ); } else { $IX56781 = ''; $IX45167 = ''; } $IX92366 .= '<div class="field first-name">' . '<label for="first_name">' . __( 'First Name', 'affiliates' ) . '</label>' . '<input ' . $IX43973 . ' name="first_name" type="text" value="' . esc_attr( $IX56781 ) . '"/>'. '</div>'; $IX92366 .= '<div class="field last-name">' . '<label for="last_name">' . __( 'Last Name', 'affiliates' ) . '</label>' . '<input ' . $IX43973 . ' name="last_name" type="text" value="' . esc_attr( $IX45167 ) . '"/>'. '</div>'; } if ( $IX16865 ) { $IX43973 = !$IX19942 ? ' readonly="readonly" ' : ''; $IX92366 .= '<div class="field affiliate-email">' . '<label for="affiliate_email">' . __( 'Email', 'affiliates' ) . '</label>' . '<input ' . $IX43973 . ' name="affiliate_email" type="text" value="' . esc_attr( $IX41779->email ) . '"/>'. '</div>'; } if ( $IX50674 ) { $IX29803 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX68157 = $affiliates_db->get_objects( "SELECT * FROM $IX29803 WHERE affiliate_id = %d", $IX87069 ); $IX11931 = array(); foreach ( $IX68157 as $IX13467 ) { $IX11931[$IX13467->attr_key] = $IX13467->attr_value; } $IX76497 = Affiliates_Attributes::get_keys(); foreach ( $IX50674 as $IX42782 ) { $IX45572 = isset( $IX11931[$IX42782] ) ? $IX11931[$IX42782] : ''; $IX43973 = !in_array( $IX42782, $IX32504 ) ? ' readonly="readonly" ' : ''; $IX52929 = "aff_attr_" . $IX42782; $IX92366 .= '<div class="field affiliate-attribute ' . esc_attr( $IX42782 ) . '">' . '<label for="' . esc_attr( $IX52929 ) . '">' . __( $IX76497[$IX42782], 'affiliates' ) . '</label>' . '<input ' . $IX43973 . ' name="' . esc_attr( $IX52929 ) . '" type="text" value="' . esc_attr( $IX45572 ) . '"/>'. '</div>'; } } if ( $IX71749 || $IX19942 || $IX32504 ) { $IX92366 .= '<div class="submit">' . wp_nonce_field( self::EDIT_PROFILE_ACTION, self::NONCE, true, false ) . '<input type="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '<input type="hidden" value="submitted" name="submitted"/>' . '</div>'; } $IX92366 .= '</form>'; $IX92366 .= '</div>'; return $IX92366; }

}
Affiliates_Affiliate_Profile_WordPress::init();
