<?php
/**
 * class-affiliates-affiliate-stats-widget.php
 * 
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates
 * @since affiliates 1.1.0 
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Affiliate stats widget.
 * 
 * @link http://codex.wordpress.org/Widgets_API#Developing_Widgets
 */
class Affiliates_Affiliate_Stats_Widget extends WP_Widget {

	/**
	 * Creates an affiliate stats widget.
	 */
	function __construct() { parent::__construct( false, $IX97653 = 'Affiliates Affiliate Stats' ); }

	/**
	 * Widget output
	 * 
	 * @see WP_Widget::widget()
	 */
	function widget( $args, $instance ) { if ( !affiliates_user_is_affiliate() ) { return; } $IX32004 = isset( $args['before_widget'] ) ? $args['before_widget'] : ''; $IX41947 = isset( $args['after_widget'] ) ? $args['after_widget'] : ''; $IX42166 = isset( $args['before_title'] ) ? $args['before_title'] : ''; $IX31714 = isset( $args['after_title'] ) ? $args['after_title'] : ''; $IX91495 = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : ''; $IX18849 = $args['widget_id']; echo $IX32004; if ( !empty( $IX91495 ) ) { echo $IX42166 . $IX91495 . $IX31714; } $IX47291 = '-' . $IX18849; $IX90606 = array( 'is_widget' => true ); $IX90606 = array_merge( $IX90606, $instance ); echo $this->render_affiliate_stats( $IX90606, $IX18849 ); echo $IX41947; }

	/**
	 * Save widget options
	 * 
	 * @see WP_Widget::update()
	 */
	function update( $new_instance, $old_instance ) { $IX85007 = $old_instance; if ( !empty( $new_instance['title'] ) ) { $IX85007['title'] = strip_tags( $new_instance['title'] ); } else { unset( $IX85007['title'] ); } $IX16852 = array( 'show_totals_accepted', 'show_totals_pending', 'show_totals_closed', 'show_totals_rejected' ); foreach ( $IX16852 as $IX85190 ) { if ( !empty( $new_instance[$IX85190] ) ) { $IX85007[$IX85190] = true; } else { unset( $IX85007[$IX85190] ); } } return $IX85007; }

	/**
	 * Output admin widget options form
	 * 
	 * @see WP_Widget::form()
	 */
	function form( $instance ) { $IX70872 = isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : ''; ?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title:', 'affiliates' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $IX70872; ?>" />
		</p>
		<?php
 $IX13130 = isset( $instance['show_totals_accepted'] ) ? $instance['show_totals_accepted'] : false; echo '<input type="checkbox" ' . ( $IX13130 ? ' checked="checked" ' : '' ) . ' name="' . $this->get_field_name( 'show_totals_accepted' ) . '" id="' . $this->get_field_id( 'show_totals_accepted' ) . '"/>'; echo '<label for="' . $this->get_field_name( 'show_totals_accepted' ) . '">' . __( 'Show totals for accepted referrals', 'affiliates' ) . '</label>'; echo '<br/>'; $IX30571 = isset( $instance['show_totals_pending'] ) ? $instance['show_totals_pending'] : false; echo '<input type="checkbox" ' . ( $IX30571 ? ' checked="checked" ' : '' ) . ' name="' . $this->get_field_name( 'show_totals_pending' ) . '" id="' . $this->get_field_id( 'show_totals_pending' ) . '"/>'; echo '<label for="' . $this->get_field_name( 'show_totals_pending' ) . '">' . __( 'Show totals for pending referrals', 'affiliates' ) . '</label>'; echo '<br/>'; $IX47586 = isset( $instance['show_totals_closed'] ) ? $instance['show_totals_closed'] : false; echo '<input type="checkbox" ' . ( $IX47586 ? ' checked="checked" ' : '' ) . ' name="' . $this->get_field_name( 'show_totals_closed' ) . '" id="' . $this->get_field_id( 'show_totals_closed' ) . '"/>'; echo '<label for="' . $this->get_field_name( 'show_totals_closed' ) . '">' . __( 'Show totals for closed referrals', 'affiliates' ) . '</label>'; echo '<br/>'; $IX64105 = isset( $instance['show_totals_rejected'] ) ? $instance['show_totals_rejected'] : false; echo '<input type="checkbox" ' . ( $IX64105 ? ' checked="checked" ' : '' ) . ' name="' . $this->get_field_name( 'show_totals_rejected' ) . '" id="' . $this->get_field_id( 'show_totals_rejected' ) . '"/>'; echo '<label for="' . $this->get_field_name( 'show_totals_rejected' ) . '">' . __( 'Show totals for rejected referrals', 'affiliates' ) . '</label>'; }

	/**
	 * Renders affiliate stats.
	 * 
	 * @param array $options rendering options
	 */
	public static function render_affiliate_stats( $options = array() ) { global $affiliates_db; $IX85494 = ''; $IX46065 = Affiliates_Affiliate_WordPress::get_user_affiliate_id(); if ( $IX46065 === false ) { return $IX85494; } wp_enqueue_style( 'affiliates' ); wp_enqueue_style( 'affiliates-pro' ); $IX78191 = $affiliates_db->get_tablename( 'affiliates' ); $IX43075 = $affiliates_db->get_tablename( 'referrals' ); $IX78490 = $affiliates_db->get_tablename( 'hits' ); $IX63373 = affiliates_get_affiliate_visits( $IX46065 ); $IX66489 = affiliates_get_affiliate_hits( $IX46065 ); $IX46366 = affiliates_get_affiliate_referrals( $IX46065 ); if ( $IX63373 > 0 ) { $IX60704 = round( $IX46366 / $IX63373, I_Affiliates_Stats_Renderer::RATIO_DECIMALS ); } else { $IX60704 = 0; } $IX85494 .= '<div class="visits">' . sprintf( _n( '%d Visit', '%d Visits', $IX63373, 'affiliates' ), $IX63373 ) . '</div>'; $IX85494 .= '<div class="hits">' . sprintf( _n( '%d Hit', '%d Hits', $IX66489, 'affiliates' ), $IX66489 ) . '</div>'; $IX85494 .= '<div class="referrals">' . sprintf( _n( '%d Referral', '%d Referrals', $IX46366, 'affiliates' ), $IX46366 ) . '</div>'; $IX85494 .= '<div class="ratio">' . sprintf( __( '%.3f Ratio', 'affiliates' ), $IX60704 ) . '</div>'; $IX38822 = isset( $options['show_totals'] ) ? ( $options['show_totals'] !== 'false' ) : true; $IX15097 = isset( $options['show_totals_accepted'] ) ? ( $options['show_totals_accepted'] === true || $options['show_totals_accepted'] === 'true' ) : false; $IX87793 = isset( $options['show_totals_pending'] ) ? ( $options['show_totals_pending'] === true || $options['show_totals_pending'] === 'true' ) : false; $IX78973 = isset( $options['show_totals_closed'] ) ? ( $options['show_totals_closed'] === true || $options['show_totals_closed'] === 'true' ) : false; $IX98967 = isset( $options['show_totals_rejected'] ) ? ( $options['show_totals_rejected'] === true || $options['show_totals_rejected'] === 'true' ) : false; if ( $IX38822 && ( $IX15097 || $IX87793 || $IX78973 || $IX98967 ) ) { $IX66099 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX43075 WHERE affiliate_id = %d AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX46065, AFFILIATES_REFERRAL_STATUS_ACCEPTED ); $IX61432 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX43075 WHERE affiliate_id = %d AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX46065, AFFILIATES_REFERRAL_STATUS_PENDING ); $IX41685 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX43075 WHERE affiliate_id = %d AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX46065, AFFILIATES_REFERRAL_STATUS_CLOSED ); $IX85015 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX43075 WHERE affiliate_id = %d AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX46065, AFFILIATES_REFERRAL_STATUS_REJECTED ); $IX85494 .= '<div class="totals">'; $IX85494 .= '<table cellpadding="0" cellspacing="0">'; $IX85494 .= '<thead>'; $IX85494 .= '<tr>'; $IX85494 .= "<th scope='col' class='total'>" . __( 'Total', 'affiliates' ) . "</th>"; $IX85494 .= "<th scope='col' class='amount'>" . __( 'Amount', 'affiliates' ) . "</th>"; $IX85494 .= "<th scope='col' class='currency'>" . __( 'Currency', 'affiliates' ) . "</th>"; $IX85494 .= '</tr>'; $IX85494 .= '</thead>'; $IX85494 .= '<tbody>'; if ( $IX15097 ) { if ( count( $IX66099 ) == 0 ) { $IX66099[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX66099 as $IX42350 ) { $IX85494 .= '<tr>'; $IX85494 .= "<td class='total accepted'>" . __( 'Accepted', 'affiliates' ) . "</td>"; $IX85494 .= "<td class='amount'>$IX42350->total</td>"; $IX85494 .= "<td class='currency'>$IX42350->currency_id</td>"; $IX85494 .= '</tr>'; } } if ( $IX87793 ) { if ( count( $IX61432 ) == 0 ) { $IX61432[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX61432 as $IX42350 ) { $IX85494 .= '<tr>'; $IX85494 .= "<td class='total pending'>" . __( 'Pending', 'affiliates' ) . "</td>"; $IX85494 .= "<td class='amount'>$IX42350->total</td>"; $IX85494 .= "<td class='currency'>$IX42350->currency_id</td>"; $IX85494 .= '</tr>'; } } if ( $IX78973 ) { if ( count( $IX41685 ) == 0 ) { $IX41685[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX41685 as $IX42350 ) { $IX85494 .= '<tr>'; $IX85494 .= "<td class='total closed'>" . __( 'Closed', 'affiliates' ) . "</td>"; $IX85494 .= "<td class='amount'>$IX42350->total</td>"; $IX85494 .= "<td class='currency'>$IX42350->currency_id</td>"; $IX85494 .= '</tr>'; } } if ( $IX98967 ) { if ( count( $IX85015 ) == 0 ) { $IX85015[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX85015 as $IX42350 ) { $IX85494 .= '<tr>'; $IX85494 .= "<td class='total rejected'>" . __( 'Rejected', 'affiliates' ) . "</td>"; $IX85494 .= "<td class='amount'>$IX42350->total</td>"; $IX85494 .= "<td class='currency'>$IX42350->currency_id</td>"; $IX85494 .= '</tr>'; } } $IX85494 .= '</tbody>'; $IX85494 .= '</table>'; $IX85494 .= '</div>'; } return $IX85494; }
}
