<?php
/**
 * class-affiliates-attributes-wordpress.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * System-specific attributes implementation.
 */
class Affiliates_Attributes_WordPress extends Affiliates_Attributes {

	/**
	 * View
	 *
	 * @param int $affiliate_id
	 */
	function view( $affiliate_id ) { global $wpdb, $affiliates_options, $affiliates_db; $IX34378 = ''; $IX59821 = new Affiliates_Affiliate_WordPress(); $IX59074 = $IX59821->get_affiliate( $affiliate_id ); if ( $IX59074 ) { $IX35930 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX35930 = remove_query_arg( 'action', $IX35930 ); $IX35930 = remove_query_arg( 'affiliate_id', $IX35930 ); $IX72228 = isset( $_POST['row_count'] ) ? intval( $_POST['row_count'] ) : 0; if ($IX72228 <= 0) { $IX72228 = $affiliates_options->get_option( 'affiliates_attributes_per_page', AFFILIATES_HITS_PER_PAGE ); } else { $affiliates_options->update_option('affiliates_attributes_per_page', $IX72228 ); } $IX62867 = isset( $_GET['offset'] ) ? intval( $_GET['offset'] ) : 0; if ( $IX62867 < 0 ) { $IX62867 = 0; } $IX41662 = isset( $_REQUEST['paged'] ) ? intval( $_REQUEST['paged'] ) : 0; if ( $IX41662 < 0 ) { $IX41662 = 0; } $IX34378 .= '<div class="manage-affiliates">' . '<div>' . '<h2>' . __( 'Affiliate Attributes', 'affiliates' ) . '</h2>' . '</div>'; $IX34378 .= '<div class="manage">' . "<a title='" . __( 'Click to add a new attribute', 'affiliates' ) . "' class='add' href='" . esc_url( $IX35930 ) . "&action=add-attribute&affiliate_id=" . urlencode( $affiliate_id ) . "'><img class='icon' alt='" . __( 'Add', 'affiliates') . "' src='". AFFILIATES_PRO_PLUGIN_URL ."images/add.png'/><span class='label'>" . __( 'New Attribute', 'affiliates') . "</span></a>" . '</div>'; $IX34378 .= '<div class="affiliates-attributes-overview">'; $IX59008 = array( 'attr_key' => __( 'Id', 'affiliates' ), 'attr_value' => __( 'Value', 'affiliates' ), 'edit' => __( 'Edit', 'affiliates' ), 'remove' => __( 'Remove', 'affiliates' ) ); $IX34378 .= '
				<table id="" class="wp-list-table widefat fixed" cellspacing="0">
				<thead>
					<tr>
					'; foreach ( $IX59008 as $IX68710 => $IX49842 ) { $IX34378 .= "<th scope='col' class='$IX68710'>$IX49842</th>"; } $IX34378 .= '</tr>
				</thead>
				<tbody>
				'; $IX65352 = $affiliates_db->get_tablename( "affiliates_attributes" ); $IX94693 = $affiliates_db->get_objects("SELECT * FROM $IX65352 WHERE affiliate_id = %d", $affiliate_id ); if ( !empty( $IX94693 ) ) { $IX72756 = Affiliates_Attributes::get_keys(); $IX12805 = 0; foreach ( $IX94693 as $IX62832 ) { $IX50176 = ''; $IX51593 = ''; $IX34378 .= '<tr class="' . $IX50176 . $IX51593 . ( $IX12805 % 2 == 0 ? 'even' : 'odd' ) . '">'; $IX34378 .= '<td>' . wp_filter_kses( $IX72756[$IX62832->attr_key] ) . '</td>'; $IX58457 = @unserialize( $IX62832->attr_value ); if ( $IX58457 !== false ) { $IX28084 = $IX58457; } else { $IX28084 = $IX62832->attr_value; } if ( is_array( $IX28084 ) ) { $IX28084 = implode( "::", $IX28084 ); } $IX34378 .= '<td>' . wp_filter_kses( $IX28084 ) . '</td>'; $IX34378 .= "<td class='edit'><a href='" . esc_url( $IX35930 ) . "&action=edit-attribute&affiliate_id=" . urlencode( $affiliate_id ) . "&attr_key=" . urlencode( $IX62832->attr_key ) . "' alt='" . __( 'Edit', 'affiliates') . "'><img src='". AFFILIATES_PRO_PLUGIN_URL ."images/edit.png'/></a></td>"; $IX34378 .= "<td class='remove'><a href='" . esc_url( $IX35930 ) . "&action=remove-attribute&affiliate_id=" . urlencode( $affiliate_id ) . "&attr_key=" . urlencode( $IX62832->attr_key ) . "' alt='" . __( 'Remove', 'affiliates') . "'><img src='". AFFILIATES_PRO_PLUGIN_URL ."images/remove.png'/></a></td>"; $IX34378 .= '</tr>'; $IX12805++; } $IX34378 .= '</table>'; $IX34378 .= '</td>'; $IX34378 .= '</tr>'; } else { $IX34378 .= '<tr><td colspan="' . count( $IX59008 ) . '">' . __('There are no results.', 'affiliates' ) . '</td></tr>'; } $IX34378 .= '</tbody>'; $IX34378 .= '</table>'; $IX34378 .= '</div>'; $IX34378 .= '</div>'; } echo $IX34378; }

	/**
	 * Show add attribute form.
	 */
	function add( $affiliate_id ) { global $affiliates_db; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } affiliates_pro_admin_notices(); $IX35526 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX35526 = remove_query_arg( 'action', $IX35526 ); $IX35526 = remove_query_arg( 'affiliate_id', $IX35526 ); $IX17917 = esc_url( $IX35526 ) . "&action=edit&affiliate_id=" . urlencode( $affiliate_id ); $IX35526 = remove_query_arg( 'paged', $IX35526 ); $affiliate_id = isset( $_POST['affiliate_id'] ) ? $_POST['affiliate_id'] : $affiliate_id; $IX65225 = isset( $_POST['attr-key-field'] ) ? $_POST['attr-key-field'] : ''; $IX21434 = isset( $_POST['attr-value-field'] ) ? $_POST['attr-value-field'] : ''; $IX15123 = array(); $IX89418 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX81630 = $affiliates_db->get_objects( "SELECT * FROM $IX89418 WHERE affiliate_id = %d", $affiliate_id ); foreach( $IX81630 as $IX92619 ) { $IX15123[] = $IX92619->attr_key; } $IX77410 = '<select id="attr-key-field" name="attr-key-field" class="attr-key-field">'; $IX40867 = Affiliates_Attributes::get_keys(); if ( !get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { unset( $IX40867[Affiliates_Attributes::REFERRAL_AMOUNT] ); unset( $IX40867[Affiliates_Attributes::REFERRAL_AMOUNT_METHOD] ); unset( $IX40867[Affiliates_Attributes::REFERRAL_RATE] ); } foreach( $IX40867 as $IX11481 => $IX56031 ) { if ( !in_array( $IX11481, $IX15123 ) ) { $IX56398 = $IX65225 == $IX11481 ? ' selected="selected" ' : ''; $IX77410 .= '<option value="' . esc_attr( $IX11481 ) . '" ' . $IX56398 . '>' . wp_filter_kses( $IX56031 ) . '</option>'; } } $IX77410 .= '</select>'; $IX78016 = '<div class="manage-affiliates">' . '<div>' . '<h1>' . __( 'Add a new attribute', 'affiliates' ) . '</h1>' . '</div>' . '<form id="add-attribute" action="' . esc_url( $IX35526 ) . '" method="post">' . '<div class="affiliate new">' . '<div class="field">' . '<label for="attr-key-field" class="field-label first required">' .__( 'Key', 'affiliates' ) . '</label>' . $IX77410 . '</div>' . '<div class="field">' . '<label for="attr-value-field" class="field-label first required">' .__( 'Value', 'affiliates' ) . '</label>' . '<input id="attr-value-field" name="attr-value-field" class="attr-value-field" type="text" value="' . esc_attr( $IX21434 ) . '"/>' . '</div>' . '<div class="field">' . wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_NONCE, true, false ) . '<input class="button button-primary" type="submit" value="' . __( 'Add', 'affiliates' ) . '"/>' . '<input type="hidden" value="' . esc_attr( $affiliate_id ) . '" name="affiliate_id"/>' . '<input type="hidden" value="add-attribute" name="action"/>' . ' ' . '<a class="cancel button" href="' . $IX17917 . '">' . __( 'Cancel', 'affiliates' ) . '</a>' . '</div>' . '</div>' . '</form>' . '</div>'; echo $IX78016; }

	/**
	 * Handle add affiliate form submission.
	 */
	function add_submit() { global $wpdb, $affiliates_db, $affiliates_pro_admin_messages; $IX25448 = true; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_NONCE], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX16829 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX87035 = isset( $_POST['affiliate_id'] ) ? $_POST['affiliate_id'] : null; $IX58786 = isset( $_POST['attr-key-field'] ) ? $_POST['attr-key-field'] : null; $IX93642 = isset( $_POST['attr-value-field'] ) ? $_POST['attr-value-field'] : null; if ( $IX93642 !== null ) { $IX93642 = Affiliates_Attributes::validate_value( $IX58786, $IX93642 ); if ( $IX93642 !== false ) { if ( is_array( $IX93642 ) || is_object( $IX93642 ) ) { $IX93642 = serialize( $IX93642 ); } } else { $IX93642 = null; } } $IX95423 = false; if ( ( $IX58786 == Affiliates_Attributes::COUPONS ) && !empty( $IX93642 ) ) { $IX22013 = explode( ",", $IX93642 ); foreach( $IX22013 as $IX25303 ) { $IX25303 = trim( $IX25303 ); $IX89140 = self::get_affiliate_for_coupon( $IX25303 ); if ( ( $IX89140 !== null ) && ( $IX89140 != $IX87035 ) ) { $affiliates_pro_admin_messages[] = '<div class="error">' . sprintf( __( 'Coupons may not be assigned to multiple affiliates. The coupon code <strong>%s</strong> has already been assigned to the affiliate with Id %d.', 'affiliates'), $IX25303, $IX89140 ) . '</div>'; $IX95423 = true; } } } if ( $IX95423 ) { return false; } if ( !empty( $IX87035 ) && Affiliates_Attributes::validate_key( $IX58786 ) && ( $IX93642 !== null ) ) { if ( !$affiliates_db->get_value( "SELECT * FROM $IX16829 WHERE affiliate_id = %d AND attr_key = %s", $IX87035, $IX58786 ) ) { if ( $affiliates_db->query( "INSERT INTO $IX16829 SET affiliate_id=%d, attr_key=%s, attr_value=%s", $IX87035, $IX58786, $IX93642 ) ) { do_action( 'affiliates_added_attribute', $IX87035, $IX58786, $IX93642 ); } } else { $affiliates_pro_admin_messages[] = '<div class="error">' . __( 'Duplicate key', 'affiliates' ) . '</div>'; $IX25448 = false; } } else { $affiliates_pro_admin_messages[] = '<div class="error">' . __( 'Invalid data', 'affiliates' ) . '</div>'; $IX25448 = false; } return $IX25448; }

	/**
	 * Show edit attribute form.
	 */
	function edit( $affiliate_id, $attr_key ) { global $affiliates_db; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } affiliates_pro_admin_notices(); $IX72662 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX72662 = remove_query_arg( 'action', $IX72662 ); $IX72662 = remove_query_arg( 'affiliate_id', $IX72662 ); $IX78279 = esc_url( $IX72662 ) . "&action=edit&affiliate_id=" . urlencode( $affiliate_id ); $IX72662 = remove_query_arg( 'paged', $IX72662 ); $IX72102 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX14039 = $affiliates_db->get_value( "SELECT attr_value FROM $IX72102 WHERE affiliate_id = %d AND attr_key = %s", $affiliate_id, $attr_key ); $affiliate_id = isset( $_POST['affiliate_id'] ) ? $_POST['affiliate_id'] : $affiliate_id; $attr_key = isset( $_POST['attr-key-field'] ) ? $_POST['attr-key-field'] : $attr_key; $IX14039 = isset( $_POST['attr-value-field'] ) ? $_POST['attr-value-field'] : $IX14039; $IX30420 = @unserialize( $IX14039 ); if ( $IX30420 === false ) { $IX30420 = $IX14039; } if ( is_array( $IX30420 ) ) { $IX30420 = implode( "::", $IX30420 ); } $IX71613 = Affiliates_Attributes::get_keys(); $IX22355 = '<div class="manage-affiliates">' . '<div>' . '<h1>' . __( 'Edit an attribute', 'affiliates' ) . '</h1>' . '</div>' . '<form id="edit-attribute" action="' . esc_url( $IX72662 ) . '" method="post">' . '<div class="affiliate-attribute edit">' . '<div class="field">' . '<label for="attr-key-field" class="field-label first required">' .__( 'Key', 'affiliates' ) . '</label>' . '<input readonly="readonly" id="attr-name-field" name="attr-name-field" class="attr-name-field" type="text" value="' . esc_attr( $IX71613[$attr_key] ) . '"/>' . '<input type="hidden" name="attr-key-field" value="' . esc_attr( $attr_key ) . '"/>' . '</div>' . '<div class="field">' . '<label for="attr-value-field" class="field-label first required">' .__( 'Value', 'affiliates' ) . '</label>' . '<input id="attr-value-field" name="attr-value-field" class="attr-value-field" type="text" value="' . esc_attr( $IX30420 ) . '"/>' . '</div>' . '<div class="field">' . wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_NONCE, true, false ) . '<input class="button button-primary" type="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '<input type="hidden" value="' . esc_attr( $affiliate_id ) . '" name="affiliate_id"/>' . '<input type="hidden" value="edit-attribute" name="action"/>' . ' ' . '<a class="cancel button" href="' . $IX78279 . '">' . __( 'Cancel', 'affiliates' ) . '</a>' . '</div>' . '</div>' . '</form>' . '</div>'; echo $IX22355; }

	/**
	 * Handle edit attribute form submission.
	 */
	function edit_submit() { global $wpdb, $affiliates_db, $affiliates_pro_admin_messages; $IX53589 = true; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_NONCE], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX83149 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX24385 = isset( $_POST['affiliate_id'] ) ? $_POST['affiliate_id'] : null; $IX95218 = isset( $_POST['attr-key-field'] ) ? $_POST['attr-key-field'] : null; $IX82442 = isset( $_POST['attr-value-field'] ) ? $_POST['attr-value-field'] : null; if ( $IX82442 !== null ) { $IX82442 = Affiliates_Attributes::validate_value( $IX95218, $IX82442 ); if ( $IX82442 !== false ) { if ( is_array( $IX82442 ) || is_object( $IX82442 ) ) { $IX82442 = serialize( $IX82442 ); } } else { $IX82442 = null; } } $IX36088 = false; if ( ( $IX95218 == Affiliates_Attributes::COUPONS ) && !empty( $IX82442 ) ) { $IX87544 = explode( ",", $IX82442 ); foreach( $IX87544 as $IX24837 ) { $IX24837 = trim( $IX24837 ); $IX98357 = self::get_affiliate_for_coupon( $IX24837 ); if ( ( $IX98357 !== null ) && ( $IX98357 != $IX24385 ) ) { $affiliates_pro_admin_messages[] = '<div class="error">' . sprintf( __( 'Coupons may not be assigned to multiple affiliates. The coupon code <strong>%s</strong> has already been assigned to the affiliate with Id %d.', 'affiliates'), $IX24837, $IX98357 ) . '</div>'; $IX36088 = true; } } } if ( $IX36088 ) { return false; } if ( !empty( $IX24385 ) && Affiliates_Attributes::validate_key( $IX95218 ) && ( $IX82442 !== null ) ) { if ( $IX13766 = $affiliates_db->get_value( "SELECT attr_value FROM $IX83149 WHERE affiliate_id = %d AND attr_key = %s", $IX24385, $IX95218 ) ) { if ( $affiliates_db->query( "UPDATE $IX83149 SET attr_value=%s WHERE affiliate_id=%d AND attr_key=%s", $IX82442 , $IX24385, $IX95218 ) ) { do_action( 'affiliates_updated_attribute', $IX24385, $IX95218, $IX13766, $IX82442 ); } } else { $affiliates_pro_admin_messages[] = '<div class="error">' . __( 'Invalid key', 'affiliates' ) . '</div>'; $IX53589 = false; } } else { $affiliates_pro_admin_messages[] = '<div class="error">' . __( 'Invalid data', 'affiliates' ) . '</div>'; $IX53589 = false; } return $IX53589; }

	/**
	 * Show remove attribute form.
	 */
	function remove( $affiliate_id, $attr_key ) { global $affiliates_db; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } affiliates_pro_admin_notices(); $IX76845 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX76845 = remove_query_arg( 'action', $IX76845 ); $IX76845 = remove_query_arg( 'affiliate_id', $IX76845 ); $IX97620 = esc_url( $IX76845 ) . "&action=edit&affiliate_id=" . urlencode( $affiliate_id ); $IX76845 = remove_query_arg( 'paged', $IX76845 ); $IX32305 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX92578 = $affiliates_db->get_value( "SELECT attr_value FROM $IX32305 WHERE affiliate_id = %d AND attr_key = %s", $affiliate_id, $attr_key ); $affiliate_id = isset( $_POST['affiliate_id'] ) ? $_POST['affiliate_id'] : $affiliate_id; $attr_key = isset( $_POST['attr-key-field'] ) ? $_POST['attr-key-field'] : $attr_key; $IX92578 = isset( $_POST['attr-value-field'] ) ? $_POST['attr-value-field'] : $IX92578; $IX43178 = @unserialize( $IX92578 ); if ( $IX43178 === false ) { $IX43178 = $IX92578; } if ( is_array( $IX43178 ) ) { $IX43178 = implode( "::", $IX43178 ); } $IX63101 = Affiliates_Attributes::get_keys(); $IX82012 = '<div class="manage-affiliates">' . '<div>' . '<h1>' . __( 'Remove an attribute', 'affiliates' ) . '</h1>' . '</div>' . '<form id="remove-attribute" action="' . esc_url( $IX76845 ) . '" method="post">' . '<div class="affiliate-attribute remove">' . '<div class="field">' . '<label for="attr-key-field" class="field-label first required">' .__( 'Key', 'affiliates' ) . '</label>' . '<input readonly="readonly" id="attr-name-field" name="attr-name-field" class="attr-name-field" type="text" value="' . esc_attr( $IX63101[$attr_key] ) . '"/>' . '<input type="hidden" name="attr-key-field" value="' . esc_attr( $attr_key ) . '"/>' . '</div>' . '<div class="field">' . '<label for="attr-value-field" class="field-label first required">' .__( 'Value', 'affiliates' ) . '</label>' . '<input readonly="readonly" id="attr-value-field" name="attr-value-field" class="attr-value-field" type="text" value="' . esc_attr( $IX43178 ) . '"/>' . '</div>' . '<div class="field">' . wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_NONCE, true, false ) . '<input class="button button-primary" type="submit" value="' . __( 'Remove', 'affiliates' ) . '"/>' . '<input type="hidden" value="' . esc_attr( $affiliate_id ) . '" name="affiliate_id"/>' . '<input type="hidden" value="remove-attribute" name="action"/>' . ' ' . '<a class="cancel button" href="' . $IX97620 . '">' . __( 'Cancel', 'affiliates' ) . '</a>' . '</div>' . '</div>' . '</form>' . '</div>'; echo $IX82012; }

	/**
	 * Handle remove attribute form submission.
	 */
	function remove_submit() { global $wpdb, $affiliates_db, $affiliates_pro_admin_messages; $IX92232 = true; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_NONCE], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX91565 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX58679 = isset( $_POST['affiliate_id'] ) ? $_POST['affiliate_id'] : null; $IX93554 = isset( $_POST['attr-key-field'] ) ? $_POST['attr-key-field'] : null; if ( !( empty( $IX58679 ) || empty( $IX93554 ) ) ) { $IX67421 = $affiliates_db->get_value( "SELECT attr_value FROM $IX91565 WHERE affiliate_id = %d AND attr_key = %s", $IX58679, $IX93554 ); if ( $affiliates_db->query( "DELETE FROM $IX91565 WHERE affiliate_id=%d AND attr_key=%s", $IX58679, $IX93554 ) ) { do_action( 'affiliates_removed_attribute', $IX58679, $IX93554, $IX67421 ); } } else { $IX92232 = false; } return $IX92232; }

	/**
	 * Returns the affiliate id that the given $coupon code is assigned to
	 * or null if the code is not yet assigned to an affiliate.
	 * 
	 * @param string $coupon coupon code
	 * @return int affiliate id of the affiliate assigned, null otherwise
	 */
	public static function get_affiliate_for_coupon( $coupon ) { global $affiliates_db; $IX10873 = $affiliates_db->get_tablename( "affiliates_attributes" ); $IX13979 = $affiliates_db->get_objects( "SELECT * FROM $IX10873 WHERE attr_key = %s AND attr_value LIKE '%%%s%%'", Affiliates_Attributes::COUPONS, $coupon ); $IX11162 = null; foreach( $IX13979 as $IX36562 ) { $IX46254 = explode( ",", $IX36562->attr_value ); foreach( $IX46254 as $IX81017 ) { $IX81017 = trim( $IX81017 ); if ( apply_filters( 'affiliates_coupons_equality_test', $IX81017 === $coupon, $IX81017, $coupon ) ) { $IX11162 = $IX36562->affiliate_id; break; } } if ( $IX11162 !== null ) { break; } } return apply_filters( 'affiliates_coupon_affiliate_id', $IX11162, $coupon ); }

	/**
	 * Returns the coupons for the affiliate.
	 * @param int $affiliate_id
	 * @return array of string, coupons associated to the affiliate
	 * @since 2.3.2
	 */
	public static function get_coupons_for_affiliate( $affiliate_id ) { global $affiliates_db; $IX87797 = array(); $IX73807 = $affiliates_db->get_tablename( 'affiliates_attributes' ); if ( $IX50576 = $affiliates_db->get_value( "SELECT attr_value FROM $IX73807 WHERE affiliate_id = %d AND attr_key = %s", intval( $affiliate_id ), Affiliates_Attributes::COUPONS ) ) { $IX87797 = explode( ',', $IX50576 ); } return $IX87797; }

	/**
	 * Sets the coupons for the affiliate.
	 * @param int $affiliate_id
	 * @param array $coupons
	 * @since 2.3.2 
	 */
	public static function set_coupons_for_affiliate( $affiliate_id, $coupons = array() ) { global $affiliates_db; $affiliate_id = intval( $affiliate_id ); $IX88910 = array(); foreach( $coupons as $IX59005 ) { $IX59005 = trim( $IX59005 ); if ( strlen( $IX59005 ) > 0 ) { $IX70178 = self::get_affiliate_for_coupon( $IX59005 ); if ( ( $IX70178 === null ) || ( $IX70178 == $affiliate_id ) ) { $IX88910[] = $IX59005; } } } $coupons = $IX88910; $IX74720 = self::get_coupons_for_affiliate( $affiliate_id ); if ( $IX74720 != $coupons ) { $IX73802 = $affiliates_db->get_tablename( 'affiliates_attributes' ); if ( count( $coupons ) == 0 ) { if ( $affiliates_db->query( "DELETE FROM $IX73802 WHERE affiliate_id=%d AND attr_key=%s", $affiliate_id, $IX42763 ) ) { do_action( 'affiliates_removed_attribute', $affiliate_id, Affiliates_Attributes::COUPONS, implode( ',', $IX74720 ) ); } } else { if ( $IX39730 = $affiliates_db->get_value( "SELECT attr_value FROM $IX73802 WHERE affiliate_id = %d AND attr_key = %s", $affiliate_id, Affiliates_Attributes::COUPONS ) ) { if ( $affiliates_db->query( "UPDATE $IX73802 SET attr_value=%s WHERE affiliate_id=%d AND attr_key=%s", implode( ',', $coupons ) , $affiliate_id, Affiliates_Attributes::COUPONS ) ) { do_action( 'affiliates_updated_attribute', $affiliate_id, Affiliates_Attributes::COUPONS, $IX39730, implode( ',', $coupons ) ); } } else { if ( $affiliates_db->query( "INSERT INTO $IX73802 SET affiliate_id=%d, attr_key=%s, attr_value=%s", $affiliate_id, Affiliates_Attributes::COUPONS, implode( ',', $coupons ) ) ) { do_action( 'affiliates_added_attribute', $affiliate_id, Affiliates_Attributes::COUPONS, implode( ',', $coupons ) ); } } } } }
}
