<?php
/**
 * class-affiliates-banner.php
 *
 * Copyright 2014 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since 2.7.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Banner post type and management.
 */
class Affiliates_Banner {

	public static function init() { add_action( 'init', array( __CLASS__, 'wp_init' ), 11 ); add_action( 'admin_init', array(__CLASS__, 'admin_init' ) ); add_shortcode( 'affiliates_banner', array( __CLASS__, 'affiliates_banner_shortcode' ) ); add_filter( 'media_view_strings', array( __CLASS__, 'media_view_strings' ), 10, 2 ); add_filter( 'upload_dir', array(__CLASS__,'upload_dir' ) ); }

	public static function admin_init() { global $pagenow; add_action( 'add_meta_boxes', array( __CLASS__, 'add_meta_boxes' ), 10, 2 ); add_filter( 'enter_title_here', array( __CLASS__, 'enter_title_here' ), 10, 2 ); add_action( 'edit_form_after_title', array( __CLASS__, 'edit_form_after_title' ) ); add_action( 'save_post', array( __CLASS__, 'save_post' ), 10, 2 ); add_filter( 'post_row_actions', array( __CLASS__, 'post_row_actions' ) ); add_filter( 'post_updated_messages', array( __CLASS__, 'post_updated_messages' ) ); add_filter( 'manage_affiliates_banner_posts_columns', array( __CLASS__, 'posts_columns' ) ); add_filter( 'manage_edit-affiliates_banner_columns', array( __CLASS__, 'edit_affiliates_banner_columns' ) ); add_filter( 'manage_affiliates_banner_posts_custom_column', array( __CLASS__, 'posts_custom_column' ), 10, 2 ); add_action( 'current_screen', array(__CLASS__, 'current_screen' ) ); add_filter( 'parent_file', array( __CLASS__, 'parent_file' ) ); $IX55054 = isset( $_REQUEST['screen_id'] ) ? $_REQUEST['screen_id'] : ''; $IX25204 = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : ''; if ( isset( $pagenow ) && ( $pagenow == 'admin-ajax.php' ) && ( ( $IX55054 == 'affiliates_banner' ) || ( $IX25204 == 'set-post-thumbnail' ) ) ) { if ( !has_filter( 'gettext', array( __CLASS__, 'gettext' ) ) ) { add_filter( 'gettext', array( __CLASS__, 'gettext' ), 10, 3 ); } } }

	public static function current_screen() { $IX20718 = get_current_screen(); if ( isset( $IX20718->id ) ) { switch( $IX20718->id ) { case 'edit-affiliates_banner' : case 'affiliates_banner' : if ( !has_filter( 'gettext', array( __CLASS__, 'gettext' ) ) ) { add_filter( 'gettext', array( __CLASS__, 'gettext' ), 10, 3 ); } break; } } }

	public static function parent_file( $parent_file ) { global $submenu_file; switch ( $submenu_file ) { case 'post-new.php?post_type=affiliates_banner' : case 'edit.php?post_type=affiliates_banner' : $parent_file = 'affiliates-admin'; $submenu_file = 'edit.php?post_type=affiliates_banner'; break; } return $parent_file; }

	public static function media_view_strings( $strings,  $post ) { if ( isset( $post->post_type ) && ( $post->post_type == 'affiliates_banner' ) ) { $strings['setFeaturedImageTitle'] = __( 'Set Banner Image', 'affiliates' ); $strings['setFeaturedImage'] = __( 'Set banner image', 'affiliates' ); } return $strings; }

	public static function gettext( $translations, $text, $domain ) { remove_filter( 'gettext', array( __CLASS__, 'gettext' ) ); switch( $text ) { case '(no title)' : $translations = __( '(no reference)', 'affiliates' ); break; case 'Set featured image' : $translations = __( 'Set banner image', 'affiliates' ); break; case 'Remove featured image' : $translations = __( 'Remove banner image', 'affiliates' ); break; } add_filter( 'gettext', array( __CLASS__, 'gettext'), 10, 3 ); return $translations; }

	public static function posts_columns( $posts_columns ) { foreach( $posts_columns as $IX97718 => $IX82997 ) { switch( $IX97718 ) { case 'title' : $posts_columns[$IX97718] = __( 'Banner', 'affiliates' ); break; } } return $posts_columns; }

	public static function edit_affiliates_banner_columns( $columns ) { if ( isset( $columns['date'] ) ) { $IX26019 = $columns['date']; unset( $columns['date'] ); } $columns['image'] = __( 'Image', 'affiliates' ); $columns['shortcode'] = __( 'Shortcode', 'affiliates' ); if ( isset( $IX26019 ) ) { $columns['date'] = $IX26019; } return $columns; }

	public static function posts_custom_column( $column_name, $post_id ) { global $affiliates_banner_admin_style_flag; if ( !isset( $affiliates_banner_admin_style_flag ) ) { $affiliates_banner_admin_style_flag = true; echo '<style type="text/css">'; echo 'th.column-title { width: 15%; }'; echo 'td.image.column-image { overflow: hidden; }'; echo '</style>'; } switch( $column_name ) { case 'image' : $IX67405 = get_the_post_thumbnail( $post_id ); if ( empty( $IX67405 ) ) { $IX67405 = self::get_url_thumbnail( $post_id ); } printf( '<a href="%s">%s</a>', esc_attr( get_edit_post_link( $post_id ) ), $IX67405 ); break; case 'shortcode' : echo '<p>'; printf( __( '<code>[affiliates_banner id="%d"]</code>', 'affiliates' ), $post_id ); echo '</p>'; break; } }

	public static function get_url_thumbnail( $post_id ) { $IX61864 = get_post_meta( $post_id, 'url', true ); $IX66592 = get_post_meta( $post_id, 'width', true ); $IX95117 = get_post_meta( $post_id, 'height', true ); list( $IX66592, $IX95117 ) = image_constrain_size_for_editor( $IX66592, $IX95117, $IX56111 = 'thumbnail' ); $IX81618 = sprintf( '<img src="%s" width="%d" height="%d" />', $IX61864, $IX66592, $IX95117 ); return $IX81618; }

	public static function get_url_image( $post_id, $alt ) { $IX90214 = get_post_meta( $post_id, 'url', true ); $IX35758 = get_post_meta( $post_id, 'width', true ); $IX94736 = get_post_meta( $post_id, 'height', true ); $IX22155 = sprintf( '<img src="%s" width="%d" height="%d" alt="%s" />', $IX90214, intval( $IX35758 ), intval( $IX94736 ), esc_attr( $alt ) ); return $IX22155; }

	public static function wp_init() { self::post_type(); }

	public static function post_type() { register_post_type( 'affiliates_banner', array( 'labels' => array( 'name' => __( 'Banners', 'affiliates' ), 'singular_name' => __( 'Banner', 'affiliates' ), 'all_items' => __( 'Banners', 'affiliates' ), 'add_new' => __( 'New Banner', 'affiliates' ), 'add_new_item' => __( 'Add New Banner', 'affiliates' ), 'edit' => __( 'Edit', 'affiliates' ), 'edit_item' => __( 'Edit Banner', 'affiliates' ), 'new_item' => __( 'New Banner', 'affiliates' ), 'not_found' => __( 'No Banners found', 'affiliates' ), 'not_found_in_trash' => __( 'No Banners found in trash', 'affiliates' ), 'parent' => __( 'Parent Banner', 'affiliates' ), 'search_items' => __( 'Search Banners', 'affiliates' ), 'view' => __( 'View Banner', 'affiliates' ), 'view_item' => __( 'View Banner', 'affiliates' ), 'menu_name' => __( 'Banners', 'affiliates' ) ), 'capability_type' => array( 'affiliates_banner', 'affiliates_banners' ), 'description' => __( 'Affiliate Banner', 'affiliates' ), 'exclude_from_search' => true, 'has_archive' => false, 'hierarchical' => false, 'map_meta_cap' => true, 'public' => false, 'publicly_queryable' => false, 'query_var' => true, 'rewrite' => false, 'show_in_nav_menus' => false, 'show_ui' => true, 'supports' => array( 'title', 'thumbnail' ), 'show_in_menu' => false, ) ); self::create_capabilities(); }

	public static function create_capabilities() { global $wp_roles; $IX47459 = $wp_roles->get_role( 'administrator' ); $IX28102 = self::get_capabilities(); foreach( $IX28102 as $IX42479 => $IX58234 ) { if ( !$IX47459->has_cap( $IX58234 ) ) { $IX47459->add_cap( $IX58234 ); } } }

	public static function get_capabilities() { return array( 'edit_posts' => 'edit_affiliates_banners', 'edit_others_posts' => 'edit_others_affiliates_banners', 'publish_posts' => 'publish_affiliates_banners', 'read_private_posts' => 'read_private_affiliates_banners', 'delete_posts' => 'delete_affiliates_banners', 'delete_private_posts' => 'delete_private_affiliates_banners', 'delete_published_posts' => 'delete_published_affiliates_banners', 'delete_others_posts' => 'delete_others_affiliates_banners', 'edit_private_posts' => 'edit_private_affiliates_banners', 'edit_published_posts' => 'edit_published_affiliates_banners', ); }

	public static function add_meta_boxes( $post_type, $post ) { if ( $post_type == 'affiliates_banner' ) { remove_meta_box( 'postimagediv', 'affiliates_banner', 'side' ); add_meta_box( 'postimagediv', __( 'Banner Image', 'affiliates' ), array( __CLASS__, 'post_thumbnail_meta_box' ), 'affiliates_banner', 'normal', 'high' ); add_meta_box( 'url', __( 'URL', 'affiliates' ), array( __CLASS__, 'url_meta_box' ), 'affiliates_banner', 'normal', 'high' ); } }

	public static function enter_title_here( $title, $post ) { if ( $post->post_type == 'affiliates_banner' ) { return __( 'Banner reference &hellip;', 'affiliates' ); } return $title; }

	public static function edit_form_after_title( $post ) { if ( isset( $post->post_type ) && $post->post_type == 'affiliates_banner' ) { echo '<div style="padding:2px 1em 1em 1em;" class="description">'; echo '<p>'; echo __( 'The reference for this banner (also used as <em>alt</em> attribute for images specified by URL).', 'affiliates' ); echo '</p>'; echo '<p>'; echo __( 'Set a banner image and determine its title and other attributes directly for the image attachment using the <strong>Banner Image</strong> facilities.', 'affiliates' ); echo '</p>'; if ( isset( $post->ID ) ) { echo '<p>'; printf( __( 'Use this shortcode to embed the banner: <code>[affiliates_banner id="%d"]</code>', 'affiliates' ), $post->ID ); echo '</p>'; } echo '</div>'; } }

	public static function url_meta_box( $post ) { $IX55289 = ''; $IX46536 = get_post_meta( $post->ID, 'url', true ); $IX26349 = get_post_meta( $post->ID, 'width', true ); $IX74900 = get_post_meta( $post->ID, 'height', true ); $IX30694 = get_post_meta( $post->ID, 'update_size', true ); if ( empty( $IX30694 ) ) { $IX30694 = 'yes'; } $IX55289 .= '<div>'; $IX55289 .= '<p>'; $IX55289 .= __( 'Alternatively, a banner image URL can be specified.', 'affiliates' ); $IX55289 .= ' '; $IX55289 .= __( 'This is useful if you want to use an external image or an image that is located outside the uploads directory structure.', 'affiliates' ); $IX55289 .= ' '; $IX55289 .= __( 'If a banner image is set, it takes precedence - this is only used if no banner image is set.', 'affiliates' ); $IX55289 .= '</p>'; $IX55289 .= '</div>'; $IX55289 .= '<div>'; $IX55289 .= self::get_url_thumbnail( $post->ID ); $IX55289 .= '</div>'; $IX55289 .= '<div>'; $IX55289 .= '<label>'; $IX55289 .= __( 'URL', 'affiliates' ); $IX55289 .= ' '; $IX55289 .= sprintf( '<input style="display:block; width:100%%" type="text" name="url" value="%s" />', esc_attr( $IX46536 ) ); $IX55289 .= '</label>'; $IX55289 .= '<p class="description">'; $IX55289 .= __( 'Banner image URL.', 'affiliates' ); $IX55289 .= '</p>'; $IX55289 .= '</div>'; $IX55289 .= '<div>'; $IX55289 .= '<label>'; $IX55289 .= sprintf( '<input type="checkbox" name="update_size" value="1" %s />', $IX30694 == 'yes' ? ' checked="checked" ' : '' ); $IX55289 .= ' '; $IX55289 .= __( 'Update Size', 'affiliates' ); $IX55289 .= '</label>'; $IX55289 .= '<p class="description">'; $IX55289 .= __( 'Try to obtain the image width and height based on the URL and update the values.', 'affiliates' ); $IX55289 .= '</p>'; $IX55289 .= '</div>'; $IX55289 .= '<div>'; $IX55289 .= '<label>'; $IX55289 .= __( 'Width', 'affiliates' ); $IX55289 .= ' '; $IX55289 .= sprintf( '<input style="display:block; width:5em" type="text" name="width" value="%s" />', esc_attr( $IX26349 ) ); $IX55289 .= '</label>'; $IX55289 .= '<p class="description">'; $IX55289 .= __( 'Banner image width in pixels.', 'affiliates' ); $IX55289 .= '</p>'; $IX55289 .= '</div>'; $IX55289 .= '<div>'; $IX55289 .= '<label>'; $IX55289 .= __( 'Height', 'affiliates' ); $IX55289 .= ' '; $IX55289 .= sprintf( '<input style="display:block; width:5em" type="text" name="height" value="%s" />', esc_attr( $IX74900 ) ); $IX55289 .= '</label>'; $IX55289 .= '<p class="description">'; $IX55289 .= __( 'Banner image height in pixels.', 'affiliates' ); $IX55289 .= '</p>'; $IX55289 .= '</div>'; echo $IX55289; }

	public static function save_post( $post_id = null, $post = null ) { if ( ! ( ( defined( "DOING_AUTOSAVE" ) && DOING_AUTOSAVE ) ) ) { if ( $post->post_type == 'affiliates_banner' ) { if ( $post->post_status != 'auto-draft' ) { if ( isset( $_REQUEST['action'] ) && ( $_REQUEST['action'] == 'inline-save' ) ) { return; } $IX87214 = !empty( $_POST['url'] ) ? trim( $_POST['url'] ) : ''; delete_post_meta( $post_id, 'url' ); if ( !empty( $IX87214 ) ) { add_post_meta( $post_id, 'url', $IX87214 ); } $IX57508 = !empty( $_POST['update_size'] ) ? 'yes' : 'no'; delete_post_meta( $post_id, 'update_size' ); add_post_meta( $post_id, 'update_size', $IX57508 ); $IX70974 = null; $IX77124 = null; if ( $IX57508 == 'yes' ) { if ( !empty( $IX87214 ) ) { if ( $IX76449 = getimagesize( $IX87214 ) ) { if ( isset( $IX76449[0] ) ) { $IX70974 = $IX76449[0]; } if ( isset( $IX76449[1] ) ) { $IX77124 = $IX76449[1]; } } } } if ( $IX70974 === null ) { $IX70974 = !empty( $_POST['width'] ) ? intval( trim( $_POST['width'] ) ) : 0; } delete_post_meta( $post_id, 'width' ); if ( $IX70974 > 0 ) { add_post_meta( $post_id, 'width', $IX70974 ); } if ( $IX77124 === null ) { $IX77124 = !empty( $_POST['height'] ) ? intval( trim( $_POST['height'] ) ) : 0; } delete_post_meta( $post_id, 'height' ); if ( $IX77124 > 0 ) { add_post_meta( $post_id, 'height', $IX77124 ); } } } } }

	public static function post_row_actions( $actions ) { $IX93467 = get_post_type(); if ( $IX93467 == 'affiliates_banner' ) { unset( $actions['view'] ); } return $actions; }

	public static function post_updated_messages( $messages ) { $IX55355 = get_post(); $messages['affiliates_banner'] = array( 0 => '', 1 => __( 'Banner updated.', 'affiliates' ), 2 => __( 'Custom field updated.', 'affiliates' ), 3 => __( 'Custom field deleted.', 'affiliates' ), 4 => __( 'Banner updated.', 'affiliates' ), 5 => isset( $_GET['revision'] ) ? sprintf( __( 'Banner restored to revision from %s', 'affiliates' ), wp_post_revision_title( ( int ) $_GET['revision'], false ) ) : false, 6 => __( 'Banner published.', 'affiliates' ), 7 => __( 'Banner saved.', 'affiliates' ), 8 => __( 'Banner submitted.', 'affiliates' ), 9 => sprintf( __( 'Banner scheduled for: <strong>%1$s</strong>.', 'affiliates' ), date_i18n( __( 'M j, Y @ G:i' ), strtotime( $IX55355->post_date ) ) ), 10 => __( 'Banner draft updated.', 'affiliates' ) ); return $messages; }

	public static function affiliates_banner_shortcode( $atts, $content = '' ) { $IX59297 = shortcode_atts( array( 'id' => '*', 'url' => '', 'render' => '' ), $atts ); $IX30639 = ''; $IX90353 = trim( $IX59297['url'] ); $IX45326 = trim( $IX59297['id'] ); $IX37148 = trim( $IX59297['render'] ); $IX93146 = array_map( 'trim', explode( ',', $IX90353 ) ); $IX39592 = array(); if ( trim( $IX45326 ) == '*' ) { $IX57439 = get_posts( array( 'numberposts' => -1, 'post_type' => 'affiliates_banner', 'post_status' => 'publish' ) ); foreach( $IX57439 as $IX27357 ) { if ( get_post_thumbnail_id( $IX27357->ID ) || get_post_meta( $IX27357->ID, 'url', true ) ) { $IX39592[] = $IX27357->ID; } } } else { $IX39592 = array_map( 'intval', array_map( 'trim', explode( ',', $IX45326 ) ) ); } $IX11050 = array(); $IX10255 = 0; foreach( $IX39592 as $IX37076 ) { if ( isset( $IX93146[$IX10255] ) ) { if ( !empty( $IX93146[$IX10255] ) ) { $IX11050['url'] = $IX93146[$IX10255]; } } $IX90353 = Affiliates_Url_Renderer_WordPress::render_affiliate_url( $IX11050 ); add_filter( 'wp_get_attachment_image_attributes', array( __CLASS__, 'wp_get_attachment_image_attributes' ), 999, 2 ); $IX28662 = get_the_post_thumbnail( $IX37076, 'full', array( 'class' => '' ) ); if ( empty( $IX28662 ) ) { $IX41394 = get_the_title( $IX37076 ); $IX28662 = self::get_url_image( $IX37076, $IX41394 ); } $IX29135 = sprintf( '<a href="%s">%s</a>', esc_attr( $IX90353 ), $IX28662 ); remove_filter( 'wp_get_attachment_image_attributes', array( __CLASS__, 'wp_get_attachment_image_attributes' ) ); $IX30639 .= apply_filters( 'affiliates_banner_before', '', $atts ); $IX30639 .= '<div class="affiliates-banner">'; if ( empty( $IX37148 ) || ( $IX37148 == 'image' ) ) { $IX30639 .= apply_filters( 'affiliates_banner_image_before', '', $IX45326, $IX90353, $atts ); $IX30639 .= apply_filters( 'affiliates_banner_image', '<div class="banner-image">' . $IX28662 . '</div>', $IX45326, $IX90353, $atts ); $IX30639 .= apply_filters( 'affiliates_banner_image_after', '', $IX45326, $IX90353, $atts ); } if ( empty( $IX37148 ) || ( $IX37148 == 'code' ) ) { $IX30639 .= apply_filters( 'affiliates_banner_code_before', '', $IX45326, $IX90353, $atts ); $IX30639 .= apply_filters( 'affiliates_banner_code', '<div class="banner-code">' . '<code>' . htmlentities( $IX29135 ) . '</code>' . '</div>', $IX45326, $IX90353, $atts ); $IX30639 .= apply_filters( 'affiliates_banner_code_after', '', $IX45326, $IX90353, $atts ); } $IX30639 .= '</div>'; $IX30639 .= apply_filters( 'affiliates_banner_after', '', $atts ); $IX10255++; } $IX30639 = apply_filters( 'affiliates_banner', $IX30639, $atts ); return $IX30639; }

	public static function wp_get_attachment_image_attributes( $attr, $attachment ) { unset( $attr['class'] ); return $attr; }

	public static function post_thumbnail_meta_box( $post ) { $IX57460 = get_post_meta( $post->ID, '_thumbnail_id', true ); echo self::_wp_post_thumbnail_html( $IX57460, $post->ID ); }

	public static function _wp_post_thumbnail_html( $thumbnail_id = null, $post = null ) { global $content_width, $_wp_additional_image_sizes; $post = get_post( $post ); $IX21426 = esc_url( get_upload_iframe_src('image', $post->ID ) ); $IX90529 = '<p class="hide-if-no-js"><a title="' . esc_attr__( 'Set banner image', 'affiliates' ) . '" href="%s" id="set-post-thumbnail" class="thickbox">%s</a></p>'; $IX74766 = sprintf( $IX90529, $IX21426, esc_html__( 'Set banner image', 'affiliates' ) ); if ( $thumbnail_id && get_post( $thumbnail_id ) ) { $IX14447 = $content_width; $content_width = 266; if ( !isset( $_wp_additional_image_sizes['full'] ) ) { $IX52784 = wp_get_attachment_image( $thumbnail_id, array( $content_width, $content_width ) ); } else { $IX52784 = wp_get_attachment_image( $thumbnail_id, 'full' ); } if ( !empty( $IX52784 ) ) { $IX20944 = wp_create_nonce( 'set_post_thumbnail-' . $post->ID ); $IX74766 = sprintf( $IX90529, $IX21426, $IX52784 ); $IX74766 .= '<p class="hide-if-no-js"><a href="#" id="remove-post-thumbnail" onclick="WPRemoveThumbnail(\'' . $IX20944 . '\');return false;">' . esc_html__( 'Remove banner image', 'affiliates' ) . '</a></p>'; } $content_width = $IX14447; } return apply_filters( 'admin_post_thumbnail_html', $IX74766, $post->ID ); }

	public static function upload_dir( $params ) { global $post, $post_id; if ( empty( $post_id ) ) { if ( !empty( $post ) && isset( $post->ID ) ) { $post_id = $post->ID; } else { $post_id = !empty( $_REQUEST['post_id'] ) ? intval( $_REQUEST['post_id'] ) : null; } } if ( !empty( $post_id ) && ( get_post_type( $post_id ) == 'affiliates_banner' ) ) { if ( apply_filters( 'affiliates_banner_empty_subdir', true ) ) { $params['subdir'] = ''; $params['path'] = $params['basedir'] . '/banners'; $params['url'] = $params['baseurl'] . '/banners'; } else { if ( empty( $params['subdir'] ) ) { $params['path'] = $params['path'] . '/banners'; $params['url'] = $params['url'] . '/banners'; $params['subdir'] = '/banners'; } else { $IX21365 = '/banners' . $params['subdir']; $params['path'] = str_replace( $params['subdir'], $IX21365, $params['path'] ); $params['url'] = str_replace( $params['subdir'], $IX21365, $params['url'] ); $params['subdir'] = str_replace( $params['subdir'], $IX21365, $params['subdir'] ); } } } return $params; }
}
Affiliates_Banner::init();
