<?php
/**
 * class-affiliates-rates-wordpress.php
 * 
 * Copyright (c) 2017 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author itthinx
 * @package affiliates-pro
 * @since affiliates-pro 3.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Rates admin section.
 */
class Affiliates_Rates_WordPress {

	const NONCE = 'nonce-rates';

	public static function init() { add_action( 'affiliates_admin_menu', array( __CLASS__, 'affiliates_admin_menu' ) ); add_action( 'wp_ajax_affiliates_rates_set_fields', array( __CLASS__, 'affiliates_rates_set_fields' ) ); }

	public static function affiliates_rates_set_fields() { ob_start(); $IX60665 = ''; $IX29727 = isset( $_REQUEST['integration'] ) ? esc_html( $_REQUEST['integration'] ) : null; switch ( $IX29727 ) { case 'affiliates-woocommerce' : $IX44994 = affiliates_pro_get_integrations(); if ( isset( $IX44994['affiliates-woocommerce'] ) ) { $IX29727 = $IX44994['affiliates-woocommerce']; $IX20945 = array(); $IX30643 = get_posts( array( 'post_type' => $IX29727['object'] ) ); if ( $IX30643 && ( count( $IX30643 ) > 0 ) ) { $IX78979 = isset( $_REQUEST['post_id'] ) ? $_REQUEST['post_id'] : ''; foreach ( $IX30643 as $IX68369 ) { $IX45131 = ( $IX78979 == $IX68369->ID ) ? true : false; $IX20945[] = array ( 'ID' => $IX68369->ID, 'title' => $IX68369->post_title, 'selected' => $IX45131 ); } } $IX65911 = array(); if ( !empty( $IX29727['taxonomy'] ) && taxonomy_exists( $IX29727['taxonomy'] ) ) { $IX43201 = get_terms( array( 'taxonomy' => $IX29727['taxonomy'] ) ); if ( $IX43201 && ( count( $IX43201 ) > 0 ) ) { $IX70953 = isset( $_REQUEST['term_id'] ) ? $_REQUEST['term_id'] : ''; foreach ( $IX43201 as $IX95750 ) { $IX45131 = ( $IX70953 == $IX95750->term_id ) ? true : false; $IX65911[] = array ( 'ID' => $IX95750->term_id, 'title' => $IX95750->name, 'selected' => $IX45131 ); } } } $IX60665 = wp_json_encode( array( 'posts' => $IX20945, 'terms' => $IX65911 ) ); } break; } ob_end_clean(); echo $IX60665; wp_die(); }

	public static function affiliates_admin_menu() { $IX35932 = add_submenu_page( 'affiliates-admin', __( 'Rates', 'affiliates' ), __( 'Rates', 'affiliates' ), AFFILIATES_ADMINISTER_OPTIONS, 'affiliates-admin-rates', array( __CLASS__, 'affiliates_admin_rates' ) ); $IX82998[] = $IX35932; add_action( 'admin_print_styles-' . $IX35932, 'affiliates_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX35932, 'affiliates_admin_print_scripts' ); add_action( 'admin_print_styles-' . $IX35932, 'affiliates_pro_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX35932, 'affiliates_pro_admin_print_scripts' ); }

	public static function admin_print_styles() { global $affiliates_pro_version; if ( !wp_style_is( 'chosen' ) ) { wp_enqueue_style( 'chosen', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'css/chosen/chosen.min.css', array(), $affiliates_pro_version ); } }

	public static function admin_print_scripts() { global $affiliates_pro_version; if ( !wp_script_is( 'chosen' ) ) { wp_enqueue_script( 'chosen', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'js/chosen/chosen.jquery.min.js', array( 'jquery' ), $affiliates_pro_version ); } }

	public static function affiliates_admin_rates() { if ( !current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } echo '<h1>'; echo __( 'Rates', 'affiliates' ); echo '</h1>'; if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { echo '<div class="error">'; echo '<h2>'; echo __( 'Important', 'affiliates' ); echo '</h2>'; echo '<p>'; echo __( 'The rates defined here are effective only when the method used to calculate commissions is <em>Rates</em>.', 'affiliates' ); echo ' '; printf( __( 'To enable the rates defined here, please go to <a href="%s">Commissions</a> and select <em>Rates</em> as the method.', 'affiliates' ), add_query_arg( 'section', 'commissions', admin_url( 'admin.php?page=affiliates-admin-settings' ) ) ); echo '</p>'; echo '</div>'; } Affiliates_Rates_Table::render(); affiliates_footer(); }

}
add_action( 'init', array( 'Affiliates_Rates_WordPress', 'init' ) );
