<?php
/**
 * class-affiliates-referral-wordpress.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Referral implementation.
 */
class Affiliates_Referral_WordPress extends Affiliates_Referral implements I_Affiliates_Referral_Legacy {

	/**
	 * Use evaluate(...) instead.
	 * @deprecated
	 * @see I_Affiliates_Referral_Legacy::suggest()
	 * @see Affiliates_Referral_WordPress::evaluate()
	 */
	public function suggest( $post_id, $description = '', $data = null, $amount = null, $currency_id = null, $status = null ) { trigger_error( __FUNCTION__ . " is deprecated", E_USER_WARNING ); return $this->evaluate( $post_id, $description, $data, null, $amount, $currency_id, $status ); }

	/**
	 * Referral evaluation.
	 * This will create a new referral if an affiliate is creditable.
	 * 
	 * @param int     $post_id
	 * @param string  $description
	 * @param array   $data
	 * @param string  $base_amount
	 * @param string  $amount
	 * @param string  $currency_id
	 * @param string  $status
	 * @param string  $type
	 * @param boolean $test
	 */
	public function evaluate( $post_id, $description = '', $data = null, $base_amount = null, $amount = null, $currency_id = null, $status = null, $type = null, $reference = null, $test = false ) { require_once( AFFILIATES_CORE_LIB . '/class-affiliates-service.php' ); $IX49836 = Affiliates_Service::get_referrer_id(); if ( !$test ) { if ( $IX49836 ) { $IX47824 = Affiliates_Service::get_hit_id(); $IX97191 = array ( $IX49836 ); $this->add_referrals( $IX97191, $post_id, $description, $data, $base_amount, $amount, $currency_id, $status, $type, $reference, false, $IX47824 ); } } return $IX49836; }

	/**
	 * If an affiliate matches the given attribute, a referral is credited
	 * to her.
	 * MULTIPLE REFERRALS are possible: This means that if there is MORE than
	 * one affiliate matching the attribute all of them will be credited a
	 * referral.
	 * @deprecated
	 * @see I_Affiliates_Referral_Legacy::suggest_by_attribute()
	 */
	public function suggest_by_attribute( $attribute_key, $attribute_value, $post_id, $description = '', $data = null, $base_amount = null, $amount = null, $currency_id = null, $status = null, $type = null, $reference = null, $test = false ) { global $wpdb, $affiliates_options; global $affiliates_db; bcscale( affiliates_get_referral_amount_decimals() ); $IX49544 = $affiliates_db->get_tablename( "affiliates" ); $IX22044 = $affiliates_db->get_tablename( "affiliates_attributes" ); $IX31426 = date( 'Y-m-d H:i:s', time() ); $IX19379 = date( 'Y-m-d', time() ); $IX42349 = $affiliates_db->get_objects( "SELECT a.affiliate_id FROM $IX49544 a
			LEFT JOIN $IX22044 aa ON a.affiliate_id = aa.affiliate_id
			WHERE
			aa.attr_key = %s
			AND aa.attr_value = %s
			AND a.from_date <= %s AND ( a.thru_date IS NULL OR a.thru_date >= %s )
			AND a.status = 'active'
			", $attribute_key, $attribute_value, $IX19379, $IX19379 ); if ( empty( $IX42349 ) ) { if ( get_option( 'aff_use_direct', true ) ) { $IX42349 = array ( (object) array( 'affiliate_id' => affiliates_get_direct_id() ) ); } } if ( !$test ) { $IX46283 = array(); foreach ( $IX42349 as $IX75144 ) { $IX46283[] = $IX75144->affiliate_id; } $this->add_referrals( $IX46283, $post_id, $description, $data, $base_amount, $amount, $currency_id, $status, $type, $reference, $test ); } return $IX42349; }

	/**
	 * @deprecated since 3.0.0
	 * {@inheritDoc}
	 * @see I_Affiliates_Referral_Legacy::add_referrals()
	 */
	public function add_referrals( $affiliate_ids, $post_id, $description = '', $data = null, $base_amount = null, $amount = null, $currency_id = null, $status = null, $type = null, $reference = null, $test = false, $hit_id = null ) { global $affiliates_db; $IX73991 = $affiliates_db->get_tablename( "affiliates" ); $IX53033 = $affiliates_db->get_tablename( "affiliates_attributes" ); $IX56627 = date( 'Y-m-d H:i:s', time() ); $IX46829 = date( 'Y-m-d', time() ); bcscale( affiliates_get_referral_amount_decimals() ); if ( !empty( $affiliate_ids ) ) { foreach ( $affiliate_ids as $IX36643 ) { $IX99930 = wp_get_current_user(); $IX56627 = date('Y-m-d H:i:s', time() ); $IX84342 = $affiliates_db->get_tablename( 'referrals' ); $IX66530 = "(affiliate_id, post_id, datetime, description"; $IX92200 = "(%d, %d, %s, %s"; $IX92302 = array($IX36643, $post_id, $IX56627, $description); if ( !empty( $IX99930 ) ) { $IX66530 .= ",user_id "; $IX92200 .= ",%d "; $IX92302[] = $IX99930->ID; } $IX74800 = $_SERVER['REMOTE_ADDR']; if ( PHP_INT_SIZE >= 8 ) { if ( $IX39383 = ip2long( $IX74800 ) ) { $IX66530 .= ',ip '; $IX92200 .= ',%d '; $IX92302[] = $IX39383; } } else { if ( $IX39383 = ip2long( $IX74800 ) ) { $IX39383 = sprintf( '%u', $IX39383 ); $IX66530 .= ',ip'; $IX92200 .= ',%s'; $IX92302[] = $IX39383; } } if ( !empty( $currency_id ) ) { if ( empty( $amount ) ) { $IX57835 = $affiliates_db->get_objects( "SELECT * FROM $IX53033
							WHERE
							affiliate_id = %d
							AND attr_key IN ('referral.rate','referral.rate.method','referral.amount','referral.amount.method')
							", $IX36643 ); $IX14806 = null; $IX17057 = null; $IX95178 = null; foreach( $IX57835 as $IX73941 ) { switch( $IX73941->attr_key ) { case 'referral.amount' : $IX14806 = bcadd( '0', $IX73941->attr_value ); break; case 'referral.amount.method' : $IX17057 = bcadd( '0', call_user_func( Affiliates_Referral::get_referral_amount_method( $IX73941->attr_value ), $IX36643, array( 'affiliate_ids' => $affiliate_ids, 'post_id' => $post_id, 'description' => $description, 'data' => $data, 'base_amount' => $base_amount, 'amount' => $amount, 'currency_id' => $currency_id, 'status' => $status, 'type' => $type, 'reference' => $reference, 'test' => $test ) ) ); break; case 'referral.rate' : $IX95178 = bcmul( $base_amount, $IX73941->attr_value ); break; } } if ( $IX14806 ) { $amount = $IX14806; } else if ( $IX17057 ) { $amount = $IX17057; } else if ( $IX95178 ) { $amount = $IX95178; } else { $IX14591 = get_option( self::DEFAULT_REFERRAL_CALCULATION_KEY, null ); if ( !$IX14591 ) { $IX30118 = new Affiliates_Referral_Controller(); if ( $IX12501 = $IX30118->seek_rate( array( 'affiliate_id' => $IX36643 ) ) ) { switch( $IX12501->type ) { case AFFILIATES_PRO_RATES_TYPE_AMOUNT : $amount = bcadd( '0', $IX12501->value, affiliates_get_referral_amount_decimals() ); break; case AFFILIATES_PRO_RATES_TYPE_RATE : $amount = bcmul( $base_amount, $IX12501->value, affiliates_get_referral_amount_decimals() ); break; } } } else if ( $IX14591 = Affiliates_Attributes::validate_key( $IX14591 ) ) { if ( $IX14389 = Affiliates_Attributes::validate_value( $IX14591, get_option( self::DEFAULT_REFERRAL_CALCULATION_VALUE, null ) ) ) { switch ( $IX14591 ) { case 'referral.amount' : $amount = bcadd( '0', $IX14389 ); break; case 'referral.amount.method' : $amount = bcadd( "0", call_user_func( Affiliates_Referral::get_referral_amount_method( $IX14389 ), $IX36643, array( 'affiliate_ids' => $affiliate_ids, 'post_id' => $post_id, 'description' => $description, 'data' => $data, 'base_amount' => $base_amount, 'amount' => $amount, 'currency_id' => $currency_id, 'status' => $status, 'type' => $type, 'reference' => $reference, 'test' => $test ) ) ); break; case 'referral.rate' : $amount = bcmul( $base_amount, $IX14389 ); break; } } } } } if ( !empty( $amount ) ) { if ( $amount = Affiliates_Utility::verify_referral_amount( $amount ) ) { if ( $currency_id = Affiliates_Utility::verify_currency_id( $currency_id ) ) { $IX66530 .= ",amount "; $IX92200 .= ",%s "; $IX92302[] = $amount; $IX66530 .= ",currency_id "; $IX92200 .= ",%s "; $IX92302[] = $currency_id; } } } } if ( is_array( $data ) && !empty( $data ) ) { $IX66530 .= ",data "; $IX92200 .= ",%s "; $IX92302[] = serialize( $data ); } if ( !empty( $status ) && Affiliates_Utility::verify_referral_status_transition( $status, $status ) ) { $IX66530 .= ',status '; $IX92200 .= ',%s '; $IX92302[] = $status; } else { $IX66530 .= ',status '; $IX92200 .= ',%s '; $IX92302[] = get_option( 'aff_default_referral_status', AFFILIATES_REFERRAL_STATUS_ACCEPTED ); } if ( !empty( $type ) ) { $IX66530 .= ',type '; $IX92200 .= ',%s '; $IX92302[] = $type; } if ( !empty( $reference ) ) { $IX66530 .= ',reference '; $IX92200 .= ',%s '; $IX92302[] = $reference; } if ( !empty( $hit_id ) ) { $IX66530 .= ',hit_id '; $IX92200 .= ',%d'; $IX92302[] = intval( $hit_id ); } $IX19230 = null; require_once( AFFILIATES_CORE_LIB . '/class-affiliates-service.php' ); if ( $IX10689 = Affiliates_Service::get_ids() ) { if ( !empty( $IX10689['affiliate_id'] ) && !empty( $IX10689['campaign_id'] ) ) { if ( $IX10689['affiliate_id'] == $IX36643 ) { $IX66530 .= ',campaign_id '; $IX92200 .= ',%d '; $IX19230 = intval( $IX10689['campaign_id'] ); $IX92302[] = $IX19230; } } } $IX66530 .= ")"; $IX92200 .= ")"; if ( !$test ) { $IX62958 = explode( ',', str_replace( ' ', '', substr( $IX66530, 1, strlen( $IX66530 ) - 2 ) ) ); $IX81341 = array_combine( $IX62958, $IX92302 ); $IX33876 = apply_filters( 'affiliates_record_referral', true, $IX81341 ); if ( $IX33876 ) { if ( !affiliates_is_duplicate_referral( array( 'affiliate_id' => $IX36643, 'amount' => $amount, 'currency_id' => $currency_id, 'type' => $type, 'reference' => $reference, 'data' => $data ) ) ) { if ( $affiliates_db->query( "INSERT INTO $IX84342 $IX66530 VALUES $IX92200", $IX92302 ) !== false ) { if ( $IX92064 = $affiliates_db->get_value( "SELECT LAST_INSERT_ID()" ) ) { do_action( 'affiliates_referral', $IX92064, array( 'affiliate_id' => $IX36643, 'post_id' => $post_id, 'description' => $description, 'data' => $data, 'base_amount' => $base_amount, 'amount' => $amount, 'currency_id' => $currency_id, 'status' => $status, 'type' => $type, 'reference' => $reference, 'hit_id' => $hit_id, 'test' => $test, 'campaign_id' => $IX19230 ) ); } } } } } } } return $affiliate_ids; }

	/**
	 * Referral constructor - retrieves referral data from the database based on the referral id.
	 * @param int $referral_id
	 * @throws Exception when the referral doesn't exist
	 */
	public function __construct( $referral_id = null ) { if ( $referral_id !== null ) { global $affiliates_db; $IX67884 = $affiliates_db->get_tablename( 'referrals' ); if ( $IX34257 = $affiliates_db->get_objects( "SELECT * FROM $IX67884 WHERE referral_id = %d", $referral_id ) ) { if ( count( $IX34257 ) > 0 ) { $this->referral = $IX34257[0]; $IX34788 = array(); $IX42335 = $affiliates_db->get_tablename( 'referral_items' ); if ( $IX12111 = $affiliates_db->get_objects( "SELECT * FROM $IX42335 WHERE referral_id = %d", intval( $referral_id ) ) ) { if ( !empty( $IX12111 ) && is_array( $IX12111 ) ) { foreach( $IX12111 as $IX65781 ) { $IX34788[] = new Affiliates_Referral_Item( $IX65781 ); } } } $this->referral_items = $IX34788; } } if ( $this->referral === null ) { throw new Exception(); } } }

	/**
	 * Update the referral.
	 * @param array $attributes to update, supports: affiliate_id, post_id, campaign_id, hit_id, datetime, description, amount, currency_id, status, reference
	 * @return array with keys, values and old_values or null if nothing was updated
	 */
	public function update( $attributes = null ) { global $affiliates_db; $IX31660 = null; if ( ( $this->referral !== null ) && ( $attributes !== null ) ) { $IX45187 = array(); $IX23405 = array(); $IX86063 = array(); $IX79441 = array(); foreach( $attributes as $IX58345 => $IX47216 ) { $IX65091 = isset( $this->referral->$IX58345 ) ? $this->referral->$IX58345 : null; if ( $IX65091 !== $IX47216 ) { switch( $IX58345 ) { case 'affiliate_id' : case 'post_id' : case 'campaign_id' : case 'hit_id' : $IX45187[] = " $IX58345 = %d "; $IX23405[] = $IX58345; $IX86063[] = intval( $IX47216 ); $IX79441[] = $IX65091; break; case 'datetime' : case 'description' : case 'reference' : $IX45187[] = " $IX58345 = %s "; $IX23405[] = $IX58345; $IX86063[] = $IX47216; $IX79441[] = $IX65091; break; case 'status' : if ( !empty( $IX47216 ) && Affiliates_Utility::verify_referral_status_transition( $IX47216, $IX47216 ) ) { $IX45187[] = " $IX58345 = %s "; $IX23405[] = $IX58345; $IX86063[] = $IX47216; $IX79441[] = $IX65091; } break; case 'amount' : case 'reference_amount' : if ( $IX47216 = Affiliates_Utility::verify_referral_amount( $IX47216 ) ) { $IX45187[] = " $IX58345 = %s "; $IX23405[] = $IX58345; $IX86063[] = $IX47216; $IX79441[] = $IX65091; } break; case 'currency_id' : if ( $IX47216 = Affiliates_Utility::verify_currency_id( $IX47216 ) ) { $IX45187[] = " $IX58345 = %s "; $IX23405[] = $IX58345; $IX86063[] = $IX47216; $IX79441[] = $IX65091; } break; } } } if ( count( $IX45187 ) > 0 ) { $IX45187 = implode( ' , ', $IX45187 ); $IX74014 = $affiliates_db->get_tablename( 'referrals' ); if ( $affiliates_db->query( "UPDATE $IX74014 SET $IX45187 WHERE referral_id = %d", array_merge( $IX86063, array( intval( $this->referral->referral_id ) ) ) ) ) { if ( $IX51239 = $affiliates_db->get_objects( "SELECT * FROM $IX74014 WHERE referral_id = %d", intval( $this->referral->referral_id ) ) ) { if ( count( $IX51239 ) > 0 ) { $this->referral = $IX51239[0]; } } $IX31660 = array( 'keys' => $IX23405, 'values' => $IX86063, 'old_values' => $IX79441 ); do_action( 'affiliates_updated_referral', intval( $this->referral->referral_id ), $IX23405, $IX86063, $IX79441 ); } } } parent::update(); return $IX31660; }

}
