<?php
/**
 * class-affiliates-stats-renderer-wordpress.php
 * 
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Statistics renderer, platform-specific implementation.
 */
class Affiliates_Stats_Renderer_WordPress extends Affiliates_Stats_Renderer {

	const NONCE          = 'affiliate-nonce';
	const NONCE_1        = 'affiliate-nonce-1';
	const NONCE_2        = 'affiliate-nonce-2';
	const NONCE_FILTERS  = 'affiliate-nonce-filters';

	static function init() { add_shortcode( 'affiliates_affiliate_stats', array( 'Affiliates_Stats_Renderer_WordPress', 'stats_shortcode' ) ); }

	static function stats_shortcode( $atts, $content = null ) { $IX46236 = null; wp_enqueue_script( 'datepicker' ); wp_enqueue_script( 'datepickers' ); wp_enqueue_style( 'smoothness' ); wp_enqueue_style( 'affiliates-pro' ); $IX17174 = shortcode_atts( self::$stats_defaults, $atts ); switch ( $IX17174['type'] ) { case self::STATS_REFERRALS : $IX46236 = Affiliates_Affiliate_Stats_Renderer_WordPress::render_referrals( $IX17174 ); break; case self::STATS_SUMMARY : $IX46236 = self::render_affiliate_stats( $IX17174 ); break; } return $IX46236; }

	static function render_affiliate_stats( $options = array() ) { global $affiliates_options, $affiliates_db; $IX11220 = ''; $IX42057 = Affiliates_Affiliate_WordPress::get_user_affiliate_id(); if ( $IX42057 === false ) { return $IX11220; } $IX81506 = $affiliates_options->get_option( 'affiliate_stats_from_date', null ); $IX96288 = $affiliates_options->get_option( 'affiliate_stats_thru_date', null ); if ( isset( $_POST[self::NONCE_FILTERS] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE_FILTERS], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( isset( $_POST['clear_filters'] ) ) { $affiliates_options->delete_option( 'affiliate_stats_from_date' ); $affiliates_options->delete_option( 'affiliate_stats_thru_date' ); $IX81506 = null; $IX96288 = null; } else { if ( !empty( $_POST['from_date'] ) ) { $IX81506 = date( 'Y-m-d', strtotime( $_POST['from_date'] ) ); $affiliates_options->update_option( 'affiliate_stats_from_date', $IX81506 ); } if ( !empty( $_POST['thru_date'] ) ) { $IX96288 = date( 'Y-m-d', strtotime( $_POST['thru_date'] ) ); $affiliates_options->update_option( 'affiliate_stats_thru_date', $IX96288 ); } if ( $IX81506 && $IX96288 ) { if ( strtotime( $IX81506 ) > strtotime( $IX96288 ) ) { $IX96288 = null; $affiliates_options->delete_option( 'affiliate_stats_thru_date' ); } } } } if ( $IX81506 ) { $IX68784 = DateHelper::u2s( $IX81506 ); } if ( $IX96288 ) { $IX32644 = DateHelper::u2s( $IX96288, 24*3600 ); } $IX65164 = $affiliates_db->get_tablename( 'affiliates' ); $IX62050 = $affiliates_db->get_tablename( 'referrals' ); $IX25756 = $affiliates_db->get_tablename( 'hits' ); if ( $IX81506 || $IX96288 || $IX42057 ) { $IX52056 = " WHERE "; } else { $IX52056 = ''; } $IX82852 = array(); if ( $IX81506 && $IX96288 ) { $IX52056 .= " datetime >= %s AND datetime < %s "; $IX82852[] = $IX68784; $IX82852[] = $IX32644; } else if ( $IX81506 ) { $IX52056 .= " datetime >= %s "; $IX82852[] = $IX68784; } else if ( $IX96288 ) { $IX52056 .= " datetime < %s "; $IX82852[] = $IX32644; } if ( $IX42057 ) { if ( $IX81506 || $IX96288 ) { $IX52056 .= " AND "; } $IX52056 .= " h.affiliate_id = %d "; $IX82852[] = $IX42057; } $IX46828 = array( 'visits' => __( 'Visits', 'affiliates' ), 'hits' => __( 'Hits', 'affiliates' ), 'referrals' => __( 'Referrals', 'affiliates' ), 'ratio' => __( 'Ratio', 'affiliates' ) ); $IX83002 = affiliates_get_affiliate_visits( $IX42057, $IX81506, $IX96288 ); $IX83687 = affiliates_get_affiliate_hits( $IX42057, $IX81506, $IX96288 ); $IX72473 = affiliates_get_affiliate_referrals( $IX42057, $IX81506, $IX96288 ); if ( $IX83002 > 0 ) { $IX18534 = round( $IX72473 / $IX83002, self::RATIO_DECIMALS ); } else { $IX18534 = 0; } $IX11220 .= '<div id="" class="affiliate-stats summary">'; $IX11220 .= '
			<table class="wp-list-table widefat fixed" cellspacing="0">
			<thead>
				<tr>
				'; foreach ( $IX46828 as $IX54900 => $IX22983 ) { $IX11220 .= "<th scope='col' class='$IX54900'>$IX22983</th>"; } $IX11220 .= '</tr>
			</thead>
			<tbody>
			'; $IX11220 .= '<tr>'; $IX11220 .= "<td class='visits'>$IX83002</td>"; $IX11220 .= "<td class='hits'>$IX83687</td>"; $IX11220 .= "<td class='referrals'>$IX72473</td>"; $IX11220 .= "<td class='ratio'>$IX18534</td>"; $IX11220 .= '</tr>'; $IX11220 .= '</tbody>'; $IX11220 .= '</table>'; $IX43539 = isset( $options['show_totals'] ) ? ( $options['show_totals'] !== 'false' ) : true; $IX25065 = isset( $options['show_totals_accepted'] ) ? ( $options['show_totals_accepted'] === true || $options['show_totals_accepted'] === 'true' ) : false; $IX10235 = isset( $options['show_totals_pending'] ) ? ( $options['show_totals_pending'] === true || $options['show_totals_pending'] === 'true' ) : false; $IX81755 = isset( $options['show_totals_closed'] ) ? ( $options['show_totals_closed'] === true || $options['show_totals_closed'] === 'true' ) : false; $IX27905 = isset( $options['show_totals_rejected'] ) ? ( $options['show_totals_rejected'] === true || $options['show_totals_rejected'] === 'true' ) : false; if ( $IX43539 && ( $IX25065 || $IX10235 || $IX81755 || $IX27905 ) ) { $IX62268 = ''; if ( $IX81506 && $IX96288 ) { $IX62268 = " AND datetime >= '$IX68784' AND datetime < '$IX32644' "; } else if ( $IX81506 ) { $IX62268 = " AND datetime >= '$IX68784' "; } else if ( $IX96288 ) { $IX62268 = " AND datetime < '$IX32644' "; } $IX86989 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX62050 WHERE affiliate_id = %d $IX62268 AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX42057, AFFILIATES_REFERRAL_STATUS_ACCEPTED ); $IX49162 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX62050 WHERE affiliate_id = %d $IX62268 AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX42057, AFFILIATES_REFERRAL_STATUS_PENDING ); $IX33627 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX62050 WHERE affiliate_id = %d $IX62268 AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX42057, AFFILIATES_REFERRAL_STATUS_CLOSED ); $IX34365 = $affiliates_db->get_objects( "SELECT SUM(amount) AS total, currency_id FROM $IX62050 WHERE affiliate_id = %d $IX62268 AND status = %s AND amount IS NOT NULL AND currency_id IS NOT NULL GROUP BY currency_id", $IX42057, AFFILIATES_REFERRAL_STATUS_REJECTED ); $IX11220 .= '<table class="wp-list-table widefat fixed" cellspacing="0">'; $IX11220 .= '<thead>'; $IX11220 .= '<tr>'; $IX11220 .= "<th scope='col' class='total'>" . __( 'Total', 'affiliates' ) . "</th>"; $IX11220 .= "<th scope='col' class='amount'>" . __( 'Amount', 'affiliates' ) . "</th>"; $IX11220 .= "<th scope='col' class='currency'>" . __( 'Currency', 'affiliates' ) . "</th>"; $IX11220 .= '</tr>'; $IX11220 .= '</thead>'; $IX11220 .= '<tbody>'; if ( $IX25065 ) { if ( count( $IX86989 ) == 0 ) { $IX86989[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX86989 as $IX57515 ) { $IX11220 .= '<tr>'; $IX11220 .= "<td class='total accepted'>" . __( 'Accepted', 'affiliates' ) . "</td>"; $IX11220 .= "<td class='amount'>$IX57515->total</td>"; $IX11220 .= "<td class='currency'>$IX57515->currency_id</td>"; $IX11220 .= '</tr>'; } } if ( $IX10235 ) { if ( count( $IX49162 ) == 0 ) { $IX49162[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX49162 as $IX57515 ) { $IX11220 .= '<tr>'; $IX11220 .= "<td class='total pending'>" . __( 'Pending', 'affiliates' ) . "</td>"; $IX11220 .= "<td class='amount'>$IX57515->total</td>"; $IX11220 .= "<td class='currency'>$IX57515->currency_id</td>"; $IX11220 .= '</tr>'; } } if ( $IX81755 ) { if ( count( $IX33627 ) == 0 ) { $IX33627[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX33627 as $IX57515 ) { $IX11220 .= '<tr>'; $IX11220 .= "<td class='total closed'>" . __( 'Closed', 'affiliates' ) . "</td>"; $IX11220 .= "<td class='amount'>$IX57515->total</td>"; $IX11220 .= "<td class='currency'>$IX57515->currency_id</td>"; $IX11220 .= '</tr>'; } } if ( $IX27905 ) { if ( count( $IX34365 ) == 0 ) { $IX34365[] = (object) array( 'total' => '--', 'currency_id' => '--' ); } foreach ( $IX34365 as $IX57515 ) { $IX11220 .= '<tr>'; $IX11220 .= "<td class='total rejected'>" . __( 'Rejected', 'affiliates' ) . "</td>"; $IX11220 .= "<td class='amount'>$IX57515->total</td>"; $IX11220 .= "<td class='currency'>$IX57515->currency_id</td>"; $IX11220 .= '</tr>'; } } $IX11220 .= '</tbody>'; $IX11220 .= '</table>'; } $IX11220 .= '<div class="filters">' . '<label class="description" for="setfilters">' . __( 'Filters', 'affiliates' ) . '</label>' . '<form id="setfilters" action="" method="post">' . '<div class="from-date">' . '<label class="from-date-filter" for="from_date">' . __('From', 'affiliates' ) . '</label>' . '<noscript><span class="description mini">' . __( 'Format: YYYY-MM-DD', 'affiliates' ) . '</span></noscript>' . '<input class="datefield from-date-filter" name="from_date" type="text" value="' . esc_attr( $IX81506 ) . '"/>'. '</div>' . '<div class="thru-date">' . '<label class="thru-date-filter" for="thru_date">' . __('Until', 'affiliates' ) . '</label>' . '<noscript><span class="description mini">' . __( 'Format: YYYY-MM-DD', 'affiliates' ) . '</span></noscript>' . '<input class="datefield thru-date-filter" name="thru_date" type="text" class="datefield" value="' . esc_attr( $IX96288 ) . '"/>'. '</div>' . '<div class="submit">' . wp_nonce_field( plugin_basename( __FILE__ ), self::NONCE_FILTERS, true, false ) . '<input type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>' . '<input type="submit" name="clear_filters" value="' . __( 'Clear', 'affiliates' ) . '"/>' . '<input type="hidden" value="submitted" name="submitted"/>' . '</div>' . '</form>' . '</div>'; $IX11220 .= '</div>'; return $IX11220; }

}
Affiliates_Stats_Renderer_WordPress::init();
