<?php
/**
 * class-affiliates-url-renderer-wordpress.php
 *
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Platform-specific URL rendering.
 */
class Affiliates_Url_Renderer_WordPress extends Affiliates_Url_Renderer {

	const NONCE          = 'affiliate-nonce';
	const NONCE_1        = 'affiliate-nonce-1';
	const NONCE_2        = 'affiliate-nonce-2';
	const NONCE_FILTERS  = 'affiliate-nonce-filters';

	/**
	 * Class initialization.
	 */
	public static function init() { self::$pname = get_option( 'aff_pname', AFFILIATES_PNAME ); self::$cname = 'cmid'; self::$encoder = 'affiliates_encode_affiliate_id'; add_shortcode( 'affiliates_affiliate_url', array( 'Affiliates_Url_Renderer_WordPress', 'url_shortcode' ) ); add_shortcode( 'affiliates_generate_url', array( 'Affiliates_Url_Renderer_WordPress', 'generate_url_shortcode' ) ); }

	/**
	 * URL shortcode handler.
	 *
	 * @param array $atts attributes
	 * @param string $content not used
	 */
	public static function url_shortcode( $atts, $content = null ) { $IX78428 = shortcode_atts( self::$url_defaults, $atts ); return self::render_affiliate_url( $IX78428 ); }

	/**
	 * Renders an affiliate URL.
	 *
	 * @param array $options rendering options
	 */
	public static function render_affiliate_url( $options = array() ) { global $wp_rewrite; parent::set_implementation( array( 'Affiliates_Affiliate' => 'Affiliates_Affiliate_WordPress', 'affiliate_id_encoder' => 'affiliates_encode_affiliate_id', 'esc_attr' => 'esc_attr', 'use_parameter' => !$wp_rewrite->using_permalinks() ) ); $IX20104 = ''; if ( !isset( $options['url'] ) ) { $options['url'] = home_url(); } $options['pname'] = get_option( 'aff_pname', AFFILIATES_PNAME ); $IX20104 .= parent::render_affiliate_url( $options ); return $IX20104; }

	/**
	 * Render the affiliate URL generator form.
	 *
	 * @param array $atts
	 * @param string $content
	 * @return string form HTML
	 */
	public static function generate_url_shortcode( $atts, $content = null ) { $atts = shortcode_atts( array( 'campaign' => 'no' ), $atts ); $IX38324 = isset( $_POST['generate-url'] ) ? trim( $_POST['generate-url'] ) : ''; if ( !empty( $IX38324 ) ) { if ( ( stripos( $IX38324, 'http://' ) !== 0 ) && ( stripos( $IX38324, 'https://' ) !== 0 ) ) { $IX38324 = 'http://' . $IX38324; } } $IX16687 = true; if ( !empty( $IX38324 ) ) { if ( function_exists( 'filter_var' ) ) { $IX16687 = filter_var( $IX38324, FILTER_VALIDATE_URL ) !== false; } } $IX20480 = !empty( $IX38324 ) ? self::render_affiliate_url( array( 'url' => $IX38324, 'type' => self::TYPE_APPEND ) ) : ''; if ( class_exists( 'Affiliates_Campaign' ) ) { if ( !empty( $IX38324 ) ) { $IX64397 = !empty( $_POST['campaign_id'] ) ? intval( $_POST['campaign_id'] ) : null; if ( $IX64397 ) { if ( $IX67807 = affiliates_get_user_affiliate( get_current_user_id() ) ) { if ( $IX74163 = array_shift( $IX67807 ) ) { if ( $IX29327 = Affiliates_Campaign::get_affiliate_campaign( $IX74163, $IX64397 ) ) { $IX20480 = $IX29327->get_url( array( 'url' => $IX38324 ) ); } } } } } } $IX98662 = ''; $IX30875 = apply_filters( 'affiliates_generate_url_style', 'div.generate-field span.field-label { display:block; }' . 'div.generate-field span.field-input { display:block; width:62%; }' . 'div.generate-field span.field-input input { width:100%; }' . 'div.generate-field span.error { display:block; color: #900; }' ); if ( !empty( $IX30875 ) ) { $IX98662 .= '<style type="text/css">'; $IX98662 .= $IX30875; $IX98662 .= '</style>'; } $IX98662 .= '<div class="affiliates-generate-url">'; $IX98662 .= '<form action="" method="post">'; $IX98662 .= '<div>'; $IX98662 .= '<div class="generate-field generate-url">'; $IX98662 .= '<label>'; $IX98662 .= '<span class="field-label">'; $IX98662 .= __( 'Page URL', 'affiliates' ); $IX98662 .= '</span>'; $IX98662 .= sprintf( '<span class="error" style="%s">', $IX16687 ? 'display:none;' : '' ); $IX98662 .= __( 'Please enter a valid URL.', 'affiliates' ); $IX98662 .= '</span>'; $IX98662 .= '<span class="field-input">'; $IX98662 .= sprintf( '<input type="text" name="generate-url" value="%s" />', $IX38324 ); $IX98662 .= '</span>'; $IX98662 .= '</label>'; $IX98662 .= '</div>'; if ( class_exists( 'Affiliates_Campaign' ) && isset( $atts['campaign'] ) && strtolower( $atts['campaign'] ) == 'yes' ) { if ( $IX67807 = affiliates_get_user_affiliate( get_current_user_id() ) ) { if ( $IX74163 = array_shift( $IX67807 ) ) { $IX15544 = Affiliates_Campaign::get_campaigns( $IX74163 ); if ( !empty( $IX15544 ) ) { $IX56914 = null; $IX64397 = !empty( $_POST['campaign_id'] ) ? intval( $_POST['campaign_id'] ) : null; if ( $IX64397 ) { if ( $IX29327 = Affiliates_Campaign::get_affiliate_campaign( $IX74163, $IX64397 ) ) { $IX56914 = $IX29327->campaign_id; } } $IX98662 .= '<div class="generate-field campaign">'; $IX98662 .= '<label>'; $IX98662 .= '<span class="field-label">'; $IX98662 .= __( 'Campaign', 'affiliates' ); $IX98662 .= '</span>'; $IX98662 .= '<select name="campaign_id">'; $IX98662 .= '<option value="">&mdash;</option>'; foreach( $IX15544 as $IX29327 ) { $IX98662 .= sprintf( '<option value="%d" %s>%s</option>', intval( $IX29327->campaign_id ), $IX56914 !== null && $IX29327->campaign_id == $IX56914 ? ' selected="selected" ' : '', esc_html( stripslashes( $IX29327->name ) ) ); } $IX98662 .= '</select>'; $IX98662 .= '</label>'; $IX98662 .= '</div>'; } } } } $IX98662 .= '<div class="generate-field affiliate-url">'; $IX98662 .= '<label>'; $IX98662 .= '<span class="field-label">'; $IX98662 .= __( 'Affiliate URL', 'affiliates' ); $IX98662 .= '</span>'; $IX98662 .= '<span class="field-input">'; $IX98662 .= sprintf( '<input type="text" name="affiliate-url" value="%s" readonly="readonly" />', $IX20480 ); $IX98662 .= '</span>'; $IX98662 .= '</label>'; $IX98662 .= '</div>'; $IX98662 .= '<div class="generate-button">'; $IX98662 .= sprintf( '<input type="submit" name="generate" value="%s" />', __( 'Generate', 'affiliates' ) ); $IX98662 .= '</div>'; $IX98662 .= '</div>'; $IX98662 .= '</form>'; $IX98662 .= '</div>'; return $IX98662; }
}
Affiliates_Url_Renderer_WordPress::init();
