<?php
/**
 * class-affiliates-multi-tier.php
 *
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-enterprise
 * @since affiliates-enterprise 2.2.3
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Multi-tier handling.
 */
class Affiliates_Multi_Tier {

	const NONCE = 'nonce-tiers';
	const TIERS = 'tiers';

	const ENABLE_TIERS = 'aff_ent_enable_tiers';
	const MAX_TIERS    = 10;
	const N_TIERS      = 'aff_ent_n_tiers';
	const TIER_RATES   = 'aff_ent_tier_rates';
	const ALLOW_TIER_REFERRALS_ON_ADMIN = 'aff_allow_tier_referrals_on_admin';
	const INCLUDE_DIRECT = 'aff_include_direct';
	const RELATIVE_TIER_RATES = 'aff_ent_relative_tier_rates';

	public static function init() { add_action( 'affiliates_admin_menu', array( __CLASS__, 'affiliates_admin_menu' ) ); if ( get_option( self::ENABLE_TIERS, false ) ) { add_action( 'affiliates_added_affiliate', array( __CLASS__, 'affiliates_added_affiliate' ) ); add_action( 'affiliates_referral', array( __CLASS__, 'affiliates_referral' ), 10, 2 ); add_action( 'affiliates_after_edit_affiliate_attributes', array( __CLASS__, 'affiliates_after_edit_affiliate_attributes' ) ); } }

	public static function affiliates_added_affiliate( $affiliate_id ) { global $affiliates_db; if ( !is_admin() || get_option( self::ALLOW_TIER_REFERRALS_ON_ADMIN, false ) ) { require_once( AFFILIATES_CORE_LIB . '/class-affiliates-service.php' ); if ( $IX98102 = Affiliates_Service::get_referrer_id() ) { if ( $IX98102 !== affiliates_get_direct_id() || get_option( self::INCLUDE_DIRECT, false ) ) { if ( $affiliate_id != $IX98102 ) { $IX34529 = $affiliates_db->get_tablename( 'affiliates_relations' ); if ( !$affiliates_db->get_value( "SELECT from_affiliate_id FROM $IX34529 WHERE to_affiliate_id = %d", $affiliate_id ) ) { $IX46445 = date( 'Y-m-d', time() ); if ( $affiliates_db->query( "INSERT INTO $IX34529 (from_affiliate_id,to_affiliate_id,type,from_date) VALUES (%d,%d,%s,%s)", intval( $IX98102 ), intval( $affiliate_id ), 'referral', $IX46445 ) ) { do_action( 'affiliates_added_affiliate_relation', $IX98102, $affiliate_id, 'referral', $IX46445 ); } } } } } } }

	public static function affiliates_stored_affiliate( $affiliate_id, $affiliate_user_id ) { self::affiliates_adedd_affiliate( $affiliate_id ); }

	public static function affiliates_referral( $referral_id, $params ) { global $affiliates_db, $affiliates_enterprise_doing_tiers; if ( !apply_filters( 'affiliates_process_tiers_referral', true, $referral_id, $params ) ) { return; } if ( !isset( $affiliates_enterprise_doing_tiers ) || !$affiliates_enterprise_doing_tiers ) { $affiliates_enterprise_doing_tiers = true; $IX41044 = $affiliates_db->get_tablename( 'referrals' ); $IX68855 = $affiliates_db->get_tablename( 'affiliates_relations' ); $IX16933 = $affiliates_db->get_objects( "SELECT * FROM $IX41044 WHERE referral_id = %d", $referral_id ); if ( count( $IX16933 ) ) { $IX17761 = $IX16933[0]; if ( !apply_filters( 'affiliates_process_tiers_referral_type', $IX17761->type != 'product', $IX17761->type, $referral_id, $params, $IX17761 ) ) { $affiliates_enterprise_doing_tiers = false; return; } $IX69115 = $IX17761->affiliate_id; $IX56074 = $IX69115; $IX32109 = get_option( self::TIER_RATES, array() ); $IX29419 = get_option( self::N_TIERS, self::MAX_TIERS ); $IX63819 = get_option( self::RELATIVE_TIER_RATES, false ); for ( $IX90765 = 0; $IX90765 < $IX29419; $IX90765++ ) { $IX26434 = $affiliates_db->get_value( "SELECT from_affiliate_id FROM $IX68855 WHERE to_affiliate_id = %d ORDER BY from_date DESC", $IX56074 ); if ( !$IX26434 ) { break; } if ( !affiliates_check_affiliate_id( $IX26434 ) ) { break; } $IX91684 = null; if ( class_exists( 'Groups_User' ) ) { if ( $IX48494 = affiliates_get_affiliate_user( $IX26434 ) ) { $IX82672 = new Groups_User( $IX48494 ); $IX91684 = $IX82672->group_ids_deep; if ( !is_array( $IX91684 ) || ( count( $IX91684 ) === 0 ) ) { $IX91684 = null; } } } $IX52585 = isset( $params['data'] ) ? $params['data'] : array(); if ( !is_array( $IX52585 ) ) { $IX52585 = array(); } $IX52585['tier_level'] = array( 'title' => 'Tier Level', 'domain' => 'affiliates', 'value' => $IX90765 + 1 ); $IX52585['tier_affiliate_id'] = array( 'title' => 'Tier Affiliate ID', 'domain' => 'affiliates', 'value' => $IX26434 ); if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { $IX65915 = get_option( self::TIER_RATES . '_' . intval( $IX26434 ), array() ); if ( isset( $IX32109[$IX90765] ) || isset( $IX65915[$IX90765] ) ) { if ( isset( $IX65915[$IX90765] ) ) { $IX55239 = $IX65915[$IX90765]; } else { $IX55239 = $IX32109[$IX90765]; } if ( isset( $params['base_amount'] ) || $IX63819 ) { if ( bccomp( $IX55239, '0', affiliates_get_referral_amount_decimals() ) > 0 ) { if ( !$IX63819 ) { $IX48464 = bcmul( $params['base_amount'], $IX55239, affiliates_get_referral_amount_decimals() ); } else { $IX48464 = bcmul( $IX17761->amount, $IX55239, affiliates_get_referral_amount_decimals() ); } $IX75083 = new Affiliates_Referral_WordPress(); $IX75083->add_referrals( array( $IX26434 ), $IX17761->post_id, $IX17761->description, $IX52585, null, $IX48464, $IX17761->currency_id, $IX17761->status, $IX17761->type, $IX17761->reference ); } } } } else { $IX81456 = new Affiliates_Referral_Controller(); $IX90361 = new Affiliates_Referral(); $IX75083 = new Affiliates_Referral(); $IX11418 = array(); if ( $IX90361->read( $referral_id ) ) { $IX98714 = $IX90361->referral_items; if ( count( $IX98714 ) > 0 ) { foreach( $IX98714 as $IX94707 ) { if ( $IX55239 = $IX81456->seek_rate( array( 'affiliate_id' => $IX26434, 'group_ids' => $IX91684, 'level' => $IX90765, 'object_id' => $IX94707->object_id, 'term_id' => $IX94707->term_id, 'integration' => $IX90361->integration ) ) ) { if ( $IX55239->level === $IX90765 ) { switch( $IX55239->type ) { case AFFILIATES_PRO_RATES_TYPE_AMOUNT : $IX48464 = bcadd( '0', $IX55239->value, affiliates_get_referral_amount_decimals() ); break; case AFFILIATES_PRO_RATES_TYPE_RATE : if ( $IX55239->get_meta( 'level-relative' ) ) { $IX48464 = bcmul( $IX94707->amount, $IX55239->value, affiliates_get_referral_amount_decimals() ); } else { $IX48464 = bcmul( $IX94707->line_amount, $IX55239->value, affiliates_get_referral_amount_decimals() ); } break; } $IX83579 = new Affiliates_Referral_Item( array( 'rate_id' => $IX55239->rate_id, 'amount' => $IX48464, 'currency_id' => $IX94707->currency_id, 'type' => $IX94707->type, 'reference' => $IX94707->reference, 'line_amount' => $IX94707->line_amount, 'object_id' => $IX94707->object_id ) ); $IX11418[] = $IX83579; } } } $IX75083->referral_items = $IX11418; $IX75083->currency_id = $IX17761->currency_id; $IX75083->compute(); } else { if ( $IX55239 = $IX81456->seek_rate( array( 'affiliate_id' => $IX26434, 'group_ids' => $IX91684, 'level' => $IX90765 ) ) ) { if ( $IX55239->level == $IX90765 ) { switch( $IX55239->type ) { case AFFILIATES_PRO_RATES_TYPE_AMOUNT : $IX48464 = bcadd( '0', $IX55239->value, affiliates_get_referral_amount_decimals() ); break; case AFFILIATES_PRO_RATES_TYPE_RATE : if ( $IX55239->get_meta( 'level-relative' ) ) { $IX48464 = bcmul( $IX90361->amount, $IX55239->value, affiliates_get_referral_amount_decimals()); } else { $IX48464 = bcmul( $IX90361->reference_amount, $IX55239->value, affiliates_get_referral_amount_decimals() ); } break; } $IX75083->amount = $IX48464; $IX75083->currency_id = $IX17761->currency_id; } } } $IX75083->affiliate_id = $IX26434; $IX75083->post_id = $IX17761->post_id; $IX75083->description = $IX17761->description; $IX75083->data = $IX52585; $IX75083->reference_amount = $IX17761->reference_amount; $IX75083->status = $IX17761->status; $IX75083->reference = $IX17761->reference; $IX75083->integration = $IX17761->integration; if ( bccomp( $IX75083->amount, '0', affiliates_get_referral_amount_decimals() ) > 0 ) { $IX75083->create(); } unset( $IX11418 ); unset( $IX75083 ); } } $IX56074 = $IX26434; } } $affiliates_enterprise_doing_tiers = false; } }

	public static function affiliates_admin_menu() { $IX30944 = add_submenu_page( 'affiliates-admin', __( 'Tiers', 'affiliates' ), __( 'Tiers', 'affiliates' ), AFFILIATES_ADMINISTER_OPTIONS, 'affiliates-admin-tiers', array( __CLASS__, 'affiliates_admin_tiers' ) ); $IX64167[] = $IX30944; add_action( 'admin_print_styles-' . $IX30944, 'affiliates_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX30944, 'affiliates_admin_print_scripts' ); add_action( 'admin_print_styles-' . $IX30944, 'affiliates_pro_admin_print_styles' ); add_action( 'admin_print_scripts-' . $IX30944, 'affiliates_pro_admin_print_scripts' ); add_action( 'admin_print_styles-affiliates_page_affiliates-admin-affiliates', array( __CLASS__, 'admin_print_styles' ) ); add_action( 'admin_print_scripts-affiliates_page_affiliates-admin-affiliates', array( __CLASS__, 'admin_print_scripts' ) ); add_action( 'contextual_help', array( __CLASS__, 'contextual_help' ), 10, 3 ); }

	public static function admin_print_styles() { global $affiliates_enterprise_version; if ( !wp_style_is( 'chosen' ) ) { wp_enqueue_style( 'chosen', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'css/chosen/chosen.min.css', array(), $affiliates_enterprise_version ); } }

	public static function admin_print_scripts() { global $affiliates_enterprise_version; if ( !wp_script_is( 'chosen' ) ) { wp_enqueue_script( 'chosen', AFFILIATES_ENTERPRISE_PLUGIN_URL . 'js/chosen/chosen.jquery.min.js', array( 'jquery' ), $affiliates_enterprise_version ); } }

	public static function contextual_help( $contextual_help, $screen_id, $screen ) { $IX62645 = ''; if ( $screen_id == 'affiliates_page_affiliates-admin-tiers' ) { $IX12745 = get_option( self::N_TIERS, self::MAX_TIERS ); $IX62645 .= '<br/>'; $IX62645 .= '<p class="description">'; $IX62645 .= sprintf( __( 'Referral rates for tier levels %d to %d are expressed using decimal numbers.', 'affiliates' ), 1, $IX12745 ); $IX62645 .= '</p>'; $IX62645 .= '<p class="description">'; $IX62645 .= __( 'Example: Use <strong>0.20</strong> to credit 20 percent commissions on order amounts.', 'affiliates' ); $IX62645 .= '</p>'; $IX62645 .= '<p class="description">'; if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { $IX62645 .= sprintf( __( 'A rate of %s results in no referral credited for affiliates in that level. The maximum rate is %s where the full amount is credited as commission.', 'affiliates' ), bcadd( '0', '0', affiliates_get_referral_amount_decimals() ), bcadd( '0', '1', affiliates_get_referral_amount_decimals() ) ); } else { $IX62645 .= sprintf( __( 'A rate of %s results in no referral credited for affiliates in that level.', 'affiliates' ), bcadd( '0', '0', affiliates_get_referral_amount_decimals() ) ); $IX62645 .= ' '; $IX62645 .= sprintf( __( 'At a rate of %s, the full amount is credited as commission.', 'affiliates' ), bcadd( '0', '1', affiliates_get_referral_amount_decimals() ) ); } $IX62645 .= '</p>'; $IX62645 .= '<p class="description">'; $IX62645 .= __( 'Tier referrals are created when an affiliate - the original referrer <strong>O.R.</strong> - is credited with a referral.', 'affiliates' ); $IX62645 .= '</p>'; $IX62645 .= '<p class="description">'; $IX62645 .= __( 'Levels represent the degree of relationship between affiliates. The affiliate who referred the O.R. is credited with a referral at the rate indicated for Level 1. Level 2 affiliates have referred affiliates in Level 1 etc.', 'affiliates' ); $IX62645 .= '</p>'; $IX62645 .= '<p class="description">'; $IX62645 .= __( 'How tier levels work:', 'affiliates' ); $IX62645 .= '</p>'; $IX62645 .= '<ul class="description">'; $IX62645 .= '<li>' . __( 'Affiliate B has referred affiliate A.', 'affiliates' ) . '</li>'; $IX62645 .= '<li>' . __( 'When affiliate A is credited with a referral, so is affiliate B at the commission rate set for Level 1.', 'affiliates' ) . '</li>'; $IX62645 .= '<li>' . __( 'If affiliate B was referred by affiliate C and a rate is set for Level 2, affiliate C will also be credited with a referral at the rate for that level.', 'affiliates' ) . '</li>'; $IX62645 .= '</ul>'; $IX62645 .= '<p class="description">'; $IX62645 .= __( 'Example:', 'affiliates' ); $IX62645 .= '</p>'; $IX62645 .= '<ul class="description">'; $IX62645 .= '<li>' . __( 'Assuming 30% for normal referrals and these rates for Level 1: 20%, Level 2: 5%, for an order of 100$, affiliate A gets a 30$ referral, affiliate B is credited with $20 and affiliate C gets $5.', 'affiliates' ) . '</li>'; $IX62645 .= '</ul>'; } return $contextual_help . $IX62645; }

	public static function affiliates_admin_tiers() { if ( !current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( get_option( self::TIER_RATES, null ) === null ) { add_option( self::TIER_RATES, array(), null, 'no' ); } if ( get_option( self::ENABLE_TIERS, null ) === null ) { add_option( self::ENABLE_TIERS, false, null, 'no' ); } if ( get_option( self::ALLOW_TIER_REFERRALS_ON_ADMIN, null ) === null ) { add_option( self::ALLOW_TIER_REFERRALS_ON_ADMIN, false, null, 'no' ); } if ( get_option( self::INCLUDE_DIRECT, null ) === null ) { add_option( self::INCLUDE_DIRECT, false, null, 'no' ); } if ( get_option( self::N_TIERS, null ) === null ) { add_option( self::N_TIERS, self::MAX_TIERS, null, 'no' ); } if ( get_option( self::RELATIVE_TIER_RATES, null ) === null ) { add_option( self::RELATIVE_TIER_RATES, false, null, 'no' ); } $IX34557 = ''; $IX79513 = get_option( self::N_TIERS, self::MAX_TIERS ); if ( isset( $_POST['submit'] ) ) { if ( wp_verify_nonce( $_POST[self::NONCE], self::TIERS ) ) { $IX79513 = isset( $_POST[self::N_TIERS] ) ? intval( $_POST[self::N_TIERS] ) : self::MAX_TIERS; if ( $IX79513 < 1 ) { $IX79513 = 1; } if ( $IX79513 > 111 && !defined( 'AFF_ENT_UNLIMITED' ) ) { $IX79513 = 111; } update_option( self::N_TIERS, $IX79513 ); if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { $IX68053 = array(); for( $IX46196 = 0; $IX46196 < $IX79513; $IX46196++ ) { if ( isset( $_POST['rate-' . $IX46196] ) ) { $IX60572 = bcadd( '0', $_POST['rate-' . $IX46196], affiliates_get_referral_amount_decimals() ); if ( bccomp( $IX60572, '0', affiliates_get_referral_amount_decimals() ) < 0 ) { $IX60572 = bcadd( '0', '0', affiliates_get_referral_amount_decimals() ); } else if ( bccomp( $IX60572, '1', affiliates_get_referral_amount_decimals() ) > 0 ) { $IX60572 = bcadd( '0', '1', affiliates_get_referral_amount_decimals() ); } $IX68053[$IX46196] = $IX60572; } } update_option( self::TIER_RATES, $IX68053 ); update_option( self::RELATIVE_TIER_RATES, isset( $_POST[self::RELATIVE_TIER_RATES] ) ); } update_option( self::ENABLE_TIERS, isset( $_POST[self::ENABLE_TIERS] ) ); update_option( self::ALLOW_TIER_REFERRALS_ON_ADMIN, isset( $_POST[self::ALLOW_TIER_REFERRALS_ON_ADMIN] ) ); update_option( self::INCLUDE_DIRECT, isset( $_POST[self::INCLUDE_DIRECT] ) ); } } $IX68053 = get_option( self::TIER_RATES, array() ); $IX87840 = get_option( self::ENABLE_TIERS, false ); $IX62939 = get_option( self::INCLUDE_DIRECT, false ); $IX79750 = get_option( self::ALLOW_TIER_REFERRALS_ON_ADMIN, false ); $IX28249 = get_option( self::RELATIVE_TIER_RATES, false ); if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { $IX31823 = 0; for( $IX46196 = 0; $IX46196 < $IX79513; $IX46196++ ) { if ( !empty( $IX68053[$IX46196] ) ) { $IX60572 = bcadd( '0', $IX68053[$IX46196], affiliates_get_referral_amount_decimals() ); $IX78325 = bcadd( $IX31823, $IX68053[$IX46196], affiliates_get_referral_amount_decimals() ); if ( ( bccomp( $IX78325, '1', affiliates_get_referral_amount_decimals() ) > 0 ) && ( bccomp( $IX68053[$IX46196], '0', affiliates_get_referral_amount_decimals() ) > 0 ) ) { $IX34557 .= '<div class="warning">'; $IX34557 .= sprintf( __( 'The rate %s indicated for level %d exceeds 1.00 for the sum of rates.', 'affiliates' ), $IX68053[$IX46196], $IX46196 + 1 ); $IX34557.= '</div>'; } $IX31823 = bcadd( $IX31823, $IX68053[$IX46196], affiliates_get_referral_amount_decimals() ); } } if ( bccomp( $IX31823, '1', affiliates_get_referral_amount_decimals() ) > 0 ) { $IX34557 .= '<div class="warning">'; $IX34557 .= sprintf( __( 'The sum of rates is %s and exceeds 1.00.', 'affiliates' ), $IX31823 ); $IX34557 .= ' '; $IX34557 .= __( 'Although this might be intended, the total commission granted should normally not exceed the net transaction value on which commissions are based.', 'affiliates' ); $IX34557 .= ' '; if ( $IX28249 ) { $IX34557 .= __( 'As relative level rates apply, these rates are relative to the amount that is credited to the O.R. instead of the order amount. Note that a sum of level rates equal to or greater than 1.00 means that the total commissions credited to tiers, is equal to - or higher than - the commission granted to the O.R.', 'affiliates' ); } else { $IX34557 .= __( 'These rates are relative to the order amount. Note that a sum of level rates equal to or greater than 1.00 means that the total commissions credited to tiers, is equal to - or higher than - the originating order amount.', 'affiliates' ); } $IX34557 .= '</div>'; } } echo '<h1>' . __( 'Tiers', 'affiliates' ) . '</h1>'; echo '<form action="" name="tiers" method="post">' . '<div>'; echo '<p>' . '<input class="button" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>'; echo '<h2>'. __( 'Multi-tiered referrals', 'affiliates' ) . '</h2>'; echo '<label>'; echo sprintf( '<input type="checkbox" name="' . self::ENABLE_TIERS . '" %s />', $IX87840 ? ' checked="checked" ' : '' ); echo ' '; echo __( 'Enable multi-tiered referrals', 'affiliates' ); echo '</label>'; echo '<p class="description">'; echo __( 'Enable multi-tiered referrals to grant referrals to affiliates in Levels 1 and above.', 'affiliates' ); echo '<br/>'; echo __( 'You <strong>must enable</strong> this option if you want to run a multi-tier affiliate program on the site, based on the level rate settings below.', 'affiliates' ); echo '</p>'; echo '<p>'; echo '<label>'; echo __( 'Levels', 'affiliates' ); echo ' '; echo sprintf( '<input name="'.self::N_TIERS.'" type="text" value="%s" />', esc_attr( $IX79513 ) ); echo '</label>'; echo '</p>'; echo '<p class="description">'; echo sprintf( __( 'You can set the number of levels as desired (minimum 1 level). By default, %d levels are provided.', 'affiliates' ), self::MAX_TIERS ); echo '</p>'; echo '<br/>'; echo '<label>'; echo sprintf( '<input type="checkbox" name="' . self::INCLUDE_DIRECT . '" %s />', $IX62939 ? ' checked="checked" ' : '' ); echo ' '; echo __( '<em>Direct</em> is a referrer', 'affiliates' ); echo '</label>'; echo '<p class="description">'; echo __( 'When a new affiliate joins, use the <em>Direct</em> affiliate as referrer if no other affiliate has referred the new one.', 'affiliates' ); echo '</p>'; echo '<br/>'; echo '<label>'; echo sprintf( '<input type="checkbox" name="' . self::ALLOW_TIER_REFERRALS_ON_ADMIN . '" %s />', $IX79750 ? ' checked="checked" ' : '' ); echo ' '; echo __( 'Always record referrers', 'affiliates' ); echo '</label>'; echo '<p class="description">'; echo __( 'If this option is enabled, referrers are recorded when an affiliate is added on the administrative back end, too. Normally, affiliate referrers are recorded only when an affiliate joins on the front end.', 'affiliates' ); echo '</p>'; echo '<h2>'. __( 'Level rates', 'affiliates' ) . '</h2>'; if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { echo '<p class="description">'; echo __( 'Affiliates in Level 1 and above get credited with a referral when an O.R. is credited with a referral and the level rate is greater than zero.', 'affiliates' ); echo '</p>'; echo $IX34557; for ( $IX46196 = 0; $IX46196 < $IX79513; $IX46196++ ) { echo '<p>'; echo '<label>'; echo sprintf( __( 'Level %d', 'affiliates' ), ( $IX46196 + 1 ) ); echo ' '; echo sprintf( '<input name="rate-%d" type="text" value="%s" />', esc_attr( $IX46196 ), esc_attr( isset( $IX68053[$IX46196] ) ? $IX68053[$IX46196] : '' ) ); echo '</label>'; echo '</p>'; } echo '<h3>' . __( 'Relative rates', 'affiliates' ) . '</h3>'; echo '<label>'; echo sprintf( '<input type="checkbox" name="' . self::RELATIVE_TIER_RATES . '" %s />', $IX28249 ? ' checked="checked" ' : '' ); echo ' '; echo __( 'Level rates are relative', 'affiliates' ); echo '</label>'; echo '<p class="description">'; echo __( 'If this option is enabled, the level rates are relative to the amount that is credited to the O.R. instead of the order amount.', 'affiliates' ); echo ' '; echo __( 'Example: Assuming 30% for normal referrals and 20% for Level 1, for an order of 100$, affiliate A gets a 30$ referral, affiliate B gets 6$ (20% of 30$).', 'affiliates' ); echo '</p>'; } else { echo '<p>'; printf( __( 'Level rates are defined in the <a href="%s">Rates</a> section.', 'affiliates' ), esc_url( admin_url( 'admin.php?page=affiliates-admin-rates' ) ) ); echo '</p>'; } echo '<p>' . wp_nonce_field( self::TIERS, self::NONCE, true, false ) . '<input class="button" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>'; echo '</div>' . '</form>'; affiliates_footer(); }

	public static function get_tree( $affiliate_ids = array(), &$IX37444 = null, $IX86987 = false, $IX62887 = null ) { global $affiliates_db; if ( $IX37444 === null ) { $IX37444 = array(); } $IX58009 = $affiliates_db->get_tablename( 'affiliates_relations' ); foreach( $affiliate_ids as $IX37639 ) { if ( $IX86987 || affiliates_check_affiliate_id( $IX37639 ) ) { $IX36931 = $affiliates_db->get_objects( "SELECT to_affiliate_id FROM $IX58009 WHERE from_affiliate_id = %d", intval( $IX37639 ) ); $IX37444[$IX37639] = array(); if ( count( $IX36931 ) > 0 ) { foreach ( $IX36931 as $IX54363 ) { if ( $IX62887 === null || $IX62887 > 0 ) { self::get_tree( array( $IX54363->to_affiliate_id ), $IX37444[$IX37639], $IX86987, $IX62887 === null ? null : $IX62887 - 1 ); } } } } } }

	public static function render_tree( &$tree, &$output, $max_depth = null, $depth = 0 ) { $output .= sprintf( '<div class="depth depth-%d %s">', $depth, $depth % 2 ? 'odd' : 'even' ); if ( $depth > 0 ) { $output .= '<span class="title">'; $output .= sprintf( __( 'Depth %d', 'affiliates' ), $depth ); $output .= '</span>'; } $output .= '<ul class="branch" style="padding-left:1em;margin-right:1em;">'; foreach( $tree as $IX93510 => $IX35754 ) { $output .= '<li>'; $IX72828 = affiliates_get_affiliate( $IX93510 ); if ( $IX72828 ) { $output .= sprintf( '<a href="%s" title="%s">%s</a>', admin_url( 'admin.php?page=affiliates-admin-affiliates&action=edit&affiliate_id=' . intval( $IX93510 ) ), sprintf( __( '%s, Affiliate ID %d, Depth %d', 'affiliates' ), wp_filter_nohtml_kses( $IX72828['name'] ), intval( $IX93510 ), $depth ), wp_filter_nohtml_kses( $IX72828['name'] ) ); } if ( !empty( $IX35754 ) ) { if ( $max_depth === null || $max_depth > 0 ) { self::render_tree( $IX35754, $output, $max_depth === null ? null : $max_depth - 1, $depth + 1 ); } } $output .= '</li>'; } $output .= '</ul>'; $output .= '</div>'; }

	public static function affiliates_after_edit_affiliate_attributes( $affiliate_id ) { global $affiliates_db; if ( $IX23156 = affiliates_get_affiliate( $affiliate_id ) ) { $IX41106 = $affiliates_db->get_tablename( 'affiliates_relations' ); if ( isset( $_POST['referrer-nonce'] ) && wp_verify_nonce( $_POST['referrer-nonce'], 'assign-referrer' ) ) { $IX42047 = isset( $_POST['referrer'] ) ? intval( $_POST['referrer'] ) : null; if ( $IX42047 !== null ) { $IX27152 = $affiliates_db->get_value( "SELECT from_affiliate_id FROM $IX41106 WHERE to_affiliate_id = %d", intval( $affiliate_id ) ); if ( $IX42047 !== intval( $IX27152 ) ) { if ( $affiliates_db->query( "DELETE FROM $IX41106 WHERE to_affiliate_id = %d AND from_affiliate_id = %d", intval( $affiliate_id ), intval( $IX27152 ) ) ) { do_action( 'affiliates_removed_affiliate_relation', $IX27152, $affiliate_id ); } if ( $IX42047 !== 0 ) { if ( $IX50949 = affiliates_get_affiliate( $IX42047 ) ) { $IX42302 = date( 'Y-m-d', time() ); if ( $affiliates_db->query( "INSERT INTO $IX41106 (from_affiliate_id,to_affiliate_id,type,from_date) VALUES (%d,%d,%s,%s)", intval( $IX42047 ), intval( $affiliate_id ), 'referral', $IX42302 ) ) { do_action( 'affiliates_added_affiliate_relation', $IX42047, $affiliate_id, 'referral', $IX42302 ); } } } } } } Affiliates_Relations_WordPress::view_relations( $affiliate_id ); echo '<h2>' . __( 'Tiers', 'affiliates' ) . '</h2>'; echo '<h3>' . __( 'Referrer', 'affiliates' ) . '</h3>'; $IX80391 = affiliates_get_affiliates(); $IX99455 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX27152 = $affiliates_db->get_value( "SELECT from_affiliate_id FROM $IX41106 WHERE to_affiliate_id = %d", intval( $affiliate_id ) ); $IX57928 = $affiliates_db->get_objects( "SELECT to_affiliate_id FROM $IX41106 WHERE from_affiliate_id = %d", intval( $affiliate_id ) ); $IX58638 = array(); foreach( $IX57928 as $IX69851 ) { $IX58638[] = intval( $IX69851->to_affiliate_id ); } $IX23216 = affiliates_get_affiliate( $IX27152 ); echo '<form id="edit-referrer" action="' . esc_url( $IX99455 ) . '" method="post">'; echo '<div>'; echo '<p>'; echo '<label>'; printf( '<select class="referrer" name="referrer" title="%s">', __( 'Referred by ...', 'affiliates' ) ); printf( '<option value="0" %s>%s</option>', $IX23216 === null ? ' selected="selected" ' : '', __( '---', 'affiliates' ) ); foreach( $IX80391 as $IX78132 ) { if ( ( $IX78132['affiliate_id'] != $affiliate_id ) && !in_array( intval( $IX78132['affiliate_id'] ), $IX58638 ) ) { printf( '<option value="%s" %s>%s [%d]</option>', esc_attr( $IX78132['affiliate_id'] ), intval( $IX27152 ) === intval( $IX78132['affiliate_id'] ) ? ' selected="selected" ' : '', wp_strip_all_tags( stripslashes( $IX78132['name'] ) ), intval( $IX78132['affiliate_id'] ) ); } } echo '</select>'; echo ' '; echo '<span class="description">'; echo __( 'The referring affiliate can be changed with immediate effect by clicking <input class="button" type="submit" value="Assign" />', 'affiliates' ); echo '</span>'; echo '</label>'; echo '</p>'; wp_nonce_field( 'assign-referrer','referrer-nonce', true, true ); echo '</div>'; echo '</form>'; echo '<script type="text/javascript">'; echo 'document.addEventListener( "DOMContentLoaded", function() {'; echo 'if (typeof jQuery !== "undefined") {'; echo 'jQuery("select.referrer").chosen();'; echo '}'; echo '} );'; echo '</script>'; if ( $IX27152 = $affiliates_db->get_value( "SELECT from_affiliate_id FROM $IX41106 WHERE to_affiliate_id = %d", intval( $affiliate_id ) ) ) { if ( $IX23216 = affiliates_get_affiliate( $IX27152 ) ) { echo sprintf( __( '<strong>%s</strong> has been referred by %s.', 'affiliates' ), wp_filter_nohtml_kses( $IX23156['name'] ), sprintf( '<a href="%s" title="%s">%s</a>', admin_url( 'admin.php?page=affiliates-admin-affiliates&action=edit&affiliate_id=' . intval( $IX27152 ) ), sprintf( __( '%s, ID %d', 'affiliates' ), wp_filter_nohtml_kses( $IX23216['name'] ), intval( $IX27152 ) ), wp_filter_nohtml_kses( $IX23216['name'] ) ) ); } } else { echo sprintf( __( '<strong>%s</strong> has not been referred by another affiliate.', 'affiliates' ), wp_filter_nohtml_kses( $IX23156['name'] ) ); } echo '<h3>' . __( 'Referred affiliates', 'affiliates' ) . '</h3>'; echo '<p class="description">'; echo sprintf( __( 'Affiliates who have been referred directly by %s - direct descendants - are shown at Depth 1, affiliates in subsequent depths have been referred by descendants and are shown directly below each referrer.', 'affiliates' ), wp_filter_nohtml_kses( $IX23156['name'] ) ); echo '</p>'; echo '<p class="description">'; echo __( 'Level rates and depths: descendants at a certain depth N, when credited with a referral, can result in referrals credited to their referring affiliates at depths N-1, N-2, etc. when the level rates are set. The rate for level 1 applies to the referring affiliate at depth N-1, the rate for level 2 to the one at depth N-2 and so on.', 'affiliates' ); echo '</p>'; self::get_tree( array( $affiliate_id ), $IX51156 ); if ( empty( $IX51156[$affiliate_id] ) ) { echo '<p>'; echo sprintf( __( '%s has not referred any affiliates yet.', 'affiliates' ), wp_filter_nohtml_kses( $IX23156['name'] ) ); echo '</p>'; } else { $IX36245 = ''; self::render_tree( $IX51156, $IX36245 ); echo $IX36245; } } if ( get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ) ) { self::specific_levels( $affiliate_id ); } }

	/**
	 * Affiliate-specific level rates.
	 * 
	 * @param int $affiliate_id
	 */
	private static function specific_levels( $affiliate_id ) { $IX14846 = get_option( self::N_TIERS, self::MAX_TIERS ); $IX99056 = get_option( self::RELATIVE_TIER_RATES, false ); $IX15417 = ''; if ( isset( $_POST['level-nonce'] ) && wp_verify_nonce( $_POST['level-nonce'], 'assign-level-rates' ) ) { delete_option( self::TIER_RATES . '_' . intval( $affiliate_id ) ); $IX40001 = array(); for( $IX52170 = 0; $IX52170 < $IX14846; $IX52170++ ) { if ( isset( $_POST['rate-' . $IX52170] ) && ( $_POST['rate-' . $IX52170] != '' ) ) { $IX75860 = bcadd( '0', $_POST['rate-' . $IX52170], affiliates_get_referral_amount_decimals() ); if ( bccomp( $IX75860, '0', affiliates_get_referral_amount_decimals() ) < 0 ) { $IX75860 = bcadd( '0', '0', affiliates_get_referral_amount_decimals() ); } else if ( bccomp( $IX75860, '1', affiliates_get_referral_amount_decimals() ) > 0 ) { $IX75860 = bcadd( '0', '1', affiliates_get_referral_amount_decimals() ); } $IX40001[$IX52170] = $IX75860; } } if ( count( $IX40001 ) > 0 ) { add_option( self::TIER_RATES . '_' . intval( $affiliate_id ), $IX40001, '', 'no' ); } } $IX40402 = get_option( self::TIER_RATES, array() ); $IX40001 = get_option( self::TIER_RATES . '_' . intval( $affiliate_id ), array() ); $IX41496 = 0; for( $IX52170 = 0; $IX52170 < $IX14846; $IX52170++ ) { if ( !empty( $IX40001[$IX52170] ) ) { $IX75860 = bcadd( '0', $IX40001[$IX52170], affiliates_get_referral_amount_decimals() ); $IX37896 = bcadd( $IX41496, $IX40001[$IX52170], affiliates_get_referral_amount_decimals() ); if ( ( bccomp( $IX37896, '1', affiliates_get_referral_amount_decimals() ) > 0 ) && ( bccomp( $IX40001[$IX52170], '0', affiliates_get_referral_amount_decimals() ) > 0 ) ) { $IX15417 .= '<div class="warning">'; $IX15417 .= sprintf( __( 'The rate %s indicated for level %d exceeds 1.00 for the sum of rates.', 'affiliates' ), $IX40001[$IX52170], $IX52170 + 1 ); $IX15417 .= '</div>'; } $IX41496 = bcadd( $IX41496, $IX40001[$IX52170], affiliates_get_referral_amount_decimals() ); } } if ( bccomp( $IX41496, '1', affiliates_get_referral_amount_decimals() ) > 0 ) { $IX15417 .= '<div class="warning">'; $IX15417 .= sprintf( __( 'The sum of rates is %s and exceeds 1.00.', 'affiliates' ), $IX41496 ); $IX15417 .= ' '; $IX15417 .= __( 'Although this might be intended, the total commission granted should normally not exceed the net transaction value on which commissions are based.', 'affiliates' ); $IX15417 .= ' '; if ( $IX99056 ) { $IX15417 .= __( 'As relative level rates apply, these rates are relative to the amount that is credited to the O.R. instead of the order amount. Note that a sum of level rates equal to or greater than 1.00 means that the total commissions credited to tiers, is equal to - or higher than - the commission granted to the O.R.', 'affiliates' ); } else { $IX15417 .= __( 'These rates are relative to the order amount. Note that a sum of level rates equal to or greater than 1.00 means that the total commissions credited to tiers, is equal to - or higher than - the originating order amount.', 'affiliates' ); } $IX15417 .= '</div>'; } echo '<h2>'. __( 'Level rates', 'affiliates' ) . '</h2>'; echo '<p class="description">'; echo __( 'Specific level rates can be set for this affiliate here.', 'affiliates' ); echo '</p>'; if ( $IX99056 ) { echo '<p class="description">'; echo __( 'Relative level rates apply.', 'affiliates' ); echo '</p>'; } if ( !empty( $IX15417 ) ) { echo $IX15417; } $IX74231 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; echo '<form id="edit-level-rates" action="' . esc_url( $IX74231 ) . '" method="post">'; echo '<div>'; for ( $IX52170 = 0; $IX52170 < $IX14846; $IX52170++ ) { echo '<p>'; echo '<label>'; echo sprintf( __( 'Level %d', 'affiliates' ), ( $IX52170 + 1 ) ); echo ' '; echo sprintf( '<input name="rate-%d" type="text" value="%s" placeholder="%s"/>', esc_attr( $IX52170 ), esc_attr( isset( $IX40001[$IX52170] ) ? $IX40001[$IX52170] : '' ), isset( $IX40402[$IX52170] ) ? sprintf( __( '%s (general level %d rate)', 'affiliates' ), $IX40402[$IX52170], $IX52170 + 1 ) : __( 'No general rate applies.', 'affiliates' ) ); echo '</label>'; echo '</p>'; } echo '<p class="description">'; echo __( 'If a level rate is set here, it will override the general level rate that applies.', 'affiliates' ); echo ' '; echo __( 'Empty fields do not override the general level rate, while specifying 0 effectively voids the rate for this affiliate at that level.', 'affiliates' ); echo '</p>'; wp_nonce_field( 'assign-level-rates','level-nonce', true, true ); echo '<p>'; echo sprintf( '<input class="button" type="submit" value="%s" title="%s" />', __( 'Set', 'affiliates' ), __( 'Click to set the level rates.', 'affiliates' ) ); echo ' '; echo '<span class="description">' . __( 'Click to set the level rates.', 'affiliates' ) . '</span>'; echo '</p>'; echo '</div>'; echo '</form>'; }

}
add_action( 'init', array( 'Affiliates_Multi_Tier', 'init' ) );
