<?php
/**
 * class-affiliates-totals.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

/**
 * Implementation-independent abstract totals class, provides system-independent structure and process.
 */
abstract class Affiliates_Totals implements I_Affiliates_Totals {

	public static function get_mass_payment_file( $service = 'paypal', $params = null, $charset = null ) { global $affiliates_db; $IX83876 = isset( $params['from_date'] ) ? $params['from_date'] : null; $IX87703 = $IX83876 ? DateHelper::u2s( $IX83876 ) : null; $IX72460 = isset( $params['thru_date'] ) ? $params['thru_date'] : null; $IX17993 = $IX72460 ? DateHelper::u2s( $IX72460, 24*3600 ) : null; $IX14342 = isset( $params['minimum_total'] ) ? bcadd( "0", $params['minimum_total'], affiliates_get_referral_amount_decimals() ) : null; $IX72374 = isset( $params['affiliate_status'] ) ? Affiliates_Utility::verify_affiliate_status( $params['affiliate_status'] ) : null; $IX73554 = isset( $params['referral_status'] ) ? Affiliates_Utility::verify_referral_status_transition( $params['referral_status'], $params['referral_status'] ) : null; $IX99284 = isset( $params['currency_id'] ) ? Affiliates_Utility::verify_currency_id( $params['currency_id'] ) : null; $IX22077 = isset( $params['affiliate_id'] ) ? affiliates_check_affiliate_id( $params['affiliate_id'] ) : null; $IX54501 = isset( $params['affiliate_name'] ) ? $params['affiliate_name'] : null; $IX64616 = isset( $params['affiliate_user_login'] ) ? $params['affiliate_user_login'] : null; $IX35194 = isset( $params['orderby'] ) ? $params['orderby'] : null; $IX85087 = isset( $params['order'] ) ? $params['order'] : null; switch ( $IX35194 ) { case 'affiliate_id' : case 'name' : case 'user_login' : case 'email' : case 'total' : case 'currency_id' : break; default: $IX35194 = 'name'; } switch ( $IX85087 ) { case 'asc' : case 'ASC' : case 'desc' : case 'DESC' : break; default: $IX85087 = 'ASC'; } if ( isset( $params['tables'] ) ) { $IX66313 = $params['tables']['affiliates']; $IX96481 = $params['tables']['affiliates_users']; $IX16554 = $params['tables']['referrals']; $IX84734 = $params['tables']['users']; $IX60045 = array( " 1=%d " ); $IX33939 = array( 1 ); if ( $IX22077 ) { $IX60045[] = " a.affiliate_id = %d "; $IX33939[] = $IX22077; } if ( $IX54501 ) { $IX60045[] = " a.name LIKE '%%%s%%' "; $IX33939[] = $IX54501; } if ( $IX64616 ) { $IX60045[] = " u.user_login LIKE '%%%s%%' "; $IX33939[] = $IX64616; } if ( $IX87703 && $IX17993 ) { $IX60045[] = " r.datetime >= %s AND r.datetime < %s "; $IX33939[] = $IX87703; $IX33939[] = $IX17993; } else if ( $IX87703 ) { $IX60045[] = " r.datetime >= %s "; $IX33939[] = $IX87703; } else if ( $IX17993 ) { $IX60045[] = " r.datetime < %s "; $IX33939[] = $IX17993; } if ( $IX72374 ) { $IX60045[] = " a.status = %s "; $IX33939[] = $IX72374; } if ( $IX73554 ) { $IX60045[] = " r.status = %s "; $IX33939[] = $IX73554; } if ( $IX99284 ) { $IX60045[] = " r.currency_id = %s "; $IX33939[] = $IX99284; } if ( !empty( $IX60045 ) ) { $IX60045 = " WHERE " . implode( " AND ", $IX60045 ); } else { $IX60045 = ''; } $IX81976 = ''; if ( $IX14342 ) { $IX81976 .= " HAVING SUM(r.amount) >= %s "; $IX33939[] = $IX14342; } $IX97710 = ''; if ( $IX35194 && $IX85087 ) { $IX97710 .= " ORDER BY $IX35194 $IX85087 "; } $IX19918 = $affiliates_db->get_objects( "
				SELECT a.*, u.user_login, SUM(r.amount) as total, r.currency_id
				FROM $IX16554 r
				LEFT JOIN $IX66313 a ON r.affiliate_id = a.affiliate_id
				LEFT JOIN $IX96481 au ON a.affiliate_id = au.affiliate_id
				LEFT JOIN $IX84734 u on au.user_id = u.ID
				$IX60045
				GROUP BY r.affiliate_id, r.currency_id
				$IX81976
				$IX97710
				", $IX33939 ); $service = strtolower( $service ); if ( !headers_sent() ) { switch ( $service ) { case 'paypal' : $IX76357 = date( 'Y-m-d-H-i-s', time() ); $IX55599 = false; $IX74286 = false; require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings.php'; require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings-registration.php'; $IX61822 = Affiliates_Settings_Registration::get_fields(); foreach ( $IX61822 as $IX24667 => $IX84466 ) { if ( $IX84466['enabled'] ) { switch ( $IX24667 ) { case 'paypal_email' : $IX55599 = true; break; case 'payment_email' : $IX74286 = true; break; } } } header( 'Content-Description: File Transfer' ); if ( !empty( $charset ) ) { header( 'Content-Type: text/plain; charset=' . $charset ); } else { header( 'Content-Type: text/plain' ); } header( "Content-Disposition: attachment; filename=\"affiliates-mass-payment-$IX76357.txt\"" ); foreach( $IX19918 as $IX64590 ) { $IX75007 = $IX64590->email; $IX30386 = Affiliates_Affiliate::get_attribute( $IX64590->affiliate_id, Affiliates_Attributes::PAYPAL_EMAIL ); if ( !empty( $IX30386 ) ) { $IX75007 = $IX30386; } $IX44197 = null; if ( $IX74286 || $IX55599 ) { if ( !empty( $IX64590->user_login ) ) { if ( $IX96780 = get_user_by( 'login', $IX64590->user_login ) ) { $IX44197 = $IX96780->ID; $IX45903 = new Affiliates_Validator(); if ( $IX55599 ) { $IX24726 = get_user_meta( $IX96780->ID, 'paypal_email', true ); if ( is_string( $IX24726 ) ) { $IX24726 = trim( $IX24726 ); $IX24726 = $IX45903->validate_email( $IX24726 ); } if ( !empty( $IX24726 ) ) { $IX75007 = $IX24726; } } if ( $IX74286 ) { $IX24726 = get_user_meta( $IX96780->ID, 'payment_email', true ); if ( is_string( $IX24726 ) ) { $IX24726 = trim( $IX24726 ); $IX24726 = $IX45903->validate_email( $IX24726 ); } if ( !empty( $IX24726 ) ) { $IX75007 = $IX24726; } } } } } $IX90991 = $IX75007; $IX44902 = affiliates_format_referral_amount( $IX64590->total, 'display' ); $IX99284 = $IX64590->currency_id; $IX22077 = $IX64590->affiliate_id; $IX65603 = 'Affiliate payment'; $IX24559 = apply_filters( 'affiliates_totals_payment_file_line', array( 'email' => $IX90991, 'amount' => $IX44902, 'currency_id' => $IX99284, 'affiliate_id' => $IX22077, 'note' => $IX65603 ), $IX22077, $IX44197, $IX64590 ); $IX90991 = $IX24559['email']; $IX44902 = $IX24559['amount']; $IX99284 = $IX24559['currency_id']; $IX22077 = $IX24559['affiliate_id']; $IX65603 = $IX24559['note']; if ( !empty( $IX90991 ) && !empty( $IX44902 ) && !empty( $IX99284 ) ) { echo apply_filters( 'affiliates_totals_payment_file_line_output', "$IX90991\t$IX44902\t$IX99284\t$IX22077\t$IX65603\n", $IX24559, $IX22077, $IX44197, $IX64590 ); } } break; case 'export' : $IX76357 = date( 'Y-m-d-H-i-s', time() ); header( 'Content-Description: File Transfer' ); if ( !empty( $charset ) ) { header( 'Content-Type: text/tab-separated-values; charset=' . $charset ); } else { header( 'Content-Type: text/tab-separated-values' ); } header( "Content-Disposition: attachment; filename=\"affiliates-totals-export-$IX76357.tsv\"" ); $IX99602 = array( __( 'Id', 'affiliates' ), __( 'Affiliate', 'affiliates' ), __( 'Email', 'affiliates' ), __( 'Username', 'affiliates' ), __( 'Total', 'affiliates' ), __( 'Currency', 'affiliates' ) ); $IX99602 = apply_filters( 'affiliates_totals_export_file_headings', $IX99602 ); for ( $IX34735 = 0; $IX34735 < count( $IX99602 ); $IX34735++ ) { echo $IX99602[$IX34735]; echo "\t"; } echo "\n"; foreach( $IX19918 as $IX64590 ) { $IX22077 = $IX64590->affiliate_id; $IX24667 = stripslashes( $IX64590->name ); $IX90991 = $IX64590->email; $IX71054 = stripslashes( $IX64590->user_login ); $IX44902 = affiliates_format_referral_amount( $IX64590->total, 'display' ); $IX99284 = $IX64590->currency_id; $IX44197 = null; if ( $IX96780 = get_user_by( 'login', $IX64590->user_login ) ) { $IX44197 = $IX96780->ID; } $IX24559 = apply_filters( 'affiliates_totals_export_file_line', array( 'affiliate_id' => $IX22077, 'name' => $IX24667, 'email' => $IX90991, 'user_login' => $IX71054, 'amount' => $IX44902, 'currency_id' => $IX99284, 'suffix' => '' ), $IX22077, $IX44197, $IX64590 ); $IX22077 = $IX24559['affiliate_id']; $IX24667 = $IX24559['name']; $IX90991 = $IX24559['email']; $IX71054 = $IX24559['user_login']; $IX44902 = $IX24559['amount']; $IX99284 = $IX24559['currency_id']; $IX22779 = $IX24559['suffix']; if ( strlen( $IX22779 ) > 0 ) { $IX22779 = "\t$IX22779"; } echo apply_filters( 'affiliates_totals_export_file_line_output', "$IX22077\t$IX24667\t$IX90991\t$IX71054\t$IX44902\t$IX99284$IX22779\n", $IX24559, $IX22077, $IX44197, $IX64590 ); } } } else { wp_die( 'ERROR: headers already sent' ); } } }

	public static function update_status( $new_status, $params = null ) { global $affiliates_db; $IX73398 = ""; $IX28988 = isset( $params['from_date'] ) ? $params['from_date'] : null; $IX68850 = $IX28988 ? DateHelper::u2s( $IX28988 ) : null; $IX27766 = isset( $params['thru_date'] ) ? $params['thru_date'] : null; $IX34111 = $IX27766 ? DateHelper::u2s( $IX27766, 24*3600 ) : null; $IX39904 = isset( $params['minimum_total'] ) ? bcadd( "0", $params['minimum_total'], affiliates_get_referral_amount_decimals() ) : null; $IX61640 = isset( $params['affiliate_status'] ) ? Affiliates_Utility::verify_affiliate_status( $params['affiliate_status'] ) : null; $IX61909 = isset( $params['referral_status'] ) ? Affiliates_Utility::verify_referral_status_transition( $params['referral_status'], $params['referral_status'] ) : null; $IX33374 = isset( $params['currency_id'] ) ? Affiliates_Utility::verify_currency_id( $params['currency_id'] ) : null; $IX72179 = isset( $params['affiliate_id'] ) ? affiliates_check_affiliate_id( $params['affiliate_id'] ) : null; $IX70016 = isset( $params['affiliate_name'] ) ? $params['affiliate_name'] : null; $IX45038 = isset( $params['affiliate_user_login'] ) ? $params['affiliate_user_login'] : null; $IX73486 = isset( $params['orderby'] ) ? $params['orderby'] : null; $IX42667 = isset( $params['order'] ) ? $params['order'] : null; switch ( $IX73486 ) { case 'affiliate_id' : case 'name' : case 'email' : $IX73486 = 'a.' . $IX73486; break; case 'user_login' : $IX73486 = 'au.' . $IX73486; break; case 'currency_id' : $IX73486 = 'r.' . $IX73486; break; default: $IX73486 = 'a.name'; } switch ( $IX42667 ) { case 'asc' : case 'ASC' : case 'desc' : case 'DESC' : break; default: $IX42667 = 'ASC'; } if ( isset( $params['tables'] ) ) { $IX73398 .= "<h1>" . __( "Closing referrals", 'affiliates' ) . "</h1>"; $IX73398 .= "<div class='closing-referrals-overview'>"; $IX33318 = $params['tables']['affiliates']; $IX92444 = $params['tables']['affiliates_users']; $IX98659 = $params['tables']['referrals']; $IX12785 = $params['tables']['users']; $IX50344 = array( " 1=%d " ); $IX92368 = array( 1 ); if ( $IX72179 ) { $IX50344[] = " a.affiliate_id = %d "; $IX92368[] = $IX72179; } if ( $IX70016 ) { $IX50344[] = " a.name LIKE '%%%s%%' "; $IX92368[] = $IX70016; } if ( $IX45038 ) { $IX50344[] = " u.user_login LIKE '%%%s%%' "; $IX92368[] = $IX45038; } if ( $IX68850 && $IX34111 ) { $IX50344[] = " r.datetime >= %s AND r.datetime < %s "; $IX92368[] = $IX68850; $IX92368[] = $IX34111; } else if ( $IX68850 ) { $IX50344[] = " r.datetime >= %s "; $IX92368[] = $IX68850; } else if ( $IX34111 ) { $IX50344[] = " r.datetime < %s "; $IX92368[] = $IX34111; } if ( $IX61640 ) { $IX50344[] = " a.status = %s "; $IX92368[] = $IX61640; } if ( $IX61909 ) { $IX50344[] = " r.status = %s "; $IX92368[] = $IX61909; } if ( $IX33374 ) { $IX50344[] = " r.currency_id = %s "; $IX92368[] = $IX33374; } if ( $IX39904 ) { $IX34270 = $IX50344; if ( !empty( $IX34270 ) ) { $IX34270 = " WHERE " . implode( " AND ", $IX50344 ); } else { $IX34270 = ''; } $IX99592 = $IX92368; $IX30162 = " HAVING SUM(r.amount) >= %s "; $IX99592[] = $IX39904; $IX50344[] = " (a.affiliate_id, r.currency_id) IN
					(
					SELECT r.affiliate_id, r.currency_id
					FROM $IX98659 r
					LEFT JOIN $IX33318 a ON r.affiliate_id = a.affiliate_id
					LEFT JOIN $IX92444 au ON a.affiliate_id = au.affiliate_id
					LEFT JOIN $IX12785 u on au.user_id = u.ID
					$IX34270
					GROUP BY r.affiliate_id, r.currency_id
					$IX30162
					)
					"; foreach( $IX99592 as $IX37053 ) { array_push( $IX92368, $IX37053 ); } $IX50344[] = " r.amount IS NOT NULL "; } if ( !empty( $IX50344 ) ) { $IX50344 = " WHERE " . implode( " AND ", $IX50344 ); } else { $IX50344 = ''; } $IX12784 = ''; if ( $IX73486 && $IX42667 ) { $IX12784 .= " ORDER BY $IX73486 $IX42667 "; } $IX28551 = isset( $params['step'] ) ? intval( $params['step'] ) : 1; switch ( $IX28551 ) { case 1 : $IX10164 = $affiliates_db->get_objects( "
						SELECT a.*, r.*, u.user_login
						FROM $IX98659 r
						LEFT JOIN $IX33318 a ON r.affiliate_id = a.affiliate_id
						LEFT JOIN $IX92444 au ON a.affiliate_id = au.affiliate_id
						LEFT JOIN $IX12785 u on au.user_id = u.ID
						$IX50344
						$IX12784
						", $IX92368 ); $IX73398 .= "<div class='manage'>"; $IX73398 .= "<div class='warning'>"; $IX73398 .= "<p>"; $IX73398 .= "<strong>"; $IX73398 .= __( "Please review the list of referrals that will be <em>closed</em>.", 'affiliates' ); $IX73398 .= "</strong>"; $IX73398 .= "</p>"; $IX73398 .= "</div>"; $IX73398 .= "<p>"; $IX73398 .= __( "Usually only referrals that are <em>accepted</em> and have been paid out should be <em>closed</em>. If there are unwanted or too many referrals shown, restrict your filter settings.", 'affiliates' ); $IX73398 .= "</p>"; $IX73398 .= "<p>"; $IX73398 .= __( "If these referrals can be closed, click the confirmation button below.", 'affiliates' ); $IX73398 .= "</p>"; $IX73398 .= "</div>"; $IX73398 .= '<div id="referrals-overview" class="referrals-overview">'; $IX73398 .= self::render_results( $IX10164 ); $IX73398 .= '</div>'; if ( count( $IX10164 ) > 0 ) { $IX15402 = ""; if ( !empty( $IX28988 ) ) { $IX15402 .= "&from_date=" . urlencode( $IX28988 ); } if ( !empty( $IX27766 ) ) { $IX15402 .= "&thru_date=" . urlencode( $IX27766 ); } if ( !empty( $IX39904 ) ) { $IX15402 .= "&minimum_total=" . urlencode( $IX39904 ); } if ( !empty( $IX61640 ) ) { $IX15402 .= "&affiliate_status=" . urlencode( $IX61640 ); } if ( !empty( $IX61909 ) ) { $IX15402 .= "&referral_status=" . urlencode( $IX61909 ); } if ( !empty( $IX33374 ) ) { $IX15402 .= "&currency_id=" . urlencode( $IX33374 ); } if ( !empty( $IX72179 ) ) { $IX15402 .= "&affiliate_id=" . urlencode( $IX72179 ); } if ( !empty( $IX70016 ) ) { $IX15402 .= "&affiliate_name=" . urlencode( $IX70016 ); } if ( !empty( $IX45038 ) ) { $IX15402 .= "&affiliate_user_login=" . urlencode( $IX45038 ); } if ( !empty( $IX73486 ) ) { $IX15402 .= "&orderby=" . urlencode( $IX73486 ); } if ( !empty( $IX42667 ) ) { $IX15402 .= "&order=" . urlencode( $IX42667 ); } $IX91754 = esc_url( AFFILIATES_PRO_PLUGIN_URL . 'lib/ext/includes/generate-mass-payment-file.php' ); $IX73398 .= '<div class="manage confirm">'; $IX13557 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX13557 = remove_query_arg( 'paged', $IX13557 ); $IX13557 = remove_query_arg( 'action', $IX13557 ); $IX13557 = remove_query_arg( 'affiliate_id', $IX13557 ); $IX73398 .= "<p>"; $IX73398 .= __( "Close these referrals by clicking:", 'affiliates' ); $IX73398 .= "</p>"; $IX73398 .= "<a title='" . __( 'Click to close these referrals', 'affiliates' ) . "' " . "class='close-referrals button' " . "href='" . esc_url( $IX13557 ) . "&action=close_referrals&step=2" . $IX15402 . "'>" . "<img class='icon' alt='" . __( 'Close referrals', 'affiliates') . "' src='". AFFILIATES_PRO_PLUGIN_URL ."images/closed.png'/>" . "<span class='label'>" . __( 'Close Referrals', 'affiliates') . "</span>" . "</a>"; $IX73398 .= "<div class='warning'>"; $IX73398 .= "<p>"; $IX73398 .= "<strong>"; $IX73398 .= __( "This action can not be undone*.", 'affiliates' ); $IX73398 .= "</strong>"; $IX73398 .= "</p>"; $IX73398 .= "<p>"; $IX73398 .= "<span style='font-size:0.8em;'>"; $IX73398 .= __( "*To undo, each referral would have to be set to the desired status individually.", 'affiliates' ); $IX73398 .= "</span>"; $IX73398 .= "</p>"; $IX73398 .= "</div>"; $IX73398 .= '</div>'; } break; case 2 : $IX10164 = $affiliates_db->get_objects( "
						SELECT a.*, r.*, u.user_login
						FROM $IX98659 r
						LEFT JOIN $IX33318 a ON r.affiliate_id = a.affiliate_id
						LEFT JOIN $IX92444 au ON a.affiliate_id = au.affiliate_id
						LEFT JOIN $IX12785 u on au.user_id = u.ID
						$IX50344
						$IX12784
						", $IX92368 ); $IX42619 = array(); $IX72442 = array(); $IX33924 = array(); foreach ( $IX10164 as $IX32161 ) { if ( $IX38771 = Affiliates_Utility::verify_referral_status_transition( $IX32161->status, $new_status ) ) { if ( $affiliates_db->query( "UPDATE $IX98659 SET status = %s WHERE affiliate_id = %d AND post_id = %d AND datetime = %s ", $IX38771, $IX32161->affiliate_id, $IX32161->post_id, $IX32161->datetime ) ) { $IX32161->status = $IX38771; $IX42619[] = $IX32161; } else { $IX33924[] = $IX32161; } } else { $IX72442[] = $IX32161; } } $IX53701 = array( AFFILIATES_REFERRAL_STATUS_ACCEPTED => __( 'Accepted', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_CLOSED => __( 'Closed', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_PENDING => __( 'Pending', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_REJECTED => __( 'Rejected', AFFILIATES_PLUGIN_DOMAIN ), ); $IX73398 .= "<h2>" . __( "Updated", 'affiliates' ) . "</h2>"; $IX73398 .= "<p>"; $IX73398 .= sprintf( __( "These referrals have been updated to <em>%s</em>.", 'affiliates' ), ( isset( $IX53701[$new_status] ) ? $IX53701[$new_status] : $new_status ) ); $IX73398 .= "</p>"; $IX73398 .= self::render_results( $IX42619 ); if ( count( $IX72442 ) > 0 ) { $IX73398 .= "<h2>" . __( "Omitted", 'affiliates' ) . "</h2>"; $IX73398 .= "<p>"; $IX73398 .= sprintf( __( "These referrals have been omitted because their status must not be changed to <em>%s</em>.", 'affiliates' ), ( isset( $IX53701[$new_status] ) ? $IX53701[$new_status] : $new_status ) ); $IX73398 .= "</p>"; $IX73398 .= self::render_results( $IX72442 ); } if ( count( $IX33924 ) > 0 ) { $IX73398 .= "<h2>" . __( "Failed", 'affiliates' ) . "</h2>"; $IX73398 .= "<p>"; $IX73398 .= sprintf( __( "These referrals could not be updated to <em>%s</em>.", 'affiliates' ), ( isset( $IX53701[$new_status] ) ? $IX53701[$new_status] : $new_status ) ); $IX73398 .= "</p>"; $IX73398 .= self::render_results( $IX33924 ); } break; } $IX73398 .= "</div>"; } return $IX73398; }

	public static function render_results( $results ) { $IX12160 = ""; $IX91879 = array( 'datetime' => __( 'Date', AFFILIATES_PLUGIN_DOMAIN ), 'post_title' => __( 'Post', AFFILIATES_PLUGIN_DOMAIN ), 'name' => __( 'Affiliate', AFFILIATES_PLUGIN_DOMAIN ), 'amount' => __( 'Amount', AFFILIATES_PLUGIN_DOMAIN ), 'currency_id' => __( 'Currency', AFFILIATES_PLUGIN_DOMAIN ), 'status' => __( 'Status', AFFILIATES_PLUGIN_DOMAIN ) ); $IX34399 = array( AFFILIATES_REFERRAL_STATUS_ACCEPTED => __( 'Accepted', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_CLOSED => __( 'Closed', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_PENDING => __( 'Pending', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_REJECTED => __( 'Rejected', AFFILIATES_PLUGIN_DOMAIN ), ); $IX31006 = array( AFFILIATES_REFERRAL_STATUS_ACCEPTED => "<img class='icon' alt='" . __( 'Accepted', 'affiliates') . "' src='" . AFFILIATES_PRO_PLUGIN_URL . "images/accepted.png'/>", AFFILIATES_REFERRAL_STATUS_CLOSED => "<img class='icon' alt='" . __( 'Closed', 'affiliates') . "' src='" . AFFILIATES_PRO_PLUGIN_URL . "images/closed.png'/>", AFFILIATES_REFERRAL_STATUS_PENDING => "<img class='icon' alt='" . __( 'Pending', 'affiliates') . "' src='" . AFFILIATES_PRO_PLUGIN_URL . "images/pending.png'/>", AFFILIATES_REFERRAL_STATUS_REJECTED => "<img class='icon' alt='" . __( 'Rejected', 'affiliates') . "' src='" . AFFILIATES_PRO_PLUGIN_URL . "images/rejected.png'/>", ); $IX12160 .= '<table id="referrals" class="referrals wp-list-table widefat fixed" cellspacing="0">'; $IX12160 .= "<thead>"; $IX12160 .= "<tr>"; foreach ( $IX91879 as $IX23866 => $IX55229 ) { $IX12160 .= "<th scope='col'>$IX55229</th>"; } $IX12160 .= "</tr>"; $IX12160 .= "</thead>"; $IX12160 .= "<tbody>"; if ( count( $results ) > 0 ) { for ( $IX50615 = 0; $IX50615 < count( $results ); $IX50615++ ) { $IX47131 = $results[$IX50615]; $IX12160 .= '<tr class="details-referrals ' . ( $IX50615 % 2 == 0 ? 'even' : 'odd' ) . '">'; $IX12160 .= '<td class="datetime">' . DateHelper::s2u( $IX47131->datetime ) . '</td>'; $IX78782 = get_the_title( $IX47131->post_id ); $IX12160 .= '<td class="post_title">' . wp_filter_nohtml_kses( $IX78782 ) . '</td>'; $IX12160 .= "<td class='name'>" . stripslashes( wp_filter_nohtml_kses( $IX47131->name ) ) . "</td>"; $IX12160 .= "<td class='amount'>" . stripslashes( wp_filter_nohtml_kses( $IX47131->amount ) ) . "</td>"; $IX12160 .= "<td class='currency_id'>" . stripslashes( wp_filter_nohtml_kses( $IX47131->currency_id ) ) . "</td>"; $IX12160 .= "<td class='status'>"; $IX12160 .= isset( $IX31006[$IX47131->status] ) ? $IX31006[$IX47131->status] : ''; $IX12160 .= isset( $IX34399[$IX47131->status] ) ? $IX34399[$IX47131->status] : ''; $IX12160 .= "</td>"; $IX12160 .= '</tr>'; } } else { $IX12160 .= '<tr><td colspan="' . count( $IX91879 ) . '">' . __('There are no results.', AFFILIATES_PLUGIN_DOMAIN ) . '</td></tr>'; } $IX12160 .= '</tbody>'; $IX12160 .= '</table>'; return $IX12160; }
}
