<?php
/**
 * class-affiliates-upgrade.3.php
 *
 * Copyright 2017 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author itthinx
 * @package affiliates-pro
 * @since affiliates-pro 3.0.0
 */

/**
 * Migrate data to 3.x
 *
 * We do not handle 'referral.amount.method' (note that 'referral.rate.method' is never used).
 */
class Affiliates_Upgrade_3 {

	public static function create_all_rates() { self::create_general_rate(); self::create_affiliate_rates(); self::create_level_rates(); self::create_wc_product_rates(); self::create_em_event_rates(); self::create_cf7_rates(); self::create_gf_rates(); self::create_ff_rates(); self::create_nf_rates(); }

	public static function form() { if ( !current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { return ''; } $IX81906 = ''; if ( isset( $_POST['generate-rates'] ) ) { if ( wp_verify_nonce( $_POST['_generate_rates'], 'generate-rates' ) ) { $IX87347 = isset( $_POST['generate-all'] ) ? 'generate-all' : null; if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-general'] ) ? 'generate-general' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-affiliate'] ) ? 'generate-affiliate' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-level'] ) ? 'generate-level' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-product'] ) ? 'generate-product' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-event'] ) ? 'generate-event' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-cf7'] ) ? 'generate-cf7' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-ff'] ) ? 'generate-ff' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-gf'] ) ? 'generate-gf' : null; } if ( $IX87347 === null ) { $IX87347 = isset( $_POST['generate-nf'] ) ? 'generate-nf' : null; } switch( $IX87347 ) { case 'generate-all' : self::create_all_rates(); break; case 'generate-general' : self::create_general_rate(); break; case 'generate-affiliate' : self::create_affiliate_rates(); break; case 'generate-level' : self::create_level_rates(); break; case 'generate-product' : self::create_wc_product_rates(); break; case 'generate-event' : self::create_em_event_rates(); break; case 'generate-cf7' : self::create_cf7_rates(); break; case 'generate-ff' : self::create_ff_rates(); break; case 'generate-gf' : self::create_gf_rates(); break; case 'generate-nf' : self::create_nf_rates(); break; } if ( $IX87347 ) { $IX81906 .= '<div class="updated">'; $IX81906 .= '<p>'; $IX81906 .= '<strong>'; $IX81906 .= __( 'Generation action executed.', 'affiliates' ); $IX81906 .= '</strong>'; $IX81906 .= '</p>'; $IX81906 .= '<p>'; $IX81906 .= __( 'Please check the <em>Rates</em> section to verify that all necessary rate entries have been created.', 'affiliates' ); $IX81906 .= '</p>'; $IX81906 .= '</div>'; } } } $IX81906 .= '<form action="" name="generate-rates" method="post">'; $IX81906 .= '<div>'; $IX81906 .= '<table>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'All rates', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-all" value="%s"/>', esc_attr( __( 'Generate all rates', 'affiliates' ) ) ); $IX81906 .= '</td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'Affiliates', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-general" value="%s"/>', esc_attr( __( 'General rate', 'affiliates' ) ) ); $IX81906 .= ' '; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-affiliate" value="%s"/>', esc_attr( __( 'Affiliate rates', 'affiliates' ) ) ); $IX81906 .= ' '; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-level" value="%s"/>', esc_attr( __( 'Level rates', 'affiliates' ) ) ); $IX81906 .= '</td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'WooCommerce', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-product" value="%s"/>', esc_attr( __( 'Product rates', 'affiliates' ) ) ); $IX81906 .= '</td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'Events Manager', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-event" value="%s"/>', esc_attr( __( 'Event rates', 'affiliates' ) ) ); $IX81906 .= '<td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'Contact Form 7', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-cf7" value="%s"/>', esc_attr( __( 'Form rates', 'affiliates' ) ) ); $IX81906 .= '<td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'Formidable Forms', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-ff" value="%s"/>', esc_attr( __( 'Form rates', 'affiliates' ) ) ); $IX81906 .= '<td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'Gravity Forms', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-gf" value="%s"/>', esc_attr( __( 'Form rates', 'affiliates' ) ) ); $IX81906 .= '<td>'; $IX81906 .= '</tr>'; $IX81906 .= '<tr>'; $IX81906 .= '<td>'; $IX81906 .= esc_html__( 'Ninja Forms', 'affiliates' ); $IX81906 .= '</td>'; $IX81906 .= '<td>'; $IX81906 .= sprintf( '<input class="button" type="submit" name="generate-nf" value="%s"/>', esc_attr( __( 'Form rates', 'affiliates' ) ) ); $IX81906 .= '<td>'; $IX81906 .= '</tr>'; $IX81906 .= '</table>'; $IX81906 .= '<input type="hidden" name="generate-rates" value="1" />'; $IX81906 .= wp_nonce_field( 'generate-rates', '_generate_rates', true, false ); $IX81906 .= '</div>'; $IX81906 .= '</form>'; echo $IX81906; }

	public static function create_general_rate() { $IX95909 = get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ); $IX79891 = get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE, null ); switch ( $IX95909 ) { case 'referral.amount' : $IX93995 = AFFILIATES_PRO_RATES_TYPE_AMOUNT; break; case 'referral.rate' : $IX93995 = AFFILIATES_PRO_RATES_TYPE_RATE; break; default : $IX93995 = null; } if ( $IX93995 !== null ) { $IX14403 = new Affiliates_Rate( (object) array( 'type' => $IX93995, 'value' => $IX79891, 'description' => __( 'Automatically generated from general rate.', 'affiliates' ) ) ); if ( !$IX14403->exists_other() ) { $IX14403->create(); } } }

	public static function create_affiliate_rates() { global $affiliates_db; $IX16705 = $affiliates_db->get_tablename( 'affiliates_attributes' ); if ( $IX24095 = $affiliates_db->get_objects( "SELECT * FROM $IX16705 WHERE attr_key IN ('referral.amount','referral.rate')" ) ) { if ( is_array( $IX24095 ) ) { foreach( $IX24095 as $IX86852 ) { $IX49568 = $IX86852->affiliate_id; $IX76133 = affiliates_get_affiliate_status( $IX49568 ); if ( $IX76133 === AFFILIATES_AFFILIATE_STATUS_DELETED ) { continue; } switch( $IX86852->attr_key ) { case 'referral.amount' : $IX35107 = AFFILIATES_PRO_RATES_TYPE_AMOUNT; break; case 'referral.rate' : $IX35107 = AFFILIATES_PRO_RATES_TYPE_RATE; break; default : $IX35107 = null; } if ( $IX35107 !== null ) { $IX11603 = $IX86852->attr_value; $IX42649 = new Affiliates_Rate( (object) array( 'affiliate_id' => $IX49568, 'type' => $IX35107, 'value' => $IX11603, 'description' => __( 'Automatically generated from affiliate rate.', 'affiliates' ) ) ); if ( !$IX42649->exists_other() ) { $IX42649->create(); } } } } } }

	public static function create_level_rates() { global $affiliates_db; if ( class_exists( 'Affiliates_Multi_Tier' ) ) { $IX94430 = get_option( Affiliates_Multi_Tier::TIER_RATES, array() ); $IX13853 = get_option( Affiliates_Multi_Tier::N_TIERS, Affiliates_Multi_Tier::MAX_TIERS ); $IX45216 = get_option( Affiliates_Multi_Tier::RELATIVE_TIER_RATES, false ); if ( is_array( $IX94430 ) ) { foreach( $IX94430 as $IX36820 => $IX96500 ) { $IX14880 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'level' => $IX36820, 'value' => $IX96500, 'description' => __( 'Automatically generated from general tier rate for level.', 'affiliates' ) ) ); if ( $IX45216 ) { $IX14880->set_meta( 'level-relative', true ); } if ( !$IX14880->exists_other() ) { $IX14880->create(); } } } $IX36822 = $affiliates_db->get_tablename( 'affiliates' ); $IX68462 = $affiliates_db->get_objects( "SELECT affiliate_id FROM $IX36822" ); if ( is_array( $IX68462 ) ) { foreach( $IX68462 as $IX29216 ) { $IX56147 = $IX29216->affiliate_id; $IX15965 = affiliates_get_affiliate_status( $IX56147 ); if ( $IX15965 === AFFILIATES_AFFILIATE_STATUS_DELETED ) { continue; } $IX94430 = get_option( Affiliates_Multi_Tier::TIER_RATES . '_' . intval( $IX56147 ), array() ); if ( !empty( $IX94430 ) && is_array( $IX94430 ) ) { foreach( $IX94430 as $IX36820 => $IX96500 ) { $IX14880 = new Affiliates_Rate( (object) array( 'affiliate_id' => $IX56147, 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'level' => $IX36820, 'value' => $IX96500, 'description' => __( 'Automatically generated from affiliate tier rate for level.', 'affiliates' ) ) ); if ( $IX45216 ) { $IX14880->set_meta( 'level-relative', true ); } if ( !$IX14880->exists_other() ) { $IX14880->create(); } } } unset( $IX94430 ); } } } }

	public static function create_wc_product_rates() { global $wpdb; if ( class_exists( 'Affiliates_WooCommerce_Integration' ) && defined( 'Affiliates_WooCommerce_Integration::PLUGIN_OPTIONS' ) && defined( 'Affiliates_WooCommerce_Integration::DEFAULT_RATE' ) ) { $IX65922 = get_option( Affiliates_WooCommerce_Integration::PLUGIN_OPTIONS , array() ); $IX66509 = isset( $IX65922[Affiliates_WooCommerce_Integration::DEFAULT_RATE] ) ? $IX65922[Affiliates_WooCommerce_Integration::DEFAULT_RATE] : ''; if ( $IX66509 !== '' ) { $IX52177 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'integration' => 'affiliates-woocommerce', 'value' => $IX66509, 'description' => __( 'Automatically generated from default product rate.', 'affiliates' ) ) ); if ( !$IX52177->exists_other() ) { $IX52177->create(); } } } $IX46220 = $wpdb->get_results( "SELECT * FROM $wpdb->postmeta pm LEFT JOIN $wpdb->posts p ON pm.post_id = p.ID WHERE meta_key = '_affiliates_rate' AND p.post_type = 'product'" ); if ( is_array( $IX46220 ) ) { foreach( $IX46220 as $IX95372 ) { $IX52177 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'integration' => 'affiliates-woocommerce', 'object_id' => $IX95372->post_id, 'value' => $IX95372->meta_value, 'description' => __( 'Automatically generated from product rate.', 'affiliates' ) ) ); if ( !$IX52177->exists_other() ) { $IX52177->create(); } } } }

	public static function create_em_event_rates() { global $wpdb; if ( class_exists( 'Affiliates_Events_Manager' ) && defined( 'Affiliates_Events_Manager::PLUGIN_OPTIONS' ) && defined( 'Affiliates_Events_Manager::REFERRAL_RATE' ) && defined( 'Affiliates_Events_Manager::DEFAULT_ZERO_VALUE' ) ) { $IX84493 = get_option( Affiliates_Events_Manager::PLUGIN_OPTIONS , array() ); $IX28542 = isset( $IX84493[Affiliates_Events_Manager::REFERRAL_RATE ] ) ? $IX84493[Affiliates_Events_Manager::REFERRAL_RATE] : Affiliates_Events_Manager::DEFAULT_ZERO_VALUE; $IX93349 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'integration' => 'affiliates-events-manager', 'value' => $IX28542, 'description' => __( 'Automatically generated from default event rate.', 'affiliates' ) ) ); if ( !$IX93349->exists_other() ) { $IX93349->create(); } } $IX97193 = $wpdb->get_results( "SELECT * FROM $wpdb->postmeta pm LEFT JOIN $wpdb->posts p ON pm.post_id = p.ID WHERE meta_key = 'referral-rate' AND p.post_type = 'event'" ); if ( is_array( $IX97193 ) ) { foreach( $IX97193 as $IX83060 ) { $IX93349 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'integration' => 'affiliates-events-manager', 'object_id' => $IX83060->post_id, 'value' => $IX83060->meta_value, 'description' => __( 'Automatically generated from event rate.', 'affiliates' ) ) ); if ( !$IX93349->exists_other() ) { $IX93349->create(); } } } }

	public static function create_cf7_rates() { if ( class_exists( 'Affiliates_CF7' ) ) { $IX96466 = Affiliates_Rate::get_rate(); if ( $IX96466 === null ) { $IX96466 = Affiliates_Rate::get_rate( array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE ) ); } if ( $IX96466 === null ) { $IX96466 = Affiliates_Rate::get_rate( array( 'type' => AFFILIATES_PRO_RATES_TYPE_AMOUNT ) ); } if ( $IX96466 !== null ) { $IX96466->rate_id = null; $IX96466->integration = 'affiliates-contact-form-7'; $IX96466->description = __( 'Automatically generated from assumed default form rate.', 'affiliates' ) . ( !empty( $IX96466->description ) ? ' | ' . $IX96466->description : '' ); } if ( $IX96466 === null ) { $IX93260 = get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_KEY, null ); $IX81156 = get_option( Affiliates_Referral::DEFAULT_REFERRAL_CALCULATION_VALUE, null ); switch ( $IX93260 ) { case 'referral.amount' : $IX88944 = AFFILIATES_PRO_RATES_TYPE_AMOUNT; break; case 'referral.rate' : $IX88944 = AFFILIATES_PRO_RATES_TYPE_RATE; break; default : $IX88944 = null; } if ( $IX88944 !== null ) { $IX96466 = new Affiliates_Rate( (object) array( 'type' => $IX88944, 'integration' => 'affiliates-contact-form-7', 'value' => $IX81156, 'description' => __( 'Automatically generated from default form rate.', 'affiliates' ) ) ); } } if ( $IX96466 === null ) { $IX99047 = get_option( Affiliates_CF7::PLUGIN_OPTIONS, array() ); $IX30949 = isset( $IX99047[Affiliates_CF7::REFERRAL_RATE] ) ? $IX99047[Affiliates_CF7::REFERRAL_RATE] : Affiliates_CF7::REFERRAL_RATE_DEFAULT; $IX29455 = class_exists( 'WPCF7_ContactForm' ) && defined( 'WPCF7_ContactForm::post_type' ) ? WPCF7_ContactForm::post_type : 'wpcf7_contact_form'; $IX96466 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_RATE, 'integration' => 'affiliates-contact-form-7', 'value' => $IX30949, 'description' => __( 'Automatically generated from default form rate.', 'affiliates' ) ) ); } if ( $IX96466 !== null ) { if ( !$IX96466->exists_other() ) { $IX96466->create(); } } } }

	public static function create_gf_rates() { if ( class_exists( 'GFAPI' ) && method_exists( 'GFAPI', 'get_forms' ) ) { $IX49026 = GFAPI::get_forms(); foreach ( $IX49026 as $IX39818 ) { $IX46615 = null; if ( !empty( $IX39818['affiliates']['amount'] ) ) { $IX46615 = $IX39818['affiliates']['amount']; $IX74824 = AFFILIATES_PRO_RATES_TYPE_AMOUNT; } else if ( !empty( $IX39818['affiliates']['rate'] ) ) { $IX46615 = $IX39818['affiliates']['rate']; $IX74824 = AFFILIATES_PRO_RATES_TYPE_RATE; } if ( $IX46615 !== null ) { $IX70064 = new Affiliates_Rate( (object) array( 'type' => $IX74824, 'integration' => 'affiliates-gravityforms', 'object_id' => $IX39818['id'], 'value' => $IX46615, 'description' => __( 'Automatically generated from form rate.', 'affiliates' ) ) ); if ( !$IX70064->exists_other() ) { $IX70064->create(); } } } } }

	public static function create_ff_rates() { if ( class_exists( 'FrmForm' ) && method_exists( 'FrmForm', 'get_published_forms' ) ) { $IX91624 = FrmForm::get_published_forms( array(), '' ); foreach ( $IX91624 as $IX76953 ) { $IX47223 = FrmFormAction::get_action_for_form( $IX76953->id, 'affiliates' ); if ( !empty( $IX47223 ) && is_array( $IX47223 ) ) { foreach ( $IX47223 as $IX83940 => $IX54298 ) { if ( isset( $IX54298->post_content ) ) { $IX14390 = isset( $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::ENABLE] ) ? $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::ENABLE] : false; if ( $IX14390 ) { $IX94679 = !empty( $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::CURRENCY_ID] ) ? $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::CURRENCY_ID] : null; $IX72646 = !empty( $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::AMOUNT] ) ? $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::AMOUNT] : ''; $IX37499 = !empty( $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::RATE] ) ? $IX54298->post_content[Affiliates_Formidable_Affiliates_Action::RATE] : ''; $IX23368 = null; $IX39096 = ''; if ( !empty( $IX72646 ) ) { $IX23368 = $IX72646; $IX54647 = AFFILIATES_PRO_RATES_TYPE_AMOUNT; $IX39096 = __( 'Automatically generated from form amount.', 'affiliates' ); } else if ( !empty( $IX37499 ) ) { $IX23368 = $IX37499; $IX54647 = AFFILIATES_PRO_RATES_TYPE_RATE; $IX39096 = __( 'Automatically generated from form rate.', 'affiliates' ); } if ( $IX23368 !== null ) { $IX37499 = new Affiliates_Rate( (object) array( 'type' => $IX54647, 'integration' => 'affiliates-formidable', 'object_id' => $IX76953->id, 'value' => $IX23368, 'description' => $IX39096, 'currency_id' => $IX94679 ) ); if ( !$IX37499->exists_other() ) { $IX37499->create(); } } } } } } } } }

	public static function create_nf_rates() { if ( class_exists( 'Affiliates_Ninja_Forms' ) && defined( 'Affiliates_Ninja_Forms::PLUGIN_OPTIONS' ) ) { $IX14689 = get_option( Affiliates_Ninja_Forms::PLUGIN_OPTIONS , array() ); $IX42267 = isset( $IX14689['aff_ninja_forms_amount'] ) ? $IX14689['aff_ninja_forms_amount'] : null; $IX45876 = isset( $IX14689['aff_ninja_forms_currency'] ) ? $IX14689['aff_ninja_forms_currency'] : Affiliates::DEFAULT_CURRENCY; if ( $IX42267 !== null ) { $IX43940 = new Affiliates_Rate( (object) array( 'type' => AFFILIATES_PRO_RATES_TYPE_AMOUNT, 'integration' => 'affiliates-ninja-forms', 'value' => $IX42267, 'currency_id' => $IX45876, 'description' => __( 'Automatically generated from default form amount.', 'affiliates' ) ) ); if ( !$IX43940->exists_other() ) { $IX43940->create(); } } } if ( class_exists( 'Ninja_Forms' ) && method_exists( 'Ninja_Forms', 'form' ) ) { foreach ( Ninja_Forms()->form()->get_forms() as $IX64638 ) { $IX24586 = $IX64638->get_id(); $IX42267 = $IX64638->get_setting( 'affiliates_referral_amount' ); $IX43940 = $IX64638->get_setting( 'affiliates_referral_rate' ); $IX28502 = null; if ( !empty( $IX42267 ) ) { $IX28502 = $IX42267; $IX10946 = AFFILIATES_PRO_RATES_TYPE_AMOUNT; } else if ( !empty( $IX43940 ) ) { $IX28502 = $IX43940; $IX10946 = AFFILIATES_PRO_RATES_TYPE_RATE; } if ( $IX28502 !== null ) { $IX43940 = new Affiliates_Rate( (object) array( 'type' => $IX10946, 'integration' => 'affiliates-ninja-forms', 'object_id' => $IX24586, 'value' => $IX28502, 'description' => __( 'Automatically generated from form rate.', 'affiliates' ) ) ); if ( !$IX43940->exists_other() ) { $IX43940->create(); } } } } }
}
