<?php
/**
 * class-affiliates-admin-notifications-extended.php
 *
 * Copyright (c) 2016 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 2.16.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Extended administrative section for notifications.
 */
class Affiliates_Admin_Notifications_Extended {

	const NONCE = 'aff-admin-menu';
	const SETTINGS = 'aff-settings';

	public static function view() { if ( !current_user_can( AFFILIATES_ADMINISTER_OPTIONS ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } wp_enqueue_style( 'affiliates-pro-admin-notifications' ); $IX30871 = apply_filters( 'affiliates_notifications_sections', array( 'affiliates' => array ( 'label' => __( 'Affiliates', 'affiliates' ), 'subsections' => array ( 'registration' => __( 'Registration', 'affiliates' ), 'referrals' => __( 'Referrals', 'affiliates' ) ) ), 'administrator' => array ( 'label' => __( 'Administrator', 'affiliates' ), 'subsections' => array ( 'registration' => __( 'Registration', 'affiliates' ), 'referrals' => __( 'Referrals', 'affiliates' ) ) ) ) ); $IX43611 = isset( $_REQUEST['section'] ) ? $_REQUEST['section'] : null; if ( !key_exists( $IX43611, $IX30871 ) ) { $IX43611 = 'affiliates'; } $IX38465 = $IX30871[$IX43611]['label']; echo '<h1>'; echo __( 'Notifications', 'affiliates' ); echo '</h1>'; $IX17963 = ''; foreach( $IX30871 as $IX96137 => $IX72539 ) { $IX17963 .= sprintf( '<a class="section-link nav-tab %s" href="%s">%s</a>', $IX43611 == $IX96137 ? 'active nav-tab-active' : '', esc_url( add_query_arg( 'section', $IX96137, admin_url( 'admin.php?page=affiliates-admin-notifications' ) ) ), $IX72539['label'] ); } echo '<div class="section-links nav-tab-wrapper">'; echo $IX17963; echo '</div>'; include_once( dirname( AFFILIATES_PRO_FILE ) . '/lib/ext/includes/class-affiliates-notifications-extended.php' ); switch ( $IX43611 ) { case 'administrator' : self::affiliates_notifications_administrator_section(); break; case 'affiliates' : default : self::affiliates_notifications_affiliates_section(); break; } affiliates_footer(); }

	protected static function affiliates_notifications_administrator_section() { $IX21397 = get_option( 'affiliates_notifications', null ); if ( $IX21397 === null ) { add_option( 'affiliates_notifications', array(), null, 'no' ); } if ( isset( $_POST['submit'] ) ) { if ( wp_verify_nonce( $_POST[self::NONCE], self::SETTINGS ) ) { if ( !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT] ) ) { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT] ); } else { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_PENDING_SUBJECT ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE] ) ) { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE] = $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE]; } else { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_PENDING_MESSAGE ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT] ) ) { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT] ); } else { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_ACTIVE_SUBJECT ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE] ) ) { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE] = $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE]; } else { $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_ACTIVE_MESSAGE ); } $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN] = !empty( $_POST[Affiliates_Notifications_Extended::NOTIFY_ADMIN] ); if ( !empty( $_POST[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL] ) ) { if ( $IX37959 = filter_var( $_POST[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL], FILTER_VALIDATE_EMAIL ) ) { $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL] = $IX37959; } else { $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL] = ''; } } else { $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL] = ''; } $IX81448 = array(); if ( !empty( $_POST['notify_admin_status_accepted'] ) ) { $IX81448[] = AFFILIATES_REFERRAL_STATUS_ACCEPTED; } if ( !empty( $_POST['notify_admin_status_pending'] ) ) { $IX81448[] = AFFILIATES_REFERRAL_STATUS_PENDING; } $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_STATUS] = $IX81448; if ( !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_SUBJECT] ) ) { $IX21397[Affiliates_Notifications_Extended::ADMIN_SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::ADMIN_SUBJECT] ); } else { $IX21397[Affiliates_Notifications_Extended::ADMIN_SUBJECT] = Affiliates_Notifications_Extended::ADMIN_DEFAULT_SUBJECT; } if ( !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_MESSAGE] ) ) { $IX21397[Affiliates_Notifications_Extended::ADMIN_MESSAGE] = $_POST[Affiliates_Notifications_Extended::ADMIN_MESSAGE]; } else { $IX21397[Affiliates_Notifications_Extended::ADMIN_MESSAGE] = Affiliates_Notifications_Extended::ADMIN_DEFAULT_MESSAGE; } $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED] = !empty( $_POST[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED] ); update_option( 'affiliates_notifications', $IX21397 ); } } $IX78275 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED] : Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED_DEFAULT; $IX53370 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_ACTIVE_SUBJECT ); $IX77466 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_ACTIVE_MESSAGE ); $IX86784 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_PENDING_SUBJECT ); $IX12569 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_ADMIN_REGISTRATION_PENDING_MESSAGE ); $IX38634 = isset( $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN] ) && $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN]; $IX37959 = isset( $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL] ) ? $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL] : ''; $IX81448 = isset( $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_STATUS] ) ? $IX21397[Affiliates_Notifications_Extended::NOTIFY_ADMIN_STATUS] : array( AFFILIATES_REFERRAL_STATUS_ACCEPTED ); $IX75925 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_SUBJECT] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_SUBJECT] : Affiliates_Notifications_Extended::ADMIN_DEFAULT_SUBJECT; $IX86021 = isset( $IX21397[Affiliates_Notifications_Extended::ADMIN_MESSAGE] ) ? $IX21397[Affiliates_Notifications_Extended::ADMIN_MESSAGE] : Affiliates_Notifications_Extended::ADMIN_DEFAULT_MESSAGE; echo '<form action="" name="notifications" method="post">'; echo '<div class="notifications">'; echo '<div class="manage">'; echo '<h1>' . __( 'Registration', 'affiliates' ) . '</h1>'; echo '<div>' . '<p>' . '<label>' . '<input type="checkbox" name="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED . '" id="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_ENABLED . '" ' . ( $IX78275 ? ' checked="checked" ' : '' ) . '/>' . __( 'Enable registration notifications', 'affiliates' ) . '</label>' . '</p>' . '<p class="description">' . __( 'Notify the administrator about new affiliate accounts.', 'affiliates' ) . '</p>' . '<h2>' . __( 'Administrator Notifications', 'affiliates' ) . '</h2>' . '<p>' . __( 'These templates are used to notify the site administrator of new affiliates.', 'affiliates' ) . '</p>' . '<h3>' . __( 'Pending', 'affiliates' ) . '</h3>' . '<p>' . __( 'This notification is sent to the administrator if a new affiliate application is pending approval.', 'affiliates' ) . '</p>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT . '" name="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX86784 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE . '" id="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE . '" name="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_PENDING_MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX12569 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this administrator notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . '<h3>' . __( 'Active', 'affiliates' ) . '</h3>' . '<p>' . __( 'This notification is sent to the administrator if an affiliate has been approved automatically.', 'affiliates' ) . '</p>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT . '" name="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX53370 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE . '" id="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE . '" name="' . Affiliates_Notifications_Extended::ADMIN_REGISTRATION_MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX77466 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this administrator notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . wp_nonce_field( self::SETTINGS, self::NONCE, true, false ) . '<input class="button button-primary" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>' . '</div>' . '</div>'; echo '</div>'; echo '<div class="notifications">'; echo '<div class="manage">'; echo '<h1>' . __( 'Referrals', 'affiliates' ) . '</h1>'; echo '<p>' . __( 'Notifications for the site administrator can be enabled here. If the integration used provides its own notification settings, enable these through the integration&rsquo;s settings or here. Do not enable them both, as that could cause duplicate notifications to be sent.', 'affiliates' ) . '</p>'; echo '<div>' . '<h2>' . __( 'Referral Notifications', 'affiliates' ) . '</h2>' . '<p>' . '<label>' . '<input type="checkbox" name="' . Affiliates_Notifications_Extended::NOTIFY_ADMIN . '" id="' . Affiliates_Notifications_Extended::NOTIFY_ADMIN . '" ' . ( $IX38634 ? ' checked="checked" ' : '' ) . '/>' . __( 'Notify the site administrator', 'affiliates' ) . '</label>' . '</p>' . '<p class="description">' . __( 'Notifications will be sent to the email address specified in <em>Settings > General</em>, or if indicated, to the email address specified here.', 'affiliates' ) . '</p>' . '<p>' . '<label>' . __( 'Administrator Email Address', 'affiliates' ) . '<br/>' . sprintf( '<input class="%s" name="%s" type="text" value="%s" placeholder="%s"/>', esc_attr( Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL ), esc_attr( Affiliates_Notifications_Extended::NOTIFY_ADMIN_EMAIL ), esc_attr( $IX37959 ), get_bloginfo( 'admin_email' ) ) . '</label>' . '</p>' . '<p>' . __( 'Notify when a referral is: ', 'affiliates' ) . '<label>' . sprintf( '<input type="checkbox" name="notify_admin_status_accepted" %s />', in_array( AFFILIATES_REFERRAL_STATUS_ACCEPTED, $IX81448 ) ? ' checked="checked" ' : '' ) . __( 'Accepted', 'affiliates' ) . '</label>' . ' ' . '<label>' . sprintf( '<input type="checkbox" name="notify_admin_status_pending" %s />', in_array( AFFILIATES_REFERRAL_STATUS_PENDING, $IX81448 ) ? ' checked="checked" ' : '' ) . __( 'Pending', 'affiliates' ) . '</label>' . '</p>' . '<ul class="description">' . '<li>' . __( 'Notifications on referral status updates are only sent when the status changes from <em>pending</em> to <em>accepted</em>.', 'affiliates' ) . '</li>' . '<li>' . __( 'More than one notification may be sent if multiple statuses are enabled.', 'affiliates' ) . '</li>' . '<li>' . __( 'Notifications on referral status updates may not be supported by all integrations.', 'affiliates' ) . '</li>' . '</ul>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::ADMIN_SUBJECT . '" name="' . Affiliates_Notifications_Extended::ADMIN_SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX75925 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="message" id="' . Affiliates_Notifications_Extended::ADMIN_MESSAGE . '" name="' . Affiliates_Notifications_Extended::ADMIN_MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX86021 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this administrator notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . '<p>' . wp_nonce_field( self::SETTINGS, self::NONCE, true, false ) . '<input class="button button-primary" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>' . '</div>' . '</div>'; echo '</div>'; echo '</form>'; }

	protected static function affiliates_notifications_affiliates_section() { $IX30254 = get_option( 'affiliates_notifications', null ); if ( $IX30254 === null ) { add_option('affiliates_notifications', array(), null, 'no' ); } if ( isset( $_POST['submit'] ) ) { if ( wp_verify_nonce( $_POST[self::NONCE], self::SETTINGS ) ) { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_ENABLED] = !empty( $_POST[Affiliates_Notifications_Extended::REGISTRATION_ENABLED] ); if ( !empty( $_POST[Affiliates_Notifications_Extended::REGISTRATION_SUBJECT] ) ) { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::REGISTRATION_SUBJECT] ); } else { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_SUBJECT] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_ACTIVE_SUBJECT ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::REGISTRATION_MESSAGE] ) ) { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_MESSAGE] = $_POST[Affiliates_Notifications_Extended::REGISTRATION_MESSAGE]; } else { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_MESSAGE] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_ACTIVE_MESSAGE ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT] ) ) { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT] ); } else { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_PENDING_SUBJECT ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE] ) ) { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE] = $_POST[Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE]; } else { $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_PENDING_MESSAGE ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT] ) ) { $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT] ); } else { $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_AFFILIATE_PENDING_TO_ACTIVE_SUBJECT ); } if ( !empty( $_POST[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE] ) ) { $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE] = $_POST[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE]; } else { $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE] = Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_AFFILIATE_PENDING_TO_ACTIVE_MESSAGE ); } $IX30254[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE] = !empty( $_POST[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE] ); $IX59113 = array(); if ( !empty( $_POST['notify_affiliate_status_accepted'] ) ) { $IX59113[] = AFFILIATES_REFERRAL_STATUS_ACCEPTED; } if ( !empty( $_POST['notify_affiliate_status_pending'] ) ) { $IX59113[] = AFFILIATES_REFERRAL_STATUS_PENDING; } $IX30254[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE_STATUS] = $IX59113; if ( !empty( $_POST[Affiliates_Notifications_Extended::SUBJECT] ) ) { $IX30254[Affiliates_Notifications_Extended::SUBJECT] = wp_filter_nohtml_kses( $_POST[Affiliates_Notifications_Extended::SUBJECT] ); } else { $IX30254[Affiliates_Notifications_Extended::SUBJECT] = Affiliates_Notifications_Extended::DEFAULT_SUBJECT; } if ( !empty( $_POST[Affiliates_Notifications_Extended::MESSAGE] ) ) { $IX30254[Affiliates_Notifications_Extended::MESSAGE] = $_POST[Affiliates_Notifications_Extended::MESSAGE]; } else { $IX30254[Affiliates_Notifications_Extended::MESSAGE] = Affiliates_Notifications_Extended::DEFAULT_MESSAGE; } update_option( 'affiliates_notifications', $IX30254 ); } } $IX58740 = isset( $IX30254[Affiliates_Notifications_Extended::REGISTRATION_ENABLED] ) ? $IX30254[Affiliates_Notifications_Extended::REGISTRATION_ENABLED] : Affiliates_Notifications_Extended::REGISTRATION_ENABLED_DEFAULT; $IX19816 = isset( $IX30254[Affiliates_Notifications_Extended::REGISTRATION_SUBJECT] ) ? $IX30254[Affiliates_Notifications_Extended::REGISTRATION_SUBJECT] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_ACTIVE_SUBJECT ); $IX78108 = isset( $IX30254[Affiliates_Notifications_Extended::REGISTRATION_MESSAGE] ) ? $IX30254[Affiliates_Notifications_Extended::REGISTRATION_MESSAGE] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_ACTIVE_MESSAGE ); $IX44343 = isset( $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT] ) ? $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_PENDING_SUBJECT ); $IX89238 = isset( $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE] ) ? $IX30254[Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_REGISTRATION_PENDING_MESSAGE ); $IX45453 = isset( $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT] ) ? $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_AFFILIATE_PENDING_TO_ACTIVE_SUBJECT ); $IX63789 = isset( $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE] ) ? $IX30254[Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE] : Affiliates_Notifications_Extended::get_default( Affiliates_Notifications_Extended::DEFAULT_AFFILIATE_PENDING_TO_ACTIVE_MESSAGE ); $IX68246 = isset( $IX30254[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE] ) && $IX30254[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE]; $IX59113 = isset( $IX30254[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE_STATUS] ) ? $IX30254[Affiliates_Notifications_Extended::NOTIFY_AFFILIATE_STATUS] : array( AFFILIATES_REFERRAL_STATUS_ACCEPTED ); $IX22012 = isset( $IX30254[Affiliates_Notifications_Extended::SUBJECT] ) ? $IX30254[Affiliates_Notifications_Extended::SUBJECT] : Affiliates_Notifications_Extended::DEFAULT_SUBJECT; $IX29566 = isset( $IX30254[Affiliates_Notifications_Extended::MESSAGE] ) ? $IX30254[Affiliates_Notifications_Extended::MESSAGE] : Affiliates_Notifications_Extended::DEFAULT_MESSAGE; echo '<form action="" name="notifications" method="post">'; echo '<div class="notifications">'; echo '<div class="manage">'; echo '<h1>' . __( 'Registration', 'affiliates' ) . '</h1>'; echo '<div>' . '<p>' . '<label>' . '<input type="checkbox" name="' . Affiliates_Notifications_Extended::REGISTRATION_ENABLED . '" id="' . Affiliates_Notifications_Extended::REGISTRATION_ENABLED . '" ' . ( $IX58740 ? ' checked="checked" ' : '' ) . '/>' . __( 'Enable registration emails', 'affiliates' ) . '</label>' . '</p>' . '<p class="description">' . __( 'Send new affiliates an email when their user account is created.', 'affiliates' ) . ' ' . __( 'This should normally be enabled, so that new affiliates receive their username and password to be able to log in and access their account.', 'affiliates' ) . '</p>' . '<h2>' . __( 'Affiliate Notifications', 'affiliates' ) . '</h2>' . '<p>' . __( 'These templates are used to notify affiliates.', 'affiliates' ) . '</p>' . '<h3>' . __( 'Pending', 'affiliates' ) . '</h3>' . '<p>' . __( 'This notification is sent to new affiliates if their application is pending approval.', 'affiliates' ) . '</p>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT . '" name="' . Affiliates_Notifications_Extended::REGISTRATION_PENDING_SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX44343 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="' . Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE . '" id="' . Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE . '" name="' . Affiliates_Notifications_Extended::REGISTRATION_PENDING_MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX89238 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this affiliate notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . '<h3>' . __( 'Active', 'affiliates' ) . '</h3>' . '<p>' . __( 'This notification is sent to new affiliates if they are approved automatically.', 'affiliates' ) . '</p>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::REGISTRATION_SUBJECT . '" name="' . Affiliates_Notifications_Extended::REGISTRATION_SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX19816 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="' . Affiliates_Notifications_Extended::REGISTRATION_MESSAGE . '" id="' . Affiliates_Notifications_Extended::REGISTRATION_MESSAGE . '" name="' . Affiliates_Notifications_Extended::REGISTRATION_MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX78108 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this affiliate notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . '<h3>' . __( 'Status changed from Pending to Active', 'affiliates' ) . '</h3>' . '<p>' . __( 'This notification is sent to affiliates once they are approved.', 'affiliates' ) . '</p>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT . '" name="' . Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX45453 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="' . Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE . '" id="' . Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE . '" name="' . Affiliates_Notifications_Extended::AFFILIATE_PENDING_TO_ACTIVE_MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX63789 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this affiliate notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . '<p>' . wp_nonce_field( self::SETTINGS, self::NONCE, true, false ) . '<input class="button button-primary" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>' . '</div>' . '</div>'; echo '</div>'; echo '<div class="notifications">'; echo '<div class="manage">'; echo '<h1>' . __( 'Referrals', 'affiliates' ) . '</h1>'; echo '<p>' . __( 'Notifications for the affiliates can be enabled here. If the integration used provides its own notification settings, enable these through the integration&rsquo;s settings or here. Do not enable them both, as that could cause duplicate notifications to be sent.', 'affiliates' ) . '</p>'; echo '<div>' . '<h2>' . __( 'Referral Notifications', 'affiliates' ) . '</h2>' . '<p>' . '<label>' . '<input type="checkbox" name="' . Affiliates_Notifications_Extended::NOTIFY_AFFILIATE . '" id="' . Affiliates_Notifications_Extended::NOTIFY_AFFILIATE . '" ' . ( $IX68246 ? ' checked="checked" ' : '' ) . '/>' . __( 'Notify the affiliates', 'affiliates' ) . '</label>' . '</p>' . '<p class="description">' . __( 'Notifications will be sent to affiliates when credited with a referral.', 'affiliates' ) . '</p>' . '<p>' . __( 'Notify when a referral is: ', 'affiliates' ) . '<label>' . sprintf( '<input type="checkbox" name="notify_affiliate_status_accepted" %s />', in_array( AFFILIATES_REFERRAL_STATUS_ACCEPTED, $IX59113 ) ? ' checked="checked" ' : '' ) . __( 'Accepted', 'affiliates' ) . '</label>' . ' ' . '<label>' . sprintf( '<input type="checkbox" name="notify_affiliate_status_pending" %s />', in_array( AFFILIATES_REFERRAL_STATUS_PENDING, $IX59113 ) ? ' checked="checked" ' : '' ) . __( 'Pending', 'affiliates' ) . '</label>' . '</p>' . '<ul class="description">' . '<li>' . __( 'Notifications on referral status updates are only sent when the status changes from <em>pending</em> to <em>accepted</em>.', 'affiliates' ) . '</li>' . '<li>' . __( 'More than one notification may be sent if multiple statuses are enabled.', 'affiliates' ) . '</li>' . '<li>' . __( 'Notifications on referral status updates may not be supported by all integrations.', 'affiliates' ) . '</li>' . '</ul>' . '<p>' . '<label>' . __( 'Subject', 'affiliates' ) . '<br/>' . '<input class="' . Affiliates_Notifications_Extended::SUBJECT . '" name="' . Affiliates_Notifications_Extended::SUBJECT . '" type="text" value="' . esc_attr( stripslashes( $IX22012 ) ) . '" />' . '</label>' . '</p>' . '<p>' . '<label> ' . __( 'Message', 'affiliates' ) . '<br/>' . '<textarea class="' . Affiliates_Notifications_Extended::MESSAGE . '" id="' . Affiliates_Notifications_Extended::MESSAGE . '" name="' . Affiliates_Notifications_Extended::MESSAGE . '" rows="10">' . htmlentities( stripslashes( $IX29566 ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</textarea>' . '</label>' . '<br/>' . '<span class="description">' . __( 'The format for this affiliate notification is <strong>HTML</strong>.', 'affiliates' ) . '</span>' . '</p>' . '<p>' . wp_nonce_field( self::SETTINGS, self::NONCE, true, false ) . '<input class="button button-primary" type="submit" name="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '</p>' . '</div>' . '</div>'; echo '</div>'; echo '</form>'; }

	public static function load_page() { $IX26804 = get_current_screen(); if ( isset( $IX26804->id ) ) { switch ( $IX26804->id ) { case 'affiliates_page_affiliates-admin-notifications' : $IX26804->add_help_tab( array( 'id' => 'affiliates-admin-notifications-affiliate-registration', 'title' => __( 'Affiliate Registration', 'affiliates' ) , 'content' => self::get_notifications_help_affiliate_registration() ) ); $IX26804->add_help_tab( array( 'id' => 'affiliates-admin-notifications-referral-notifications', 'title' => __( 'Referral Notifications', 'affiliates' ) , 'content' => self::get_notifications_help_referral_notifications() ) ); break; } } }

	private static function get_notifications_help_affiliate_registration() { return '<div class="manage">' . '<h2>' . __( 'Affiliates Registration', 'affiliates' ) . '</h2>' . '<h3>' . __( 'Message format and tokens', 'affiliates' ) . '</h3>' . '<p class="description">' . __( 'The message format is HTML and line breaks must be indicated by <code>&lt;br/&gt;</code>.', 'affiliates' ) . '<p class="description">' . __( 'These default tokens can be used in the subjects and the messages:', 'affiliates' ) . '<ul>' . '<li><code>[site_title]</code> : '. wp_specialchars_decode( get_bloginfo( 'blogname' ), ENT_QUOTES ) . '</li>' . '<li><code>[site_url]</code> : '. htmlentities( home_url(), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</li>' . '<li><code>[site_login_url]</code> : '. htmlentities( wp_login_url(), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</li>' . '<li><code>[username]</code> : ' . __( 'The username for the new affiliate user account.', 'affiliates' ) . '</li>' . '<li><code>[password]</code> : '. __( 'The password for the new affiliate user account.', 'affiliates' ) . '</li>' . '<li><code>[user_id]</code> : '. __( 'The ID of the new affiliate user account. This is the user ID, not the affiliate ID.', 'affiliates' ) . '</li>' . '<li><code>[blogname]</code> : '. __( 'Same as [site_title].', 'affiliates' ) . '</li>' . '</ul>' . '</p>' . '<h3>' . __( 'Default subject and message', 'affiliates' ) . '</h4>' . '<p class="description">' . __( 'Subject:', 'affiliates' ) . '</p>' . '<pre>' . htmlentities( stripslashes( Affiliates_Notifications::get_default( Affiliates_Notifications::DEFAULT_REGISTRATION_ACTIVE_SUBJECT ) ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</pre>' . '<p class="description">' . __( 'Message:', 'affiliates' ) . '</p>' . '<pre>' . htmlentities( stripslashes( Affiliates_Notifications::get_default( Affiliates_Notifications::DEFAULT_REGISTRATION_ACTIVE_MESSAGE ) ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</pre>' . '</div>' . Affiliates_Admin_Menu_WordPress::get_help_tab_footer(); }

	private static function get_notifications_help_referral_notifications() { return '<div class="manage">' . '<h3>' . __( 'Message format and tokens', 'affiliates' ) . '</h3>' . '<p class="description">' . __( 'The message format is HTML and line breaks must be indicated by <code>&lt;br/&gt;</code>.', 'affiliates' ) . '<p class="description">' . __( 'These default tokens can be used in the subjects and the messages:', 'affiliates' ) . '<ul>' . '<li><code>[site_title]</code> : '. wp_specialchars_decode( get_bloginfo( 'blogname' ), ENT_QUOTES ) . '</li>' . '<li><code>[site_url]</code> : '. htmlentities( home_url(), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</li>' . '<li><code>[affiliate_id]</code> : ' . __( 'The referring affiliate&rsquo;s ID', 'affiliates' ) . '</li>' . '<li><code>[affiliate_email]</code> : '. __( 'The referring affiliate&rsquo;s email address', 'affiliates' ) . '</li>' . '<li><code>[affiliate_name]</code> : '. __( 'The referring affiliate&rsquo;s name', 'affiliates' ) . '</li>' . '<li><code>[referral_status]</code> : '. __( 'The current referral status', 'affiliates' ) . '</li>' . '<li><code>[referral_amount]</code> : '. __( 'The referral amount', 'affiliates' ) . '</li>' . '<li><code>[referral_currency_id]</code> : '. __( 'The referral currency ID', 'affiliates' ) . '</li>' . '<li><code>[referral_type]</code> : '. __( 'The referral type (an internal reference)', 'affiliates' ) . '</li>' . '<li><code>[referral_reference]</code> : '. __( 'The referral reference (an internal reference normally related to the originating transaction)', 'affiliates' ) . '</li>' . '</ul>' . '</p>' . '<p class="description">' . __( 'Integration-specific data tokens can also be used in the subject and message.', 'affiliates' ) . '</p>' . '<h4>' . __( 'Default subjects and messages', 'affiliates' ) . '</h4>' . '<p class="description">' . __( 'Administrator subject:', 'affiliates' ) . '</p>' . '<pre>' . htmlentities( Affiliates_Notifications_Extended::ADMIN_DEFAULT_SUBJECT, ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</pre>' . '<p class="description">' . __( 'Administrator message:', 'affiliates' ) . '</p>' . '<pre>' . htmlentities( stripslashes( Affiliates_Notifications_Extended::ADMIN_DEFAULT_MESSAGE ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</pre>' . '<p class="description">' . __( 'Affiliate subject:', 'affiliates' ) . '</p>' . '<pre>' . htmlentities( Affiliates_Notifications_Extended::DEFAULT_SUBJECT, ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</pre>' . '<p class="description">' . __( 'Affiliate message:', 'affiliates' ) . '</p>' . '<pre>' . htmlentities( stripslashes( Affiliates_Notifications_Extended::DEFAULT_MESSAGE ), ENT_COMPAT, get_bloginfo( 'charset' ) ) . '</pre>' . '</div>' . Affiliates_Admin_Menu_WordPress::get_help_tab_footer(); }

}
