<?php
/**
 * class-affiliates-admin-referral-ext.php
 *
 * Copyright (c) 2017 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 3.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Extends the referral editing form.
 */
class Affiliates_Admin_Referral_Ext {

	public static function init() { add_filter( 'affiliates_admin_referrals_expanded_items', array( __CLASS__, 'affiliates_admin_referrals_expanded_items' ), 10, 2 ); add_filter( 'affiliates_admin_referral_edit_add_referral', array( __CLASS__, 'affiliates_admin_referral_edit_add_referral' ), 10, 2 ); add_filter( 'affiliates_admin_referral_edit_update_referral', array( __CLASS__, 'affiliates_admin_referral_edit_update_referral' ), 10, 2 ); add_filter( 'affiliates_admin_referral_edit_form_suffix', array( __CLASS__, 'affiliates_admin_referral_edit_form_suffix' ), 10, 2 ); add_action( 'affiliates_deleted_referral', array( __CLASS__, 'affiliates_deleted_referral' ), 10, 1 ); }

	public static function affiliates_admin_referrals_expanded_items( $output, $params ) { $IX18924 = isset( $params['referral_id'] ) ? $params['referral_id'] : null; $IX63994 = isset( $params['expanded_items'] ) ? $params['expanded_items'] : null; $IX74723 = isset( $params['column_count'] ) ? $params['column_count'] : null; $IX33071 = isset( $params['i'] ) ? $params['i'] : null; if ( $IX63994 ) { $IX46863 = ''; $IX43526 = AFFILIATES_EXPANDER_RETRACT; } else { $IX46863 = ' style="display:none;" '; $IX43526 = AFFILIATES_EXPANDER_EXPAND; } $IX94360 = new Affiliates_Referral_WordPress(); if ( $IX94360->read( $IX18924 ) ) { $IX85981 = $IX94360->referral_items; if ( $IX85981 ) { $output .= '<tr class="items ' . ( $IX33071 % 2 == 0 ? 'even' : 'odd' ) . '">'; $output .= "<td colspan='$IX74723'>"; $output .= '<div class="view-toggle">'; $output .= "<div class='expander'>$IX43526</div>"; $output .= '<div class="view-toggle-label">' . __( 'Items', 'affiliates' ) . '</div>'; $output .= "<div class='view' $IX46863>"; $output .= '<table class="referral-items wp-list-table widefat fixed" cellspacing="0">'; $output .= '<thead>'; $output .= '<tr>'; $output .= '<th scope="col" class="referral_item_id">' . __( 'ID', 'affiliates' ) . '</th>'; $output .= '<th scope="col" class="reference">' . __( 'Reference', 'affiliates' ) . '</th>'; $output .= '<th scope="col" class="item_amount">' . __( 'Line Amount', 'affiliates' ) . '</th>'; $output .= '<th scope="col" class="amount">' . __( 'Amount', 'affiliates' ) . '</th>'; $output .= '<th scope="col" class="currency_id">' . __( 'Currency', 'affiliates' ) . '</th>'; $output .= '<th scope="col" class="rate_id">' . __( 'Rate', 'affiliates' ) . '</th>'; $output .= '</tr>'; $output .= '</thead>'; $output .= '<tbody>'; if ( is_array( $IX85981 ) ) { $IX93040 = new Affiliates_Rate(); foreach ( $IX85981 as $IX73182 ) { $output .= '<tr class="referral-item">'; $output .= '<td class="referral-item-id">'; $output .= intval( $IX73182->referral_item_id ); $output .= '</td>'; $output .= '<td class="referral-item-reference">'; $output .= stripslashes( wp_filter_nohtml_kses( $IX73182->reference ) ); $output .= '</td>'; $output .= '<td class="referral-item-line-amount">'; $output .= stripslashes( wp_filter_nohtml_kses( $IX73182->line_amount ) ); $output .= '</td>'; $output .= '<td class="referral-item-amount">'; $output .= stripslashes( wp_filter_nohtml_kses( $IX73182->amount ) ); $output .= '</td>'; $output .= '<td class="referral-item-currency">'; $output .= stripslashes( wp_filter_kses( $IX73182->currency_id ) ); $output .= '</td>'; $output .= '<td class="referral-item-rate_id">'; if ( $IX73182->rate_id ) { if ( $IX93040->read( $IX73182->rate_id ) ) { $IX33492 = $IX93040->value; if ( $IX93040->type === AFFILIATES_PRO_RATES_TYPE_FORMULA ) { $IX33492 = $IX93040->get_meta( 'formula' ); } $output .= sprintf( '#%d %s %s', intval( $IX93040->rate_id ), esc_html( $IX93040->type ), esc_html( $IX33492 ) ); } else { $output .= '#' . intval( $IX73182->rate_id ); } } $output .= '</td>'; $output .= '</tr>'; } } $output .= '</tbody>'; $output .= '</table>'; $output .= '</div>'; $output .= '</div>'; $output .= '</td>'; $output .= '</tr>'; } } return $output; }

	public static function affiliates_admin_referral_edit_add_referral( $add_referral, $params ) { $IX12073 = ''; $IX97471 = isset( $params['affiliate_id'] ) ? $params['affiliate_id'] : null; $IX69330 = isset( $params['datetime'] ) ? $params['datetime'] : null; $IX36544 = isset( $params['description'] ) ? $params['description'] : null; $IX87861 = isset( $params['reference_amount'] ) ? $params['reference_amount'] : null; $IX77040 = isset( $params['amount'] ) ? $params['amount'] : null; $IX42759 = isset( $params['currency_id'] ) ? $params['currency_id'] : null; $IX26014 = isset( $params['status'] ) ? $params['status'] : null; $IX85507 = isset( $params['reference'] ) ? $params['reference'] : null; $IX27175 = new Affiliates_Referral_WordPress(); $IX27175->affiliate_id = $IX97471; $IX27175->datetime = $IX69330; $IX27175->description = $IX36544; $IX27175->reference_amount = $IX87861; $IX27175->amount = $IX77040; $IX27175->currency_id = $IX42759; $IX27175->status = $IX26014; $IX27175->type = 'manual'; $IX27175->reference = $IX85507; $IX71209 = isset( $_POST['item_reference'] ) ? count( $_POST['item_reference'] ) : 0; $IX82333 = isset( $_POST['item_id'] ) ? $_POST['item_id'] : array(); $IX50303 = isset( $_POST['item_reference'] ) ? $_POST['item_reference'] : array(); $IX99214 = isset( $_POST['item_type'] ) ? $_POST['item_type'] : array(); $IX60666 = isset( $_POST['item_rate_id'] ) ? $_POST['item_rate_id'] : array(); $IX98590 = isset( $_POST['item_line_amount'] ) ? $_POST['item_line_amount'] : array(); $IX67930 = isset( $_POST['item_amount'] ) ? $_POST['item_amount'] : array(); $IX62110 = isset( $_POST['item_currency_id'] ) ? $_POST['item_currency_id'] : array(); $IX82333 = array_map( 'trim', $IX82333 ); $IX50303 = array_map( 'trim', $IX50303 ); $IX99214 = array_map( 'trim', $IX99214 ); $IX60666 = array_map( 'trim', $IX60666 ); $IX98590 = array_map( 'trim', $IX98590 ); $IX67930 = array_map( 'trim', $IX67930 ); $IX62110 = array_map( 'trim', $IX62110 ); $IX64683 = array(); for ( $IX62849=0; $IX62849 < $IX71209; $IX62849++ ) { $IX64683[] = new Affiliates_Referral_Item( array( 'reference' => $IX50303[$IX62849], 'type' => $IX99214[$IX62849], 'rate_id' => $IX60666[$IX62849], 'line_amount' => $IX98590[$IX62849], 'amount' => $IX67930[$IX62849], 'currency_id' => $IX42759 ) ); } $IX27175->referral_items = $IX64683; $IX27175->create(); return array( 'add_referral' => false, 'output' => $IX12073, 'referral_id' => $IX27175->referral_id ); }

	public static function affiliates_admin_referral_edit_update_referral( $update_referral, $params ) { $IX59270 = ''; $IX68666 = isset( $params['referral_id'] ) ? $params['referral_id'] : null; $IX59961 = isset( $params['affiliate_id'] ) ? $params['affiliate_id'] : null; $IX68914 = isset( $params['datetime'] ) ? $params['datetime'] : null; $IX34171 = isset( $params['description'] ) ? $params['description'] : null; $IX90475 = isset( $params['reference_amount'] ) ? $params['reference_amount'] : null; $IX81095 = isset( $params['amount'] ) ? $params['amount'] : null; $IX46743 = isset( $params['currency_id'] ) ? $params['currency_id'] : null; $IX81143 = isset( $params['status'] ) ? $params['status'] : null; $IX89134 = isset( $params['reference'] ) ? $params['reference'] : null; try { $IX70946 = new Affiliates_Referral_WordPress(); $IX70946->read( $IX68666 ); $IX31149 = isset( $_POST['item_reference'] ) ? count( $_POST['item_reference'] ) : 0; $IX90562 = !empty( $_POST['item_id'] ) ? $_POST['item_id'] : array(); $IX47607 = !empty( $_POST['item_reference'] ) ? $_POST['item_reference'] : array(); $IX76968 = !empty( $_POST['item_type'] ) ? $_POST['item_type'] : array(); $IX71368 = !empty( $_POST['item_rate_id'] ) ? $_POST['item_rate_id'] : array(); $IX37100 = !empty( $_POST['item_line_amount'] ) ? $_POST['item_line_amount'] : array(); $IX97926 = !empty( $_POST['item_amount'] ) ? $_POST['item_amount'] : array(); $IX49526 = !empty( $_POST['item_currency_id'] ) ? $_POST['item_currency_id'] : array(); $IX90562 = array_map( 'trim', $IX90562 ); $IX47607 = array_map( 'trim', $IX47607 ); $IX76968 = array_map( 'trim', $IX76968 ); $IX71368 = array_map( 'trim', $IX71368 ); $IX37100 = array_map( 'trim', $IX37100 ); $IX97926 = array_map( 'trim', $IX97926 ); $IX49526 = array_map( 'trim', $IX49526 ); $IX31937 = array(); for ( $IX16172=0; $IX16172 < $IX31149; $IX16172++ ) { $IX31937[] = new Affiliates_Referral_Item( array( 'referral_item_id' => !empty( $IX90562[$IX16172] ) ? intval( $IX90562[$IX16172] ) : null, 'reference' => !empty( $IX47607[$IX16172] ) ? $IX47607[$IX16172] : null, 'type' => !empty( $IX76968[$IX16172] ) ? $IX76968[$IX16172] : null, 'rate_id' => !empty( $IX71368[$IX16172] ) ? intval( $IX71368[$IX16172] ) : null, 'line_amount' => !empty( $IX37100[$IX16172] ) ? $IX37100[$IX16172] : null, 'amount' => !empty( $IX97926[$IX16172] ) ? $IX97926[$IX16172] : null, 'currency_id' => $IX46743, 'referral_id' => !empty( $IX68666 ) ? intval( $IX68666 ) : null ) ); } $IX70946->referral_items = $IX31937; $IX70946->affiliate_id = intval( $IX59961 ); $IX70946->datetime = $IX68914; $IX70946->description = $IX34171; $IX70946->reference_amount = $IX90475; $IX70946->amount = $IX81095; $IX70946->currency_id = $IX46743; $IX70946->status = $IX81143; $IX70946->reference = $IX89134; if ( $IX70946->update( array( 'affiliate_id' => intval( $IX59961 ), 'datetime' => $IX68914, 'description' => $IX34171, 'reference_amount' => $IX90475, 'amount' => $IX81095, 'currency_id' => $IX46743, 'status' => $IX81143, 'reference' => $IX89134 ) ) ) { $IX59270 .= '<br/>'; $IX59270 .= '<div class="info">' . __( 'The referral has been saved.', 'affiliates' ) . '</div>'; $IX28731 = true; } } catch ( Exception $IX59737 ) { $IX59270 .= '<br/>'; $IX59270 .= '<div class="error">' . __( 'The referral could not be saved.', 'affiliates' ) . '</div>'; } $IX51159[] = $IX59270; return array( 'update_referral' => false, 'output' => $IX59270 ); }

	public static function affiliates_admin_referral_edit_form_suffix( $output, $params ) { $IX45291 = isset( $params['referral_id'] ) ? $params['referral_id'] : null; $IX87753 = isset( $params['affiliate_id'] ) ? $params['affiliate_id'] : null; $IX20214 = isset( $params['datetime'] ) ? $params['datetime'] : null; $IX13667 = isset( $params['description'] ) ? $params['description'] : null; $IX52526 = isset( $params['reference_amount'] ) ? $params['reference_amount'] : null; $IX30768 = isset( $params['amount'] ) ? $params['amount'] : null; $IX35690 = isset( $params['currency_id'] ) ? $params['currency_id'] : null; $IX65211 = isset( $params['status'] ) ? $params['status'] : null; $IX97542 = isset( $params['reference'] ) ? $params['reference'] : null; $IX53841 = new Affiliates_Referral_WordPress(); $IX53841->read( $IX45291 ); $output .= '<h2>'; $output .= __( 'Referral Items', 'affiliates' ); $output .= '</h2>'; $output .= sprintf( '<span class="new-referral-item button" title="%s">', esc_attr( 'Add a new referral item to this referral.', 'affiliates' ) ); $output .= sprintf( '<img src="%s" alt="%s" class="img_add_item_action" style="vertical-align:middle;padding-bottom:2px;"/>', esc_url( AFFILIATES_PLUGIN_URL . 'images/add.png' ), esc_attr( __( 'New Referral Item', 'affiliates' ) ) ); $output .= ' '; $output .= __( 'New Referral Item', 'affiliates' ); $output .= '</span>'; $output .= '<br/><br/>'; $output .= '<table class="referral_items" id="referral_items">'; $output .= '<thead>'; $output .= '<th>'; $output .= __( 'ID', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= __( 'Reference', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= __( 'Type', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= __( 'Rate ID', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= __( 'Line Amount', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= __( 'Amount', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= __( 'Currency', 'affiliates' ); $output .= '</th>'; $output .= '<th>'; $output .= ''; $output .= '</th>'; $output .= '</thead>'; $IX48471 = 0; $output .= '<tbody>'; $output .= '<script type="text/javascript">'; $output .= 'affiliates_plugin_url = \'' . AFFILIATES_PLUGIN_URL . '\';'; $output .= 'affiliates_referral_item_remove_alt = \'' . __( 'Remove', 'affiliates' ) . '\';'; $output .= 'affiliates_referral_item_remove_title = \'' . __( 'Remove this referral item from the referral.', 'affiliates' ) . '\';'; $output .= '</script>'; if ( ( $IX53841->referral_items ) && ( sizeof( $IX53841->referral_items ) > 0 ) ) { foreach ( $IX53841->referral_items as $IX77525 ) { $output .= sprintf( '<tr id="row_%s">', $IX48471 ); $output .= '<td>'; $output .= esc_html( $IX77525->referral_item_id ); $output .= sprintf( '<input type="hidden" name="item_id[]" value="%s"></input>', esc_attr( $IX77525->referral_item_id ) ); $output .= '</td>'; $output .= '<td>'; $output .= sprintf( '<input type="text" name="item_reference[]" value="%s"></input>', esc_attr( $IX77525->reference ) ); $output .= '</td>'; $output .= '<td>'; $output .= sprintf( '<input type="text" name="item_type[]" value="%s"></input>', esc_attr( $IX77525->type ) ); $output .= '</td>'; $output .= '<td>'; $output .= sprintf( '<input type="text" name="item_rate_id[]" value="%s"></input>', esc_attr( $IX77525->rate_id ) ); $output .= '</td>'; $output .= '<td>'; $output .= sprintf( '<input type="text" name="item_line_amount[]" value="%s"></input>', esc_attr( $IX77525->line_amount ) ); $output .= '</td>'; $output .= '<td>'; $output .= sprintf( '<input type="text" name="item_amount[]" value="%s"></input>', esc_attr( $IX77525->amount ) ); $output .= '</td>'; $output .= '<td>'; $output .= sprintf( '<input type="text" name="item_currency_id[]" value="%s" readonly="readonly"></input>', esc_attr( $IX77525->currency_id ) ); $output .= '</td>'; $output .= '<td class="actions">'; $output .= sprintf( '<img src="%s" alt="%s" class="img_remove_action" row_id="%d" title="%s"/>', esc_url( AFFILIATES_PLUGIN_URL . 'images/remove.png' ), esc_attr( __( 'Remove', 'affiliates' ) ), esc_attr( $IX48471 ), esc_attr( __( 'Remove this referral item from the referral.', 'affiliates' ) ) ); $output .= '</td>'; $output .= '</tr>'; $IX48471++; } } $output .= '</tbody>'; $output .= '</table>'; $output .= '<input type="hidden" name="num_items" id="num_items" value="' . $IX48471 . '"></input>'; $output .= '<br/><br/>'; return $output; }

	public static function affiliates_deleted_referral( $referral_id ) { global $affiliates_db; $IX23014 = $affiliates_db->get_tablename( 'referral_items' ); $IX80694 = $affiliates_db->get_objects( "SELECT * FROM $IX23014 WHERE referral_id = %d", intval( $referral_id ) ); if ( count( $IX80694 ) > 0 ) { foreach( $IX80694 as $IX40210 ) { if ( $affiliates_db->query( "DELETE FROM $IX23014 WHERE referral_item_id = %d", intval( $IX40210->referral_item_id ) ) ) { do_action( 'affiliates_deleted_referral_item', intval( $IX40210->referral_item_id ), $IX40210 ); } } } }
}
Affiliates_Admin_Referral_Ext::init();
