<?php
/**
 * class-affiliates-affiliate-stats-renderer-wordpress.php
 * 
 * Copyright (c) 2011 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Stats renderer implementation.
 */
class Affiliates_Affiliate_Stats_Renderer_WordPress extends Affiliates_Affiliate_Stats_Renderer {

	const NONCE          = 'affiliate-stats-nonce';
	const NONCE_1        = 'affiliate-stats-nonce-1';
	const NONCE_2        = 'affiliate-stats-nonce-2';
	const NONCE_FILTERS  = 'affiliate-stats-nonce-filters';

	static function render_referrals( $options = array() ) { global $wpdb, $affiliates_options, $affiliates_db; $IX57740 = ''; $IX59437 = Affiliates_Affiliate_WordPress::get_user_affiliate_id(); if ( $IX59437 === false ) { return $IX57740; } $IX49763 = $affiliates_options->get_option( 'affiliate_stats_referrals_from_date', null ); $IX86968 = $affiliates_options->get_option( 'affiliate_stats_referrals_thru_date', null ); if ( isset( $_POST[self::NONCE_FILTERS] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE_FILTERS], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( isset( $_POST['clear_filters'] ) ) { $affiliates_options->delete_option( 'affiliate_stats_referrals_from_date' ); $affiliates_options->delete_option( 'affiliate_stats_referrals_thru_date' ); $IX49763 = null; $IX86968 = null; } else { if ( !empty( $_POST['from_date'] ) ) { $IX49763 = date( 'Y-m-d', strtotime( $_POST['from_date'] ) ); $affiliates_options->update_option( 'affiliate_stats_referrals_from_date', $IX49763 ); } if ( !empty( $_POST['thru_date'] ) ) { $IX86968 = date( 'Y-m-d', strtotime( $_POST['thru_date'] ) ); $affiliates_options->update_option( 'affiliate_stats_referrals_thru_date', $IX86968 ); } if ( $IX49763 && $IX86968 ) { if ( strtotime( $IX49763 ) > strtotime( $IX86968 ) ) { $IX86968 = null; $affiliates_options->delete_option( 'affiliate_stats_referrals_thru_date' ); } } } } if ( $IX49763 ) { $IX35124 = DateHelper::u2s( $IX49763 ); } if ( $IX86968 ) { $IX25635 = DateHelper::u2s( $IX86968, 24*3600 ); } if ( isset( $_POST['row_count'] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE_1], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } if ( isset( $_POST['paged'] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE_2], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } $IX16016 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX16016 = remove_query_arg( 'paged', $IX16016 ); $IX52432 = $affiliates_db->get_tablename( 'affiliates' ); $IX46889 = $affiliates_db->get_tablename( 'referrals' ); $IX75392 = $wpdb->prefix . 'posts'; $IX13885 = isset( $_POST['row_count'] ) ? intval( $_POST['row_count'] ) : 0; if ($IX13885 <= 0) { $IX13885 = $affiliates_options->get_option( 'affiliate_stats_referrals_per_page', self::AFFILIATES_STATS_PER_PAGE ); } else { $affiliates_options->update_option( 'affiliate_stats_referrals_per_page', $IX13885 ); } $IX37884 = isset( $_REQUEST['paged'] ) ? intval( $_REQUEST['paged'] ) : 1; if ( !isset( $_REQUEST['paged'] ) ) { $IX37884 = intval( get_query_var( 'paged' ) ); } if ( $IX37884 < 1 ) { $IX37884 = 1; } $IX87012 = isset( $_GET['orderby'] ) ? $_GET['orderby'] : null; switch ( $IX87012 ) { case 'referral_id' : case 'reference' : case 'datetime' : case 'post_title' : case 'amount' : case 'currency_id' : case 'status' : break; default : $IX87012 = 'datetime'; } $IX62372 = isset( $_GET['order'] ) ? $_GET['order'] : null; switch ( $IX62372 ) { case 'asc' : case 'ASC' : $IX14099 = 'DESC'; break; case 'desc' : case 'DESC' : $IX14099 = 'ASC'; break; default: $IX62372 = 'DESC'; $IX14099 = 'ASC'; } if ( $IX49763 || $IX86968 || $IX59437 ) { $IX61697 = " WHERE "; } else { $IX61697 = ''; } $IX84624 = array(); if ( $IX49763 && $IX86968 ) { $IX61697 .= " datetime >= %s AND datetime < %s "; $IX84624[] = $IX35124; $IX84624[] = $IX25635; } else if ( $IX49763 ) { $IX61697 .= " datetime >= %s "; $IX84624[] = $IX35124; } else if ( $IX86968 ) { $IX61697 .= " datetime < %s "; $IX84624[] = $IX25635; } if ( $IX59437 ) { if ( $IX49763 || $IX86968 ) { $IX61697 .= " AND "; } $IX61697 .= " r.affiliate_id = %d "; $IX84624[] = $IX59437; } $IX94719 = isset( $options['show_accepted'] ) && ( ( $options['show_accepted'] === true ) || ( $options['show_accepted'] == 'true' ) ); $IX35171 = isset( $options['show_pending'] ) && ( ( $options['show_pending'] === true ) || ( $options['show_pending'] == 'true' ) ); $IX89578 = isset( $options['show_closed'] ) && ( ( $options['show_closed'] === true ) || ( $options['show_closed'] == 'true' ) ); $IX69549 = isset( $options['show_rejected'] ) && ( ( $options['show_rejected'] === true ) || ( $options['show_rejected'] == 'true' ) ); $IX81777 = 0; if ( $IX94719 ) { $IX81777++; $IX84624[] = AFFILIATES_REFERRAL_STATUS_ACCEPTED; } if ( $IX35171 ) { $IX81777++; $IX84624[] = AFFILIATES_REFERRAL_STATUS_PENDING; } if ( $IX89578 ) { $IX81777++; $IX84624[] = AFFILIATES_REFERRAL_STATUS_CLOSED; } if ( $IX69549 ) { $IX81777++; $IX84624[] = AFFILIATES_REFERRAL_STATUS_REJECTED; } if ( $IX49763 || $IX86968 || $IX59437 ) { $IX61697 .= " AND "; } switch ( $IX81777 ) { case 1 : $IX61697 .= " r.status = %s "; break; case 2 : $IX61697 .= " r.status IN ( %s, %s ) "; break; case 3 : $IX61697 .= " r.status IN ( %s, %s, %s ) "; break; case 4 : $IX61697 .= " r.status IN ( %s, %s, %s, %s ) "; break; default : $IX61697 .= " r.status = '' "; } do { $IX67553 = false; $IX43004 = ( $IX37884 - 1 ) * $IX13885; $IX38139 = $wpdb->prepare( "SELECT SQL_CALC_FOUND_ROWS r.* " . "FROM $IX46889 r " . "LEFT JOIN $IX52432 a ON r.affiliate_id = a.affiliate_id " . "LEFT JOIN $IX75392 p ON r.post_id = p.ID " . "$IX61697 " . "ORDER BY $IX87012 $IX62372 " . "LIMIT $IX13885 OFFSET $IX43004", $IX84624 ); $IX71810 = $wpdb->get_results( $IX38139, OBJECT ); $IX50315 = intval( $wpdb->get_var( "SELECT FOUND_ROWS()" ) ); if ( $IX50315 > $IX13885 ) { $IX75402 = true; } else { $IX75402 = false; } $IX74738 = max( array( 1, ceil( $IX50315 / $IX13885 ) ) ); if ( $IX37884 > $IX74738 ) { $IX37884 = $IX74738; $IX67553 = true; } } while ( $IX67553 ); $IX57740 .= '<div class="affiliate-stats referrals">'; $IX57740 .= '<div class="page-options">' . '<form id="setrowcount" action="" method="post">' . '<div>' . '<label for="row_count">' . __('Results per page', 'affiliates' ) . '</label>' . '<input name="row_count" type="text" size="2" value="' . esc_attr( $IX13885 ) . '" />' . wp_nonce_field( plugin_basename( __FILE__ ), self::NONCE_1, true, false ) . '<input type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>' . '</div>' . '</form>' . '</div>'; if ( $IX75402 ) { $IX68865 = new Affiliates_Pagination( $IX50315, null, $IX13885 ); $IX57740 .= '<form id="posts-filter" method="post" action="">'; $IX57740 .= '<div>'; $IX57740 .= wp_nonce_field( plugin_basename( __FILE__ ), self::NONCE_2, true, false ); $IX57740 .= '</div>'; $IX57740 .= '<div class="tablenav top">'; $IX57740 .= $IX68865->pagination( 'top' ); $IX57740 .= '</div>'; $IX57740 .= '</form>'; } $IX77745 = isset( $options['show_post'] ) && ( ( $options['show_post'] === true ) || ( $options['show_post'] == 'true' ) ); $IX97446 = isset( $options['show_referral_id'] ) && ( ( $options['show_referral_id'] === true ) || ( $options['show_referral_id'] == 'true' ) ); $IX49691 = isset( $options['show_reference'] ) && ( ( $options['show_reference'] === true ) || ( $options['show_reference'] == 'true' ) ); $IX85225 = array( 'datetime' => __( 'Date', 'affiliates' ) ); if ( $IX97446 ) { $IX85225['referral_id'] = __( 'ID', 'affiliates' ); } if ( $IX49691 ) { $IX85225['reference'] = __( 'Reference', 'affiliates' ); } if ( $IX77745 ) { $IX85225['post_title'] = __( 'Post', 'affiliates' ); } $IX97678 = isset( $options['show_amount'] ) && ( ( $options['show_amount'] === true ) || ( $options['show_amount'] == 'true' ) ); if ( $IX97678 ) { $IX85225['amount'] = __( 'Amount', 'affiliates' ); } $IX29106 = isset( $options['show_currency_id'] ) && ( ( $options['show_currency_id'] === true ) || ( $options['show_currency_id'] == 'true' ) ); if ( $IX29106 ) { $IX85225['currency_id'] = __( 'Currency', 'affiliates' ); } $IX86693 = isset( $options['show_status'] ) && ( ( $options['show_status'] === true ) || ( $options['show_status'] == 'true' ) ); if ( $IX86693 ) { $IX85225['status'] = __( 'Status', 'affiliates' ); } if ( !empty( $options['data'] ) ) { $IX85225['data'] = __( 'Details', 'affiliates' ); } $IX85225 = apply_filters( 'affiliates_affiliate_stats_renderer_column_display_names', $IX85225 ); $IX82292 = count( $IX85225 ); $IX57740 .= '<table class="referrals" cellspacing="0" cellpadding="0">'; $IX57740 .= '<thead>'; $IX57740 .= '<tr>'; foreach ( $IX85225 as $IX49050 => $IX52462 ) { $IX97029 = array( 'orderby' => $IX49050, 'order' => $IX14099 ); if ( in_array( $IX49050, array( 'referral_id', 'reference', 'datetime', 'post_title', 'amount', 'currency_id', 'status' ) ) ) { $IX97913 = ""; if ( strcmp( $IX49050, $IX87012 ) == 0 ) { $IX84428 = strtolower( $IX62372 ); $IX97913 = "$IX49050 manage-column sorted $IX84428"; } else { $IX97913 = "$IX49050 manage-column sortable"; } $IX52462 = '<a href="' . esc_url( add_query_arg( $IX97029, $IX16016 ) ) . '"><span>' . $IX52462 . '</span><span class="sorting-indicator"></span></a>'; $IX57740 .= "<th scope='col' class='$IX97913'>$IX52462</th>"; } else { $IX57740 .= "<th scope='col' class='$IX49050'>$IX52462</th>"; } } $IX57740 .= '</tr>'; $IX57740 .= '</thead>'; $IX57740 .= '<tbody>'; if ( count( $IX71810 ) > 0 ) { $IX99688 = array(); if ( !empty( $options['data'] ) ) { $IX14339 = explode(",", $options['data'] ); if ( !empty( $IX14339 ) ) { foreach( $IX14339 as $IX73164 ) { $IX99688[] = trim( $IX73164 ); } } } $IX75472 = array( AFFILIATES_REFERRAL_STATUS_ACCEPTED => __( 'Accepted', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_CLOSED => __( 'Closed', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_PENDING => __( 'Pending', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_REJECTED => __( 'Rejected', AFFILIATES_PLUGIN_DOMAIN ), ); for ( $IX83543 = 0; $IX83543 < count( $IX71810 ); $IX83543++ ) { $IX72665 = $IX71810[$IX83543]; $IX57740 .= '<tr class="details-referrals ' . ( $IX83543 % 2 == 0 ? 'even' : 'odd' ) . '">'; foreach( $IX85225 as $IX49050 => $IX52462 ) { switch( $IX49050 ) { case 'referral_id' : $IX57740 .= '<td class="referral_id">' . wp_filter_nohtml_kses( $IX72665->referral_id ) . '</td>'; break; case 'reference' : $IX57740 .= '<td class="reference">' . wp_filter_nohtml_kses( $IX72665->reference ) . '</td>'; break; case 'datetime' : $IX57740 .= '<td class="datetime">' . DateHelper::s2u( $IX72665->datetime ) . '</td>'; break; case 'post_title' : if ( $IX77745 ) { if ( !empty( $IX72665->post_id ) ) { $IX86588 = get_permalink( $IX72665->post_id ); $IX14740 = get_the_title( $IX72665->post_id ); $IX57740 .= '<td class="post_title"><a href="' . esc_attr( $IX86588 ) . '" target="_blank">' . wp_filter_nohtml_kses( $IX14740 ) . '</a></td>'; } else { $IX57740 .= '<td class="post_title"></td>'; } } break; case 'amount' : if ( $IX97678 ) { $IX57740 .= '<td class="amount">' . esc_attr( $IX72665->amount ) . '</td>'; } break; case 'currency_id' : if ( $IX29106 ) { $IX57740 .= '<td class="currency_id">' . esc_attr( $IX72665->currency_id ) . '</td>'; } break; case 'status' : if ( $IX86693 ) { $IX57740 .= '<td class="status">' . ( isset( $IX75472[$IX72665->status] ) ? $IX75472[$IX72665->status] : esc_attr( $IX72665->status ) ) . '</td>'; } break; case 'data' : if ( !empty( $IX99688 ) ) { $IX30152 = $IX72665->data; if ( !empty( $IX30152 ) ) { $IX30152 = unserialize( $IX30152 ); } else { $IX30152 = array(); } $IX30152 = apply_filters( 'affiliates_affiliate_stats_renderer_data', $IX30152, $IX72665 ); $IX57740 .= '<td>'; if ( $IX30152 ) { $IX47107 = ''; if ( is_array( $IX30152 ) ) { foreach ( $IX99688 as $IX49050 ) { if ( isset( $IX30152[$IX49050] ) ) { $IX66873 = $IX30152[$IX49050]; $IX74702 = __( $IX66873['title'], $IX66873['domain'] ); $IX17401 = $IX66873['value']; $IX47107 .= '<div class="referral-data-title">'; $IX47107 .= stripslashes( wp_filter_nohtml_kses( $IX74702 ) ); $IX47107 .= '</div>'; $IX47107 .= '<div class="referral-data-value">'; $IX47107 .= stripslashes( wp_filter_nohtml_kses( $IX17401 ) ); $IX47107 .= '</div>'; } } } else { if ( !empty( $IX99688 ) && ( $IX99688[0] == 'data' ) ) { $IX47107 .= '<div class="referral-data-value">'; $IX47107 .= stripslashes( wp_filter_nohtml_kses( $IX30152 ) ); $IX47107 .= '</div>'; } } $IX57740 .= apply_filters( 'affiliates_affiliate_stats_renderer_data_output', $IX47107, $IX72665 ); } $IX57740 .= '</td>'; } break; default : $IX57740 .= sprintf( '<td class="%s">', esc_attr( $IX49050 ) ); $IX57740 .= apply_filters( 'affiliates_affiliate_stats_renderer_column_output', '', $IX49050, $IX72665 ); $IX57740 .= '</td>'; } } $IX57740 .= '</tr>'; } } else { $IX57740 .= '<tr><td colspan="' . $IX82292 . '">' . __('There are no results.', 'affiliates' ) . '</td></tr>'; } $IX57740 .= '</tbody>'; $IX57740 .= '</table>'; if ( $IX75402 ) { $IX68865 = new Affiliates_Pagination( $IX50315, null, $IX13885 ); $IX57740 .= '<div class="tablenav bottom">'; $IX57740 .= $IX68865->pagination( 'bottom' ); $IX57740 .= '</div>'; } $IX57740 .= '<div class="filters">' . '<label class="description" for="setfilters">' . __( 'Filters', 'affiliates' ) . '</label>' . '<form id="setfilters" action="" method="post">' . '<div class="from-date">' . '<label class="from-date-filter" for="from_date">' . __('From', 'affiliates' ) . '</label>' . '<input class="datefield from-date-filter" name="from_date" type="text" value="' . esc_attr( $IX49763 ) . '"/>'. '</div>' . '<div class="thru-date">' . '<label class="thru-date-filter" for="thru_date">' . __('Until', 'affiliates' ) . '</label>' . '<input class="datefield thru-date-filter" name="thru_date" type="text" class="datefield" value="' . esc_attr( $IX86968 ) . '"/>'. '</div>' . '<div class="submit">' . wp_nonce_field( plugin_basename( __FILE__ ), self::NONCE_FILTERS, true, false ) . '<input type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>' . '<input type="submit" name="clear_filters" value="' . __( 'Clear', 'affiliates' ) . '"/>' . '<input type="hidden" value="submitted" name="submitted"/>' . '</div>' . '</form>' . '</div>'; $IX57740 .= '</div>'; return $IX57740; }
}
