<?php
/**
 * class-affiliates-affiliate-wordpress.php
 * 
 * Copyright (c) 2010, 2011 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Provides affiliate editing form and update functions.
 */
class Affiliates_Affiliate_WordPress extends Affiliates_Affiliate {

	public static function get_user_affiliate_id( $user_id = null ) { global $affiliates_db; $IX61464 = false; $IX71009 = null; if ( $user_id === null ) { if ( is_user_logged_in() ) { $IX71009 = wp_get_current_user(); } } else { $IX71009 = get_user_by( 'id', $user_id ); } if ( $IX71009 ) { $IX61464 = parent::get_user_affiliate_id( $IX71009->ID ); } return $IX61464; }

	public static function update_name( $affiliate_id, $name ) { global $affiliates_db; $IX62791 = false; $IX87160 = self::get_affiliate( $affiliate_id ); if ( $IX87160 ) { $name = Affiliates_Utility::filter( $name ); if ( !empty( $name ) ) { $IX66803 = $IX87160->name; if ( $IX66803 != $name ) { $IX27220 = $affiliates_db->get_tablename( 'affiliates' ); if ( $affiliates_db->query( "UPDATE $IX27220 SET name = %s WHERE affiliate_id = %d", $name, $affiliate_id ) ) { $IX62791 = $name; do_action( 'affiliates_updated_name', $affiliate_id, $IX66803, $name ); do_action( 'affiliates_updated_affiliate', intval( $affiliate_id ) ); } } } } return $IX62791; }

	public static function update_email( $affiliate_id, $email ) { global $affiliates_db; $IX61276 = false; $IX68731 = self::get_affiliate( $affiliate_id ); if ( $IX68731 ) { if ( $email = Affiliates_Validator::validate_email( $email ) ) { $IX99254 = $IX68731->email; if ( $IX99254 != $email ) { $IX53169 = $affiliates_db->get_tablename( 'affiliates' ); if ( $affiliates_db->query( "UPDATE $IX53169 SET email = %s WHERE affiliate_id = %d", $email, $affiliate_id ) ) { $IX61276 = $email; do_action( 'affiliates_updated_email', $affiliate_id, $IX99254, $email ); do_action( 'affiliates_updated_affiliate', intval( $affiliate_id ) ); } } } } return $IX61276; }

	public static function update_attribute( $affiliate_id, $key, $value ) { global $affiliates_db; $IX13890 = false; $IX67050 = self::get_affiliate( $affiliate_id ); if ( $IX67050 && Affiliates_Attributes::validate_key( $key ) ) { if ( $value = Affiliates_Attributes::validate_value( $key, $value ) ) { $IX50952 = $affiliates_db->get_tablename( 'affiliates_attributes' ); $IX55066 = $affiliates_db->get_value( "SELECT attr_value FROM $IX50952 WHERE affiliate_id = %d AND attr_key = %s", $affiliate_id, $key ); if ( $IX55066 != $value ) { if ( $affiliates_db->query( "INSERT INTO $IX50952 SET affiliate_id = %d, attr_key = %s, attr_value = %s ON DUPLICATE KEY UPDATE attr_value = %s", $affiliate_id, $key, $value, $value ) ) { $IX13890 = $value; do_action( 'affiliates_updated_attribute', $affiliate_id, $key, $IX55066, $value ); do_action( 'affiliates_updated_affiliate', intval( $affiliate_id ) ); } } } } return $IX13890; }

	function edit( $affiliate_id ) { global $wpdb; if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX28531 = affiliates_get_affiliate( intval( $affiliate_id ) ); if ( empty( $IX28531 ) ) { wp_die( __( 'No such affiliate.', 'affiliates' ) ); } $IX26699 = _affiliates_get_tablename( 'affiliates_users' ); $IX19390 = null; $IX75600 = ''; $IX44590 = ''; $IX46187 = $wpdb->get_var( $wpdb->prepare( "SELECT user_id FROM $IX26699 WHERE affiliate_id = %d", intval( $affiliate_id ) ) ); if ( $IX46187 !== null ) { $IX19390 = get_user_by( 'id', intval( $IX46187 ) ); if ( $IX19390 ) { if ( current_user_can( 'edit_user', $IX19390->ID ) ) { $IX75600 = sprintf( __( 'Edit %s', 'affiliates' ) , '<a target="_blank" href="' . esc_url( "user-edit.php?user_id=$IX19390->ID" ) . '">' . $IX19390->user_login . '</a>' ); } require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings.php'; require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings-registration.php'; $IX57124 = Affiliates_Settings_Registration::get_fields(); foreach( Affiliates_Registration::get_skip_meta_fields() as $IX16446 ) { unset( $IX57124[$IX16446] ); } foreach( $IX57124 as $IX47798 => $IX43833 ) { if ( $IX43833['enabled'] ) { $IX44590 .= '<div class="field">'; $IX44590 .= '<label>'; $IX44590 .= esc_html( stripslashes( $IX43833['label'] ) ); $IX44590 .= ' '; $IX73699 = isset( $IX43833['type'] ) ? $IX43833['type'] : 'text'; $IX92078 = get_user_meta( $IX19390->ID, $IX47798 , true ); $IX44590 .= sprintf( '<input type="text" value="%s" readonly="readonly" />', esc_attr( stripslashes( $IX92078 ) ) ); $IX44590 .= '</label>'; $IX44590 .= '</div>'; } } } } $IX44401 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX44401 = remove_query_arg( 'action', $IX44401 ); $IX44401 = remove_query_arg( 'affiliate_id', $IX44401 ); $IX47798 = isset( $_POST['name-field'] ) ? $_POST['name-field'] : $IX28531['name']; $IX66659 = isset( $_POST['email-field'] ) ? $_POST['email-field'] : $IX28531['email']; $IX40012 = isset( $_POST['user-field'] ) ? $_POST['user-field'] : ( $IX19390 != null ? $IX19390->user_login : '' ); $IX51241 = isset( $_POST['from-date-field'] ) ? $_POST['from-date-field'] : $IX28531['from_date']; $IX75841 = isset( $_POST['thru-date-field'] ) ? $_POST['thru-date-field'] : $IX28531['thru_date']; $IX78647 = isset( $_POST['status'] ) ? $_POST['status'] : $IX28531['status']; $IX62429 = ''; if ( isset( $_POST['errors'] ) && is_array( $_POST['errors'] ) ) { $IX38867 = array(); foreach( $_POST['errors'] as $IX99201 ) { switch ( $IX99201 ) { case AFFILIATES_ADMIN_AFFILIATES_ERROR_NAME_EMPTY : $IX38867[] = __( 'Name can not be empty.', 'affiliates' ); break; case AFFILIATES_ADMIN_AFFILIATES_ERROR_USERNAME : $IX38867[] = __( 'The username does not exist.', 'affiliates' ); break; default: $IX38867[] = __( 'Something went wrong.', 'affiliates' ); break; } } $IX62429 .= '<div class="updated error">'; $IX62429 .= implode( '<br/>', $IX38867 ); $IX62429 .= '</div>'; } $IX96244 = '<div class="manage-affiliates">' . '<div>' . '<h1>' . __( 'Edit an affiliate', 'affiliates' ) . '</h1>' . '</div>' . $IX62429 . '<form id="edit-affiliate" action="' . esc_url( $IX44401 ) . '" method="post">' . '<div class="affiliate edit">' . '<input id="affiliate-id-field" name="affiliate-id-field" type="hidden" value="' . esc_attr( intval( $affiliate_id ) ) . '"/>' . '<div class="field">' . '<label class="field-label first required">' . '<span class="label">' . __( 'Name', 'affiliates' ) . '</span>' . ' ' . '<input id="name-field" name="name-field" class="namefield" type="text" value="' . esc_attr( stripslashes( $IX47798 ) ) . '"/>' . '</label>' . '</div>' . '<div class="field">' . '<label for="email-field" class="field-label">' . '<span class="label">' . __( 'Email', 'affiliates' ) . '</span>' . ' ' . '<input id="email-field" name="email-field" class="emailfield" type="text" value="' . esc_attr( $IX66659 ) . '"/>' . '</label>' . ' ' . '<span class="description">' . __( "If a valid <strong>Username</strong> is specified and no email is given, the user's email address will be used automatically.", 'affiliates' ) . '</span>' . '</div>' . '<div class="field">' . '<label for="user-field" class="field-label">' . '<span class="label">' . __( 'Username', 'affiliates' ) . '</span>' . ' ' . '<input id="user-field" name="user-field" class="userfield" type="text" value="' . esc_attr( stripslashes( $IX40012 ) ) . '"/>' . '</label>' . ' ' . $IX75600 . '</div>' . $IX44590 . '<div class="field">' . '<label class="field-label first">' . '<span class="label">' . __( 'From', 'affiliates' ) . '</span>' . ' ' . '<input id="from-date-field" name="from-date-field" class="datefield" type="text" value="' . esc_attr( $IX51241 ) . '"/>' . '</label>' . '</div>' . '<div class="field">' . '<label class="field-label">' . '<span class="label">' . __( 'Until', 'affiliates' ) . '</span>' . ' ' . '<input id="thru-date-field" name="thru-date-field" class="datefield" type="text" value="' . esc_attr( $IX75841 ) . '"/>' . '</label>' . '</div>'; $IX96244 .= '<div class="field">' . '<label class="field-label">' . '<span class="label">' . __( 'Status', 'affiliates' ) . '</span>' . ' ' . '<select id="status" name="status" class="datafield">' . '<option value="active" ' . ( $IX78647 == 'active' ? 'selected="selected"' : '' ) . ' >' . __('Accepted', 'affiliates') . '</option>' . '<option value="pending" ' . ( $IX78647 == 'pending' ? 'selected="selected"' : '' ) . ' >' . __('Pending', 'affiliates') . '</option>' . '<option value="deleted" ' . ( $IX78647 == 'deleted' ? 'selected="selected"' : '' ) . ' >' . __('Deleted', 'affiliates') . '</option>' . '</select>' . '</label>' . '</div>'; $IX96244 .= '<div class="field">' . wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_NONCE, true, false ) . '<input class="button button-primary" type="submit" value="' . __( 'Save', 'affiliates' ) . '"/>' . '<input type="hidden" value="edit" name="action"/>' . ' ' . '<a class="button" class="cancel" href="' . esc_url( $IX44401 ) . '">' . __( 'Cancel', 'affiliates' ) . '</a>' . '</div>' . '</div>' . '</form>' . '</div>'; echo $IX96244; do_action( 'affiliates_after_edit_affiliate_form', $affiliate_id ); $IX28883 = new Affiliates_Attributes_WordPress(); $IX28883->view( $affiliate_id ); do_action( 'affiliates_after_edit_affiliate_attributes', $affiliate_id ); affiliates_footer(); }

	function edit_submit() { global $wpdb; $IX17717 = array(); if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_NONCE], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX33353 = _affiliates_get_tablename( 'affiliates' ); $IX52415 = _affiliates_get_tablename( 'affiliates_users' ); $IX50025 = isset( $_POST['affiliate-id-field'] ) ? $_POST['affiliate-id-field'] : null; $IX27294 = false; $IX51533 = null; if ( $IX51533 = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $IX33353 WHERE affiliate_id = %d", intval( $IX50025 ) ) ) ) { $IX27294 = isset( $IX51533->type ) && ( $IX51533->type == AFFILIATES_DIRECT_TYPE ); } if ( empty( $IX51533 ) ) { wp_die( __( 'No such affiliate.', 'affiliates' ) ); } $IX50166 = self::get_affiliate( $IX50025 ); $IX57275 = isset( $_POST['name-field'] ) ? trim( $_POST['name-field'] ) : null; if ( $IX27294 ) { $IX57275 = AFFILIATES_DIRECT_NAME; } if ( empty( $IX57275 ) ) { $IX17717['errors'][] = AFFILIATES_ADMIN_AFFILIATES_ERROR_NAME_EMPTY; } $IX95346 = true; if ( !empty( $_POST['user-field'] ) ) { $IX17169 = trim( $_POST['user-field'] ); if ( !empty( $IX17169 ) ) { if ( !get_user_by( 'login', $IX17169 ) ) { $IX95346 = false; $IX17717['errors'][] = AFFILIATES_ADMIN_AFFILIATES_ERROR_USERNAME; } } } if ( !empty( $IX57275 ) && $IX95346 ) { $IX21355 = array( 'name' => $IX57275 ); $IX85787 = array( '%s' ); $IX96878 = trim( $_POST['email-field'] ); if ( is_email( $IX96878 ) ) { $IX21355['email'] = $IX96878; $IX85787[] = '%s'; } else { $IX21355['email'] = null; $IX85787[] = 'NULL'; } $IX25783 = $_POST['from-date-field']; if ( empty( $IX25783 ) ) { $IX25783 = date( 'Y-m-d', time() ); } else { $IX25783 = date( 'Y-m-d', strtotime( $IX25783 ) ); } $IX21355['from_date'] = $IX25783; $IX85787[] = '%s'; $IX77968 = $_POST['thru-date-field']; if ( !empty( $IX77968 ) && strtotime( $IX77968 ) < strtotime( $IX25783 ) ) { $IX77968 = null; } if ( !empty( $IX77968 ) ) { $IX77968 = date( 'Y-m-d', strtotime( $IX77968 ) ); $IX21355['thru_date'] = $IX77968; $IX85787[] = '%s'; } else { $IX21355['thru_date'] = null; $IX85787[] = 'NULL'; } $IX30085 = $_POST['status']; $IX60010 = $IX51533->status; if ( empty( $IX30085 ) ) { $IX30085 = get_option( 'aff_status', 'active' ); } $IX21355['status'] = $IX30085; $IX85787[] = '%s'; $IX43482 = array(); $IX33378 = array(); $IX86236 = 0; foreach( $IX21355 as $IX55002 => $IX77113 ) { $IX43482[] = $IX55002 . ' = ' . $IX85787[$IX86236]; if ( $IX77113 ) { $IX33378[] = $IX77113; } $IX86236++; } if ( !empty( $IX43482 ) ) { $IX43482 = implode( ', ', $IX43482 ); $IX33378[] = intval( $IX50025 ); $IX26612 = $wpdb->prepare( "UPDATE $IX33353 SET $IX43482 WHERE affiliate_id = %d", $IX33378 ); $wpdb->query( $IX26612 ); } $IX93085 = $wpdb->get_row( $wpdb->prepare(" SELECT affiliate_id, user_id, user_login FROM $IX52415 LEFT JOIN $wpdb->users ON $IX52415.user_id = $wpdb->users.ID WHERE affiliate_id = %d", intval( $IX50025 ) ) ); $IX30247 = trim( $_POST['user-field'] ); if ( ( empty( $IX30247 ) && !empty( $IX93085 ) ) || ( !empty( $IX93085 ) && ( strcmp( $IX93085->user_login, $IX30247 ) !== 0 ) ) ) { $wpdb->query( $wpdb->prepare( "DELETE FROM $IX52415 WHERE affiliate_id = %d", intval( $IX50025 ) ) ); } if ( !empty( $IX50025 ) && !empty( $IX30247 ) && ( empty( $IX93085 ) || ( !empty( $IX93085 ) && ( strcmp( $IX93085->user_login, $IX30247 ) !== 0 ) ) ) ) { $IX36355 = get_user_by( 'login', $IX30247 ); if ( !empty( $IX36355 ) ) { if ( $wpdb->query( $wpdb->prepare( "INSERT INTO $IX52415 SET affiliate_id = %d, user_id = %d", intval( $IX50025 ), intval( $IX36355->ID ) ) ) ) { if ( empty( $IX96878 ) && !empty( $IX36355->user_email ) ) { $wpdb->query( $wpdb->prepare( "UPDATE $IX33353 SET email = %s WHERE affiliate_id = %d", $IX36355->user_email, $IX50025 ) ); } } } } $IX98396 = self::get_affiliate( $IX50025 ); if ( $IX50166->name != $IX98396->name ) { do_action( 'affiliates_updated_name', $IX50025, $IX50166->name, $IX98396->name ); } if ( $IX50166->email != $IX98396->email ) { do_action( 'affiliates_updated_email', $IX50025, $IX50166->email, $IX98396->email ); } if ( !empty( $IX50025 ) ) { do_action( 'affiliates_updated_affiliate', intval( $IX50025 ) ); if ( !empty( $IX30085 ) ) { do_action( 'affiliates_updated_affiliate_status', intval( $IX50025 ), $IX60010, $IX30085 ); } } } return $IX17717; }

}
