<?php
/**
 * class-affiliates-affiliates-wordpress.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * System-specific affiliates implementation.
 */
class Affiliates_Affiliates_WordPress extends Affiliates_Affiliates {

	public function view() { global $wpdb, $wp_rewrite, $affiliates_options; global $affiliates_db; $IX56584 = ''; $IX83807 = date( 'Y-m-d', time() ); $IX55581 = get_option( 'aff_pname', AFFILIATES_PNAME ); if ( !current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } $IX16673 = ''; if ( isset( $_POST['action'] ) ) { $IX27181 = ''; switch( $_POST['action'] ) { case 'add' : $IX27747 = affiliates_admin_affiliates_add_submit(); if ( !empty( $IX27747['errors'] ) ) { $_POST['errors'] = $IX27747['errors']; return affiliates_admin_affiliates_add(); } $IX27181 = __( 'Affiliate added.', 'affiliates' ); break; case 'edit' : $IX75398 = new Affiliates_Affiliate_WordPress(); $IX27747 = $IX75398->edit_submit(); if ( !empty( $IX27747['errors'] ) ) { $_POST['errors'] = $IX27747['errors']; return $IX75398->edit( $_POST['affiliate-id-field'] ); } $IX27181 = __( 'Affiliate updated.', 'affiliates' ); break; case 'remove' : affiliates_admin_affiliates_remove_submit(); $IX27181 = __( 'Affiliate removed.', 'affiliates' ); break; case 'add-attribute' : $IX94065 = new Affiliates_Attributes_WordPress(); if ( !$IX94065->add_submit() ) { if ( isset( $_POST['affiliate_id'] ) ) { return $IX94065->add( $_POST['affiliate_id' ] ); } } else { $IX75398 = new Affiliates_Affiliate_WordPress(); return $IX75398->edit( $_POST['affiliate_id'] ); } break; case 'edit-attribute' : $IX94065 = new Affiliates_Attributes_WordPress(); if ( !$IX94065->edit_submit() ) { if ( isset( $_POST['affiliate_id'] ) && isset( $_GET['attr_key'] ) ) { return $IX94065->edit( $_POST['affiliate_id' ], $_GET['attr_key'] ); } } else { $IX75398 = new Affiliates_Affiliate_WordPress(); return $IX75398->edit( $_POST['affiliate_id'] ); } break; case 'remove-attribute' : $IX94065 = new Affiliates_Attributes_WordPress(); $IX94065->remove_submit(); $IX75398 = new Affiliates_Affiliate_WordPress(); return $IX75398->edit( $_POST['affiliate_id'] ); break; case 'add-relation' : break; case 'edit-relation' : break; case 'remove-relation' : break; case 'affiliate-action' : if ( wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_ACTION_NONCE], 'admin' ) ) { $IX82228 = isset( $_POST['affiliate_ids'] ) ? $_POST['affiliate_ids'] : null; $IX27111 = null; if ( isset( $_POST['bulk'] ) ) { $IX27111 = $_POST['bulk-action']; } if ( is_array( $IX82228 ) && ( $IX27111 !== null ) ) { foreach ( $IX82228 as $IX86621 ) { switch ( $IX27111 ) { case 'remove-affiliate' : $IX59834 = isset( $_POST['confirm'] ) ? true : false; if ( $IX59834 ) { affiliates_admin_affiliates_bulk_remove_submit(); } else { return affiliates_admin_affiliates_bulk_remove(); } break; case 'status-active' : affiliates_admin_affiliates_bulk_status_active_submit(); break; case 'status-pending' : affiliates_admin_affiliates_bulk_status_pending_submit(); break; } } } } $IX27181 = __( 'Bulk action executed', 'affiliates' ); break; } $IX16673 .= '<div class="updated">'; $IX16673 .= $IX27181; $IX16673 .= '</div>'; } else if ( isset ( $_GET['action'] ) ) { switch( $_GET['action'] ) { case 'add' : return affiliates_admin_affiliates_add(); break; case 'edit' : if ( isset( $_GET['affiliate_id'] ) ) { $IX75398 = new Affiliates_Affiliate_WordPress(); return $IX75398->edit( $_GET['affiliate_id'] ); } break; case 'remove' : if ( isset( $_GET['affiliate_id'] ) ) { return affiliates_admin_affiliates_remove( $_GET['affiliate_id'] ); } break; case 'add-attribute' : $IX94065 = new Affiliates_Attributes_WordPress(); if ( isset( $_GET['affiliate_id'] ) ) { return $IX94065->add( $_GET['affiliate_id' ] ); } break; case 'edit-attribute' : $IX94065 = new Affiliates_Attributes_WordPress(); if ( isset( $_GET['affiliate_id'] ) && isset( $_GET['attr_key'] ) ) { return $IX94065->edit( $_GET['affiliate_id' ], $_GET['attr_key'] ); } break; case 'remove-attribute' : $IX94065 = new Affiliates_Attributes_WordPress(); if ( isset( $_GET['affiliate_id'] ) && isset( $_GET['attr_key'] ) ) { return $IX94065->remove( $_GET['affiliate_id' ], $_GET['attr_key'] ); } break; case 'add-relation' : break; case 'edit-relation' : break; case 'remove-relation' : break; } } if ( isset( $_POST['clear_filters'] ) || isset( $_POST['submitted'] ) ) { if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_FILTER_NONCE], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } $IX49159 = $affiliates_options->get_option( 'affiliates_from_date', null ); $IX20508 = null; $IX69824 = $affiliates_options->get_option( 'affiliates_thru_date', null ); $IX57818 = null; $IX86621 = $affiliates_options->get_option( 'affiliates_affiliate_id', null ); $IX38122 = $affiliates_options->get_option( 'affiliates_affiliate_name', null ); $IX94055 = $affiliates_options->get_option( 'affiliates_affiliate_email', null ); $IX83949 = $affiliates_options->get_option( 'affiliates_affiliate_user_login', null ); $IX53568 = $affiliates_options->get_option( 'affiliates_show_active', true ); $IX16877 = $affiliates_options->get_option( 'affiliates_show_pending', true ); $IX82010 = $affiliates_options->get_option( 'affiliates_show_deleted', false ); $IX11994 = $affiliates_options->get_option( 'affiliates_show_inoperative', false ); $IX79769 = $affiliates_options->get_option( 'affiliates_show_totals', true ); if ( isset( $_POST['clear_filters'] ) ) { $affiliates_options->delete_option( 'affiliates_from_date' ); $affiliates_options->delete_option( 'affiliates_thru_date' ); $affiliates_options->delete_option( 'affiliates_affiliate_id' ); $affiliates_options->delete_option( 'affiliates_affiliate_name' ); $affiliates_options->delete_option( 'affiliates_affiliate_email' ); $affiliates_options->delete_option( 'affiliates_affiliate_user_login' ); $affiliates_options->delete_option( 'affiliates_show_deleted' ); $affiliates_options->delete_option( 'affiliates_show_inoperative' ); $affiliates_options->delete_option( 'affiliates_show_totals' ); $IX49159 = null; $IX20508 = null; $IX69824 = null; $IX57818 = null; $IX86621 = null; $IX38122 = null; $IX94055 = null; $IX83949 = null; $IX53568 = true; $IX16877 = true; $IX82010 = false; $IX11994 = false; $IX79769 = true; } else if ( isset( $_POST['submitted'] ) ) { if ( !empty( $_POST['affiliate_name'] ) ) { $IX38122 = trim( $_POST['affiliate_name'] ); if ( strlen( $IX38122 ) > 0 ) { $affiliates_options->update_option( 'affiliates_affiliate_name', $IX38122 ); } else { $IX38122 = null; $affiliates_options->delete_option( 'affiliates_affiliate_name' ); } } else { $IX38122 = null; $affiliates_options->delete_option( 'affiliates_affiliate_name' ); } if ( !empty( $_POST['affiliate_email'] ) ) { $IX94055 = trim( $_POST['affiliate_email'] ); if ( strlen( $IX94055 ) > 0 ) { $affiliates_options->update_option( 'affiliates_affiliate_email', $IX94055 ); } else { $IX94055 = null; $affiliates_options->delete_option( 'affiliates_affiliate_email' ); } } else { $IX94055 = null; $affiliates_options->delete_option( 'affiliates_affiliate_email' ); } if ( !empty( $_POST['affiliate_user_login'] ) ) { $IX83949 = trim( $_POST['affiliate_user_login'] ); if ( strlen( $IX83949 ) > 0 ) { $affiliates_options->update_option( 'affiliates_affiliate_user_login', $IX83949 ); } else { $IX83949 = null; $affiliates_options->delete_option( 'affiliates_affiliate_user_login' ); } } else { $IX83949 = null; $affiliates_options->delete_option( 'affiliates_affiliate_user_login' ); } $IX53568 = isset( $_POST['show_active'] ); $affiliates_options->update_option( 'affiliates_show_active', $IX53568 ); $IX16877 = isset( $_POST['show_pending'] ); $affiliates_options->update_option( 'affiliates_show_pending', $IX16877 ); $IX82010 = isset( $_POST['show_deleted'] ); $affiliates_options->update_option( 'affiliates_show_deleted', $IX82010 ); $IX11994 = isset( $_POST['show_inoperative'] ); $affiliates_options->update_option( 'affiliates_show_inoperative', $IX11994 ); $IX79769 = isset( $_POST['show_totals'] ); $affiliates_options->update_option( 'affiliates_show_totals', $IX79769 ); if ( !empty( $_POST['from_date'] ) ) { $IX49159 = date( 'Y-m-d', strtotime( $_POST['from_date'] ) ); $affiliates_options->update_option( 'affiliates_from_date', $IX49159 ); } else { $affiliates_options->delete_option( 'affiliates_from_date' ); } if ( !empty( $_POST['thru_date'] ) ) { $IX69824 = date( 'Y-m-d', strtotime( $_POST['thru_date'] ) ); $affiliates_options->update_option( 'affiliates_thru_date', $IX69824 ); } else { $affiliates_options->delete_option( 'affiliates_thru_date' ); } if ( $IX49159 && $IX69824 ) { if ( strtotime( $IX49159 ) > strtotime( $IX69824 ) ) { $IX69824 = null; $affiliates_options->delete_option( 'affiliates_thru_date' ); } } if ( $IX49159 ) { $IX20508 = DateHelper::u2s( $IX49159 ); } if ( $IX69824 ) { $IX57818 = DateHelper::u2s( $IX69824, 24*3600 ); } if ( !empty( $_POST['affiliate_id'] ) ) { $IX86621 = affiliates_check_affiliate_id( $_POST['affiliate_id'] ); if ( $IX86621 ) { $affiliates_options->update_option( 'affiliates_affiliate_id', $IX86621 ); } } else if ( isset( $_POST['affiliate_id'] ) ) { $IX86621 = null; $affiliates_options->delete_option( 'affiliates_affiliate_id' ); } } if ( isset( $_POST['row_count'] ) ) { if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_NONCE_1], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } if ( isset( $_POST['paged'] ) ) { if ( !wp_verify_nonce( $_POST[AFFILIATES_ADMIN_AFFILIATES_NONCE_2], plugin_basename( __FILE__ ) ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } $IX13513 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX13513 = remove_query_arg( 'paged', $IX13513 ); $IX13513 = remove_query_arg( 'action', $IX13513 ); $IX13513 = remove_query_arg( 'affiliate_id', $IX13513 ); $IX36367 = _affiliates_get_tablename( 'affiliates' ); $IX15267 = _affiliates_get_tablename( 'affiliates_users' ); $IX36216 = _affiliates_get_tablename( 'affiliates_attributes' ); $IX56584 .= '<div class="manage-affiliates">' . '<h1>' . __( 'Manage Affiliates', 'affiliates' ) . '</h1>'; $IX56584 .= $IX16673; $IX49954 = $affiliates_options->get_option( 'show_filters', true ); $IX17525 = $affiliates_options->get_option( 'show_columns', true ); $IX56584 .= '<div class="manage">'; $IX56584 .= "<a title='" . __( 'Click to add a new affiliate', 'affiliates' ) . "' class='button add' href='" . esc_url( $IX13513 ) . "&action=add'><img class='icon' alt='" . __( 'Add', 'affiliates') . "' src='". AFFILIATES_PRO_PLUGIN_URL ."images/add.png'/><span class='label'>" . __( 'New Affiliate', 'affiliates') . "</span></a>"; $IX56584 .= '<div style="float:right">'; $IX56584 .= '<div style="display:inline">'; $IX56584 .= '<form style="display:inline" id="export-affiliates" action="" method="post">'; $IX56584 .= sprintf( '<input class="button" type="submit" value="%s" />', __( 'Export', 'affiliates' ) ); $IX56584 .= '<input type="hidden" name="action" value="export" />'; $IX56584 .= wp_nonce_field( 'export-affiliates', 'export-nonce', true, false ); $IX56584 .= '</form>'; $IX56584 .= '</div>'; $IX56584 .= ' '; $IX56584 .= sprintf( '<div class="button toggle-button %s" id="filters-toggle">', ( $IX49954 ? 'on' : 'off' ) ); $IX56584 .= __( 'Filters', 'affiliates' ); $IX56584 .= '</div>'; $IX56584 .= ' '; $IX56584 .= sprintf( '<div class="button toggle-button %s" id="columns-toggle">', ( $IX17525 ? 'on' : 'off' ) ); $IX56584 .= __( 'Columns', 'affiliates' ); $IX56584 .= '</div>'; $IX56584 .= '</div>'; $IX56584 .= '</div>'; $IX94448 = isset( $_POST['row_count'] ) ? intval( $_POST['row_count'] ) : 0; if ($IX94448 <= 0) { $IX94448 = $affiliates_options->get_option( 'affiliates_per_page', AFFILIATES_AFFILIATES_PER_PAGE ); } else { $affiliates_options->update_option('affiliates_per_page', $IX94448 ); } $IX36601 = isset( $_REQUEST['paged'] ) ? intval( $_REQUEST['paged'] ) : 1; if ( $IX36601 < 1 ) { $IX36601 = 1; } $IX16781 = isset( $_GET['orderby'] ) ? $_GET['orderby'] : null; switch ( $IX16781 ) { case 'from_date' : case 'thru_date' : case 'email' : case 'affiliate_id' : case 'name' : case 'user_login' : break; default: $IX16781 = 'name'; } $IX67100 = isset( $_GET['order'] ) ? $_GET['order'] : null; switch ( $IX67100 ) { case 'asc' : case 'ASC' : $IX47132 = 'DESC'; break; case 'desc' : case 'DESC' : $IX47132 = 'ASC'; break; default: $IX67100 = 'ASC'; $IX47132 = 'DESC'; } $IX52587 = array( " 1=%d " ); $IX57236 = array( 1 ); if ( $IX86621 ) { $IX52587[] = " $IX36367.affiliate_id = %d "; $IX57236[] = $IX86621; } if ( $IX38122 ) { $IX52587[] = " $IX36367.name LIKE '%%%s%%' "; $IX57236[] = $IX38122; } if ( $IX94055 ) { $IX52587[] = " $IX36367.email LIKE '%%%s%%' "; $IX57236[] = $IX94055; } if ( $IX83949 ) { $IX52587[] = " $wpdb->users.user_login LIKE '%%%s%%' "; $IX57236[] = $IX83949; } $IX94419 = array( '' ); if ( $IX53568 ) { $IX94419[] = 'active'; } if ( $IX16877 ) { $IX94419[] = 'pending'; } if ( $IX82010 ) { $IX94419[] = 'deleted'; } $IX52587[] = sprintf( " $IX36367.status IN (%s) ", !empty($IX94419) ? "'" . implode( "','", $IX94419 ) . "'" : '' ); if ( !$IX11994 ) { $IX52587[] = " $IX36367.from_date <= %s AND ( $IX36367.thru_date IS NULL OR $IX36367.thru_date >= %s ) "; $IX57236[] = $IX83807; $IX57236[] = $IX83807; } if ( $IX20508 && $IX57818 ) { $IX52587[] = " $IX36367.from_date >= %s AND ( $IX36367.thru_date IS NULL OR $IX36367.thru_date < %s ) "; $IX57236[] = $IX20508; $IX57236[] = $IX57818; } else if ( $IX20508 ) { $IX52587[] = " $IX36367.from_date >= %s "; $IX57236[] = $IX20508; } else if ( $IX57818 ) { $IX52587[] = " $IX36367.thru_date < %s "; $IX57236[] = $IX57818; } if ( !empty( $IX52587 ) ) { $IX52587 = " WHERE " . implode( " AND ", $IX52587 ); } else { $IX52587 = ''; } do { $IX59515 = false; $IX34949 = ( $IX36601 - 1 ) * $IX94448; $IX68839 = $wpdb->prepare( "SELECT SQL_CALC_FOUND_ROWS $IX36367.*, $wpdb->users.* " . "FROM $IX36367 " . "LEFT JOIN $IX15267 ON $IX36367.affiliate_id = $IX15267.affiliate_id " . "LEFT JOIN $wpdb->users on $IX15267.user_id = $wpdb->users.ID " . "$IX52587 " . "ORDER BY $IX16781 $IX67100 " . "LIMIT $IX94448 OFFSET $IX34949", $IX57236 ); $IX15986 = $wpdb->get_results( $IX68839, OBJECT ); $IX56559 = intval( $wpdb->get_var( "SELECT FOUND_ROWS()" ) ); if ( $IX56559 > $IX94448 ) { $IX81724 = true; } else { $IX81724 = false; } $IX40092 = max( array( 1, ceil( $IX56559 / $IX94448 ) ) ); if ( $IX36601 > $IX40092 ) { $IX36601 = $IX40092; $IX59515 = true; } } while ( $IX59515 ); $IX93074 = array( 'affiliate_id' => __( 'Id', 'affiliates' ), 'name' => __( 'Affiliate', 'affiliates' ), 'email' => __( 'Email', 'affiliates' ), 'user_login' => __( 'Username', 'affiliates' ), 'from_date' => __( 'From', 'affiliates' ), 'thru_date' => __( 'Until', 'affiliates' ), 'status' => __( 'Status', 'affiliates' ), 'links' => __( 'Links', 'affiliates' ), ); foreach ( Affiliates_Attributes::get_keys() as $IX73761 => $IX51136 ) { $IX61804 = $IX73761; $IX73761 = '_attr_' . preg_replace( '/(\.|\-)/', '_', $IX73761 ); $IX93074[$IX73761] = $IX51136; } require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings.php'; require_once AFFILIATES_CORE_LIB . '/class-affiliates-settings-registration.php'; $IX75680 = Affiliates_Settings_Registration::get_fields(); foreach( Affiliates_Registration::get_skip_meta_fields() as $IX90236 ) { unset( $IX75680[$IX90236] ); } if ( !empty( $IX75680 ) ) { foreach( $IX75680 as $IX38012 => $IX91918 ) { if ( $IX91918['enabled'] ) { $IX93074[$IX38012] = stripslashes( $IX91918['label'] ); } } } $IX67781 = array(); foreach( array_keys( $IX93074 ) as $IX90236 ) { $IX90236 = preg_replace( '/(\.|\-)/', '_', $IX90236 ); switch( $IX90236 ) { case 'name' : case 'email' : case 'user_login' : $IX67781[$IX90236] = true; break; default : $IX67781[$IX90236] = false; } } $IX19341 = $IX67781; foreach( $affiliates_options->get_option( 'affiliates_overview_columns', array() ) as $IX90236 => $IX22450 ) { $IX19341[$IX90236] = $IX22450; } $IX86080 = 0; $IX56584 .= '<script type="text/javascript">'; $IX56584 .= 'affiliates_overview_columns={'; $IX13409 = array(); foreach( $IX19341 as $IX90236 => $IX22450 ) { $IX13409[] = wp_strip_all_tags( $IX90236 ).':' . ( $IX22450 ? 'true' : 'false' ); if ( $IX22450 ) { $IX86080++; } } $IX86080++; $IX56584 .= implode( ',', $IX13409 ); $IX56584 .= '};'; $IX56584 .= '</script>'; $IX56584 .= '<div class="affiliates-overview">'; $IX56584 .= sprintf( '<div id="filters-container" class="filters" style="%s">', $IX49954 ? '' : 'display:none' ); $IX56584 .= '<label class="description" for="setfilters">' . __( 'Filters', 'affiliates' ) . '</label>'; $IX56584 .= '<div>'; $IX56584 .= '<form id="setfilters" action="" method="post">'; $IX56584 .= '<div class="filter-section">' . '<label class="affiliate-id-filter shrink">' . __( 'Id', 'affiliates' ) . ' ' . '<input class="affiliate-id-filter" name="affiliate_id" type="text" value="' . esc_attr( $IX86621 ) . '"/>' . '</label>' . ' ' . '<label class="affiliate-name-filter">' . __( 'Name', 'affiliates' ) . ' ' . '<input class="affiliate-name-filter" name="affiliate_name" type="text" value="' . $IX38122 . '"/>' . '</label>' . ' ' . '<label class="affiliate-email-filter">' . __( 'Email', 'affiliates' ) . ' ' . '<input class="affiliate-email-filter" name="affiliate_email" type="text" value="' . $IX94055 . '"/>' . '</label>' . ' ' . '<label class="affiliate-user-login-filter">' . __( 'Username', 'affiliates' ) . ' ' . '<input class="affiliate-user-login-filter" name="affiliate_user_login" type="text" value="' . $IX83949 . '" />' . '</label>' . '</div>' . '<div class="filter-section">' . '<label class="from-date-filter">' . __( 'From', 'affiliates' ) . ' ' . '<input class="datefield from-date-filter" name="from_date" type="text" value="' . esc_attr( $IX49159 ) . '"/>'. '</label>' . ' ' . '<label class="thru-date-filter">' . __( 'Until', 'affiliates' ) . ' ' . '<input class="datefield thru-date-filter" name="thru_date" type="text" class="datefield" value="' . esc_attr( $IX69824 ) . '"/>'. '</label>' . '</div>' . '<div class="filter-section">' . '<label class="show-inoperative-filter">' . '<input class="show-inoperative-filter" name="show_inoperative" type="checkbox" ' . ( $IX11994 ? 'checked="checked"' : '' ) . '/>' . ' ' . __( 'Include inoperative affiliates', 'affiliates' ) . '</label>' . ' ' . '<label class="show-active-filter">' . '<input class="show-active-filter" name="show_active" type="checkbox" ' . ( $IX53568 ? 'checked="checked"' : '' ) . '/>' . ' ' . __( 'Include active affiliates', AFFILIATES_PLUGIN_DOMAIN ) . '</label>' . ' ' . '<label class="show-pending-filter">' . '<input class="show-pending-filter" name="show_pending" type="checkbox" ' . ( $IX16877 ? 'checked="checked"' : '' ) . '/>' . ' ' . __( 'Include pending affiliates', AFFILIATES_PLUGIN_DOMAIN ) . '</label>' . ' ' . '<label class="show-deleted-filter">' . '<input class="show-deleted-filter" name="show_deleted" type="checkbox" ' . ( $IX82010 ? 'checked="checked"' : '' ) . '/>' . ' ' . __( 'Include removed affiliates', 'affiliates' ) . '</label>' . ' ' . '<label class="show-totals-filter">' . '<input class="show-totals-filter" name="show_totals" type="checkbox" ' . ( $IX79769 ? 'checked="checked"' : '' ) . '/>' . ' ' . __( 'Show accumulated referral totals', 'affiliates' ) . '</label>' . '</div>'; $IX56584 .= '<div class="filter-buttons">' . wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_FILTER_NONCE, true, false ) . '<input class="button" type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>' . '<input class="button" type="submit" name="clear_filters" value="' . __( 'Clear', 'affiliates' ) . '"/>' . '<input type="hidden" value="submitted" name="submitted"/>' . '</div>'; $IX56584 .= '</form>'; $IX56584 .= '</div>'; $IX56584 .= '</div>'; $IX56584 .= sprintf( '<div id="columns-container" class="filters" style="%s">', $IX17525 ? '' : 'display:none' ); $IX56584 .= '<div>'; $IX56584 .= __( 'Columns', 'affiliates' ); $IX56584 .= '</div>'; $IX56584 .= '<div id="column-toggles" class="column-toggles">'; foreach( $IX93074 as $IX90236 => $IX74516 ) { $IX15617 = preg_replace( '/(\.|\-)/', '_', $IX90236 ); $IX56584 .= '<div class="column-toggle-container">'; $IX56584 .= '<label>'; $IX56584 .= sprintf( '<input class="column-toggle" type="checkbox" name="column-toggle-%s" id="column-toggle-%s" value="%s" %s />', esc_attr( $IX15617 ), esc_attr( $IX15617 ), esc_attr( $IX15617 ), isset( $IX19341[$IX15617] ) && $IX19341[$IX15617] ? ' checked="checked" ' : '' ); $IX56584 .= $IX74516; $IX56584 .= '</label>'; $IX56584 .= '</div>'; } $IX56584 .= '</div>'; $IX56584 .= '</div>'; $IX56584 .= '
			<div class="page-options right">
				<form id="setrowcount" action="" method="post">
					<div>
						<label for="row_count">' . __( 'Results per page', 'affiliates' ) . '</label>' . '<input name="row_count" type="text" size="2" value="' . esc_attr( $IX94448 ) .'" />
						' . wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_NONCE_1, true, false ) . '
						<input class="button" type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>
					</div>
				</form>
			</div>
			'; if ( $IX81724 ) { $IX57048 = new Affiliates_Pagination($IX56559, null, $IX94448); $IX56584 .= '<form id="posts-filter" method="post" action="">'; $IX56584 .= '<div>'; $IX56584 .= wp_nonce_field( plugin_basename( __FILE__ ), AFFILIATES_ADMIN_AFFILIATES_NONCE_2, true, false ); $IX56584 .= '</div>'; $IX56584 .= '<div class="tablenav top">'; $IX56584 .= $IX57048->pagination( 'top' ); $IX56584 .= '</div>'; $IX56584 .= '</form>'; } $IX56584 .= '<form id="affiliates-action" method="post" action="">'; $IX56584 .= wp_nonce_field( 'admin', AFFILIATES_ADMIN_AFFILIATES_ACTION_NONCE, true, false ); $IX56584 .= '<div class="affiliates-bulk-container">'; $IX56584 .= '<select class="bulk-action" name="bulk-action">'; $IX56584 .= '<option selected="selected" value="-1">' . esc_html( __( 'Bulk Actions', 'affiliates' ) ) . '</option>'; $IX56584 .= '<option value="remove-affiliate">' . esc_html( __( 'Remove affiliate', 'affiliates' ) ) . '</option>'; $IX56584 .= '<option value="status-pending">' . esc_html( __( 'Set status to Pending', 'affiliates' ) ) . '</option>'; $IX56584 .= '<option value="status-active">' . esc_html( __( 'Set status to Active', 'affiliates' ) ) . '</option>'; $IX56584 .= '</select>'; $IX56584 .= sprintf( '<input class="button" type="submit" name="bulk" value="%s" />', esc_attr( __( 'Apply', 'affiliates' ) ) ); $IX56584 .= '<input type="hidden" name="action" value="affiliate-action"/>'; $IX56584 .= '</div>'; $IX56584 .= '<table id="affiliates-overview-table" class="wp-list-table widefat fixed" cellspacing="0">'; $IX56584 .= '<thead>'; $IX56584 .= '<tr>'; $IX56584 .= '<th id="cb" class="manage-column column-cb check-column" scope="col"><input type="checkbox"></th>'; foreach ( $IX93074 as $IX90236 => $IX33366 ) { $IX90236 = preg_replace( '/(\.|\-)/', '_', $IX90236 ); $IX21669 = array( 'orderby' => $IX90236, 'order' => $IX47132 ); $IX90753 = $IX90236; if ( in_array( $IX90236, array( 'affiliate_id', 'name', 'email', 'user_login', 'from_date', 'thru_date', 'status' ) ) ) { if ( strcmp( $IX90236, $IX16781 ) == 0 ) { $IX73246 = strtolower( $IX67100 ); $IX90753 = "$IX90236 manage-column sorted $IX73246"; } else { $IX90753 = "$IX90236 manage-column sortable"; } $IX33366 = '<a href="' . esc_url( add_query_arg( $IX21669, $IX13513 ) ) . '"><span>' . $IX33366 . '</span><span class="sorting-indicator"></span></a>'; } $IX56584 .= sprintf( '<th scope="col" class="%s" style="%s">%s</th>', esc_attr( $IX90753 ), isset( $IX19341[$IX90236] ) && $IX19341[$IX90236] ? '' : 'display:none', $IX33366 ); } $IX56584 .= '</tr>'; $IX56584 .= '</thead>'; $IX56584 .= '<tbody>'; if ( count( $IX15986 ) > 0 ) { for ( $IX95619 = 0; $IX95619 < count( $IX15986 ); $IX95619++ ) { $IX27747 = $IX15986[$IX95619]; $IX94245 = ''; $IX14799 = ''; if ( $IX88660 = ( strcmp( $IX27747->status, 'deleted' ) == 0 ) ) { $IX14799 = ' deleted '; $IX94245 .= " " . __( '(removed)', 'affiliates' ); } else if ( strcmp( $IX27747->status, 'pending' ) == 0 ) { $IX14799 .= ' pending '; } $IX16391 = ''; if ( $IX47609 = ! ( ( $IX27747->from_date <= $IX83807 ) && ( $IX27747->thru_date == null || $IX27747->thru_date >= $IX83807 ) ) ) { $IX16391 = ' inoperative '; $IX94245 .= " " . __( '(inoperative)', 'affiliates' ); } $IX56584 .= '<tr class="' . $IX14799 . $IX16391 . ( $IX95619 % 2 == 0 ? 'even' : 'odd' ) . '">'; $IX56584 .= '<th class="check-column">'; $IX56584 .= '<input type="checkbox" value="' . esc_attr( $IX27747->affiliate_id ) . '" name="affiliate_ids[]"/>'; $IX56584 .= '</th>'; $IX56584 .= sprintf( '<td class="affiliate_id" style="%s">', isset( $IX19341['affiliate_id'] ) && $IX19341['affiliate_id'] ? '' : 'display:none' ); if ( affiliates_encode_affiliate_id( $IX27747->affiliate_id ) != $IX27747->affiliate_id ) { $IX56584 .= '<span class="encoded-hint" title="' . affiliates_encode_affiliate_id( $IX27747->affiliate_id ) . '">' . $IX27747->affiliate_id . '</span>'; } else { $IX56584 .= $IX27747->affiliate_id; } $IX56584 .= '</td>'; $IX14019 = remove_query_arg( array( 'paged', 'action', 'affiliate_id' ), $IX13513 ); $IX14019 = add_query_arg( array( 'paged' => $IX36601, 'action' => 'edit', 'affiliate_id' => $IX27747->affiliate_id ), $IX13513 ); $IX56584 .= sprintf( '<td class="name affiliate-name" style="%s">', isset( $IX19341['name'] ) && $IX19341['name'] ? '' : 'display:none' ); $IX56584 .= '<div>'; $IX56584 .= sprintf( '<a href="%s">%s</a>', esc_url( $IX14019 ), stripslashes( wp_filter_nohtml_kses( $IX27747->name ) ) . $IX94245 ); $IX56584 .= '</div>'; $IX56584 .= '<div>'; $IX56584 .= sprintf( '<a class="edit" href="%s">%s</a>', esc_url( $IX14019 ), __( 'Edit', 'affiliates' ), __( 'Edit', 'affiliates' ) ); if ( !$IX88660 && ( !isset( $IX27747->type ) || ( $IX27747->type != AFFILIATES_DIRECT_TYPE ) ) ) { $IX94974 = remove_query_arg( array( 'paged', 'action', 'affiliate_id' ), $IX13513 ); $IX94974 = add_query_arg( array( 'paged' => $IX36601, 'action' => 'remove', 'affiliate_id' => $IX27747->affiliate_id ), $IX13513 ); $IX56584 .= ' '; $IX56584 .= sprintf( '<a class="remove" href="%s">%s</a>', esc_url( $IX94974 ), __( 'Remove', 'affiliates' ), __( 'Remove', 'affiliates' ) ); } $IX56584 .= '</div>'; $IX56584 .= '</td>'; $IX56584 .= sprintf( '<td class="email affiliate-email" style="%s">', isset( $IX19341['email'] ) && $IX19341['email'] ? '' : 'display:none' ); $IX56584 .= $IX27747->email; if ( isset( $IX27747->email ) && isset( $IX27747->user_email ) && strcmp( $IX27747->email, $IX27747->user_email ) !== 0 ) { $IX56584 .= '<span title="' . sprintf( __( 'There are different email addresses on record for the affiliate and the associated user. This might be ok, but if in doubt please check. The email address on file for the user is %s', 'affiliates' ), $IX27747->user_email ) . '" class="warning"> [&nbsp;!&nbsp]</span>'; } $IX56584 .= '</td>'; $IX56584 .= sprintf( '<td class="user_login affiliate-user-login" style="%s">', isset( $IX19341['user_login'] ) && $IX19341['user_login'] ? '' : 'display:none' ); if ( !empty( $IX27747->ID ) ) { if ( current_user_can( 'edit_user', $IX27747->ID ) ) { $IX56584 .= '<a target="_blank" href="' . esc_url( "user-edit.php?user_id=$IX27747->ID" ) . '">' . $IX27747->user_login . '</a>'; } else { $IX56584 .= $IX27747->user_login; } } $IX56584 .= '</td>'; $IX56584 .= sprintf( '<td class="from_date from-date" style="%s">', isset( $IX19341['from_date'] ) && $IX19341['from_date'] ? '' : 'display:none' ); $IX56584 .= $IX27747->from_date; $IX56584 .= '</td>'; $IX56584 .= sprintf( '<td class="thru_date thru-date" style="%s">', isset( $IX19341['thru_date'] ) && $IX19341['thru_date'] ? '' : 'display:none' ); $IX56584 .= $IX27747->thru_date; $IX56584 .= '</td>'; $IX56584 .= sprintf( '<td class="status" style="%s">', isset( $IX19341['status'] ) && $IX19341['status'] ? '' : 'display:none' ); $IX56584 .= $IX27747->status; $IX56584 .= '</td>'; $IX56584 .= sprintf( '<td class="links" style="%s">', isset( $IX19341['links'] ) && $IX19341['links'] ? '' : 'display:none' ); $IX79478 = affiliates_encode_affiliate_id( $IX27747->affiliate_id ); $IX56584 .= __( 'Link', 'affiliates' ) . ': ' . '<span class="affiliate-link">' . Affiliates_Url_Renderer::get_affiliate_url( home_url(), $IX27747->affiliate_id ) . '</span>' . '<br/>' . __( 'URL Parameter', 'affiliates' ) . ': ' . '<span class="affiliate-link-param">' . '?' . $IX55581 . '=' . $IX79478 . '</span>'; $IX56584 .= '</td>'; foreach ( Affiliates_Attributes::get_keys() as $IX73761 => $IX51136 ) { $IX61804 = $IX73761; $IX73761 = '_attr_' . preg_replace( '/(\.|\-)/', '_', $IX73761 ); $IX80292 = isset( $IX19341[$IX73761] ) && $IX19341[$IX73761] ? '' : 'display:none'; $IX15090 = $affiliates_db->get_value( "SELECT attr_value FROM $IX36216 WHERE affiliate_id = %d AND attr_key = %s", $IX27747->affiliate_id, $IX61804 ); $IX56584 .= sprintf( '<td class="%s" style="%s">', $IX73761, $IX80292 ); $IX56584 .= wp_filter_nohtml_kses( $IX15090 ); $IX56584 .= '</td>'; } foreach( $IX75680 as $IX38012 => $IX91918 ) { if ( $IX91918['enabled'] ) { $IX66395 = isset( $IX91918['type'] ) ? $IX91918['type'] : 'text'; $IX22450 = ''; switch( $IX38012 ) { case 'user_login' : $IX22450 = $IX24628->user_login; break; case 'user_email' : $IX22450 = $IX24628->user_email; break; case 'user_url' : $IX22450 = $IX24628->user_url; break; case 'password' : $IX22450 = ''; break; default : $IX22450 = get_user_meta( $IX27747->ID, $IX38012 , true ); } $IX80292 = isset( $IX19341[$IX38012] ) && $IX19341[$IX38012] ? '' : 'display:none'; $IX56584 .= sprintf( '<td class="%s" style="%s">', $IX38012, $IX80292 ); $IX56584 .= stripslashes( wp_filter_nohtml_kses( $IX22450 ) ); $IX56584 .= '</td>'; } } $IX56584 .= '</tr>'; if ( $IX79769 ) { $IX56584 .= '<tr class="' . $IX14799 . $IX16391 . ( $IX95619 % 2 == 0 ? 'even' : 'odd' ) . '">'; $IX25650 = array(); $IX25650[AFFILIATES_REFERRAL_STATUS_CLOSED] = Affiliates_Shortcodes::get_total( $IX27747->affiliate_id, null, null, AFFILIATES_REFERRAL_STATUS_CLOSED ); $IX25650[AFFILIATES_REFERRAL_STATUS_ACCEPTED] = Affiliates_Shortcodes::get_total( $IX27747->affiliate_id, null, null, AFFILIATES_REFERRAL_STATUS_ACCEPTED ); $IX25650[AFFILIATES_REFERRAL_STATUS_PENDING] = Affiliates_Shortcodes::get_total( $IX27747->affiliate_id, null, null, AFFILIATES_REFERRAL_STATUS_PENDING ); $IX25650[AFFILIATES_REFERRAL_STATUS_REJECTED] = Affiliates_Shortcodes::get_total( $IX27747->affiliate_id, null, null, AFFILIATES_REFERRAL_STATUS_REJECTED ); $IX56584 .= '<td class="dynamic-colspan" colspan="' . $IX86080 . '">'; $IX56584 .= '<table class="affiliate-referral-totals">'; $IX56584 .= '<thead>'; $IX56584 .= '<tr>'; foreach( $IX25650 as $IX88344 => $IX55213 ) { if ( $IX55213 ) { $IX56584 .= '<th>'; $IX56584 .= '<strong>'; switch( $IX88344 ) { case AFFILIATES_REFERRAL_STATUS_CLOSED : $IX56584 .= sprintf( __( '<span style="cursor:help" title="%s">Closed</span>', 'affiliates' ), esc_attr( __( 'Accumulated total for closed referrals (commissions paid).', 'affiliates' ) ) ); break; case AFFILIATES_REFERRAL_STATUS_ACCEPTED : $IX56584 .= sprintf( __( '<span style="cursor:help" title="%s">Accepted</span>', 'affiliates' ), esc_attr( __( 'Accumulated total for accepted referrals (commissions unpaid).', 'affiliates' ) ) ); break; case AFFILIATES_REFERRAL_STATUS_PENDING : $IX56584 .= sprintf( __( '<span style="cursor:help" title="%s">Pending</span>', 'affiliates' ), esc_attr( __( 'Accumulated total for pending referrals.', 'affiliates' ) ) ); break; case AFFILIATES_REFERRAL_STATUS_REJECTED : $IX56584 .= sprintf( __( '<span style="cursor:help" title="%s">Rejected</span>', 'affiliates' ), esc_attr( __( 'Accumulated total for rejected referrals.', 'affiliates' ) ) ); break; } $IX56584 .= '</strong>'; $IX56584 .= '</th>'; } } $IX56584 .= '</thead>'; $IX56584 .= '</tr>'; $IX56584 .= '<tbody>'; $IX56584 .= '<tr>'; foreach( $IX25650 as $IX88344 => $IX55213 ) { if ( $IX55213 ) { $IX56584 .= '<td>'; $IX56584 .= '<ul>'; foreach( $IX55213 as $IX20074 => $IX83500 ) { $IX56584 .= '<li>'; $IX56584 .= sprintf( __( '%1$s %2$s', 'affiliates' ), $IX20074, $IX83500 ); $IX56584 .= '</li>'; } $IX56584 .= '</ul>'; $IX56584 .= '</td>'; } } $IX56584 .= '</tr>'; $IX56584 .= '<tbody>'; $IX56584 .= '</table>'; $IX56584 .= '</td>'; $IX56584 .= '</tr>'; } } } else { $IX56584 .= '<tr><td class="dynamic-colspan" colspan="' . $IX86080 . '">' . __('There are no results.', 'affiliates' ) . '</td></tr>'; } $IX56584 .= '</tbody>'; $IX56584 .= '</table>'; if ( $IX81724 ) { $IX57048 = new Affiliates_Pagination( $IX56559, null, $IX94448 ); $IX56584 .= '<div class="tablenav bottom">'; $IX56584 .= $IX57048->pagination( 'bottom' ); $IX56584 .= '</div>'; } $IX56584 .= '</div>'; $IX56584 .= '</div>'; echo $IX56584; affiliates_footer(); }
}
