<?php
/**
 * class-affiliates-rates-wordpress.php
 *
 * Copyright (c) 2017 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 *
 * @author itthinx
 * @package affiliates-pro
 * @since affiliates-pro 3.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

if ( !class_exists( 'WP_Screen' ) ) {
	include_once(ABSPATH . 'wp-admin/includes/class-wp-screen.php');
	require_once ABSPATH . 'wp-admin/includes/screen.php';
}
if ( !function_exists( 'convert_to_screen' ) ) {
	require_once ABSPATH . 'wp-admin/includes/template.php';
}
if( !class_exists( 'WP_List_Table' ) ){
	require_once ABSPATH . 'wp-admin/includes/class-wp-list-table.php';
}

/**
 * Extends WP_List_Table for rates.
 */
class Affiliates_Rates_Table extends WP_List_Table {

	/**
	 * Constructor.
	 */
	function __construct( $args = array() ){ global $status, $page; parent::__construct( array( 'singular' => 'rate', 'plural' => 'rates', 'ajax' => false, 'screen' => 'manage-rates' ) ); }

	function column_default( $item, $column_name ){ $IX49537 = ''; if ( $column_name == 'actions' || ( isset( $item[$column_name] ) && ( $item[$column_name] ) !== null ) ) { switch( $column_name ) { case 'value' : if ( $item['type'] !== AFFILIATES_PRO_RATES_TYPE_FORMULA ) { $IX49537 = $item[$column_name]; } else { $IX27069 = null; if ( $IX25169 = Affiliates_Rate::get_rate_by_id( $item['rate_id'] ) ) { $IX27069 = $IX25169->get_meta( 'formula' ); unset( $IX25169 ); } if ( $IX27069 === null ) { $IX27069 = ''; } $IX49537 = esc_html( $IX27069 ); } break; case 'currency_id' : $IX49537 = !empty( $item[$column_name] ) ? esc_html( $item[$column_name] ) : ''; break; case 'type' : $IX49537 = stripslashes( $item[$column_name] ); break; case 'affiliate_id' : if ( $IX51737 = affiliates_get_affiliate( $item[$column_name] ) ) { $IX49537 = stripslashes( wp_filter_nohtml_kses( $IX51737['name'] ) ); } break; case 'group_id' : if ( class_exists( 'Groups_Group' ) ) { if ( $IX65804 = Groups_Group::read( $item[$column_name] ) ) { $IX49537 = stripslashes( wp_filter_nohtml_kses( $IX65804->name ) ); } } break; case 'object_id' : $IX76474 = !empty( $item['integration'] ) ? $item['integration'] : null; switch( $IX76474 ) { case 'affiliates-contact-form-7' : if ( function_exists( 'wpcf7_contact_form' ) ) { $IX13390 = wpcf7_contact_form( $item['object_id'] ); if ( is_object( $IX13390 ) ) { $IX49537 = sprintf( '#%d &ndash; %s', intval( $item['object_id'] ), esc_html( $IX13390->title() ) ); } } break; case 'affiliates-events-manager' : if ( function_exists( 'em_get_event' ) ) { $IX17417 = em_get_event( $item['object_id'], 'post_id' ); if ( is_object( $IX17417 ) && class_exists( 'EM_Event' ) && ( $IX17417 instanceof EM_Event ) ) { $IX49537 = sprintf( '#%d &ndash; %s', intval( $item['object_id'] ), esc_html( $IX17417->event_name ) ); } } break; case 'affiliates-formidable' : if ( class_exists( 'FrmForm' ) && method_exists( 'FrmForm', 'getOne' ) ) { $IX13390 = FrmForm::getOne( $item['object_id'] ); if ( is_object( $IX13390 ) ) { $IX49537 = sprintf( '#%d &ndash; %s', intval( $item['object_id'] ), esc_html( $IX13390->name ) ); } } break; case 'affiliates-gravityforms' : if ( class_exists( 'GFAPI' ) && method_exists( 'GFAPI', 'get_form' ) ) { $IX13390 = GFAPI::get_form( $item['object_id'] ); if ( $IX13390 !== false ) { $IX49537 = sprintf( '#%d &ndash; %s', intval( $item['object_id'] ), esc_html( !empty( $IX13390['title'] ) ? $IX13390['title'] : 'Gravity Forms' ) ); } } break; case 'affiliates-ninja-forms' : if ( class_exists( 'Ninja_Forms' ) && method_exists( 'Ninja_Forms', 'form' ) ) { $IX13390 = Ninja_Forms()->form( $item['object_id'] )->get(); if ( $IX13390->get_id() ) { $IX17557 = $IX13390->get_setting( 'title' ); $IX49537 = sprintf( '#%d &ndash; %s', intval( $item['object_id'] ), esc_html( !empty( $IX17557 ) ? $IX17557 : 'Ninja Forms' ) ); } } break; case 'affiliates-woocommerce' : if ( function_exists( 'wc_get_product' ) ) { $IX98724 = wc_get_product( $item['object_id'] ); if ( is_object( $IX98724 ) ) { $IX49537 = wp_kses_post( $IX98724->get_formatted_name() ); } } break; default : $IX49537 = sprintf( '#%d', intval( $item['object_id'] ) ); } break; case 'term_id' : if ( $IX68590 = get_term( $item['term_id'] ) ) { $IX99912 = ''; if ( ! $IX68590 instanceof WP_Error ) { $IX99912 = $IX68590->name; } else { $IX99912 = implode( ',', $IX68590->get_error_messages() ); } $IX49537 = sprintf( '%s (#%d)', esc_html( $IX99912 ), intval( $item['term_id'] ) ); } break; case 'integration' : $IX39579 = affiliates_pro_get_integrations(); if ( key_exists( $item['integration'], $IX39579 ) ) { if ( isset( $IX39579[$item['integration']]['title'] ) ) { $IX49537 = esc_html( $IX39579[$item['integration']]['title'] ); } else { $IX49537 = esc_html( $item['integration'] ); } } else { $IX49537 = sprintf( '<span style="cursor:help" title="%s">', esc_attr__( 'This integration seems to be inactive or not installed.', 'affiliates' ) ) . '(' . esc_html( $item['integration'] ) . ')' . '</span>'; } break; case 'level' : if ( !empty( $item['rate_id'] ) ) { $IX67452 = false; if ( $IX25169 = Affiliates_Rate::get_rate_by_id( $item['rate_id'] ) ) { $IX67452 = $IX25169->get_meta( 'level-relative' ); unset( $IX25169 ); } $IX49537 = esc_html( $item['level'] + 1 ); if ( $IX67452 ) { $IX49537 .= ' '; $IX49537 .= sprintf( '<span title="%s">&Delta;</span>', esc_attr( __( 'Relative', 'affiliates' ) ) ); } } break; case 'actions' : if ( !empty( $item['rate_id'] ) ) { $IX68144 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX49537 = sprintf( '<a class="button action" title="%s" href="%s">%s</a>', esc_attr( __( 'Edit this rate', 'affiliates' ) ), esc_url( wp_nonce_url( add_query_arg( array( 'rate_id' => $item['rate_id'], 'action' => 'edit-rate' ), $IX68144 ) ) ), esc_html( __( 'Edit', 'affiliates' ) ) ); } break; default : $IX49537 = esc_html( $item[$column_name] ); } } return $IX49537; }

	function column_cb( $item ){ return sprintf( '<input class="rate-cb" type="checkbox" name="_rate_id[]" value="%d" />', intval( $item['rate_id'] ) ); }

	function get_columns(){ $IX46489 = array( 'cb' => '<input type="checkbox" />', 'rate_id' => __( 'ID', 'affiliates' ), 'value' => __( 'Value', 'affiliates' ), 'currency_id' => __( 'Currency', 'affiliates' ), 'type' => __( 'Type', 'affiliates' ), 'affiliate_id' => __( 'Affiliate', 'affiliates' ) ); if ( class_exists( 'Groups_Group' ) ) { $IX20259 = Groups_Group::get_group_ids(); if ( isset( $IX20259 ) && ( sizeof( $IX20259 ) > 0 ) ) { $IX46489['group_id'] = __( 'Group', 'affiliates' ); } } $IX46489 = array_merge( $IX46489, array ( 'object_id' => __( 'Object', 'affiliates' ), 'term_id' => __( 'Term', 'affiliates' ), ) ); if ( class_exists( 'Affiliates_Multi_Tier' ) && get_option( Affiliates_Multi_Tier::ENABLE_TIERS, false ) ) { $IX46489['level'] = __( 'Level', 'affiliates' ); } $IX46489 = array_merge( $IX46489, array ( 'integration' => __( 'Integration', 'affiliates' ), 'description' => __( 'Description', 'affiliates' ), 'actions' => '' ) ); if ( isset( $this->rate_id ) ) { unset( $IX46489['rate_id'] ); } return $IX46489; }

	function get_sortable_columns() { $IX15058 = array( 'rate_id' => array( 'rate_id', false ), 'value' => array( 'value', false ), 'currency_id' => array( 'currency_id', false ), 'type' => array( 'type', false ), 'affiliate_id' => array( 'affiliate_id', false ), 'object_id' => array( 'object_id', false ), 'term_id' => array( 'term_id', false ), 'integration' => array( 'integration', false ), 'description' => array( 'description', false ) ); if ( class_exists( 'Affiliates_Multi_Tier' ) && get_option( Affiliates_Multi_Tier::ENABLE_TIERS, false ) ) { $IX15058['level'] = array( 'level', false ); } if ( class_exists( 'Groups_Group' ) ) { $IX93470 = Groups_Group::get_group_ids(); if ( isset( $IX93470 ) && ( sizeof( $IX93470 ) > 0 ) ) { $IX15058['group_id'] = array( 'group_id', false ); } } if ( isset( $this->rate_id ) ) { unset( $IX15058['rate_id'] ); } return $IX15058; }

	function get_bulk_actions() { $IX76331 = array( 'delete' => __( 'Delete', 'affiliates' ) ); return $IX76331; }

	function process_bulk_action() { $IX56331 = $this->current_action(); switch( $IX56331 ) { case 'delete' : if ( !empty( $_REQUEST['_rate_id'] ) ) { $IX72306 = $_REQUEST['_rate_id']; if ( is_array( $IX72306 ) ) { foreach( $IX72306 as $IX88430 ) { if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { $IX92041 = new Affiliates_Rate(); if ( $IX92041->read( $IX88430 ) ) { $IX92041->delete(); } } } } } break; } }

	function prepare_items() { global $wpdb; $IX65975 = 10; $IX45685 = $this->get_columns(); $IX60498 = array(); $IX16745 = $this->get_sortable_columns(); $this->_column_headers = array ($IX45685, $IX60498, $IX16745 ); $this->process_bulk_action(); $IX70618 = array(); $IX40027 = isset( $_GET['filter_affiliate_id'] ) ? affiliates_check_affiliate_id( $_GET['filter_affiliate_id'] ) : null; if ( $IX40027 ) { $IX70618['affiliate_id'] = $IX40027; } $IX42055 = isset( $_GET['filter_type'] ) ? $_GET['filter_type'] : null; switch( $IX42055 ) { case AFFILIATES_PRO_RATES_TYPE_RATE : case AFFILIATES_PRO_RATES_TYPE_AMOUNT : case AFFILIATES_PRO_RATES_TYPE_FORMULA : $IX70618['type'] = $IX42055; break; } $IX64483 = affiliates_pro_get_integrations(); $IX17050 = isset( $_GET['filter_integration'] ) ? $_GET['filter_integration'] : null; if ( key_exists( $IX17050, $IX64483 ) ) { $IX70618['integration'] = $IX17050; } $IX22835 = Affiliates_Rate::get_rates( $IX70618 ); $IX26284 = array(); $IX49465 = 0; foreach( $IX22835 as $IX38737 ) { $IX26284[] = $IX38737->to_array(); $IX26284[$IX49465]['rate'] = $IX38737; $IX49465++; } if ( !empty( $IX26284 ) ) { usort( $IX26284, array( __CLASS__, 'sort' ) ); } $IX11818 = $this->get_pagenum(); $IX83717 = count( $IX26284 ); $IX26284 = array_slice( $IX26284, ( ( $IX11818 - 1 ) * $IX65975 ), $IX65975 ); $this->items = $IX26284; $this->set_pagination_args( array( 'total_items' => $IX83717, 'per_page' => $IX65975, 'total_pages' => ceil( $IX83717 / $IX65975 ) ) ); }

	function extra_tablenav( $which ) { echo '<div class="alignleft actions">'; if ( $which === 'top' && !is_singular() ) { $IX73033 = isset( $_GET['filter_affiliate_id'] ) ? affiliates_check_affiliate_id( $_GET['filter_affiliate_id'] ) : null; $IX52923 = affiliates_get_affiliates(); $IX57307 = ''; if ( !empty( $IX52923 ) ) { $IX57307 = '<label>'; $IX57307 .= '<select class="affiliate-id-filter" name="filter_affiliate_id">'; $IX57307 .= sprintf( '<option value="">%s</option>', esc_html( 'Any Affiliate', 'affiliates' ) ); foreach ( $IX52923 as $IX83103 ) { if ( $IX73033 == $IX83103['affiliate_id']) { $IX88162 = ' selected="selected" '; } else { $IX88162 = ''; } $IX57307 .= '<option ' . $IX88162 . ' value="' . esc_attr( $IX83103['affiliate_id'] ) . '">' . esc_attr( stripslashes( $IX83103['name'] ) ) . '</option>'; } $IX57307 .= '</select>'; $IX57307 .= '</label>'; } echo '<style type="text/css">'; echo '.rates-table .tablenav .actions {overflow: visible;}'; echo '.rates-table .selectize-input {padding: 3px 10px;}'; echo '</style>'; echo '<div style="width: 180px;float: left;vertical-align: middle;">'; echo $IX57307; echo Affiliates_UI_Elements::render_select( 'select.affiliate-id-filter' ); echo '</div>'; $IX78835 = isset( $_GET['filter_type'] ) ? $_GET['filter_type'] : null; switch( $IX78835 ) { case AFFILIATES_PRO_RATES_TYPE_RATE : case AFFILIATES_PRO_RATES_TYPE_AMOUNT : case AFFILIATES_PRO_RATES_TYPE_FORMULA : break; default : $IX78835 = null; } echo '<label>'; echo '<select name="filter_type" id="filter-by-type">'; printf( '<option value="" %s>%s</option>', $IX78835 !== null ? ' selected="selected" ' : '', esc_html__( 'Any Type', 'affiliates' ) ); $IX77801 = array( AFFILIATES_PRO_RATES_TYPE_RATE => __( 'Rate', 'affiliates' ), AFFILIATES_PRO_RATES_TYPE_AMOUNT => __( 'Amount', 'affiliates' ), AFFILIATES_PRO_RATES_TYPE_FORMULA => __( 'Formula', 'affiliates' ) ); foreach ( $IX77801 as $IX72674 => $IX82003 ) { $IX88162 = ( $IX72674 === $IX78835 ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX72674 ), $IX88162, esc_html( $IX82003 ) ); } echo '</select>'; echo '</label>'; $IX31222 = affiliates_pro_get_integrations(); $IX19340 = isset( $_GET['filter_integration'] ) ? $_GET['filter_integration'] : null; if ( !key_exists( $IX19340, $IX31222 ) ) { $IX19340 = null; } echo '<label>'; echo '<select name="filter_integration" id="filter-by-integration">'; printf( '<option value="" %s>%s</option>', $IX19340 !== null ? ' selected="selected" ' : '', esc_html__( 'All Integrations', 'affiliates' ) ); if ( count( $IX31222 ) > 0 ) { foreach ( $IX31222 as $IX72674 => $IX40825 ) { $IX88162 = ( $IX72674 === $IX19340 ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX72674 ), $IX88162, esc_html( $IX40825['title'] ) ); } } echo '</select>'; echo '</label>'; submit_button( __( 'Filter', 'affiliates' ), '', 'filter_action', false, array( 'id' => 'post-query-submit' ) ); } echo '</div>'; }

	public static function sort( $item1, $item2 ) { $IX73077 = !empty( $_REQUEST['orderby'] ) ? $_REQUEST['orderby'] : 'rate_id'; $IX94426 = !empty( $_REQUEST['order'] ) ? strtolower( $_REQUEST['order'] ) : 'asc'; $IX92068 = 0; switch ( $IX73077 ) { case 'rate_id' : case 'object_id' : case 'term_id' : case 'level' : $IX27786 = $item1[$IX73077]; $IX98221 = $item2[$IX73077]; if ( $IX27786 === null && $IX98221 === null ) { $IX92068 = 0; } else if ( $IX27786 === null ) { $IX92068 = -1; } else if ( $IX98221 === null ) { $IX92068 = 1; } else { $IX92068 = intval( $item1[$IX73077] ) - intval( $item2[$IX73077] ); } break; case 'value' : $IX92068 = bccomp( $item1['value'], $item2['value'], affiliates_get_referral_amount_decimals() ); break; case 'currency_id' : $IX92068 = strcmp( $item1['currency_id'], $item2['currency_id'] ); break; case 'affiliate_id' : $IX27786 = affiliates_get_affiliate( $item1[$IX73077] ); $IX98221 = affiliates_get_affiliate( $item2[$IX73077] ); if ( $IX27786 === null && $IX98221 === null ) { $IX92068 = 0; } else if ( $IX27786 === null ) { $IX92068 = -1; } else if ( $IX98221 === null ) { $IX92068 = 1; } else { $IX92068 = strcmp( $IX63899['name'], $IX43853['name'] ); } break; case 'group_id' : if ( class_exists( 'Groups_Group' ) ) { $IX95997 = Groups_Group::read( $item1[$IX73077] ); $IX86860 = Groups_Group::read( $item2[$IX73077] ); $IX38519 = ( $IX95997 ) ? $IX95997->name : ''; $IX82638 = ( $IX86860 ) ? $IX86860->name : ''; $IX92068 = strcmp( $IX38519, $IX82638 ); } break; case 'type' : $IX92068 = strcmp( $item1['type'], $item2['type'] ); break; case 'integration' : $IX92068 = strcmp( $item1['integration'], $item2['integration'] ); break; case 'description' : $IX92068 = strcmp( $item1['description'], $item2['description'] );; break; } return ( $IX94426 === 'asc' ) ? $IX92068 : -$IX92068; }

	public static function render( $options = array() ) { global $wpdb; if ( !is_admin() && did_action( 'wp_enqueue_scripts' ) && wp_script_is( 'affiliates-rates' ) ) { wp_enqueue_script( 'affiliates-rates' ); } if ( ( did_action( 'wp_enqueue_scripts' ) || did_action( 'admin_enqueue_scripts' ) ) && wp_style_is( 'affiliates-rates' ) ) { wp_enqueue_style( 'affiliates-rates' ); } $IX72714 = false; if ( isset( $_REQUEST['rate-action'] ) || isset( $_REQUEST['rate-action'] ) ) { if ( wp_verify_nonce($_REQUEST['_wpnonce'] ) ) { if ( isset( $_REQUEST['action'] ) && !isset( $_REQUEST['skip-action'] ) ) { switch( $_REQUEST['action'] ) { case 'create-rate' : if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { $IX20879 = self::get_validated_request_parameters(); $IX61883 = new Affiliates_Rate( (object) array( 'type' => $IX20879['type'], 'value' => $IX20879['value'], 'currency_id' => $IX20879['currency_id'], 'affiliate_id' => $IX20879['affiliate_id'], 'group_id' => $IX20879['group_id'], 'object_id' => $IX20879['object_id'], 'term_id' => $IX20879['term_id'], 'level' => $IX20879['level'], 'integration' => $IX20879['integration'], 'description' => $IX20879['description'] ) ); if ( !empty( $IX20879['level-relative'] ) ) { $IX61883->set_meta( 'level-relative', true ); } if ( !empty( $IX20879['formula'] ) ) { $IX61883->set_meta( 'formula', $IX20879['formula'] ); } if ( !$IX61883->exists() ) { if ( $IX61883->create() ) { $IX72714 = true; echo '<div class="updated">'; echo __( 'Rate created.', 'affiliates' ); echo '</div>'; } else { echo '<div class="error">'; echo __( 'Rate could not be created.', 'affiliates' ); echo '</div>'; } } else { echo '<div class="error">'; echo __( 'An entry with matching conditions already exists.', 'affiliates' ); echo '</div>'; } } else { wp_die( __( 'Access denied.', 'affiliates' ) ); } break; case 'edit-rate' : $IX22824 = !empty( $_REQUEST['rate_id'] ) ? intval( $_REQUEST['rate_id'] ) : null; if ( !empty( $IX22824 ) ) { $IX36048 = new Affiliates_Rate(); if ( $IX36048->read( $IX22824 ) ) { if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { $IX20879 = self::get_validated_request_parameters(); $IX36048->type = $IX20879['type']; $IX36048->value = $IX20879['value']; $IX36048->currency_id = $IX20879['currency_id']; $IX36048->affiliate_id = $IX20879['affiliate_id']; $IX36048->group_id = $IX20879['group_id']; $IX36048->object_id = $IX20879['object_id']; $IX36048->term_id = $IX20879['term_id']; $IX36048->description = $IX20879['description']; $IX36048->integration = $IX20879['integration']; $IX36048->level = $IX20879['level']; if ( !empty( $IX20879['level-relative'] ) && $IX20879['level-relative'] ) { $IX36048->set_meta( 'level-relative', true ); } else { $IX36048->delete_meta( 'level-relative' ); } if ( !empty( $IX20879['formula'] ) ) { $IX36048->set_meta( 'formula', $IX20879['formula'] ); } else { $IX36048->delete_meta( 'formula' ); } if ( !$IX36048->exists_other() ) { if ( $IX36048->update() ) { $IX72714 = true; echo '<div class="updated">'; echo __( 'Rate updated.', 'affiliates' ); echo '</div>'; } else { if ( ( $wpdb->rows_affected === 0 ) && ( $wpdb->last_error === "" ) ) { $IX72714 = true; } else { echo '<div class="error">'; echo __( 'Rate could not be updated.', 'affiliates' ); echo '</div>'; } } } else { echo '<div class="error">'; echo __( 'An entry with matching conditions already exists.', 'affiliates' ); echo '</div>'; } } else { wp_die( __( 'Access denied.', 'affiliates' ) ); } } } break; } } } } $IX53634 = false; $IX77401 = false; if ( !$IX72714 ) { if ( isset( $_REQUEST['action'] ) && isset( $_REQUEST['_wpnonce'] ) && wp_verify_nonce( $_REQUEST['_wpnonce'] ) ) { $IX22824 = isset( $_REQUEST['rate_id'] ) ? intval( $_REQUEST['rate_id'] ) : null; switch( $_REQUEST['action'] ) { case 'create-rate' : $IX53634 = true; self::create_rate_form(); break; case 'edit-rate' : $IX77401 = true; self::edit_rate_form( $IX22824 ); break; } } } if ( !$IX53634 && !$IX77401 ) { $IX19280 = new Affiliates_Rates_Table( $options ); $IX19280->prepare_items(); echo '<div class="rates">'; echo '<form class="rates-table" method="get">'; echo '<div>'; echo '<div class="buttons">'; $IX90770 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX90770 = remove_query_arg( 'action', $IX90770 ); printf( "<a class='button button-primary page-title-action' title='%s' href='%s'>%s</a>", esc_attr( __( 'Create a new rate', 'affiliates' ) ), esc_url( wp_nonce_url( add_query_arg( array( 'action' => 'create-rate' ), $IX90770 ) ) ), __( 'New Rate', 'affiliates' ) ); echo '</div>'; echo '<br/>'; if ( isset( $_REQUEST['page'] ) ) { echo sprintf( '<input type="hidden" name="page" value="%s" />', esc_attr( $_REQUEST['page'] ) ); } $IX19280->display(); echo '</div>'; echo '</form>'; echo '</div>'; } }

	private static function get_validated_request_parameters() { $IX37534 = !empty( $_REQUEST['type'] ) ? trim( $_REQUEST['type'] ): AFFILIATES_PRO_RATES_TYPE_RATE; switch( $IX37534 ) { case AFFILIATES_PRO_RATES_TYPE_AMOUNT : case AFFILIATES_PRO_RATES_TYPE_RATE : case AFFILIATES_PRO_RATES_TYPE_FORMULA : break; default : $IX37534 = AFFILIATES_PRO_RATES_TYPE_RATE; } $IX65251 = null; switch ( $IX37534 ) { case AFFILIATES_PRO_RATES_TYPE_FORMULA : $IX59964 = new Affiliates_Formula_Tokenizer( trim( $_REQUEST['value'] ) ); $IX59964->tokenize(); $IX65251 = $IX59964->to_string(); $IX46286 = bcadd( '0', '0', affiliates_get_referral_amount_decimals() ); break; default : $IX46286 = !empty( $_REQUEST['value'] ) ? trim( $_REQUEST['value'] ) : '0'; $IX46286 = bcadd( '0', $IX46286, affiliates_get_referral_amount_decimals() ); } $IX57842 = !empty( $_REQUEST['currency_id'] ) ? Affiliates_Utility::verify_currency_id( trim( $_REQUEST['currency_id'] ) ) : null; if ( $IX57842 === false ) { $IX57842 = null; } $IX59648 = !empty( $_REQUEST['affiliate_id'] ) ? intval( trim( $_REQUEST['affiliate_id'] ) ) : null; $IX59192 = !empty( $_REQUEST['integration'] ) ? trim( $_REQUEST['integration'] ) : null; $IX65665 = !empty( $_REQUEST['object_id'] ) ? intval( trim( $_REQUEST['object_id'] ) ) : null; $IX48096 = !empty( $_REQUEST['term_id'] ) ? intval( trim( $_REQUEST['term_id'] ) ) : null; $IX46915 = !empty( $_REQUEST['description'] ) ? stripslashes( wp_strip_all_tags( trim( $_REQUEST['description'] ) ) ) : null; $IX77090 = null; if ( class_exists( 'Groups_Group' ) ) { $IX28242 = Groups_Group::get_group_ids(); if ( isset( $_REQUEST['group_id'] ) && in_array( intval( $_REQUEST['group_id'] ), $IX28242 ) ) { $IX77090 = intval( $_REQUEST['group_id'] ); } } $IX21074 = null; $IX87627 = null; if ( class_exists( 'Affiliates_Multi_Tier' ) ) { $IX14316 = intval( get_option( Affiliates_Multi_Tier::N_TIERS, Affiliates_Multi_Tier::MAX_TIERS ) ); $IX21074 = !empty( $_REQUEST['level'] ) ? intval( trim( $_REQUEST['level'] ) ) : null; if ( $IX21074 !== null ) { $IX21074 = max( min( $IX14316, $IX21074 ), 1 ); $IX21074--; } $IX87627 = !empty( $_REQUEST['level-relative'] ); } return array( 'type' => $IX37534, 'value' => $IX46286, 'currency_id' => $IX57842, 'level' => $IX21074, 'level-relative' => $IX87627, 'affiliate_id' => $IX59648, 'group_id' => $IX77090, 'integration' => $IX59192, 'object_id' => $IX65665, 'term_id' => $IX48096, 'description' => $IX46915, 'formula' => $IX65251 ); }

	public static function create_rate_form( ) { global $wpdb; wp_enqueue_style( 'affiliates-rates' ); if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { $IX67847 = self::get_validated_request_parameters(); $IX77977 = $IX67847['type']; $IX78604 = $IX67847['value']; $IX59839 = $IX67847['currency_id']; $IX12439 = $IX67847['affiliate_id']; $IX98973 = $IX67847['group_id']; $IX78498 = $IX67847['object_id']; $IX92013 = $IX67847['term_id']; $IX84195 = $IX67847['description']; $IX95679 = $IX67847['integration']; $IX39768 = $IX67847['level']; $IX54128 = $IX67847['level-relative']; $IX22699 = $IX67847['formula']; echo '<div class="rate-create">'; echo '<h2>'; echo __( 'New Rate', 'affiliates' ); echo '</h2>'; printf( '<form action="%s" method="post">', esc_attr( self::current_url_clean() ) ); echo '<div>'; echo '<div class="field type">'; echo '<label>'; echo '<span class="label">'; echo __( 'Type', 'affiliates' ); echo '</span>'; echo ' '; echo '<select name="type">'; $IX45687 = ( $IX77977 == AFFILIATES_PRO_RATES_TYPE_RATE ) ? 'selected="selected"' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( AFFILIATES_PRO_RATES_TYPE_RATE ), $IX45687, esc_html( __( 'Rate', 'affiliates' ) ) ); $IX45687 = ( $IX77977 == AFFILIATES_PRO_RATES_TYPE_AMOUNT ) ? 'selected="selected"' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( AFFILIATES_PRO_RATES_TYPE_AMOUNT ), $IX45687, esc_html( __( 'Amount', 'affiliates' ) ) ); $IX45687 = ( $IX77977 == AFFILIATES_PRO_RATES_TYPE_FORMULA ) ? 'selected="selected"' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( AFFILIATES_PRO_RATES_TYPE_FORMULA ), $IX45687, esc_html( __( 'Formula', 'affiliates' ) ) ); echo '</select>'; echo '</label>'; echo '</div>'; echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Value', 'affiliates' ); echo '</span>'; echo ' '; if ( $IX77977 === AFFILIATES_PRO_RATES_TYPE_FORMULA ) { if ( $IX22699 === null ) { $IX22699 = ''; } printf( '<input type="text" name="value" value="%s" />', esc_attr( $IX22699 ) ); } else { printf( '<input type="text" name="value" value="%s" />', esc_attr( $IX78604 ) ); } echo '</label>'; echo '</div>'; echo '<div class="field currency_id">'; echo '<label>'; echo '<span class="label">'; echo __( 'Currency ID', 'affiliates' ); echo '</span>'; echo ' '; if ( $IX59839 === null ) { echo '<input type="text" name="currency_id" value="" />'; } else { echo sprintf( '<input type="text" name="currency_id" value="%s" />', esc_attr( $IX59839 ) ); } echo ' '; echo '<span class="description">' . __( 'Leave this empty in most cases. It is only required in cases where the currency cannot be determined from the originating transaction. Examples: USD, GBP, EUR, ...', 'affiliates') . '</span>'; echo '</label>'; echo '</div>'; echo '<div class="field affiliate_id">'; echo Affiliates_UI_Elements::affiliates_select( array( 'affiliate_id' => $IX12439, 'label-prefix' => '<span class="label">', 'label-suffix' => '</span>' ) ); echo Affiliates_UI_Elements::render_select(); echo '</div>'; if ( class_exists( 'Groups_Group' ) ) { if ( $IX48141 = Groups_Group::get_groups( array( 'orderby'=> 'name' ) ) ) { echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Group', 'affiliates' ); echo '</span>'; echo ' '; echo '<select name="group_id" class="group-id-select">'; printf( '<option value="" %s>--</option>', empty( $IX98973 ) ? ' selected="selected" ' : '' ); foreach ( $IX48141 as $IX30836 ) { printf( '<option value="%d" %s>%s</option>', $IX30836->group_id, $IX98973 == $IX30836->group_id ? ' selected="selected" ' : '', esc_html( $IX30836->name ) ); } echo '</select>'; echo '</label>'; echo '</div>'; echo Groups_UIE::render_select( 'select.group-id-select' ); } } echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Integration', 'affiliates' ); echo '</span>'; echo ' '; echo '<select class="update-skip-action" name="integration" id="integration">'; printf( '<option value="" %s>--</option>', empty( $IX95679 ) ? ' selected="selected" ' : '' ); $IX52603 = affiliates_pro_get_integrations(); if ( count( $IX52603 ) > 0 ) { foreach ( $IX52603 as $IX47183 => $IX67299 ) { $IX45687 = ( $IX95679 == $IX47183 ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX47183 ), $IX45687, esc_html( $IX67299['title'] ) ); } } echo '</select>'; echo '</label>'; echo '</div>'; printf( '<input type="hidden" id="ajax_object_id" value="%s" />', esc_attr( $IX78498 ) ); printf( '<input type="hidden" id="ajax_term_id" value="%s" />', esc_attr( $IX92013 ) ); echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Object', 'affiliates' ); echo '</span>'; echo ' '; switch( isset( $IX52603[$IX95679] ) ? $IX95679 : '' ) { case 'affiliates-formidable' : if ( class_exists( 'FrmForm' ) && method_exists( 'FrmForm', 'get_published_forms' ) ) { echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX78498 ) ? ' selected="selected" ' : '' ); $IX27539 = FrmForm::get_published_forms( array(), '' ); foreach ( $IX27539 as $IX63443 ) { $IX45687 = ( $IX78498 == $IX63443->id ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX63443->id ), $IX45687, esc_html( !empty( $IX63443->name ) ? '#' . $IX63443->id . ' &ndash; ' . $IX63443->name : 'Formidable Forms &ndash; #' . $IX63443->id ) ); } echo '</select>'; } break; case 'affiliates-gravityforms' : if ( class_exists( 'GFAPI' ) && method_exists( 'GFAPI', 'get_forms' ) ) { echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX78498 ) ? ' selected="selected" ' : '' ); $IX27539 = GFAPI::get_forms(); foreach ( $IX27539 as $IX63443 ) { $IX45687 = ( $IX78498 == $IX63443['id'] ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX63443['id'] ), $IX45687, esc_html( !empty( $IX63443['title'] ) ? '#' . $IX63443['id'] . ' &ndash; ' . $IX63443['title'] : 'Gravity Forms &ndash; #' . $IX63443['id'] ) ); } echo '</select>'; } break; case 'affiliates-ninja-forms' : if ( class_exists( 'Ninja_Forms' ) ) { echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX78498 ) ? ' selected="selected" ' : '' ); foreach ( Ninja_Forms()->form()->get_forms() as $IX63443 ) { $IX45687 = ( $IX78498 == $IX63443->get_id() ) ? ' selected="selected" ' : ''; $IX93300 = $IX63443->get_setting( 'title' ); printf( '<option value="%s" %s >%s</option>', esc_attr( $IX63443->get_id() ), $IX45687, esc_html( !empty( $IX93300 ) ? '#' . $IX63443->get_id() . ' &ndash; ' . $IX93300 : 'Ninja Forms &ndash; #' . $IX63443->get_id() ) ); } echo '</select>'; } break; case 'affiliates-paypal' : printf( '<input type="text" name="object_id" id="post_type_select" value="%s" placeholder="%s"/>', !empty( $IX78498 ) ? esc_attr( $IX78498 ) : '', __( 'Item ID (numeric) or empty', 'affiliates' ) ); break; case 'affiliates-woocommerce' : if ( function_exists( 'wc_get_product' ) ) { wp_enqueue_script( 'wc-enhanced-select' ); wp_enqueue_style( 'woocommerce_admin_styles' ); wp_enqueue_style( 'jquery-ui-style' ); global $woocommerce; if ( isset( $woocommerce ) && version_compare( $woocommerce->version, '3.0.0' ) >= 0 ) { ?>
							<select class="wc-product-search" style="width:203px;" id="object_id" name="object_id" data-multiple="false" data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce' ); ?>" data-action="woocommerce_json_search_products_and_variations">
								<?php
 $IX67172 = wc_get_product( $IX78498 ); if ( is_object( $IX67172 ) ) { echo '<option value="' . esc_attr( $IX78498 ) . '"' . selected( true, true, false ) . '>' . wp_kses_post( $IX67172->get_formatted_name() ) . '</option>'; } ?>
							</select>
							<?php
 } else { ?>
							<input type="hidden" class="wc-product-search" data-multiple="false" style="width: 50%;" id="object_id" name="object_id" data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce' ); ?>" data-action="woocommerce_json_search_products_and_variations" data-selected="<?php
 $IX65185 = array(); $IX67172 = wc_get_product( $IX78498 ); if ( is_object( $IX67172 ) ) { $IX65185[ $IX78498 ] = wp_kses_post( $IX67172->get_formatted_name() ); } echo esc_attr( json_encode( $IX65185 ) ); ?>" value="<?php echo implode( ',', array_keys( $IX65185 ) ); ?>" />
							<?php
 } } break; case 'affiliates-contact-form-7' : case 'affiliates-events-manager' : default : echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX78498 ) ? ' selected="selected" ' : '' ); if ( isset( $IX52603[$IX95679] ) && !empty( $IX52603[$IX95679]['object'] ) ) { $IX98653 = get_posts( array( 'post_type' => $IX52603[$IX95679]['object'] ) ); if ( $IX98653 && ( sizeof( $IX98653 ) > 0 ) ) { foreach ( $IX98653 as $IX17770 ) { $IX45687 = ( $IX78498 == $IX17770->ID ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX17770->ID ), $IX45687, esc_html( '#' . $IX17770->ID . ' &ndash; ' . $IX17770->post_title ) ); } } } echo '</select>'; } echo '</label>'; echo '</div>'; echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Term', 'affiliates' ); echo '</span>'; echo ' '; echo '<select name="term_id" id="term_select">'; printf( '<option value="" %s>--</option>', empty( $IX92013 ) ? ' selected="selected" ' : '' ); if ( isset( $IX52603[$IX95679] ) && !empty( $IX52603[$IX95679]['taxonomy'] ) && taxonomy_exists( $IX52603[$IX95679]['taxonomy'] ) ) { $IX54505 = get_terms( array( 'taxonomy' => $IX52603[$IX95679]['taxonomy'] ) ); if ( $IX54505 && ( sizeof( $IX54505 ) > 0 ) ) { foreach ( $IX54505 as $IX78679 ) { $IX45687 = ( $IX92013 == $IX78679->term_id ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX78679->term_id ), $IX45687, esc_html( '#' . $IX78679->term_id . ' &ndash; ' . $IX78679->name ) ); } } } echo '</select>'; echo '</label>'; echo '</div>'; if ( class_exists( 'Affiliates_Multi_Tier' ) && get_option( Affiliates_Multi_Tier::ENABLE_TIERS, false ) ) { $IX76808 = get_option( Affiliates_Multi_Tier::N_TIERS, Affiliates_Multi_Tier::MAX_TIERS ); echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Level', 'affiliates' ); echo '</span>'; echo ' '; if ( $IX39768 === null ) { printf( '<input name="level" type="number" value="" min="1" max="%d" />', intval( $IX76808 ) ); } else { printf( '<input name="level" type="number" value="%d" min="1" max="%d" />', esc_attr( $IX39768 + 1 ), intval( $IX76808 ) ); } echo '</label>'; echo '<label>'; printf( '<input name="level-relative" type="checkbox" %s />', $IX54128 ? ' checked="checked" ' : '' ); echo ' '; echo __( 'Relative', 'affiliates' ); echo '</label>'; echo '</div>'; } echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Description', 'affiliates' ); echo '</span>'; echo ' '; printf( '<textarea name="description">%s</textarea>', esc_textarea( $IX84195 ) ); echo '</label>'; echo '</div>'; echo '<div class="buttons">'; printf( '<input type="submit" name="rate-action" class="button button-primary action" value="%s" />', esc_attr( __( 'Create', 'affiliates' ) ) ); echo '<input type="hidden" name="action" value="create-rate" />'; echo ' '; self::cancel_link(); wp_nonce_field(); wp_referer_field(); echo '</div>'; echo '</div>'; echo '</form>'; echo '</div>'; } else { wp_die( __( 'Access denied.', 'affiliates' ) ); } }

	public static function edit_rate_form( $rate_id ) { global $wpdb; wp_enqueue_style( 'affiliates-rates' ); if ( current_user_can( AFFILIATES_ADMINISTER_AFFILIATES ) ) { $IX25255 = new Affiliates_Rate(); if ( $IX25255->read( $rate_id ) ) { if ( !empty( $_REQUEST['rate-action'] ) && !empty( $_REQUEST['skip-action'] ) ) { $IX59923 = self::get_validated_request_parameters(); $IX25255->type = $IX59923['type']; $IX25255->value = $IX59923['value']; $IX25255->currency_id = $IX59923['currency_id']; $IX25255->affiliate_id = $IX59923['affiliate_id']; $IX25255->group_id = $IX59923['group_id']; $IX25255->object_id = $IX59923['object_id']; $IX25255->term_id = $IX59923['term_id']; $IX25255->description = $IX59923['description']; $IX25255->integration = $IX59923['integration']; $IX25255->level = $IX59923['level']; } echo '<div class="rate-edit">'; echo '<h2>'; echo __( 'Edit Rate', 'affiliates' ); echo '</h2>'; printf( '<form action="%s" method="post">', esc_attr( self::current_url_clean() ) ); echo '<div>'; echo '<div class="field type">'; echo '<label>'; echo '<span class="label">'; echo __( 'Type', 'affiliates' ); echo '</span>'; echo ' '; echo '<select name="type">'; $IX87313 = ( $IX25255->type == AFFILIATES_PRO_RATES_TYPE_RATE ) ? 'selected="selected"' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( AFFILIATES_PRO_RATES_TYPE_RATE ), $IX87313, esc_html( __( 'Rate', 'affiliates' ) ) ); $IX87313 = ( $IX25255->type == AFFILIATES_PRO_RATES_TYPE_AMOUNT ) ? 'selected="selected"' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( AFFILIATES_PRO_RATES_TYPE_AMOUNT ), $IX87313, esc_html( __( 'Amount', 'affiliates' ) ) ); $IX87313 = ( $IX25255->type == AFFILIATES_PRO_RATES_TYPE_FORMULA ) ? 'selected="selected"' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( AFFILIATES_PRO_RATES_TYPE_FORMULA ), $IX87313, esc_html( __( 'Formula', 'affiliates' ) ) ); echo '</select>'; echo '</label>'; echo '</div>'; echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Value', 'affiliates' ); echo '</span>'; echo ' '; if ( $IX25255->type === AFFILIATES_PRO_RATES_TYPE_FORMULA ) { $IX26562 = $IX25255->get_meta( 'formula' ); if ( $IX26562 === null ) { $IX26562 = ''; } printf( '<input type="text" name="value" value="%s" />', esc_attr( $IX26562 ) ); } else { printf( '<input type="text" name="value" value="%s" />', esc_attr( $IX25255->value ) ); } echo '</label>'; echo '</div>'; echo '<div class="field currency_id">'; echo '<label>'; echo '<span class="label">'; echo __( 'Currency ID', 'affiliates' ); echo '</span>'; echo ' '; if ( $IX25255->currency_id === null ) { echo '<input type="text" name="currency_id" value="" />'; } else { echo sprintf( '<input type="text" name="currency_id" value="%s" />', esc_attr( $IX25255->currency_id ) ); } echo ' '; echo '<span class="description">' . __( 'Leave this empty in most cases. It is only required in cases where the currency cannot be determined from the originating transaction. Examples: USD, GBP, EUR, ...', 'affiliates') . '</span>'; echo '</label>'; echo '</div>'; $IX57274 = null; if ( $IX25255->affiliate_id ) { $IX57274 = intval( $IX25255->affiliate_id ); } echo '<div class="field affiliate_id">'; echo Affiliates_UI_Elements::affiliates_select( array( 'affiliate_id' => $IX57274, 'label-prefix' => '<span class="label">', 'label-suffix' => '</span>' ) ); echo Affiliates_UI_Elements::render_select(); echo '</div>'; if ( class_exists( 'Groups_Group' ) ) { $IX73109 = _groups_get_tablename( 'group' ); if ( $IX87652 = Groups_Group::get_groups( array( 'orderby'=> 'name' ) ) ) { echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Group', 'affiliates' ); echo '</span>'; echo ' '; echo '<select name="group_id" class="group-id-select">'; printf( '<option value="" %s>--</option>', !$IX25255->group_id ? ' selected="selected" ' : '' ); foreach ( $IX87652 as $IX60721 ) { printf( '<option value="%d" %s>%s</option>', Groups_Utility::id( $IX60721->group_id ), $IX60721->group_id == $IX25255->group_id ? ' selected="selected" ' : '', esc_html( $IX60721->name ) ); } echo '</select>'; echo '</label>'; echo '</div>'; echo Groups_UIE::render_select( 'select.group-id-select' ); } } echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Integration', 'affiliates' ); echo '</span>'; echo ' '; echo '<select class="update-skip-action" name="integration" id="integration">'; printf( '<option value="" %s>--</option>', !$IX25255->integration ? ' selected="selected" ' : '' ); $IX49765 = affiliates_pro_get_integrations(); if ( count( $IX49765 ) > 0 ) { foreach ( $IX49765 as $IX77290 => $IX38912 ) { $IX87313 = ( $IX77290 == $IX25255->integration ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX77290 ), $IX87313, esc_html( $IX38912['title'] ) ); } } echo '</select>'; echo '</label>'; echo '</div>'; printf( '<input type="hidden" id="ajax_object_id" value="%s" />', esc_attr( $IX25255->object_id ) ); printf( '<input type="hidden" id="ajax_term_id" value="%s" />', esc_attr( $IX25255->term_id ) ); echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Object', 'affiliates' ); echo '</span>'; echo ' '; switch( isset( $IX49765[$IX25255->integration] ) ? $IX25255->integration : '' ) { case 'affiliates-formidable' : if ( class_exists( 'FrmForm' ) && method_exists( 'FrmForm', 'get_published_forms' ) ) { echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX25255->object_id ) ? ' selected="selected" ' : '' ); $IX39794 = FrmForm::get_published_forms( array(), '' ); foreach ( $IX39794 as $IX53543 ) { $IX87313 = ( $IX25255->object_id == $IX53543->id ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX53543->id ), $IX87313, esc_html( !empty( $IX53543->name ) ? '#' . $IX53543->id . ' &ndash; ' . $IX53543->name : 'Formidable Forms &ndash; #' . $IX53543->id ) ); } echo '</select>'; } break; case 'affiliates-gravityforms' : if ( class_exists( 'GFAPI' ) && method_exists( 'GFAPI', 'get_forms' ) ) { echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX25255->object_id ) ? ' selected="selected" ' : '' ); $IX39794 = GFAPI::get_forms(); foreach ( $IX39794 as $IX53543 ) { $IX87313 = ( $IX25255->object_id == $IX53543['id'] ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX53543['id'] ), $IX87313, esc_html( !empty( $IX53543['title'] ) ? '#' . $IX53543['id'] . ' &ndash; ' . $IX53543['title'] : 'Gravity Forms &ndash; #' . $IX53543['id'] ) ); } echo '</select>'; } break; case 'affiliates-ninja-forms' : if ( class_exists( 'Ninja_Forms' ) ) { echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX25255->object_id ) ? ' selected="selected" ' : '' ); foreach ( Ninja_Forms()->form()->get_forms() as $IX53543 ) { $IX87313 = ( $IX25255->object_id == $IX53543->get_id() ) ? ' selected="selected" ' : ''; $IX25592 = $IX53543->get_setting( 'title' ); printf( '<option value="%s" %s >%s</option>', esc_attr( $IX53543->get_id() ), $IX87313, esc_html( !empty( $IX25592 ) ? '#' . $IX53543->get_id() . ' &ndash; ' . $IX25592 : 'Ninja Forms &ndash; #' . $IX53543->get_id() ) ); } echo '</select>'; } break; case 'affiliates-paypal' : printf( '<input type="text" name="object_id" id="post_type_select" value="%s" placeholder="%s"/>', $IX25255->object_id !== null ? esc_attr( $IX25255->object_id ) : '', __( 'Item ID (numeric) or empty', 'affiliates' ) ); break; case 'affiliates-woocommerce' : if ( function_exists( 'wc_get_product' ) ) { wp_enqueue_script( 'wc-enhanced-select' ); wp_enqueue_style( 'woocommerce_admin_styles' ); wp_enqueue_style( 'jquery-ui-style' ); global $woocommerce; if ( isset( $woocommerce ) && version_compare( $woocommerce->version, '3.0.0' ) >= 0 ) { ?>
								<select class="wc-product-search" style="width:203px;" id="object_id" name="object_id" data-multiple="true" data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce' ); ?>" data-action="woocommerce_json_search_products_and_variations">
								<?php
 $IX55885 = wc_get_product( $IX25255->object_id ); if ( is_object( $IX55885 ) ) { echo '<option value="' . esc_attr( $IX25255->object_id ) . '"' . selected( true, true, false ) . '>' . wp_kses_post( $IX55885->get_formatted_name() ) . '</option>'; } ?>
								</select>
								<?php
 } else { ?>
								<input type="hidden" class="wc-product-search" data-multiple="false" style="width: 50%;" id="object_id" name="object_id"
								data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce' ); ?>"
								data-action="woocommerce_json_search_products_and_variations"
								data-selected="<?php
 $IX98090 = array(); $IX55885 = wc_get_product( $IX25255->object_id ); if ( is_object( $IX55885 ) ) { $IX98090[ $IX25255->object_id ] = wp_kses_post( $IX55885->get_formatted_name() ); } echo esc_attr( json_encode( $IX98090 ) ); ?>"
								value="<?php echo implode( ',', array_keys( $IX98090 ) ); ?>"
								/>
								<?php
 } } break; case 'affiliates-contact-form-7' : case 'affiliates-events-manager' : default : echo '<select name="object_id" id="post_type_select">'; printf( '<option value="" %s>--</option>', empty( $IX55052 ) ? ' selected="selected" ' : '' ); if ( isset( $IX49765[$IX25255->integration] ) && !empty( $IX49765[$IX25255->integration]['object'] )) { $IX72724 = get_posts( array( 'post_type' => $IX49765[$IX25255->integration]['object'] ) ); if ( $IX72724 && ( sizeof( $IX72724 ) > 0 ) ) { foreach ( $IX72724 as $IX32193 ) { $IX87313 = ( $IX25255->object_id == $IX32193->ID ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX32193->ID ), $IX87313, esc_html( '#' . $IX32193->ID . ' &ndash; ' . $IX32193->post_title ) ); } } } echo '</select>'; } echo '</label>'; echo '</div>';; echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Term', 'affiliates' ); echo '</span>'; echo ' '; echo '<select name="term_id" id="term_select">'; printf( '<option value="" %s>--</option>', empty( $IX28188 ) ? ' selected="selected" ' : '' ); if ( isset( $IX49765[$IX25255->integration] ) ) { if ( !empty( $IX49765[$IX25255->integration]['taxonomy'] ) && taxonomy_exists( $IX49765[$IX25255->integration]['taxonomy']) ) { $IX79492 = get_terms( array( 'taxonomy' => $IX49765[$IX25255->integration]['taxonomy'] ) ); if ( $IX79492 && ( sizeof( $IX79492 ) > 0 ) ) { foreach ( $IX79492 as $IX53126 ) { $IX87313 = ( $IX25255->term_id == $IX53126->term_id ) ? ' selected="selected" ' : ''; printf( '<option value="%s" %s >%s</option>', esc_attr( $IX53126->term_id ), $IX87313, esc_html( '#' . $IX53126->term_id . ' &ndash; ' .$IX53126->name ) ); } } } } echo '</select>'; echo '</label>'; echo '</div>'; if ( class_exists( 'Affiliates_Multi_Tier' ) && get_option( Affiliates_Multi_Tier::ENABLE_TIERS, false ) ) { $IX79553 = get_option( Affiliates_Multi_Tier::N_TIERS, Affiliates_Multi_Tier::MAX_TIERS ); echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Level', 'affiliates' ); echo '</span>'; echo ' '; if ( $IX25255->level === null ) { printf( '<input name="level" type="number" value="" min="1" max="%d" />', intval( $IX79553 ) ); } else { printf( '<input name="level" type="number" value="%d" min="1" max="%d" />', esc_attr( $IX25255->level + 1 ), intval( $IX79553 ) ); } echo '</label>'; $IX72580 = $IX25255->get_meta( 'level-relative' ); echo '<label>'; printf( '<input name="level-relative" type="checkbox" %s />', $IX72580 ? ' checked="checked" ' : '' ); echo ' '; echo __( 'Relative', 'affiliates' ); echo '</label>'; echo '</div>'; } echo '<div class="field value">'; echo '<label>'; echo '<span class="label">'; echo __( 'Description', 'affiliates' ); echo '</span>'; echo ' '; printf( '<textarea name="description">%s</textarea>', esc_textarea( $IX25255->description ) ); echo '</label>'; echo '</div>'; echo '<div class="buttons">'; printf( '<input type="hidden" name="rate_id" value="%d" />', intval( $rate_id ) ); printf( '<input type="submit" name="rate-action" class="button button-primary action" value="%s" />', __( 'Save', 'affiliates' ) ); echo '<input type="hidden" name="action" value="edit-rate" />'; echo ' '; self::cancel_link(); wp_nonce_field(); echo '</div>'; echo '</div>'; echo '</form>'; echo '</div>'; } } }

	private static function cancel_link() { $IX23112 = self::current_url_clean(); printf( '<a class="button action" title="%s" href="%s">%s</a>', esc_attr( __( 'Cancel this action', 'affiliates' ) ), esc_url( $IX23112 ), esc_html( __( 'Cancel', 'affiliates' ) ) ); }

	private static function current_url_clean() { $IX88033 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX88033 = remove_query_arg( 'rate_id', $IX88033 ); $IX88033 = remove_query_arg( 'action', $IX88033 ); $IX88033 = remove_query_arg( '_wpnonce', $IX88033 ); return $IX88033; }

	public static function admin_enqueue_scripts() { wp_register_style( 'affiliates-rates', AFFILIATES_PRO_PLUGIN_URL . 'css/affiliates-rates.css', array(), AFFILIATES_EXT_VERSION ); }

	public static function wp_enqueue_scripts() { wp_register_script( 'affiliates-rates', AFFILIATES_PRO_PLUGIN_URL . 'js/affiliates-rates.js', array( 'jquery' ), AFFILIATES_EXT_VERSION, true ); wp_register_style( 'affiliates-rates', AFFILIATES_PRO_PLUGIN_URL . 'css/affiliates-rates.css', array(), AFFILIATES_EXT_VERSION ); }

	public static function init() { }
}
Affiliates_Rates_Table::init();
