<?php
/**
 * class-affiliates-settings-integrations-ext.php
 * 
 * Copyright (c) 2015 "kento" Karim Rahimpur www.itthinx.com
 *
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 2.8.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Integration section.
 */
class Affiliates_Settings_Integrations_Ext {

	private static $integrations = null;

	public static function init() { add_filter( 'affiliates_settings_integrations', array( __CLASS__, 'affiliates_settings_integrations' ) ); add_filter( 'plugins_api', array( __CLASS__, 'plugins_api'), 10, 3 ); add_filter( 'affiliates_settings_integration_button', array( __CLASS__, 'affiliates_settings_integration_button' ), 10, 4 ); add_filter( 'affiliates_settings_integration_explanation', array( __CLASS__, 'affiliates_settings_integration_explanation' ), 10, 4 ); }

	public static function sort( $o1, $o2 ) { $IX41159 = 0; if ( in_array('affiliates-pro', $o1['targets'] ) ) { $IX41159++; } if ( in_array('affiliates-pro', $o2['targets'] ) ) { $IX41159--; } if ( in_array('affiliates-enterprise', $o1['targets'] ) ) { $IX41159++; } if ( in_array('affiliates-pro', $o1['targets'] ) ) { $IX41159--; } if ( isset( $o1['priority'] ) ) { $IX41159 += $o1['priority']; } if ( isset( $o2['priority'] ) ) { $IX41159 -= $o2['priority']; } return -$IX41159; }

	public static function affiliates_settings_integrations( $integrations ) { $IX60044 = apply_filters( 'active_plugins', get_option('active_plugins' ) ); if ( !in_array( 'itthinx-updates/itthinx-updates.php', $IX60044 ) ) { echo '<div class="error">'; echo '<p>'; echo __( 'To maintain advanced integrations, the <strong>itthinx updates</strong> plugin is required.', 'affiliates' ); echo '</p>'; echo '<p>'; printf( __( 'Please install and activate the <a href="%s">itthinx updates</a> plugin to enable automatic updates for your plugins by itthinx.', 'affiliates' ), esc_url( 'http://www.itthinx.com/plugins/itthinx-updates/' ) ); echo '</p>'; echo '</div>'; } $integrations['affiliates-woocommerce'] = array( 'title' => __( 'WooCommerce', 'affiliates' ), 'plugin_title' => __( 'Affiliates WooCommerce Integration', 'affiliates' ), 'plugin_url' => 'http://www.itthinx.com/plugins/affiliates-woocommerce/', 'description' => sprintf( __( 'This plugin integrates <a href="%s">Affiliates Pro</a> and <a href="%s">Affiliates Enterprise</a> with <a href="%s">WooCommerce</a>. With this advanced integration plugin, referrals are created and synchronized automatically for your affiliates when sales are made. This integration also supports referrals on recurring payments related to subscriptions and coupons related to affiliates to grant referrals when customers use them to credit the corresponding affiliate.', 'affiliates' ), 'http://www.itthinx.com/shop/affiliates-pro/', 'http://www.itthinx.com/shop/affiliates-enterprise/', 'https://woocommerce.com/?aff=7223&cid=1656523' ), 'plugin_file' => 'affiliates-woocommerce/affiliates-woocommerce.php', 'notes' => __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ), 'repository' => 'itthinx', 'access' => 'non-free', 'targets' => array( 'affiliates-pro', 'affiliates-enterprise' ), 'platforms' => array( 'woocommerce' ), 'priority' => 100, 'class' => 'ext', 'super' => 'affiliates-woocommerce-light' ); if ( is_plugin_active( 'affiliates-woocommerce-light/affiliates-woocommerce-light.php' ) ) { if ( is_plugin_active( 'affiliates-woocommerce/affiliates-woocommerce.php' ) ) { echo '<div class="error">'; echo '<p>'; echo __( 'You should deactivate the <a href="#integration-affiliates-woocommerce-light">Affiliates WooCommerce Integration Light</a> and only leave the advanced <a href="#integration-affiliates-woocommerce">Affiliates WooCommerce Integration</a> activated.', 'affiliates' ); echo '</p>'; echo '</div>'; } else { echo '<div class="error">'; echo '<p>'; echo __( 'Instead of <a href="#integration-affiliates-woocommerce-light">Affiliates WooCommerce Integration Light</a>, you should install and activate the advanced <a href="#integration-affiliates-woocommerce">Affiliates WooCommerce Integration</a>.', 'affiliates' ); echo '</p>'; echo '</div>'; } } $integrations['affiliates-addtoany'] = array( 'title' => __( 'AddToAny', 'affiliates' ), 'plugin_title' => __( 'Affiliates AddToAny Integration', 'affiliates' ), 'plugin_url' => 'http://www.itthinx.com/plugins/affiliates-addthis/', 'description' => __( 'This plugin integrates <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> and <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a> with <a href="http://www.addtoany.com/">AddToAny</a> &hellip; <em>&ldquo;The Universal Sharing Platform&rdquo;</em>. The <a href="https://wordpress.org/plugins/add-to-any/">Share Buttons by AddToAny</a> are required.', 'affiliates' ), 'plugin_file' => 'affiliates-addtoany/affiliates-addtoany.php', 'notes' => __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ), 'repository' => 'itthinx', 'access' => 'non-free', 'targets' => array( 'affiliates-pro', 'affiliates-enterprise' ), 'platforms' => array( 'addtoany' ), 'priority' => 80, 'class' => 'ext' ); $integrations['affiliates-addthis'] = array( 'title' => __( 'AddThis', 'affiliates' ), 'plugin_title' => __( 'Affiliates AddThis Integration', 'affiliates' ), 'plugin_url' => 'http://www.itthinx.com/plugins/affiliates-addthis/', 'description' => __( 'This plugin integrates <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> and <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a> with <a href="http://www.addthis.com/">AddThis</a> &hellip; <em>&ldquo;Website tools that drive more shares, follows and conversions&rdquo;</em>. The <a href="https://wordpress.org/plugins/addthis/">Smart Website Tools</a> by AddThis are required.', 'affiliates' ), 'plugin_file' => 'affiliates-addthis/affiliates-addthis.php', 'notes' => __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ), 'repository' => 'itthinx', 'access' => 'non-free', 'targets' => array( 'affiliates-pro', 'affiliates-enterprise' ), 'platforms' => array( 'addthis' ), 'priority' => 70, 'class' => 'ext' ); $integrations['affiliates-ppc'] = array( 'title' => __( 'Pay per Click', 'affiliates' ), 'plugin_title' => __( 'Affiliates Pay per Click', 'affiliates' ), 'plugin_url' => 'http://www.itthinx.com/plugins/affiliates-ppc/', 'description' => __( 'Pay affiliate commissions based on clicks or visits to affiliate links. This plugin adds the possibility to grant commissions based on Pay per Click, Pay per Visit and Pay per Daily Visit with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> and <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ), 'plugin_file' => 'affiliates-ppc/affiliates-ppc.php', 'notes' => __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ), 'repository' => 'itthinx', 'access' => 'non-free', 'targets' => array( 'affiliates-pro', 'affiliates-enterprise' ), 'platforms' => array(), 'priority' => 66, 'class' => 'ext' ); $integrations['affiliates-gravityforms'] = array( 'title' => __( 'Gravity Forms', 'affiliates' ), 'plugin_title' => __( 'Affiliates Gravity Forms Integration', 'affiliates' ), 'plugin_url' => 'http://www.itthinx.com/plugins/affiliates-gravityforms/', 'description' => __( 'This plugin integrates <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> and <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a> with <a href="https://www.e-junkie.com/ecom/gb.php?cl=54585&c=ib&aff=290919">Gravity Forms</a>.', 'affiliates' ), 'plugin_file' => 'affiliates-gravityforms/affiliates-gravityforms.php', 'notes' => __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ), 'repository' => 'itthinx', 'access' => 'non-free', 'targets' => array( 'affiliates-pro', 'affiliates-enterprise' ), 'platforms' => array( 'gravityforms' ), 'priority' => 50, 'class' => 'ext' ); if ( isset( $integrations['affiliates-contact-form-7'] ) ) { if ( empty( $integrations['affiliates-contact-form-7']['notes'] ) ) { $integrations['affiliates-contact-form-7']['notes'] = __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ); $integrations['affiliates-contact-form-7']['priority'] = 50; $integrations['affiliates-contact-form-7']['class'] = 'ext'; } } if ( isset( $integrations['affiliates-formidable'] ) ) { if ( empty( $integrations['affiliates-formidable']['notes'] ) ) { $integrations['affiliates-formidable']['notes'] = __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ); $integrations['affiliates-formidable']['priority'] = 50; $integrations['affiliates-formidable']['class'] = 'ext'; } } if ( isset( $integrations['affiliates-ninja-forms'] ) ) { if ( empty( $integrations['affiliates-ninja-forms']['notes'] ) ) { $integrations['affiliates-ninja-forms']['notes'] = __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ); $integrations['affiliates-ninja-forms']['priority'] = 50; $integrations['affiliates-ninja-forms']['class'] = 'ext'; } } if ( isset( $integrations['affiliates-events-manager'] ) ) { if ( empty( $integrations['affiliates-events-manager']['notes'] ) ) { $integrations['affiliates-events-manager']['notes'] = __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>.', 'affiliates' ); $integrations['affiliates-events-manager']['priority'] = 65; $integrations['affiliates-events-manager']['class'] = 'ext'; } } $integrations['affiliates-paypal'] = array( 'title' => __( 'PayPal', 'affiliates' ), 'plugin_title' => __( 'Affiliates PayPal Integration', 'affiliates' ), 'plugin_url' => 'http://www.itthinx.com/plugins/affiliates-pro-paypal/', 'description' => __( 'This plugin integrates <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> and <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a> with PayPal Payments Standard. With this advanced integration plugin, referrals are created and synchronized automatically for your affiliates when sales are made.', 'affiliates' ), 'plugin_file' => 'affiliates-paypal/affiliates-paypal.php', 'notes' => __( 'This integration is suitable to be used with <a href="http://www.itthinx.com/shop/affiliates-pro/">Affiliates Pro</a> or <a href="http://www.itthinx.com/shop/affiliates-enterprise/">Affiliates Enterprise</a>. Note that this integration is not intended to be used for e-commerce systems that provide their own PayPal Payments Standard gateway.', 'affiliates' ), 'repository' => 'itthinx', 'access' => 'non-free', 'targets' => array( 'affiliates-pro', 'affiliates-enterprise' ), 'platforms' => array( 'paypal' ), 'priority' => 30, 'class' => 'ext' ); uasort( $integrations,array( __CLASS__, 'sort' ) ); return $integrations; }

	public static function affiliates_settings_integration_button( $button, $action, $key, $integration ) { if ( $integration['access'] != 'free' ) { if ( !class_exists( 'Itthinx_Updates_Bridge' ) ) { $button = ''; } else if ( !method_exists( 'Itthinx_Updates_Bridge', 'get_plugins' ) ) { $button = ''; } } return $button; }

	public static function affiliates_settings_integration_explanation( $explanation, $action, $key, $integration ) { if ( $integration['access'] != 'free' ) { if ( !class_exists( 'Itthinx_Updates_Bridge' ) ) { $explanation = __( 'This <strong>requires</strong> the <a href="http://www.itthinx.com/plugins/itthinx-updates/">itthinx updates</a> plugin.', 'affiliates' ); } else if ( !method_exists( 'Itthinx_Updates_Bridge', 'get_plugins' ) ) { $explanation = __( 'This requires an <strong>update</strong> of the <a href="http://www.itthinx.com/plugins/itthinx-updates/">itthinx updates</a> plugin.', 'affiliates' ); } } return $explanation; }

	public static function plugins_api( $result, $action, $args ) { ob_start(); $IX86383 = self::affiliates_settings_integrations( array() ); ob_end_clean(); if ( !empty( $IX86383 ) ) { if ( isset( $args->slug ) && key_exists( $args->slug, $IX86383 ) ) { global $itthinx_plugins; if ( empty( $itthinx_plugins ) || !is_array( $itthinx_plugins ) || !in_array( $args->slug, $itthinx_plugins ) ) { if ( $action == 'plugin_information' ) { $result = false; if ( class_exists( 'Itthinx_Updates_Bridge' ) && method_exists( 'Itthinx_Updates_Bridge', 'get_plugin_info' ) ) { if ( !empty( $args->slug ) ) { $IX28483 = Itthinx_Updates_Bridge::get_plugin_info( $args->slug ); if ( $IX28483 ) { $result = $IX28483; } } } } } } } return $result; }
}
Affiliates_Settings_Integrations_Ext::init();
