<?php
/**
 * class-affiliates-totals-wordpress.php
 *
 * Copyright 2011 "kento" Karim Rahimpur - www.itthinx.com
 *
 * This code is provided subject to the license granted.
 * Unauthorized use and distribution is prohibited.
 * See COPYRIGHT.txt and LICENSE.txt
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This header and all notices must be kept intact.
 *
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Totals platform-specific extension.
 */
class Affiliates_Totals_WordPress extends Affiliates_Totals {

	const NONCE       = 'totals-nonce';
	const NONCE_1     = 'totals-nonce-1';
	const NONCE_2     = 'totals-nonce-2';
	const SET_FILTERS = 'set-filters';
	const SET_RPP     = 'set-rpp';
	const SET_PAGE    = 'set-page';

	const NONCE_MP    = 'totals-nonce-mp';
	const MP_PAYPAL   = 'gen-mp-pp';

	const TOTALS_PER_PAGE = 10;

	public static function view() { global $wpdb, $wp_rewrite, $affiliates_options; global $affiliates_db; $IX48755 = ''; $IX73416 = date( 'Y-m-d', time() ); if ( !current_user_can( AFFILIATES_ACCESS_AFFILIATES ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } if ( isset( $_POST['action'] ) ) { switch( $_POST['action'] ) { case 'do_foo' : break; } } else if ( isset ( $_GET['action'] ) ) { switch( $_GET['action'] ) { case 'close_referrals' : $IX27900 = array( 'tables' => array( 'referrals' => $affiliates_db->get_tablename( 'referrals' ), 'affiliates' => $affiliates_db->get_tablename( 'affiliates' ), 'affiliates_users' => $affiliates_db->get_tablename( 'affiliates_users' ), 'users' => $wpdb->users, ) ); $IX27900 = array_merge( $_GET, $IX27900 ); echo self::update_status( AFFILIATES_REFERRAL_STATUS_CLOSED, $IX27900 ); die(); break; } } if ( isset( $_POST['from_date'] ) || isset( $_POST['thru_date'] ) || isset( $_POST['minimum_total'] ) || isset( $_POST['affiliate_status'] ) || isset( $_POST['referral_status'] ) || isset( $_POST['currency_id'] ) || isset( $_POST['clear_filters'] ) || isset( $_POST['affiliate_id'] ) || isset( $_POST['affiliate_name'] ) || isset( $_POST['affiliate_user_login'] ) || isset( $_POST['show_deleted'] ) || isset( $_POST['show_inoperative'] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE], self::SET_FILTERS ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } $IX93012 = $affiliates_options->get_option( 'totals_from_date', null ); $IX36071 = null; $IX62621 = $affiliates_options->get_option( 'totals_thru_date', null ); $IX25332 = null; $IX49131 = $affiliates_options->get_option( 'totals_minimum_total', null ); $IX72745 = $affiliates_options->get_option( 'totals_affiliate_status', null ); $IX88931 = $affiliates_options->get_option( 'totals_referral_status', null ); $IX72531 = $affiliates_options->get_option( 'totals_currency_id', null ); $IX10135 = $affiliates_options->get_option( 'totals_affiliate_id', null ); $IX57773 = $affiliates_options->get_option( 'totals_affiliate_name', null ); $IX71003 = $affiliates_options->get_option( 'totals_affiliate_user_login', null ); $IX68631 = $affiliates_options->get_option( 'totals_show_deleted', false ); $IX32948 = $affiliates_options->get_option( 'totals_show_inoperative', false ); if ( isset( $_POST['clear_filters'] ) ) { $affiliates_options->delete_option( 'totals_from_date' ); $affiliates_options->delete_option( 'totals_thru_date' ); $affiliates_options->delete_option( 'totals_minimum_total' ); $affiliates_options->delete_option( 'totals_affiliate_status' ); $affiliates_options->delete_option( 'totals_referral_status' ); $affiliates_options->delete_option( 'totals_currency_id' ); $affiliates_options->delete_option( 'totals_affiliate_id' ); $affiliates_options->delete_option( 'totals_affiliate_name' ); $affiliates_options->delete_option( 'totals_affiliate_user_login' ); $affiliates_options->delete_option( 'totals_show_deleted' ); $affiliates_options->delete_option( 'totals_show_inoperative' ); $IX93012 = null; $IX36071 = null; $IX62621 = null; $IX25332 = null; $IX49131 = null; $IX72745 = null; $IX88931 = null; $IX72531 = null; $IX10135 = null; $IX57773 = null; $IX71003 = null; $IX68631 = false; $IX32948 = false; } else if ( isset( $_POST['submitted'] ) ) { if ( !empty( $_POST['minimum_total'] ) ) { $IX49131 = bcadd( "0", $_POST['minimum_total'], affiliates_get_referral_amount_decimals() ); $affiliates_options->update_option( 'totals_minimum_total', $IX49131 ); } else { $IX49131 = null; $affiliates_options->delete_option( 'totals_minimum_total' ); } if ( !empty( $_POST['affiliate_status'] ) && ( $IX72745 = Affiliates_Utility::verify_affiliate_status( $_POST['affiliate_status'] ) ) ) { $affiliates_options->update_option( 'totals_affiliate_status', $IX72745 ); } else { $IX72745 = null; $affiliates_options->delete_option( 'totals_affiliate_status' ); } if ( !empty( $_POST['referral_status'] ) && ( $IX88931 = Affiliates_Utility::verify_referral_status_transition( $_POST['referral_status'], $_POST['referral_status'] ) ) ) { $affiliates_options->update_option( 'totals_referral_status', $IX88931 ); } else { $IX88931 = null; $affiliates_options->delete_option( 'totals_referral_status' ); } if ( !empty( $_POST['currency_id'] ) && ( $IX72531 = Affiliates_Utility::verify_currency_id( $_POST['currency_id'] ) ) ) { $affiliates_options->update_option( 'totals_currency_id', $IX72531 ); } else { $IX72531 = null; $affiliates_options->delete_option( 'totals_currency_id' ); } if ( !empty( $_POST['affiliate_name'] ) ) { $IX57773 = $_POST['affiliate_name']; $affiliates_options->update_option( 'totals_affiliate_name', $IX57773 ); } else { $IX57773 = null; $affiliates_options->delete_option( 'totals_affiliate_name' ); } if ( !empty( $_POST['affiliate_user_login'] ) ) { $IX71003 = $_POST['affiliate_user_login']; $affiliates_options->update_option( 'totals_affiliate_user_login', $IX71003 ); } else { $IX71003 = null; $affiliates_options->delete_option( 'totals_affiliate_user_login' ); } $IX68631 = isset( $_POST['show_deleted'] ); $affiliates_options->update_option( 'totals_show_deleted', $IX68631 ); $IX32948 = isset( $_POST['show_inoperative'] ); $affiliates_options->update_option( 'totals_show_inoperative', $IX32948 ); if ( !empty( $_POST['from_date'] ) ) { $IX93012 = date( 'Y-m-d', strtotime( $_POST['from_date'] ) ); $affiliates_options->update_option( 'totals_from_date', $IX93012 ); } else { $IX93012 = null; $affiliates_options->delete_option( 'totals_from_date' ); } if ( !empty( $_POST['thru_date'] ) ) { $IX62621 = date( 'Y-m-d', strtotime( $_POST['thru_date'] ) ); $affiliates_options->update_option( 'totals_thru_date', $IX62621 ); } else { $IX62621 = null; $affiliates_options->delete_option( 'totals_thru_date' ); } if ( $IX93012 && $IX62621 ) { if ( strtotime( $IX93012 ) > strtotime( $IX62621 ) ) { $IX62621 = null; $affiliates_options->delete_option( 'totals_thru_date' ); } } if ( !empty( $_POST['affiliate_id'] ) ) { $IX10135 = affiliates_check_affiliate_id( $_POST['affiliate_id'] ); if ( $IX10135 ) { $affiliates_options->update_option( 'totals_affiliate_id', $IX10135 ); } } else if ( isset( $_POST['affiliate_id'] ) ) { $IX10135 = null; $affiliates_options->delete_option( 'totals_affiliate_id' ); } } if ( isset( $_POST['row_count'] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE_1], self::SET_RPP ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } if ( isset( $_POST['paged'] ) ) { if ( !wp_verify_nonce( $_POST[self::NONCE_2], self::SET_PAGE ) ) { wp_die( __( 'Access denied.', 'affiliates' ) ); } } $IX32877 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX32877 = remove_query_arg( 'paged', $IX32877 ); $IX32877 = remove_query_arg( 'action', $IX32877 ); $IX32877 = remove_query_arg( 'affiliate_id', $IX32877 ); $IX27113 = $affiliates_db->get_tablename( 'referrals' ); $IX73268 = $affiliates_db->get_tablename( 'affiliates' ); $IX44948 = $affiliates_db->get_tablename( 'affiliates_users' ); $IX48755 .= '<div class="totals">' . '<div>' . '<h1>' . __( 'Totals', 'affiliates' ) . '</h1>' . '</div>'; $IX99341 = isset( $_POST['row_count'] ) ? intval( $_POST['row_count'] ) : 0; if ($IX99341 <= 0) { $IX99341 = $affiliates_options->get_option( 'totals_per_page', self::TOTALS_PER_PAGE ); } else { $affiliates_options->update_option('totals_per_page', $IX99341 ); } $IX96109 = isset( $_GET['offset'] ) ? intval( $_GET['offset'] ) : 0; if ( $IX96109 < 0 ) { $IX96109 = 0; } $IX45522 = isset( $_REQUEST['paged'] ) ? intval( $_REQUEST['paged'] ) : 0; if ( $IX45522 < 0 ) { $IX45522 = 0; } $IX37613 = isset( $_GET['orderby'] ) ? $_GET['orderby'] : null; switch ( $IX37613 ) { case 'affiliate_id' : case 'name' : case 'user_login' : case 'email' : case 'total' : case 'currency_id' : break; default: $IX37613 = 'name'; } $IX68461 = isset( $_GET['order'] ) ? $_GET['order'] : null; switch ( $IX68461 ) { case 'asc' : case 'ASC' : $IX55128 = 'DESC'; break; case 'desc' : case 'DESC' : $IX55128 = 'ASC'; break; default: $IX68461 = 'ASC'; $IX55128 = 'DESC'; } $IX53873 = array( " 1=%d " ); $IX52533 = array( 1 ); if ( $IX10135 ) { $IX53873[] = " a.affiliate_id = %d "; $IX52533[] = $IX10135; } if ( $IX57773 ) { $IX53873[] = " a.name LIKE '%%%s%%' "; $IX52533[] = $IX57773; } if ( $IX71003 ) { $IX53873[] = " u.user_login LIKE '%%%s%%' "; $IX52533[] = $IX71003; } if ( $IX93012 ) { $IX36071 = DateHelper::u2s( $IX93012 ); } if ( $IX62621 ) { $IX25332 = DateHelper::u2s( $IX62621, 24*3600 ); } if ( $IX36071 && $IX25332 ) { $IX53873[] = " r.datetime >= %s AND r.datetime < %s "; $IX52533[] = $IX36071; $IX52533[] = $IX25332; } else if ( $IX36071 ) { $IX53873[] = " r.datetime >= %s "; $IX52533[] = $IX36071; } else if ( $IX25332 ) { $IX53873[] = " r.datetime < %s "; $IX52533[] = $IX25332; } if ( $IX72745 ) { $IX53873[] = " a.status = %s "; $IX52533[] = $IX72745; } if ( $IX88931 ) { $IX53873[] = " r.status = %s "; $IX52533[] = $IX88931; } if ( $IX72531 ) { $IX53873[] = " r.currency_id = %s "; $IX52533[] = $IX72531; } if ( !empty( $IX53873 ) ) { $IX53873 = " WHERE " . implode( " AND ", $IX53873 ); } else { $IX53873 = ''; } $IX96684 = ''; if ( $IX49131 ) { $IX96684 .= " HAVING SUM(r.amount) >= %s "; $IX52533[] = $IX49131; } $IX97065 = $affiliates_db->get_value( "
			SELECT COUNT(*) FROM (
			SELECT r.affiliate_id
			FROM $IX27113 r
			LEFT JOIN $IX73268 a ON r.affiliate_id = a.affiliate_id
			LEFT JOIN $IX44948 au ON a.affiliate_id = au.affiliate_id
			LEFT JOIN $wpdb->users u on au.user_id = u.ID
			$IX53873 
			GROUP BY r.affiliate_id, r.currency_id
			$IX96684
			) tmp
			", $IX52533 ); if ( $IX97065 > $IX99341 ) { $IX16251 = true; } else { $IX16251 = false; } $IX81505 = ceil ( $IX97065 / $IX99341 ); if ( $IX45522 > $IX81505 ) { $IX45522 = $IX81505; } if ( $IX45522 != 0 ) { $IX96109 = ( $IX45522 - 1 ) * $IX99341; } $IX72618 = $affiliates_db->get_objects( "SELECT a.*, u.user_login, SUM(r.amount) as total, r.currency_id " . "FROM $IX27113 r " . "LEFT JOIN $IX73268 a ON r.affiliate_id = a.affiliate_id " . "LEFT JOIN $IX44948 au ON a.affiliate_id = au.affiliate_id " . "LEFT JOIN $wpdb->users u on au.user_id = u.ID " . "$IX53873 " . "GROUP BY r.affiliate_id, r.currency_id " . "$IX96684 " . "ORDER BY $IX37613 $IX68461 LIMIT $IX99341 OFFSET $IX96109 ", $IX52533 ); $IX97633 = $affiliates_db->get_objects( "SELECT SUM(r.amount) as total, r.currency_id " . "FROM $IX27113 r " . "LEFT JOIN $IX73268 a ON r.affiliate_id = a.affiliate_id " . "LEFT JOIN $IX44948 au ON a.affiliate_id = au.affiliate_id " . "LEFT JOIN $wpdb->users u on au.user_id = u.ID " . "$IX53873 " . "GROUP BY r.currency_id " . "$IX96684 ", $IX52533 ); $IX89442 = array( 'affiliate_id' => __( 'Id', 'affiliates' ), 'name' => __( 'Affiliate', 'affiliates' ), 'email' => __( 'Email', 'affiliates' ), 'user_login' => __( 'Username', 'affiliates' ), 'total' => __( 'Total', 'affiliates' ), 'currency_id' => __( 'Currency', 'affiliates' ) ); $IX48755 .= '<div class="totals-overview">'; $IX82980 = ""; if ( !empty( $IX93012 ) ) { $IX82980 .= "&from_date=" . urlencode( $IX93012 ); } if ( !empty( $IX62621 ) ) { $IX82980 .= "&thru_date=" . urlencode( $IX62621 ); } if ( !empty( $IX49131 ) ) { $IX82980 .= "&minimum_total=" . urlencode( $IX49131 ); } if ( !empty( $IX72745 ) ) { $IX82980 .= "&affiliate_status=" . urlencode( $IX72745 ); } if ( !empty( $IX88931 ) ) { $IX82980 .= "&referral_status=" . urlencode( $IX88931 ); } if ( !empty( $IX72531 ) ) { $IX82980 .= "&currency_id=" . urlencode( $IX72531 ); } if ( !empty( $IX10135 ) ) { $IX82980 .= "&affiliate_id=" . urlencode( $IX10135 ); } if ( !empty( $IX57773 ) ) { $IX82980 .= "&affiliate_name=" . urlencode( $IX57773 ); } if ( !empty( $IX71003 ) ) { $IX82980 .= "&affiliate_user_login=" . urlencode( $IX71003 ); } if ( !empty( $IX37613 ) ) { $IX82980 .= "&orderby=" . urlencode( $IX37613 ); } if ( !empty( $IX68461 ) ) { $IX82980 .= "&order=" . urlencode( $IX68461 ); } $IX53462 = esc_url( AFFILIATES_PRO_PLUGIN_URL . 'lib/ext/includes/generate-mass-payment-file.php' ); $IX48755 .= '<div class="manage">'; $IX48755 .= "<p>"; $IX48755 .= "<a target='_blank' title='" . __( 'Export to File', 'affiliates' ) . "' " . "class='button generate export' " . "href='" . $IX53462 . "?action=generate_mass_payment_file&service=export" . $IX82980 . "'>" . "<img class='icon' alt='" . __( 'Generate', 'affiliates') . "' src='". AFFILIATES_PRO_PLUGIN_URL ."images/export.png'/>" . "<span class='label'>" . __( 'Export', 'affiliates') . "</span>" . "</a>"; $IX48755 .= "<a target='_blank' title='" . __( 'Generate a Mass Payment File', 'affiliates' ) . "' " . "class='button generate paypal' " . "href='" . $IX53462 . "?action=generate_mass_payment_file&service=paypal" . $IX82980 . "'>" . "<img class='icon' alt='" . __( 'Generate', 'affiliates') . "' src='". AFFILIATES_PRO_PLUGIN_URL ."images/export.png'/>" . "<span class='label'>" . __( 'Mass Payment File', 'affiliates') . "</span>" . "</a>"; $IX48755 .= "<a title='" . __( 'Click to close these referrals', 'affiliates' ) . "' " . "class='button close-referrals' " . "href='" . esc_url( $IX32877 ) . "&action=close_referrals" . $IX82980 . "'>" . "<img class='icon' alt='" . __( 'Close referrals', 'affiliates') . "' src='". AFFILIATES_PRO_PLUGIN_URL ."images/closed.png'/>" . "<span class='label'>" . __( 'Close Referrals', 'affiliates') . "</span>" . "</a>"; $IX48755 .= "</p>"; $IX48755 .= '<ul>'; $IX48755 .= '<li>'; $IX48755 .= __( '<strong>Export</strong> : Export the current totals listing to a file.', 'affiliates' ); $IX48755 .= '</li>'; $IX48755 .= '<li>'; $IX48755 .= __( '<strong>Mass Payment File</strong> : Export the current totals for mass payment compatible with the PayPal file format<sup>*</sup>.', 'affiliates' ); $IX48755 .= '</li>'; $IX48755 .= '<li>'; $IX48755 .= '</ul>'; $IX48755 .= '<p style="font-size:0.92em">'; $IX48755 .= sprintf( __( "<sup>*</sup>Note that the PayPal Mass Payment <a target='_blank' href='%s'>File Format</a> allows only one currency type per Mass Payment file.", 'affiliates' ), "https://www.paypal.com/cgi-bin/webscr?cmd=_batch-payment-format-outside" ); $IX48755 .= ' '; $IX48755 .= __( 'Use the <em>Currency</em> filter to restrict the listing to one currency.', 'affiliates' ); $IX48755 .= ' '; $IX48755 .= __( 'Where a specific PayPal email address is on file for an affiliate, it will be used.', 'affiliates' ); $IX48755 .= '</p>'; $IX48755 .= '</div>'; $IX73551 = array( AFFILIATES_AFFILIATE_STATUS_ACTIVE => __( 'Active', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_AFFILIATE_STATUS_PENDING => __( 'Pending', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_AFFILIATE_STATUS_DELETED => __( 'Deleted', AFFILIATES_PLUGIN_DOMAIN ), ); $IX88395 = '<label class="affiliate-status-filter" for="affiliate_status">'; $IX88395 .= __('Affiliate Status', 'affiliates' ); $IX88395 .= ' '; $IX88395 .= '<select class="affiliate-status-filter" name="affiliate_status">'; $IX88395 .= '<option value="" ' . ( empty( $IX72745 ) ? ' selected="selected" ' : '' ) . '>--</option>'; foreach ( $IX73551 as $IX90375 => $IX38626 ) { $IX33983 = $IX90375 == $IX72745 ? ' selected="selected" ' : ''; $IX88395 .= '<option ' . $IX33983 . ' value="' . esc_attr( $IX90375 ) . '">' . $IX38626 . '</option>'; } $IX88395 .= '</select>'; $IX88395 .= '</label>'; $IX47141 = array( AFFILIATES_REFERRAL_STATUS_ACCEPTED => __( 'Accepted', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_CLOSED => __( 'Closed', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_PENDING => __( 'Pending', AFFILIATES_PLUGIN_DOMAIN ), AFFILIATES_REFERRAL_STATUS_REJECTED => __( 'Rejected', AFFILIATES_PLUGIN_DOMAIN ), ); $IX53680 = '<label class="referral-status-filter" for="referral_status">'; $IX53680 .= __('Referral Status', 'affiliates' ); $IX53680 .= ' '; $IX53680 .= '<select class="referral-status-filter" name="referral_status">'; $IX53680 .= '<option value="" ' . ( empty( $IX88931 ) ? ' selected="selected" ' : '' ) . '>--</option>'; foreach ( $IX47141 as $IX90375 => $IX38626 ) { $IX33983 = $IX90375 == $IX88931 ? ' selected="selected" ' : ''; $IX53680 .= '<option ' . $IX33983 . ' value="' . esc_attr( $IX90375 ) . '">' . $IX38626 . '</option>'; } $IX53680 .= '</select>'; $IX53680 .= '</label>'; $IX40817 = $affiliates_db->get_objects( "SELECT DISTINCT(currency_id) FROM $IX27113 WHERE currency_id IS NOT NULL" ); $IX13264 = '<label class="currency-id-filter" for="currency_id">'; $IX13264 .= __( 'Currency', 'affiliates' ); $IX13264 .= ' '; $IX13264 .= '<select class="currency-id-filter" name="currency_id">'; $IX13264 .= '<option value="" ' . ( empty( $IX72531 ) ? ' selected="selected" ' : '' ) . '>--</option>'; foreach ( $IX40817 as $IX61808 ) { $IX33983 = $IX61808->currency_id == $IX72531 ? ' selected="selected" ' : ''; $IX13264 .= '<option ' . $IX33983 . ' value="' . esc_attr( $IX61808->currency_id ) . '">' . $IX61808->currency_id . '</option>'; } $IX13264 .= '</select>'; $IX13264 .= '</label>'; $IX48755 .= '<div class="filters">' . '<label class="description" for="setfilters">' . __( 'Filters', 'affiliates' ) . '</label>' . '<form id="setfilters" action="" method="post">' . '<div class="filter-section">' . $IX53680 . '<label class="minimum-total-filter" for="minimum_total">' . __( 'Minimum Total', 'affiliates' ) . '<input class="minimum-total-filter" name="minimum_total" type="text" value="' . esc_attr( $IX49131 ) . '"/>' . '</label>' . $IX13264 . $IX88395 . '</div>' . '<div class="filter-section">' . '<label class="affiliate-id-filter shrink" for="affiliate_id">' . __( 'Affiliate Id', 'affiliates' ) . '<input class="affiliate-id-filter" name="affiliate_id" type="text" value="' . esc_attr( $IX10135 ) . '"/>' . '</label>' . '<label class="affiliate-name-filter" for="affiliate_name">' . __( 'Affiliate Name', 'affiliates' ) . '<input class="affiliate-name-filter" name="affiliate_name" type="text" value="' . $IX57773 . '"/>' . '</label>' . '<label class="affiliate-user-login-filter" for="affiliate_user_login">' . __( 'Affiliate Username', 'affiliates' ) . '<input class="affiliate-user-login-filter" name="affiliate_user_login" type="text" value="' . $IX71003 . '" />' . '</label>' . '</div>' . '<div class="filter-section">' . '<label class="from-date-filter" for="from_date">' . __( 'From', 'affiliates' ) . '<input class="datefield from-date-filter" name="from_date" type="text" value="' . esc_attr( $IX93012 ) . '"/>'. '</label>' . '<label class="thru-date-filter" for="thru_date">' . __( 'Until', 'affiliates' ) . '<input class="datefield thru-date-filter" name="thru_date" type="text" class="datefield" value="' . esc_attr( $IX62621 ) . '"/>'. '</label>' . '</div>
					<div class="filter-buttons">' . wp_nonce_field( self::SET_FILTERS, self::NONCE, true, false ) . '<input class="button" type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>' . '<input class="button" type="submit" name="clear_filters" value="' . __( 'Clear', 'affiliates' ) . '"/>' . '<input type="hidden" value="submitted" name="submitted"/>' . '</div>' . '</form>' . '</div>'; $IX48755 .= '<div class="page-options">' . '<form id="setrowcount" action="" method="post">' . '<div>' . '<label for="row_count">' . __( 'Results per page', 'affiliates' ) . '</label>' . '<input name="row_count" type="text" size="2" value="' . esc_attr( $IX99341 ) . '" />' . wp_nonce_field( self::SET_RPP, self::NONCE_1, true, false ) . '<input class="button" type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>' . '</div>' . '</form>' . '</div>'; if ( $IX16251 ) { $IX99880 = new Affiliates_Pagination( $IX97065, null, $IX99341 ); $IX48755 .= '<form id="posts-filter" method="post" action="">'; $IX48755 .= '<div>'; $IX48755 .= wp_nonce_field( self::SET_PAGE, self::NONCE_2, true, false ); $IX48755 .= '</div>'; $IX48755 .= '<div class="tablenav top">'; $IX48755 .= $IX99880->pagination( 'top' ); $IX48755 .= '</div>'; $IX48755 .= '</form>'; } $IX48755 .= '<table class="wp-list-table widefat fixed" cellspacing="0">'; $IX48755 .= '<thead>'; $IX48755 .= '<tr>'; foreach ( $IX89442 as $IX90375 => $IX23668 ) { $IX92278 = array( 'orderby' => $IX90375, 'order' => $IX55128 ); $IX20777 = $IX90375; if ( !in_array($IX90375, array( 'edit', 'remove', 'links' ) ) ) { if ( strcmp( $IX90375, $IX37613 ) == 0 ) { $IX58632 = strtolower( $IX68461 ); $IX20777 = "$IX90375 manage-column sorted $IX58632"; } else { $IX20777 = "$IX90375 manage-column sortable"; } $IX23668 = '<a href="' . esc_url( add_query_arg( $IX92278, $IX32877 ) ) . '"><span>' . $IX23668 . '</span><span class="sorting-indicator"></span></a>'; } $IX48755 .= "<th scope='col' class='$IX20777'>$IX23668</th>"; } $IX48755 .= '</tr>'; $IX48755 .= '</thead>'; $IX48755 .= '<tbody>'; if ( count( $IX72618 ) > 0 ) { for ( $IX35029 = 0; $IX35029 < count( $IX72618 ); $IX35029++ ) { $IX72510 = $IX72618[$IX35029]; $IX19682 = ''; $IX49414 = ''; if ( $IX23267 = ( strcmp( $IX72510->status, 'deleted' ) == 0 ) ) { $IX49414 = ' deleted '; $IX19682 .= " " . __( '(removed)', 'affiliates' ); } $IX16615 = ''; if ( $IX84225 = ! ( ( $IX72510->from_date <= $IX73416 ) && ( $IX72510->thru_date == null || $IX72510->thru_date >= $IX73416 ) ) ) { $IX16615 = ' inoperative '; $IX19682 .= " " . __( '(inoperative)', 'affiliates' ); } $IX48755 .= '<tr class="' . $IX49414 . $IX16615 . ( $IX35029 % 2 == 0 ? 'even' : 'odd' ) . '">'; $IX48755 .= '<td class="affiliate-id">'; if ( affiliates_encode_affiliate_id( $IX72510->affiliate_id ) != $IX72510->affiliate_id ) { $IX48755 .= '<span class="encoded-hint" title="' . affiliates_encode_affiliate_id( $IX72510->affiliate_id ) . '">' . $IX72510->affiliate_id . '</span>'; } else { $IX48755 .= $IX72510->affiliate_id; } $IX48755 .= '</td>'; $IX48755 .= sprintf( '<td class="affiliate-name">%s</td>', stripslashes( wp_filter_nohtml_kses( $IX72510->name ) ) . $IX19682 ); $IX48755 .= sprintf( '<td class="affiliate-email">%s</td>', esc_html( $IX72510->email ) ); $IX48755 .= sprintf( '<td class="affiliate-user-login">%s</td>', esc_html( $IX72510->user_login ) ); $IX48755 .= sprintf( '<td class="total">%s</td>', esc_html( affiliates_format_referral_amount( $IX72510->total, 'display' ) ) ); $IX48755 .= sprintf( '<td class="currency-id">%s</td>', esc_html( $IX72510->currency_id ) ); $IX48755 .= '</tr>'; } if ( is_array( $IX97633 ) && count( $IX97633 ) > 0 ) { foreach ( $IX97633 as $IX18015 ) { if ( !empty( $IX18015->currency_id ) && !empty( $IX18015->total ) ) { $IX48755 .= sprintf( '<tr style="font-weight: bold"><td colspan="4">%s %s</td><td class="total">%s</td><td class="currency-id">%s</td></tr>', esc_html__( 'Total', 'affiliates' ), esc_html( $IX18015->currency_id ), esc_html( affiliates_format_referral_amount( $IX18015->total, 'display' ) ), esc_html( $IX18015->currency_id ) ); } } } } else { $IX48755 .= '<tr><td colspan="' . count( $IX89442 ) . '">' . __( 'There are no results.', 'affiliates' ) . '</td></tr>'; } $IX48755 .= '</tbody>'; $IX48755 .= '</table>'; if ( $IX16251 ) { $IX99880 = new Affiliates_Pagination($IX97065, null, $IX99341); $IX48755 .= '<div class="tablenav bottom">'; $IX48755 .= $IX99880->pagination( 'bottom' ); $IX48755 .= '</div>'; } $IX48755 .= '</div>'; $IX48755 .= '</div>'; echo $IX48755; affiliates_footer(); }
}
