<?php
/**
 * class-affiliates-traffic-renderer-wordpress.php
 * 
 * Copyright (c) 2011-2017 "kento" Karim Rahimpur www.itthinx.com
 * 
 * This code is released under the GNU General Public License.
 * See COPYRIGHT.txt and LICENSE.txt.
 * 
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * This header and all notices must be kept intact.
 * 
 * @author Karim Rahimpur
 * @package affiliates-pro
 * @since affiliates-pro 2.17.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Traffic-renderer, platform-dependent extension.
 */
class Affiliates_Traffic_Renderer_WordPress extends Affiliates_Traffic_Renderer {

	/**
	 * Class initialization.
	 */
	public static function init() { add_shortcode( 'affiliates_traffic', array( __CLASS__, 'affiliates_traffic' ) ); }

	public static function affiliates_traffic( $atts, $content = null ) { $IX65620 = ''; wp_enqueue_script( 'datepicker' ); wp_enqueue_script( 'datepickers' ); wp_enqueue_style( 'smoothness' ); wp_enqueue_style( 'affiliates-pro' ); $IX37044 = shortcode_atts( self::$traffic_defaults, $atts ); foreach( self::$traffic_defaults as $IX64321 => $IX83567 ) { switch( $IX64321 ) { case 'show_dates' : case 'show_visits' : case 'show_hits' : case 'show_referrals' : case 'show_src_uris' : case 'show_dest_uris' : case 'show_filters' : case 'show_pagination' : if ( isset( $IX37044[$IX64321] ) ) { if ( is_string( $IX37044[$IX64321] ) ) { $IX77483 = strtolower( trim( $IX37044[$IX64321] ) ); switch( $IX77483 ) { case 'true' : case 'yes' : $IX37044[$IX64321] = true; break; case 'false' : case 'no' : $IX37044[$IX64321] = false; break; default : $IX37044[$IX64321] = $IX83567; } } else { $IX37044[$IX64321] = $IX37044[$IX64321] ? true : false; } } break; case 'src_uri_maxlength' : case 'dest_uri_maxlength' : case 'per_page' : $IX77483 = trim( $IX37044[$IX64321] ); if ( !empty( $IX77483 ) ) { $IX37044[$IX64321] = max( 0, intval( $IX77483 ) ); } else { $IX37044[$IX64321] = 0; } break; case 'status' : if ( is_string( $IX37044[$IX64321] ) ) { $IX37044[$IX64321] = array_map( 'trim', explode( ',', $IX37044[$IX64321] ) ); } $IX34623 = array(); foreach( $IX37044[$IX64321] as $IX36010 ) { if ( $IX36010 = Affiliates_Utility::verify_referral_status_transition( $IX36010, $IX36010 ) ) { $IX34623[] = $IX36010; } } if (!empty( $IX34623 ) ) { $IX37044[$IX64321] = $IX34623; } else { $IX37044[$IX64321] = self::$traffic_defaults[$IX64321]; } break; } } if ( $IX37044['per_page'] <= 0 ) { $IX37044['per_page'] = self::$traffic_defaults['per_page']; } $IX65620 = self::render_affiliate_traffic( $IX37044 ); return $IX65620; }

	public static function render_affiliate_traffic( $options = array() ) { global $wpdb, $affiliates_options, $affiliates_db; $options = shortcode_atts( self::$traffic_defaults, $options ); $IX11079 = array(); if ( $options['show_dates'] ) { $IX11079['date'] = __( 'Date', 'affiliates' ); } if ( $options['show_visits'] ) { $IX11079['visits'] = __( 'Visits', 'affiliates' ); } if ( $options['show_hits'] ) { $IX11079['hits'] = __( 'Hits', 'affiliates' ); } if ( $options['show_referrals'] ) { $IX11079['referrals'] = __( 'Referrals', 'affiliates' ); } if ( $options['show_src_uris'] ) { $IX11079['src_uri'] = __( 'Source URI', 'affiliates' ); } if ( $options['show_dest_uris'] ) { $IX11079['dest_uri'] = __( 'Landing URI', 'affiliates' ); } if ( empty( $options['affiliate_id'] ) || $options['affiliate_id'] === null ) { $IX39994 = get_current_user_id(); $IX50724 = null; if ( $IX39994 ) { $IX97181 = affiliates_get_user_affiliate( $IX39994 ); if ( !empty( $IX97181 ) ) { $IX50724 = array_shift( $IX97181 ); } } } else { $IX34507 = affiliates_get_affiliate( $options['affiliate_id'] ); if ( $IX34507 === null || $IX34507['status'] !== AFFILIATES_AFFILIATE_STATUS_ACTIVE ) { $IX50724 = null; } else { $IX50724 = $IX34507['affiliate_id']; } } $IX99155 = ''; if ( !$IX50724 ) { return $IX99155; } $IX45081 = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; $IX45081 = remove_query_arg( 'uris_paged', $IX45081 ); $IX45081 = remove_query_arg( 'clear_filters', $IX45081 ); $IX45081 = remove_query_arg( 'apply_filters', $IX45081 ); $IX21311 = isset( $_REQUEST['from_date'] ) ? trim( $_REQUEST['from_date'] ) : null; $IX10811 = isset( $_REQUEST['thru_date'] ) ? trim( $_REQUEST['thru_date'] ) : null; $IX98155 = isset( $_REQUEST['src_uri'] ) ? trim( $_REQUEST['src_uri'] ) : null; $IX18087 = isset( $_REQUEST['dest_uri'] ) ? trim( $_REQUEST['dest_uri'] ) : null; $IX79354 = isset( $_REQUEST['min_referrals'] ) ? trim( $_REQUEST['min_referrals'] ) : null; if ( isset( $_REQUEST['clear_filters'] ) ) { unset( $_REQUEST['from_date'] ); unset( $_REQUEST['thru_date'] ); unset( $_REQUEST['src_uri'] ); unset( $_REQUEST['dest_uri'] ); unset( $_REQUEST['min_referrals'] ); $IX21311 = null; $IX10811 = null; $IX98155 = null; $IX18087 = null; $IX79354 = null; $IX45081 = remove_query_arg( 'from_date', $IX45081 ); $IX45081 = remove_query_arg( 'thru_date', $IX45081 ); $IX45081 = remove_query_arg( 'src_uri', $IX45081 ); $IX45081 = remove_query_arg( 'dest_uri', $IX45081 ); $IX45081 = remove_query_arg( 'min_referrals', $IX45081 ); } else { if ( !empty( $_REQUEST['from_date'] ) ) { $IX21311 = date( 'Y-m-d', strtotime( $_REQUEST['from_date'] ) ); } else { $IX21311 = null; } if ( !empty( $_REQUEST['thru_date'] ) ) { $IX10811 = date( 'Y-m-d', strtotime( $_REQUEST['thru_date'] ) ); } else { $IX10811 = null; } if ( $IX21311 && $IX10811 ) { if ( strtotime( $IX21311 ) > strtotime( $IX10811 ) ) { $IX10811 = null; } } if ( !empty( $_REQUEST['src_uri'] ) ) { $IX98155 = trim( $_REQUEST['src_uri'] ); } else if ( isset( $_REQUEST['src_uri'] ) ) { $IX98155 = null; } if ( !empty( $_REQUEST['dest_uri'] ) ) { $IX18087 = trim( $_REQUEST['dest_uri'] ); } else if ( isset( $_REQUEST['dest_uri'] ) ) { $IX18087 = null; } if ( !empty( $_REQUEST['min_referrals'] ) ) { $IX79354 = max( 0, intval( $_REQUEST['min_referrals'] ) ); } else if ( isset( $_REQUEST['min_referrals'] ) ) { $IX79354 = null; } } $IX59363 = _affiliates_get_tablename( 'affiliates' ); $IX12398 = _affiliates_get_tablename( 'referrals' ); $IX85084 = _affiliates_get_tablename( 'hits' ); $IX70633 = _affiliates_get_tablename( 'uris' ); $IX72407 = isset( $_REQUEST['row_count'] ) ? intval( $_REQUEST['row_count'] ) : 0; if ($IX72407 <= 0) { $IX72407 = $options['per_page']; } $IX78804 = isset( $_REQUEST['uris_paged'] ) ? intval( $_REQUEST['uris_paged'] ) : 0; if ( $IX78804 < 0 ) { $IX78804 = 0; } $IX32089 = isset( $_GET['orderby'] ) ? $_GET['orderby'] : null; switch ( $IX32089 ) { case 'date' : case 'visits' : case 'hits' : case 'referrals' : case 'src_uri' : case 'dest_uri' : break; default: $IX32089 = 'date'; } $IX59253 = isset( $_GET['order'] ) ? $_GET['order'] : null; switch ( $IX59253 ) { case 'asc' : case 'ASC' : $IX15230 = 'DESC'; break; case 'desc' : case 'DESC' : $IX15230 = 'ASC'; break; default: $IX59253 = 'DESC'; $IX15230 = 'ASC'; } $IX43233 = " WHERE 1=%d "; $IX41211 = array( 1 ); if ( $IX21311 ) { $IX26723 = DateHelper::u2s( $IX21311 ); } if ( $IX10811 ) { $IX82728 = DateHelper::u2s( $IX10811, 24*3600 ); } if ( $IX21311 && $IX10811 ) { $IX43233 .= " AND h.datetime >= %s AND h.datetime <= %s "; $IX41211[] = $IX26723; $IX41211[] = $IX82728; } else if ( $IX21311 ) { $IX43233 .= " AND h.datetime >= %s "; $IX41211[] = $IX26723; } else if ( $IX10811 ) { $IX43233 .= " AND h.datetime < %s "; $IX41211[] = $IX82728; } $IX43233 .= " AND h.affiliate_id = %d "; $IX41211[] = $IX50724; if ( $IX98155 ) { $IX43233 .= " AND su.uri LIKE '%%%s%%' "; $IX41211[] = $wpdb->esc_like( $IX98155 ); } if ( $IX18087 ) { $IX43233 .= " AND du.uri LIKE '%%%s%%' "; $IX41211[] = $wpdb->esc_like( $IX18087 ); } $IX10210 = ''; if ( $IX79354 ) { $IX10210 = " HAVING COUNT(r.hit_id) >= " . intval( $IX79354 ). " "; } $IX93438 = ''; if ( is_array( $options['status'] ) && count( $options['status'] ) > 0 ) { $IX93438 = " AND ( r.status IS NULL OR r.status IN ('" . implode( "','", array_map( 'esc_sql', $options['status'] ) ) . "') ) "; $IX43233 .= $IX93438; } $IX61092 = $IX72407; $IX26309 = $IX78804; $IX25993 = $IX61092 * $IX26309; $IX74554 = $wpdb->prepare( "SELECT SQL_CALC_FOUND_ROWS " . "h.*, " . "a.name, " . "su.uri src_uri, " . "du.uri dest_uri, " . "COUNT(distinct h.ip) visits, " . "COUNT(*) hits, " . "COUNT(r.hit_id) referrals " . "FROM $IX85084 h " . "LEFT JOIN $IX59363 a ON h.affiliate_id = a.affiliate_id " . "LEFT JOIN $IX70633 su ON h.src_uri_id = su.uri_id " . "LEFT JOIN $IX70633 du ON h.dest_uri_id = du.uri_id " . "LEFT JOIN $IX12398 r ON r.hit_id = h.hit_id " . "$IX43233 " . "GROUP BY h.affiliate_id, h.date, su.uri_id, du.uri_id " . "$IX10210 " . "ORDER BY $IX32089 $IX59253 " . "LIMIT $IX72407 OFFSET $IX25993", $IX41211 ); $IX13331 = $wpdb->get_results( $IX74554, OBJECT ); $IX69366 = intval( $wpdb->get_var( "SELECT FOUND_ROWS()" ) ); if ( $IX69366 > $IX72407 ) { $IX32926 = true; } else { $IX32926 = false; } $IX99155 .= '<div class="affiliates-traffic">'; if ( $options['show_filters'] ) { $IX99155 .= '<div class="filters">'; $IX99155 .= '<label class="description" for="setfilters">' . __( 'Filters', 'affiliates' ) . '</label>'; $IX99155 .= '<form id="setfilters" action="" method="get">'; if ( isset( $IX11079['date'] ) ) { $IX99155 .= '<div class="filter-section">'; $IX99155 .= '<label class="from-date-filter">'; $IX99155 .= __( 'From', 'affiliates' ); $IX99155 .= ' '; $IX99155 .= '<input class="datefield from-date-filter" name="from_date" type="text" value="' . esc_attr( $IX21311 ) . '"/>'; $IX99155 .= '</label>'; $IX99155 .= ' '; $IX99155 .= '<label class="thru-date-filter">'; $IX99155 .= __( 'Until', 'affiliates' ); $IX99155 .= ' '; $IX99155 .= '<input class="datefield thru-date-filter" name="thru_date" type="text" class="datefield" value="' . esc_attr( $IX10811 ) . '"/>'; $IX99155 .= '</label>'; $IX99155 .= '</div>'; } if ( isset( $IX11079['src_uri'] ) || isset( $IX11079['dest_uri'] ) ) { $IX99155 .= '<div class="filter-section">'; } if ( isset( $IX11079['src_uri'] ) ) { $IX99155 .= '<label class="src-uri-filter">'; $IX99155 .= __( 'Source URI', 'affiliates' ); $IX99155 .= ' '; $IX99155 .= '<input class="src-uri-filter" name="src_uri" type="text" value="' . esc_attr( stripslashes( $IX98155 ) ) . '"/>'; $IX99155 .= '</label>'; $IX99155 .= ' '; } if ( isset( $IX11079['dest_uri'] ) ) { $IX99155 .= '<label class="dest-uri-filter">'; $IX99155 .= __( 'Landing URI', 'affiliates' ); $IX99155 .= ' '; $IX99155 .= '<input class="dest-uri-filter" name="dest_uri" type="text" value="' . esc_attr( stripslashes( $IX18087 ) ) . '"/>'; $IX99155 .= '</label>'; } if ( isset( $IX11079['src_uri'] ) || isset( $IX11079['dest_uri'] ) ) { $IX99155 .= '</div>'; } if ( isset( $IX11079['referrals'] ) ) { $IX99155 .= '<div class="filter-section">'; $IX99155 .= '<label class="min-referrals-filter">'; $IX99155 .= __( 'Referrals', 'affiliates' ); $IX99155 .= ' '; $IX99155 .= sprintf( '<input class="input-text min-referrals-filter" title="%s" name="min_referrals" type="number" value="%d" min="0"/>', esc_attr( __( 'Minimum number of referrals', 'affiliates' ) ), esc_attr( $IX79354 ) ); $IX99155 .= '</label>'; $IX99155 .= '</div>'; } $IX99155 .= sprintf( '<input type="hidden" name="row_count" value="%s" />', esc_attr( $IX72407 ) ); $IX99155 .= '<div class="filter-buttons">'; $IX99155 .= '<input class="button apply-button" type="submit" name="apply_filters" value="' . __( 'Apply', 'affiliates' ) . '"/>'; $IX99155 .= '<input class="button clear-button" type="submit" name="clear_filters" value="' . __( 'Clear', 'affiliates' ) . '"/>'; $IX99155 .= '</div>'; $IX99155 .= '</form>'; $IX99155 .= '</div>'; } if ( $options['show_pagination'] ) { $IX99155 .= '<div class="page-options">'; $IX99155 .= '<form id="setrowcount" action="" method="get">'; $IX99155 .= '<label class="row-count">'; $IX99155 .= __( 'Results per page', 'affiliates' ); $IX99155 .= ' '; $IX99155 .= '<input name="row_count" type="text" size="2" value="' . esc_attr( $IX72407 ) .'" />'; $IX99155 .= ' '; $IX99155 .= '<input class="button" type="submit" value="' . __( 'Apply', 'affiliates' ) . '"/>'; $IX99155 .= '</label>'; $IX99155 .= sprintf( '<input type="hidden" name="from_date" value="%s" />', esc_attr( $IX21311 ) ); $IX99155 .= sprintf( '<input type="hidden" name="thru_date" value="%s" />', esc_attr( $IX10811 ) ); $IX99155 .= sprintf( '<input type="hidden" name="src_uri" value="%s" />', esc_attr( stripslashes( $IX98155 ) ) ); $IX99155 .= sprintf( '<input type="hidden" name="dest_uri" value="%s" />', esc_attr( stripslashes( $IX18087 ) ) ); $IX99155 .= sprintf( '<input type="hidden" name="min_referrals" value="%s" />', esc_attr( $IX79354 ) ); $IX99155 .= '</form>'; $IX99155 .= '</div>'; if ( $IX32926 ) { require_once AFFILIATES_CORE_LIB . '/class-affiliates-pagination.php'; $IX27753 = new Affiliates_Pagination( $IX69366, null, $IX72407, 'uris_paged' ); $IX99155 .= '<form id="posts-filter" method="get" action="">'; $IX99155 .= '<div>'; $IX99155 .= sprintf( '<input type="hidden" name="from_date" value="%s" />', esc_attr( $IX21311 ) ); $IX99155 .= sprintf( '<input type="hidden" name="thru_date" value="%s" />', esc_attr( $IX10811 ) ); $IX99155 .= sprintf( '<input type="hidden" name="src_uri" value="%s" />', esc_attr( stripslashes( $IX98155 ) ) ); $IX99155 .= sprintf( '<input type="hidden" name="dest_uri" value="%s" />', esc_attr( stripslashes( $IX18087 ) ) ); $IX99155 .= sprintf( '<input type="hidden" name="min_referrals" value="%s" />', esc_attr( $IX79354 ) ); $IX99155 .= '</div>'; $IX99155 .= '<div class="tablenav top">'; $IX99155 .= $IX27753->pagination( 'top' ); $IX99155 .= '</div>'; $IX99155 .= '</form>'; } } $IX88387 = DateHelper::getServerDateTimeZone(); $IX12497['date'] = sprintf( __( "* Date is given for the server's time zone : %s, which has an offset of %s hours with respect to GMT.", 'affiliates' ), $IX88387->getName(), $IX88387->getOffset( new DateTime() ) / 3600.0 ); $IX12497['referrals'] = __( 'The number of corresponding referrals or conversions.', 'affiliates' ); $IX12497['visits'] = __( 'The number of unique visits.', 'affiliates' ); $IX12497['hits'] = __( 'The number of hits or clicks.', 'affiliates' ); $IX12497['src_uri'] = __( 'Where the traffic originated from.', 'affiliates' ); $IX12497['dest_uri'] = __( 'Where the traffic lead to.', 'affiliates' ); $IX99155 .= '<table class="wp-list-table widefat fixed" cellspacing="0">'; $IX99155 .= '<thead>'; $IX99155 .= '<tr>'; foreach ( $IX11079 as $IX36849 => $IX62693 ) { $IX50740 = array( 'orderby' => $IX36849, 'order' => $IX15230 ); $IX77332 = ''; $IX30409 = ''; if ( strcmp( $IX36849, $IX32089 ) == 0 ) { $IX14540 = strtolower( $IX59253 ); $IX77332 = "$IX36849 manage-column sorted $IX14540"; switch( $IX14540 ) { case 'asc' : $IX30409 = ' &uarr;'; break; case 'desc' : $IX30409 = ' &darr;'; break; } } else { $IX77332 = "$IX36849 manage-column sortable"; } $IX62693 = sprintf( '<a href="%s" title="%s"><span>%s%s</span><span class="sorting-indicator"></span></a>', esc_url( add_query_arg( $IX50740, $IX45081 ) ), !empty( $IX12497[$IX36849] ) ? esc_attr( $IX12497[$IX36849] ) : '', esc_html( $IX62693 ), esc_html( $IX30409 ) ); $IX99155 .= "<th scope='col' class='$IX77332'>$IX62693</th>"; } $IX99155 .= '</tr>'; $IX99155 .= '</thead>'; $IX99155 .= '<tbody>'; if ( count( $IX13331 ) > 0 ) { for ( $IX24807 = 0; $IX24807 < count( $IX13331 ); $IX24807++ ) { $IX46399 = $IX13331[$IX24807]; $IX99155 .= '<tr class=" ' . ( $IX24807 % 2 == 0 ? 'even' : 'odd' ) . '">'; $IX99155 .= isset( $IX11079['date'] ) ? "<td class='date'>$IX46399->date</td>" : ''; $IX99155 .= isset( $IX11079['visits'] ) ? "<td class='visits'>$IX46399->visits</td>" : ''; $IX99155 .= isset( $IX11079['hits'] ) ? "<td class='hits'>$IX46399->hits</td>" : ''; $IX99155 .= isset( $IX11079['referrals'] ) ? "<td class='referrals'>$IX46399->referrals</td>" : ''; $IX39319 = ''; $IX60689 = ''; $IX98155 = $IX46399->src_uri; if ( $options['src_uri_maxlength'] && (strlen( $IX46399->src_uri ) > $options['src_uri_maxlength'] ) ) { $IX98155 = substr( $IX46399->src_uri, 0, $options['src_uri_maxlength'] ) . '&hellip;'; $IX39319 = 'truncated'; } $IX99155 .= isset( $IX11079['src_uri'] ) ? sprintf( "<td class='src-uri %s'><span title='%s'>%s</span></td>", esc_attr( $IX39319 ), esc_attr( $IX46399->src_uri ), esc_html( $IX98155 ) ) : ''; $IX18087 = $IX46399->dest_uri; if ( $options['dest_uri_maxlength'] && (strlen( $IX46399->dest_uri ) > $options['dest_uri_maxlength'] ) ) { $IX18087 = substr( $IX46399->dest_uri, 0, $options['dest_uri_maxlength'] ) . '&hellip;'; $IX60689 = 'truncated'; } $IX99155 .= isset( $IX11079['dest_uri'] ) ? sprintf( "<td class='dest-uri %s'><span title='%s'>%s</span></td>", esc_attr( $IX60689 ), esc_attr( $IX46399->dest_uri ), esc_html( $IX18087 ) ) : ''; $IX99155 .= '</tr>'; } } else { $IX99155 .= '<tr><td colspan="' . sizeof( $IX11079 ) .'">' . __('There are no results.', 'affiliates' ) . '</td></tr>'; } $IX99155 .= '</tbody>'; $IX99155 .= '</table>'; if ( $options['show_pagination'] ) { if ( $IX32926 ) { require_once AFFILIATES_CORE_LIB . '/class-affiliates-pagination.php'; $IX27753 = new Affiliates_Pagination( $IX69366, null, $IX72407, 'uris_paged' ); $IX99155 .= '<div class="tablenav bottom">'; $IX99155 .= $IX27753->pagination( 'bottom' ); $IX99155 .= '</div>'; } } $IX99155 .= '</div>'; return $IX99155; }
}
Affiliates_Traffic_Renderer_WordPress::init();
